#include "http.h"

const char HttpPages[]="/\0/access.htm\0/config.htm\0/log.htm\0\0";

const char ResultHead[]="HTTP/1.0 %s\r\nServer: PDS Daemon %d.%d.%d\r\nContent-Length: %d\r\nContent-Type: text/html; charset=windows-1250\r\n\r\n";

const char Err404[]="<html><head>\r\n<title>404 Not Found</title>\r\n</head><body>\r\n<h1>Not Found</h1>\r\n<p>The requested URL %s was not found on this server.</p>" \
                    "<hr>\r\n<address>PDS Daemon %d.%d.%d (compilation %s %s) at Port %d</address>\r\n</body></html>\r\n";

const char msg_01_begin[]="<html><head>\r\n<title>PDS Daemon</title>\r\n</head><body>\r\n<h1>PDS Daemon %d.%d.%d</h1>\r\n<hr>\r\n" \
                          "<input type=\"button\" value=\"Status\" onclick=\"parent.location='/'\">\r\n" \
                          "<input type=\"button\" value=\"Access\" onclick=\"parent.location='/access.htm'\">\r\n" \
                          "<input type=\"button\" value=\"Config\" onclick=\"parent.location='/config.htm'\">\r\n" \
                          "<input type=\"button\" value=\"Log\" onclick=\"parent.location='/log.htm'\">\r\n" \
                          "<hr>";
const char msg_01_01[]="<p>Open files: <b>%d</b><br>\r\n";

const char msg_01_02[]="<tr><td align=\"right\">%d</td><td>%s</td><td align=\"center\">%s</td><td align=\"right\">%d</td></tr>";
const char msg_01_03[]="</table></p></div>\r\n";
const char msg_01_04[]="<div>Active keys: <b>%d</b>\r\n<p><table border=1>\r\n<tr bgcolor=\"silver\"><th></th><th>key</th><th>password</th><th>used</th></tr>\r\n";
const char msg_01_05[]="<div>Active users: <b>%d</b>\r\n<p><table border=1>\r\n<tr bgcolor=\"silver\"><th></th><th>Address</th><th>thread</th>";
const char msg_01_06[]="<tr><td align=\"right\">%d</td><td>%u.%u.%u.%u:%u</td><td align=\"right\">%u</td>";
const char msg_01_07[]="<th>Key</th><th>Files</th><th>Start</th><th>Messages</th></tr>\r\n";
const char msg_01_08[]="<td>%s</td><td align=\"right\">%d</td><td>%s</td><td align=\"right\">%lu</td></tr>";
const char msg_01_09[]="<th>Ident %d</th>";
const char msg_01_10[]="<td>%s</td>";
const char msg_01_11[]="<br>Daemon start at %s\r\n<br>Daemon uptime %s\r\n<br>Total messages served %lu<br><br>\r\n";

const char msg_01_end[]="<hr>\r\n<address>PDS Daemon %d.%d.%d (compilation %s %s) at Port %d</address>\r\n</body></html>\r\n";

const char msg_02_01[]="<div>Access rules: <b>%u</b>\r\n<p><table border=1>\r\n<tr bgcolor=\"silver\"><th>Rule</th><th>Address</th><th>pds</th><th>http</th></tr>\r\n";
const char msg_02_02[]="<tr><td align=\"right\">%d</td><td>%u.%u.%u.%u/%u</td><td align=\"center\">%s</td><td align=\"center\">%s</td></tr>";
const char msg_02_03[]="</table></p></div>\r\n";

const char msg_03_01[]="<p>PDS port: <b>%u</b><br>\r\nHTTP port: <b>%u</b><br>\r\nPath: <b>%s</b><br>\r\nName: <b>%s</b><br>\r\nEcho server: <b>%s</b><br>\r\nDebug level: <b>%d</b><br>\r\nLog mode: <b>%d</b><br>\r\nLog file: <b>%s</b><br>\r\n";

const char msg_04_01[]="<code><pre>\r\n";
const char msg_04_02[]="</pre></code>\r\n";

extern char compilation_time[];
extern char compilation_date[];

int IsHttpHeadComplete(char * Buffer,int Size)
{
    Size&=0xFFFFFFFC;
    if(Size>=4)
    {
        char * BufPoint=Buffer;
        while(Size>0)
        {
            Size--;
            if(*BufPoint==0x0D)
            {
                if(*((uint32_t *)BufPoint)==0x0A0D0A0D)
                {
                    return 1;
                }
            }
            BufPoint++;
        }
    }
    return 0;
}

void SendHTTPResult(int sockfd,char * Buffer, int BufferSize,char * Data,int DataSize,int ResultCode)
{
    char ResultStr[4];
    snprintf(ResultStr,4,"%d03",ResultCode);
    int LocI=snprintf(Buffer,BufferSize,ResultHead,ResultStr,Version.major,Version.minor,Version.revision,DataSize);
    if(LocI>BufferSize-1)
    {
        LocI=BufferSize-1;
    }
    if(_send(sockfd,Buffer,LocI)==-1)
    {
        message(0,"HTTP Send head error %d\n",errno);
    }
    else
    {
        if(DataSize)
        {
            if(_send(sockfd,Data,DataSize)==-1)
            {
                message(0,"HTTP Send data error %d\n",errno);
            }
        }
    }
}

void SendLogFile(int sockfd,char * Buffer, int BufferSize,char * Data,int DataSize,int SplitPoint,int ResultCode)
{
    if((SplitPoint>DataSize)||(SplitPoint<=0))
        SplitPoint=DataSize;
    char ResultStr[4];
    int LogSize=0;
    int LogFD=-1;
    if(Params->LogName)
    {
        LogFD=open(Params->LogName,O_RDONLY);
    }
    if(LogFD>=-1)
    {
        LogSize=lseek(LogFD,0,SEEK_END);
    }
    snprintf(ResultStr,4,"%d03",ResultCode);
    int TotalSize=DataSize;
    if(LogSize>0)
      TotalSize+=LogSize;
    int LocI=snprintf(Buffer,BufferSize,ResultHead,ResultStr,Version.major,Version.minor,Version.revision,TotalSize);
    if(LocI>BufferSize-1)
    {
        LocI=BufferSize-1;
    }
    if(_send(sockfd,Buffer,LocI)==-1)
    {
        message(0,"HTTP Send head error %d\n",errno);
    }
    else
    {
        if(DataSize)
        {
            if(_send(sockfd,Data,SplitPoint)==-1)
            {
                message(0,"HTTP Send data error %d\n",errno);
            }
            else
            {
                if(LogSize>0)
                {
                    if(lseek(LogFD,0,SEEK_SET)==0)
                    {
                        uint8_t OK=1;
                        while((LogSize>0)&&(OK))
                        {
                            int Readed=LogSize;
                            if(Readed>BufferSize)
                              Readed=BufferSize;
                            Readed=read(LogFD,Buffer,Readed);
                            if(Readed>=0)
                            {
                                if(Readed)
                                {
                                    if(_send(sockfd,Buffer,Readed)==-1)
                                    {
                                        message(0,"HTTP Send log error %d\n",errno);
                                        OK=0;
                                    }
                                    LogSize-=Readed;
                                }
                                else
                                {
                                    LogSize=0;
                                }
                            }
                            else
                            {
                                OK=0;
                            }
                        }
                    }
                    else
                    {
                        message(0,"Seek into log file error %d\n",errno);
                    }
                }
                DataSize-=SplitPoint;
                if(DataSize)
                {
                    char * DataPoint=Data;
                    DataPoint+=SplitPoint;
                    if(_send(sockfd,DataPoint,DataSize)==-1)
                    {
                        message(0,"HTTP Send complete error %d\n",errno);
                    }
                }
            }
        }
    }
    if(LogFD>=0)
    {
        close(LogFD);
    }
}

void HTTPResult(int sockfd,int PageID,char * Buffer,int BufferSize,char * IDStr)
{
    char * ResultBuffer=GetMem(MaxHttpResultSize);
    if(ResultBuffer)
    {
        int FreeInBuffer=MaxHttpResultSize;
        int InBuffer=0;
        int LocI;
        char * BufPoint=ResultBuffer;
        switch(PageID)
        {
            case 1:
            {
                LocI=snprintf(ResultBuffer,FreeInBuffer,msg_01_begin,Version.major,Version.minor,Version.revision);
                if(LocI>FreeInBuffer-1)
                {
                    LocI=FreeInBuffer-1;
                }
                InBuffer+=LocI;
                BufPoint+=LocI;
                FreeInBuffer-=LocI;
                LocI=snprintf(BufPoint,FreeInBuffer,msg_01_01,_Files->Opened);
                if(LocI>FreeInBuffer-1)
                {
                    LocI=FreeInBuffer-1;
                }
                InBuffer+=LocI;
                BufPoint+=LocI;
                FreeInBuffer-=LocI;

                int LocI2=0;

                if(semaphore_p(2,NULL))
                {
                    int MaxIdent=0;
                    P_pds_child child;
                    child=_Childs->Busy;
                    while(child!=NULL)
                    {
                        if(child->Local)
                        {
                            if(child->Local->ip)
                            {
                                LocI2++;
                                if(child->Local->IdentStrCount>MaxIdent)
                                {
                                    MaxIdent=child->Local->IdentStrCount;
                                }
                            }
                        }
                        child=child->NextChild;
                    }
                    LocI=snprintf(BufPoint,FreeInBuffer,msg_01_05,LocI2);
                    if(LocI>FreeInBuffer-1)
                    {
                        LocI=FreeInBuffer-1;
                    }
                    InBuffer+=LocI;
                    BufPoint+=LocI;
                    FreeInBuffer-=LocI;
                    LocI2=0;
                    while(LocI2<MaxIdent)
                    {
                        LocI2++;
                        LocI=snprintf(BufPoint,FreeInBuffer,msg_01_09,LocI2);
                        if(LocI>FreeInBuffer-1)
                        {
                            LocI=FreeInBuffer-1;
                        }
                        InBuffer+=LocI;
                        BufPoint+=LocI;
                        FreeInBuffer-=LocI;
                    }
                    LocI=snprintf(BufPoint,FreeInBuffer,msg_01_07);
                    if(LocI>FreeInBuffer-1)
                    {
                        LocI=FreeInBuffer-1;
                    }
                    InBuffer+=LocI;
                    BufPoint+=LocI;
                    FreeInBuffer-=LocI;
                    LocI2=0;
                    child=_Childs->Busy;
                    char TimeBuf[32];
                    while(child!=NULL)
                    {
                        if(child->Local)
                        {
                            if(child->Local->ip)
                            {
                                LocI2++;
                                char * KeyName="";
                                if((child->Local->MyKey>=0)&&(child->Local->MyKey<_Files->MaxKeys))
                                {
                                    KeyName=(char *)_Files->Keys[child->Local->MyKey].Key;
                                }
                                StrTime(child->Local->start,(char *)&TimeBuf,sizeof(TimeBuf));
                                LocI=snprintf(BufPoint,FreeInBuffer,msg_01_06,LocI2,child->Local->ip8[3],child->Local->ip8[2],child->Local->ip8[1],child->Local->ip8[0],child->Local->port,child->pid);
                                if(LocI>FreeInBuffer-1)
                                {
                                    LocI=FreeInBuffer-1;
                                }
                                InBuffer+=LocI;
                                BufPoint+=LocI;
                                FreeInBuffer-=LocI;
                                int LocI3=0;
                                char * ActIdent=child->Local->IdentStr;
                                while(LocI3<MaxIdent)
                                {
                                    char * IdentStr;
                                    if(LocI3<child->Local->IdentStrCount)
                                    {
                                        IdentStr="";
                                        if(ActIdent)
                                        {
                                            IdentStr=ActIdent;
                                            ActIdent+=strlen(ActIdent)+1;
                                        }
                                    }
                                    LocI=snprintf(BufPoint,FreeInBuffer,msg_01_10,IdentStr);
                                    if(LocI>FreeInBuffer-1)
                                    {
                                        LocI=FreeInBuffer-1;
                                    }
                                    InBuffer+=LocI;
                                    BufPoint+=LocI;
                                    FreeInBuffer-=LocI;
                                    LocI3++;
                                }
                                LocI=snprintf(BufPoint,FreeInBuffer,msg_01_08,KeyName,child->Local->Opened,(char *)&TimeBuf,child->Local->Messages);
                                if(LocI>FreeInBuffer-1)
                                {
                                    LocI=FreeInBuffer-1;
                                }
                                InBuffer+=LocI;
                                BufPoint+=LocI;
                                FreeInBuffer-=LocI;
                            }
                        }
                        child=child->NextChild;
                    }
                    semaphore_v(2,NULL);
                    LocI=snprintf(BufPoint,FreeInBuffer,msg_01_03);
                    if(LocI>FreeInBuffer-1)
                    {
                        LocI=FreeInBuffer-1;
                    }
                    InBuffer+=LocI;
                    BufPoint+=LocI;
                    FreeInBuffer-=LocI;
                }

                LocI=snprintf(BufPoint,FreeInBuffer,msg_01_04,_Files->ActKeys);
                if(LocI>FreeInBuffer-1)
                {
                    LocI=FreeInBuffer-1;
                }
                InBuffer+=LocI;
                BufPoint+=LocI;
                FreeInBuffer-=LocI;
                LocI2=0;
                while(LocI2<_Files->ActKeys)
                {
                    LocI=snprintf(BufPoint,FreeInBuffer,msg_01_02,LocI2+1,(char *)&_Files->Keys[LocI2].Key,GetBooleanStr(_Files->Keys[LocI2].ValidPassword),_Files->Keys[LocI2].UseCount);
                    if(LocI>FreeInBuffer-1)
                    {
                        LocI=FreeInBuffer-1;
                    }
                    InBuffer+=LocI;
                    BufPoint+=LocI;
                    FreeInBuffer-=LocI;
                    LocI2++;
                }
                LocI=snprintf(BufPoint,FreeInBuffer,msg_01_03);
                if(LocI>FreeInBuffer-1)
                {
                    LocI=FreeInBuffer-1;
                }
                InBuffer+=LocI;
                BufPoint+=LocI;
                FreeInBuffer-=LocI;
                char TimeBuf[32];
                StrTime(start_time,(char *)&TimeBuf,sizeof(TimeBuf));
                char UptimeBuf[32];
                StrUptime(start_time,(char *)&UptimeBuf,sizeof(UptimeBuf));
                LocI=snprintf(BufPoint,FreeInBuffer,msg_01_11,(char *)&TimeBuf,(char *)&UptimeBuf,_Files->TotalMessages);
                if(LocI>FreeInBuffer-1)
                {
                    LocI=FreeInBuffer-1;
                }
                InBuffer+=LocI;
                BufPoint+=LocI;
                FreeInBuffer-=LocI;
                LocI=snprintf(BufPoint,FreeInBuffer,msg_01_end,Version.major,Version.minor,Version.revision,compilation_date,compilation_time,Params->httpport);
                if(LocI>FreeInBuffer-1)
                {
                    LocI=FreeInBuffer-1;
                }
                InBuffer+=LocI;
                BufPoint+=LocI;
                FreeInBuffer-=LocI;
                SendHTTPResult(sockfd,Buffer,BufferSize,ResultBuffer,InBuffer,200);
                break;
            }
            case 2:
            {
                LocI=snprintf(ResultBuffer,FreeInBuffer,msg_01_begin,Version.major,Version.minor,Version.revision);
                if(LocI>FreeInBuffer-1)
                {
                    LocI=FreeInBuffer-1;
                }
                InBuffer+=LocI;
                BufPoint+=LocI;
                FreeInBuffer-=LocI;
                LocI=snprintf(BufPoint,FreeInBuffer,msg_02_01,Params->access_count);
                if(LocI>FreeInBuffer-1)
                {
                    LocI=FreeInBuffer-1;
                }
                InBuffer+=LocI;
                BufPoint+=LocI;
                FreeInBuffer-=LocI;
                int LocI2=0;
                while(LocI2<Params->access_count)
                {
                    LocI=snprintf(BufPoint,FreeInBuffer,msg_02_02,LocI2+1,Params->access[LocI2].ip8[3],Params->access[LocI2].ip8[2],Params->access[LocI2].ip8[1],Params->access[LocI2].ip8[0],Params->access[LocI2].mask,GetBooleanStr(Params->access[LocI2].allow&allow_pds),GetBooleanStr(Params->access[LocI2].allow&allow_http));
                    if(LocI>FreeInBuffer-1)
                    {
                        LocI=FreeInBuffer-1;
                    }
                    InBuffer+=LocI;
                    BufPoint+=LocI;
                    FreeInBuffer-=LocI;
                    LocI2++;
                }
                LocI=snprintf(BufPoint,FreeInBuffer,msg_02_03);
                if(LocI>FreeInBuffer-1)
                {
                    LocI=FreeInBuffer-1;
                }
                InBuffer+=LocI;
                BufPoint+=LocI;
                FreeInBuffer-=LocI;
                LocI=snprintf(BufPoint,FreeInBuffer,msg_01_end,Version.major,Version.minor,Version.revision,compilation_date,compilation_time,Params->httpport);
                if(LocI>FreeInBuffer-1)
                {
                    LocI=FreeInBuffer-1;
                }
                InBuffer+=LocI;
                BufPoint+=LocI;
                FreeInBuffer-=LocI;
                SendHTTPResult(sockfd,Buffer,BufferSize,ResultBuffer,InBuffer,200);
                break;
            }
            case 3:
            {
                LocI=snprintf(ResultBuffer,FreeInBuffer,msg_01_begin,Version.major,Version.minor,Version.revision);
                if(LocI>FreeInBuffer-1)
                {
                    LocI=FreeInBuffer-1;
                }
                InBuffer+=LocI;
                BufPoint+=LocI;
                FreeInBuffer-=LocI;
                char * LogFile="";
                if(Params->LogName)
                  LogFile=Params->LogName;
                LocI=snprintf(BufPoint,FreeInBuffer,msg_03_01,Params->port,Params->httpport,Params->path,(char *)Params->Name,GetBooleanStr(Params->Echo),DebugLevel,Params->LogMode,LogFile);
                if(LocI>FreeInBuffer-1)
                {
                    LocI=FreeInBuffer-1;
                }
                InBuffer+=LocI;
                BufPoint+=LocI;
                FreeInBuffer-=LocI;
                LocI=snprintf(BufPoint,FreeInBuffer,msg_01_end,Version.major,Version.minor,Version.revision,compilation_date,compilation_time,Params->httpport);
                if(LocI>FreeInBuffer-1)
                {
                    LocI=FreeInBuffer-1;
                }
                InBuffer+=LocI;
                BufPoint+=LocI;
                FreeInBuffer-=LocI;
                SendHTTPResult(sockfd,Buffer,BufferSize,ResultBuffer,InBuffer,200);
                break;
            }
            case 4:
            {
                LocI=snprintf(ResultBuffer,FreeInBuffer,msg_01_begin,Version.major,Version.minor,Version.revision);
                if(LocI>FreeInBuffer-1)
                {
                    LocI=FreeInBuffer-1;
                }
                InBuffer+=LocI;
                BufPoint+=LocI;
                FreeInBuffer-=LocI;
                LocI=snprintf(BufPoint,FreeInBuffer,msg_04_01);
                if(LocI>FreeInBuffer-1)
                {
                    LocI=FreeInBuffer-1;
                }
                InBuffer+=LocI;
                BufPoint+=LocI;
                FreeInBuffer-=LocI;
                int LocI2=InBuffer;
                LocI=snprintf(BufPoint,FreeInBuffer,msg_04_02);
                if(LocI>FreeInBuffer-1)
                {
                    LocI=FreeInBuffer-1;
                }
                InBuffer+=LocI;
                BufPoint+=LocI;
                FreeInBuffer-=LocI;
                LocI=snprintf(BufPoint,FreeInBuffer,msg_01_end,Version.major,Version.minor,Version.revision,compilation_date,compilation_time,Params->httpport);
                if(LocI>FreeInBuffer-1)
                {
                    LocI=FreeInBuffer-1;
                }
                InBuffer+=LocI;
                BufPoint+=LocI;
                FreeInBuffer-=LocI;
                SendLogFile(sockfd,Buffer,BufferSize,ResultBuffer,InBuffer,LocI2,200);
                break;
            }
            case -404:
            {
                LocI=snprintf(ResultBuffer,FreeInBuffer,Err404,IDStr,Version.major,Version.minor,Version.revision,compilation_date,compilation_time,Params->httpport);
                if(LocI>FreeInBuffer-1)
                {
                    LocI=FreeInBuffer-1;
                }
                InBuffer+=LocI;
                SendHTTPResult(sockfd,Buffer,BufferSize,ResultBuffer,InBuffer,404);
                break;
            }
        }
        FreeMem(ResultBuffer);
    }
}

void HTTPAction(int sockfd,char * Buffer,int InBuffer,int BufferSize)
{
    if((InBuffer>17) // "GET  HTTP/x.y"
        &&(memcmp(Buffer,"GET ",4)==0))
    {
        char * EOL=strchr(Buffer,0x0d);
        if(EOL)
        {
            *EOL='\0';
            int delka=strlen(Buffer);
            if(delka)
            {
                char * identstr=GetMem(delka);
                if(identstr)
                {
                    memset(identstr,0,delka);
                    if(EOF!=sscanf(Buffer,"GET %s HTTP/",identstr))
                    {
                        char * Pages=(char *)HttpPages;
                        int  ActID=0;
                        int  PageID=0;
                        while(*Pages!='\0')
                        {
                            ActID++;
                            if(strcmp(identstr,Pages)==0)
                            {
                                PageID=ActID;
                                HTTPResult(sockfd,PageID,Buffer,BufferSize,identstr);
                                break;
                            }
                            Pages+=strlen(Pages)+1;
                        }
                        if(PageID==0)
                        {
                            HTTPResult(sockfd,-404,Buffer,BufferSize,identstr);
                        }
                    }
                    FreeMem(identstr);
                }
            }
        }
    }
}
