#include "ini.h"

int OpenIniFile(P_local_files * Local,char * Key,char * SubKey,char * FileName,const char * Path)
{
	int Index=-1;
	uint8_t NeedOpen=0;
	if(FindFile(Key,SubKey,FileName,filetype_Ini,&Index))
	{
		Index=_Files_Sorted[Index];
		int LocI=(*Local)->FirstOpen;
		NeedOpen=1;
		while((LocI!=-1)&&(NeedOpen))
		{
			if((*Local)->Files[LocI].Index==Index)
			{
				NeedOpen=0;
			}
			else
			{
				LocI=(*Local)->Files[LocI].NextItem;
			}
		}
	}
	else
	{
		NeedOpen=1;
	}
	if(NeedOpen)
	{
		Index=OpenFile(Local,Key,SubKey,FileName,filetype_Ini,1,0,NULL,Path);
		if(Index!=-1)
			Index=(*Local)->Files[Index].Index;
	}
	return Index;
}

int ParseIniParam(char * Params,int Size,P_char * Key,P_char * SubKey,P_char * Name,P_char * Section,P_char * IniKey,P_char * NextData)
{
	char * LocPCh=Params;
	if(Key)
		*Key=NULL;
	if(SubKey)
		*SubKey=NULL;
	if(Name)
		*Name=NULL;
	if(Section)
		*Section=NULL;
	if(IniKey)
		*IniKey=NULL;
	if(NextData)
		*NextData=NULL;
	int Result=0;
	int LocI=strlen(LocPCh);
	if((LocI<Size)&&(*LocPCh!=26))
	{
		if(Key)
			*Key=LocPCh;
		Result++;
		Size-=LocI+1;
		LocPCh+=LocI+1;
		LocI=strlen(LocPCh);
		if((LocI<Size)&&(*LocPCh!=26))
		{
			if(SubKey)
				*SubKey=LocPCh;
			Result++;
			LocPCh+=LocI+1;
			LocI=strlen(LocPCh);
			if((LocI<Size)&&(*LocPCh!=26))
			{
				if(Name)
					*Name=LocPCh;
				Result++;
				LocPCh+=LocI+1;
				LocI=strlen(LocPCh);
				if((LocI<Size)&&(*LocPCh!=26))
				{
					if(Section)
						*Section=LocPCh;
					Result++;
					LocPCh+=LocI+1;
					LocI=strlen(LocPCh);
					if((LocI<Size)&&(*LocPCh!=26))
					{
						if(IniKey)
							*IniKey=LocPCh;
						Result++;
						LocPCh+=LocI+1;
						LocI=strlen(LocPCh);
						if((LocI<Size)&&(*LocPCh!=26))
						{
							if(NextData)
								*NextData=LocPCh;
							Result++;
							LocPCh+=LocI+1;
							LocI=strlen(LocPCh);
						}
					}
				}
			}
		}
	}
	if(NextData)
	{
		if(*LocPCh==26)
		{
			LocPCh++;
			if(!*NextData)
				*NextData=LocPCh;
		}
	}
	return Result;
}

int TXTRewind(P_local_files Local,P_pds_file File)
{
	File->InTXTBuffer=0;
	File->TXTBufferPos=0;
	File->Flags&=(~0x0002);
	File->TXTFilePos=0;
	if(lseek(File->Handle,0,SEEK_SET)==0)
	{
		return 1;
	}
	else
	{
		Local->LastErrorCode=errno;
		if(!Local->LastErrorCode)
			Local->LastErrorCode=err_SeekError;
		return 0;
	}
}

int TXTReadLn(P_local_files Local,P_pds_file File,P_char * Result,int * Offset,int * Size)
{
	int LocI,LocI2;
	if(File->TXTBuffer==NULL)
	{
		File->InTXTBuffer=0;
		File->TXTBufferPos=0;
		File->Flags&=(~0x0002);
		File->TXTFilePos=0;
		File->TXTBuffer=(char *)GetMem(TXTBufferSize);
		if(File->TXTBuffer==NULL)
		{
			Local->LastErrorCode=err_LowMemory;
			return 0;
		}
	}
	if(Offset)
	{
		*Offset=File->TXTFilePos;
	}
	if(Size)
	{
		*Size=0;
	}
	if(!File->InTXTBuffer)
	{
		if((File->Flags&0x0002)!=0)
		{
			*File->TXTBuffer=0x00;
			*Result=File->TXTBuffer;
			return 2;
		}
		File->TXTFilePos=lseek(File->Handle,0,SEEK_CUR);
		if(File->TXTFilePos==-1)
		{
			Local->LastErrorCode=errno;
			Local->LastErrorCode=GetLastFileError(Local,err_SeekError);
			return 0;
		}
		LocI=read(File->Handle,File->TXTBuffer,TXTBufferSize);
		if(LocI==-1)
		{
			Local->LastErrorCode=errno;
			Local->LastErrorCode=GetLastFileError(Local,err_ReadError);
			return 0;
		}
		if(LocI!=TXTBufferSize)
			File->Flags|=0x0002;
		File->InTXTBuffer=LocI;
		File->TXTBufferPos=0;
		if(!LocI)
		{
			*File->TXTBuffer=0x00;
			*Result=File->TXTBuffer;
			return 2;
		}
	}
	char * LocCh;
	do
	{
		LocCh=File->TXTBuffer;
		LocCh+=File->TXTBufferPos;
		char * LocCh2=(char *) memchr(LocCh,'\n',File->InTXTBuffer);
		if(LocCh2==NULL)
		{
			if(LocCh!=File->TXTBuffer)
				memmove(File->TXTBuffer,LocCh,File->InTXTBuffer);
			LocI2=TXTBufferSize-File->InTXTBuffer;
			if(LocI2<=0)
			{
				Local->LastErrorCode=err_LineTooLong;
				return 0;
			}
			if((File->Flags&0x0002)!=0)
			{
				LocCh=File->TXTBuffer;
				LocCh+=File->InTXTBuffer;
				*LocCh=0x00;
				File->InTXTBuffer=0;
				*Result=File->TXTBuffer;
				return 2;
			}
			LocCh=File->TXTBuffer+File->InTXTBuffer;
			File->TXTFilePos=lseek(File->Handle,0,SEEK_CUR);
			if(File->TXTFilePos==-1)
			{
				Local->LastErrorCode=errno;
				Local->LastErrorCode=GetLastFileError(Local,err_SeekError);
				return 0;
			}
			File->TXTFilePos-=File->InTXTBuffer;
			LocI=read(File->Handle,LocCh,LocI2);
			if(LocI==-1)
			{
				Local->LastErrorCode=errno;
				Local->LastErrorCode=GetLastFileError(Local,err_ReadError);
				return 0;
			}
			if(LocI!=LocI2)
				File->Flags|=0x0002;
			File->InTXTBuffer+=LocI;
			File->TXTBufferPos=0;
			if(!File->InTXTBuffer)
			{
				*File->TXTBuffer=0x00;
				*Result=File->TXTBuffer;
				return 2;
			}
		}
		else
		{
			if(Size)
			{
				*Size=(LocCh2-LocCh)+1;
			}
			*LocCh2=0x00;
			if(LocCh2!=LocCh)
			{
				char * LocCh3=LocCh2-1;
				if(*LocCh3==0x0D)
					*LocCh3=0x00;
			}
			LocCh2++;
			LocI=(int)(LocCh2-LocCh);
			File->TXTBufferPos+=LocI;
			File->InTXTBuffer-=LocI;
			*Result=LocCh;
			if(Offset)
			{
				*Offset=File->TXTFilePos+(LocCh-File->TXTBuffer);
			}
			return 1;
		}
	} while(1);
}

int GetFromIni(P_local_files Local,int Index,const char * Section,const char * Key,char * ResultValue,unsigned short MaxResSize)
{
	int Result=0;
	*ResultValue=0x00;
	if(Index!=-1)
	{
		if((Index>=0)&&(Index<MaxFiles))
		{
			P_pds_file File=&_Files->Files[Index];
			if(File->Handle!=-1)
			{
				fileID fID={File->Random,File->FileGen,(uint32_t)Index};
				if(AppropriateFile(Local,fID,filetype_Ini,0))
				{
					if(TXTRewind(Local,File))
					{
						int LocI=1;
						int LocI2;
						char * LocCh;
						char * LocCh2;
						char * LocCh3;
						int KeySize=strlen(Key);
						int SectionSize=strlen(Section);
						uint8_t InSection=0;
						while((!Result)&&(LocI==1))
						{
							LocI=TXTReadLn(Local,File,&LocCh,NULL,NULL);
							if(LocI)
							{
								if(InSection)
								{
									if(*LocCh=='[')
									{
										LocI=2;Result=1;
									}
									else
									{
										while(*LocCh==' ')
										{
											LocCh++;
										};
										LocCh2=strchr(LocCh,'=');
										if(LocCh2!=NULL)
										{
											LocCh3=LocCh2+1;
											do
											{
												LocCh2--;
											} while((LocCh2>LocCh)&&(*LocCh2==' '));
											LocI2=(int)(LocCh2-LocCh)+1;
											if(LocI2==KeySize)
											{
												if(strncasecmp1250(LocCh,Key,LocI2)==0)
												{
													Result=1;
													LocI=strlen(LocCh3);
													if(LocI>0)
													{
														if(LocI>=MaxResSize)
														{
															LocI=MaxResSize-1;
														}
														memcpy(ResultValue,LocCh3,LocI);
													}
													LocCh3=ResultValue+LocI;
													*LocCh3=0x00;
												}
											}
										}
									}
								}
								else
								{
									if(*LocCh=='[')
									{
										do
										{
											LocCh++;
										} while(*LocCh==' ');
										LocCh2=strchr(LocCh,']');
										if(LocCh2!=NULL)
										{
											do
											{
												LocCh2--;
											} while((LocCh2>LocCh)&&(*LocCh2==' '));
											LocI2=(int)(LocCh2-LocCh)+1;
											if(LocI2==SectionSize)
											{
												if(strncasecmp1250(LocCh,Section,LocI2)==0)
												{
													InSection=1;
												}
											}
										}
									}
								}
							}
						}
						if((!Result)&&(LocI==2))
						{
							*ResultValue=0x00;
							Result=1;
						}
					}
					else
					{
						Local->LastErrorCode=GetLastFileError(Local,err_ReadError);
					}
					UnAppropriateFile(fID);
				}
				else
				{
					Local->LastErrorCode=GetLastFileError(Local,err_Appropriation);
				}
			}
			else
			{
				Local->LastErrorCode=err_NotOpen;
			}
		}
		else
		{
			Local->LastErrorCode=err_BadDescriptor;
		}
	}
	else
	{
		Local->LastErrorCode=err_NotOpen;
	}
	return Result;
}

int ExistInIni(P_local_files Local,int Index,const char * Section,const char * Key,uint8_t * ResultValue)
{
	int Result=0;
	*ResultValue=0;
	if(Index!=-1)
	{
		if((Index>=0)&&(Index<MaxFiles))
		{
			P_pds_file File=&_Files->Files[Index];
			if(File->Handle!=-1)
			{
				fileID fID={File->Random,File->FileGen,(uint32_t)Index};
				if(AppropriateFile(Local,fID,filetype_Ini,0))
				{
					if(TXTRewind(Local,File))
					{
						int LocI=1;
						int LocI2;
						char * LocCh;
						char * LocCh2;
						int KeySize=strlen(Key);
						int SectionSize=strlen(Section);
						uint8_t InSection=0;
						while((!Result)&&(LocI==1))
						{
							LocI=TXTReadLn(Local,File,&LocCh,NULL,NULL);
							if(LocI)
							{
								if(InSection)
								{
									if(*LocCh=='[')
									{
										LocI=2;Result=1;
									}
									else
									{
										while(*LocCh==' ')
										{
											LocCh++;
										};
										LocCh2=strchr(LocCh,'=');
										if(LocCh2!=NULL)
										{
											do
											{
												LocCh2--;
											} while((LocCh2>LocCh)&&(*LocCh==' '));
											LocI2=(int)(LocCh2-LocCh)+1;
											if(LocI2==KeySize)
											{
												if(strncasecmp1250(LocCh,Key,LocI2)==0)
												{
													*ResultValue=1;
													Result=1;
												}
											}
										}
									}
								}
								else
								{
									if(*LocCh=='[')
									{
										do
										{
											LocCh++;
										} while(*LocCh==' ');
										LocCh2=strchr(LocCh,']');
										if(LocCh2!=NULL)
										{
											do
											{
												LocCh2--;
											} while((LocCh2>LocCh)&&(*LocCh==' '));
											LocI2=(int)(LocCh2-LocCh)+1;
											if(LocI2==SectionSize)
											{
												if(strncasecmp1250(LocCh,Section,LocI2)==0)
												{
													InSection=1;
												}
											}
										}
									}
								}
							}
						}
						if(LocI==2)
							Result=1;
					}
					else
					{
						Local->LastErrorCode=GetLastFileError(Local,err_ReadError);
					}
					UnAppropriateFile(fID);
				}
				else
				{
					Local->LastErrorCode=GetLastFileError(Local,err_Appropriation);
				}
			}
			else
			{
				Local->LastErrorCode=err_NotOpen;
			}
		}
		else
		{
			Local->LastErrorCode=err_BadDescriptor;
		}
	}
	else
	{
		Local->LastErrorCode=err_NotOpen;
	}
	return Result;
}

int GetIniSections(P_local_files Local,int Index,char * ResultValue,unsigned short MaxResSize)
{
	int Result=-1;
	*ResultValue=0x00;
	if(Index!=-1)
	{
		if((Index>=0)&&(Index<MaxFiles))
		{
			P_pds_file File=&_Files->Files[Index];
			if(File->Handle!=-1)
			{
				fileID fID={File->Random,File->FileGen,(uint32_t)Index};
				if(AppropriateFile(Local,fID,filetype_Ini,0))
				{
					if(TXTRewind(Local,File))
					{
						int LocI=1;
						int LocI2;
						char * ActResPos=ResultValue;
						int ActResSize=0;
						char * LocCh;
						char * LocCh2;
						while(LocI==1)
						{
							LocI=TXTReadLn(Local,File,&LocCh,NULL,NULL);
							if(LocI)
							{
								if(*LocCh=='[')
								{
									do
									{
										LocCh++;
									} while(*LocCh==' ');
									LocCh2=strchr(LocCh,']');
									if(LocCh2!=NULL)
									{
										do
										{
											LocCh2--;
										} while((LocCh2>LocCh)&&(*LocCh==' '));
										LocI2=(int)(LocCh2-LocCh)+1;
										if(LocI2)
										{
											if(LocI2+2<=MaxResSize)
											{
												memcpy(ActResPos,LocCh,LocI2);
												ActResPos+=LocI2;
												*ActResPos=0x00;
												ActResPos++;
												LocI2++;
												MaxResSize-=LocI2;
												ActResSize+=LocI2;
											}
										}
									}
								}
							}
						}
						if(LocI==2)
						{
							MaxResSize--;
							ActResSize++;
							*ActResPos=0x00;
							Result=ActResSize;
						}
					}
					else
					{
						Local->LastErrorCode=GetLastFileError(Local,err_ReadError);
					}
					UnAppropriateFile(fID);
				}
				else
				{
					Local->LastErrorCode=GetLastFileError(Local,err_Appropriation);
				}
			}
			else
			{
				Local->LastErrorCode=err_NotOpen;
			}
		}
		else
		{
			Local->LastErrorCode=err_BadDescriptor;
		}
	}
	else
	{
		Local->LastErrorCode=err_NotOpen;
	}
	return Result;
}

int GetIniKeys(P_local_files Local,int Index,const char * Section,char * ResultValue,unsigned short MaxResSize)
{
	int Result=-1;
	*ResultValue=0x00;
	if(Index!=-1)
	{
		if((Index>=0)&&(Index<MaxFiles))
		{
			P_pds_file File=&_Files->Files[Index];
			if(File->Handle!=-1)
			{
				fileID fID={File->Random,File->FileGen,(uint32_t)Index};
				if(AppropriateFile(Local,fID,filetype_Ini,0))
				{
					if(TXTRewind(Local,File))
					{
						int LocI=1;
						int LocI2;
						char * ActResPos=ResultValue;
						int ActResSize=0;
						char * LocCh;
						char * LocCh2;
						int SectionSize=strlen(Section);
						uint8_t InSection=0;
						while(LocI==1)
						{
							LocI=TXTReadLn(Local,File,&LocCh,NULL,NULL);
							if(LocI)
							{
								if(InSection)
								{
									if(*LocCh=='[')
									{
										LocI=2;
									}
									else
									{
										while(*LocCh==' ')
										{
											LocCh++;
										};
										LocCh2=strchr(LocCh,'=');
										if(LocCh2!=NULL)
										{
											do
											{
												LocCh2--;
											} while((LocCh2>LocCh)&&(*LocCh==' '));
											LocI2=(int)(LocCh2-LocCh)+1;
											if(LocI2+2<=MaxResSize)
											{
												memcpy(ActResPos,LocCh,LocI2);
												ActResPos+=LocI2;
												*ActResPos=0x00;
												ActResPos++;
												LocI2++;
												MaxResSize-=LocI2;
												ActResSize+=LocI2;
											}
										}
									}
								}
								else
								{
									if(*LocCh=='[')
									{
										do
										{
											LocCh++;
										} while(*LocCh==' ');
										LocCh2=strchr(LocCh,']');
										if(LocCh2!=NULL)
										{
											do
											{
												LocCh2--;
											} while((LocCh2>LocCh)&&(*LocCh==' '));
											LocI2=(int)(LocCh2-LocCh)+1;
											if(LocI2==SectionSize)
											{
												if(strncasecmp1250(LocCh,Section,LocI2)==0)
												{
													InSection=1;
												}
											}
										}
									}
								}
							}
						}
						if(LocI==2)
						{
							MaxResSize--;
							ActResSize++;
							*ActResPos=0x00;
							Result=ActResSize;
						}
					}
					else
					{
						Local->LastErrorCode=GetLastFileError(Local,err_ReadError);
					}
					UnAppropriateFile(fID);
				}
				else
				{
					Local->LastErrorCode=GetLastFileError(Local,err_Appropriation);
				}
			}
			else
			{
				Local->LastErrorCode=err_NotOpen;
			}
		}
		else
		{
			Local->LastErrorCode=err_BadDescriptor;
		}
	}
	else
	{
		Local->LastErrorCode=err_NotOpen;
	}
	return Result;
}


int DistendFile(P_local_files Local,int Handle,int Offset,int Distend)
{
	int LocI=lseek(Handle,0,SEEK_END);
	if(LocI==-1)
	{
		Local->LastErrorCode=errno;
		Local->LastErrorCode=GetLastFileError(Local,err_SeekError);
		return 0;
	}
	int LocI2=LocI-Offset;
	int LocI3=LocI2;
	if(LocI2>CopyBufferSize)
	{
		LocI3=CopyBufferSize;
	}
	else
	if(LocI2<=0)
	{
		return 1;
	}
	char * Buffer=(char *)GetMem(LocI3);
	if(!Buffer)
	{
		Local->LastErrorCode=err_LowMemory;
		return 0;
	}
	int Src=LocI-LocI3;
	int Dst=Src+Distend;
	int LocI4;
	while(LocI3)
	{
		if(lseek(Handle,Src,SEEK_SET)!=Src)
		{
			Local->LastErrorCode=errno;
			Local->LastErrorCode=GetLastFileError(Local,err_SeekError);
			FreeMem(Buffer);
			return 0;
		}
		if(read(Handle,Buffer,LocI3)!=LocI3)
		{
			Local->LastErrorCode=errno;
			Local->LastErrorCode=GetLastFileError(Local,err_ReadError);
			FreeMem(Buffer);
			return 0;
		}
		if(lseek(Handle,Dst,SEEK_SET)!=Dst)
		{
			Local->LastErrorCode=errno;
			Local->LastErrorCode=GetLastFileError(Local,err_SeekError);
			FreeMem(Buffer);
			return 0;
		}
		if(write(Handle,Buffer,LocI3)!=LocI3)
		{
			Local->LastErrorCode=errno;
			Local->LastErrorCode=GetLastFileError(Local,err_WriteError);
			FreeMem(Buffer);
			return 0;
		}
		Src-=LocI3;
		Dst-=LocI3;
		if(Src<Offset)
		{
			LocI4=Offset-Src;
			LocI3-=LocI4;
			Src+=LocI4;
			Dst+=LocI4;
		}
	}
	FreeMem(Buffer);
	return 1;
}

int DeflateFile(P_local_files Local,int Handle,int Offset,int Deflate)
{
	int LocI=lseek(Handle,0,SEEK_END);
	if(LocI==-1)
	{
		Local->LastErrorCode=errno;
		Local->LastErrorCode=GetLastFileError(Local,err_SeekError);
		return 0;
	}
	int LocI2=LocI-Offset;
	int LocI3=LocI2;
	int Dst=Offset-Deflate;
	if(LocI2>CopyBufferSize)
	{
		LocI3=CopyBufferSize;
	}
	else
	if(LocI2<0)
	{
		return 1;
	}
	if(LocI2==0)
	{
	}
	else
	{
		char * Buffer=(char *)GetMem(LocI3);
		if(!Buffer)
		{
			Local->LastErrorCode=err_LowMemory;
			return 0;
		}
		int Src=Offset;
		int LocI4;
		while(LocI2>0)
		{
			if(lseek(Handle,Src,SEEK_SET)!=Src)
			{
				Local->LastErrorCode=errno;
				Local->LastErrorCode=GetLastFileError(Local,err_SeekError);
				FreeMem(Buffer);
				return 0;
			}
			LocI4=LocI2;
			if(LocI4>LocI3)
				LocI4=LocI3;
			if(read(Handle,Buffer,LocI4)!=LocI4)
			{
				Local->LastErrorCode=errno;
				Local->LastErrorCode=GetLastFileError(Local,err_ReadError);
				FreeMem(Buffer);
				return 0;
			}
			if(lseek(Handle,Dst,SEEK_SET)!=Dst)
			{
				Local->LastErrorCode=errno;
				Local->LastErrorCode=GetLastFileError(Local,err_SeekError);
				FreeMem(Buffer);
				return 0;
			}
			if(write(Handle,Buffer,LocI4)!=LocI4)
			{
				Local->LastErrorCode=errno;
				Local->LastErrorCode=GetLastFileError(Local,err_WriteError);
				FreeMem(Buffer);
				return 0;
			}
			LocI2-=LocI4;
			Src+=LocI4;
			Dst+=LocI4;
		}
		FreeMem(Buffer);
	}
	if(ftruncate(Handle,Dst)==-1)
	{
		Local->LastErrorCode=errno;
		Local->LastErrorCode=GetLastFileError(Local,err_WriteError);
		return 0;
	}
	return 1;
}

int WriteSection(P_local_files Local,int Handle,const char * Section,int * Position)
{
	int Result=0;
	int LocI=strlen(Section);
	char * WriteBuffer=(char *)GetMem(LocI+6);
	if(WriteBuffer)
	{
		char * LocCh=WriteBuffer;
		memcpy(LocCh,"\r\n[",3);
		LocCh+=3;
		memcpy(LocCh,Section,LocI);
		LocCh+=LocI;
		memcpy(LocCh,"]\r\n",3);
		LocI+=6;
		if(write(Handle,WriteBuffer,LocI)==LocI)
		{
			if(Position)
			{
				LocI=lseek(Handle,0,SEEK_END);
				if(LocI==-1)
				{
					Local->LastErrorCode=errno;
					Local->LastErrorCode=GetLastFileError(Local,err_SeekError);
				}
				else
				{
					*Position=LocI;
					Result=1;
				}
			}
			else
				Result=1;
		}
		else
		{
			Local->LastErrorCode=errno;
			Local->LastErrorCode=GetLastFileError(Local,err_WriteError);
		}
		FreeMem(WriteBuffer);
	}
	return Result;
}

int WriteIniData(P_local_files Local,int Handle,int Position,const char * Key,const char * Value)
{
	int Result=0;
	if(lseek(Handle,Position,SEEK_SET)==Position)
	{
		char * WriteBuffer=(char *)GetMem(strlen(Key)+1+strlen(Value)+2);
		if(WriteBuffer)
		{
			char * LocCh=WriteBuffer;
			int LocI=strlen(Key);
			if(Key)
			{
				memcpy(LocCh,Key,LocI);
				LocCh+=LocI;
			}
			*LocCh='=';
			LocCh++;
			LocI=strlen(Value);
			if(LocI)
			{
				memcpy(LocCh,Value,LocI);
				LocCh+=LocI;
			}
			*LocCh=0x0d;
			LocCh++;
			*LocCh=0x0a;
			LocCh++;
			LocI=LocCh-WriteBuffer;
			if(write(Handle,WriteBuffer,LocI)==LocI)
			{
				Result=1;
			}
			else
			{
				Local->LastErrorCode=errno;
				Local->LastErrorCode=GetLastFileError(Local,err_WriteError);
			}
			FreeMem(WriteBuffer);
		}
	}
	else
	{
		Local->LastErrorCode=errno;
		Local->LastErrorCode=GetLastFileError(Local,err_SeekError);
	}
	return Result;
}

int SetToIni(P_local_files Local,int Index,const char * Section,const char * Key,const char * Value)
{
	int Result=0;
	int KeySize=strlen(Key);
	int ValueSize=strlen(Value);
	int LineSize=KeySize+1+ValueSize+2;
	int SectionSize=strlen(Section);
	if(Index!=-1)
	{
		if((Index>=0)&&(Index<MaxFiles))
		{
			P_pds_file File=&_Files->Files[Index];
			if(File->Handle!=-1)
			{
				fileID fID={File->Random,File->FileGen,(uint32_t)Index};
				if(AppropriateFile(Local,fID,filetype_Ini,0))
				{
					if(TXTRewind(Local,File))
					{
						int LocI=1;
						int LocI2;
						char * LocCh;
						char * LocCh2;
						int Position;
						int Size;
						uint8_t InSection=0;
						while((!Result)&&(LocI==1))
						{
							LocI=TXTReadLn(Local,File,&LocCh,&Position,&Size);
							if(LocI)
							{
								if(InSection)
								{
									if(*LocCh=='[')
									{
										LocI=0;
										if(DistendFile(Local,File->Handle,Position,LineSize))
										{
											if(WriteIniData(Local,File->Handle,Position,Key,Value))
											{
												Result=1;
											}
										}
									}
									else
									{
										while(*LocCh==' ')
										{
											LocCh++;
										};
										LocCh2=strchr(LocCh,'=');
										if(LocCh2!=NULL)
										{
											do
											{
												LocCh2--;
											} while((LocCh2>LocCh)&&(*LocCh==' '));
											LocI2=(int)(LocCh2-LocCh)+1;
											if(LocI2==KeySize)
											{
												if(strncasecmp1250(LocCh,Key,LocI2)==0)
												{
													LocI=0;
													LocI2=LineSize-Size;
													if(LocI2>0)
													{
														LocI2=DistendFile(Local,File->Handle,Position+LineSize-LocI2,LocI2);
													}
													else
													{
														LocI2=abs(LocI2);
														LocI2=DeflateFile(Local,File->Handle,Position+LineSize+LocI2,LocI2);
													}
													if(LocI2)
													{
														if(WriteIniData(Local,File->Handle,Position,Key,Value))
														{
															Result=1;
														}
													}
												}
											}
										}
									}
								}
								else
								{
									if(*LocCh=='[')
									{
										do
										{
											LocCh++;
										} while(*LocCh==' ');
										LocCh2=strchr(LocCh,']');
										if(LocCh2!=NULL)
										{
											do
											{
												LocCh2--;
											} while((LocCh2>LocCh)&&(*LocCh==' '));
											LocI2=(int)(LocCh2-LocCh)+1;
											if(LocI2==SectionSize)
											{
												if(strncasecmp1250(LocCh,Section,LocI2)==0)
												{
													InSection=1;
												}
											}
										}
									}
								}
							}
						}
						if((LocI==2)&&(!Result))
						{
							if((Position=lseek(File->Handle,0,SEEK_END))!=-1)
							{
								if(!InSection)
								{
									if(WriteSection(Local,File->Handle,Section,&Position))
									{
										if(WriteIniData(Local,File->Handle,Position,Key,Value))
										{
											Result=1;
										}
									}
								}
								else
								if(WriteIniData(Local,File->Handle,Position,Key,Value))
								{
									Result=1;
								}
							}
							else
							{
								Local->LastErrorCode=errno;
								Local->LastErrorCode=GetLastFileError(Local,err_SeekError);
							}
						}
					}
					else
					{
						Local->LastErrorCode=GetLastFileError(Local,err_ReadError);
					}
					UnAppropriateFile(fID);
				}
				else
				{
					Local->LastErrorCode=GetLastFileError(Local,err_Appropriation);
				}
			}
			else
			{
				Local->LastErrorCode=err_NotOpen;
			}
		}
		else
		{
			Local->LastErrorCode=err_BadDescriptor;
		}
	}
	else
	{
		Local->LastErrorCode=err_NotOpen;
	}
	return Result;
}

int DeleteIniKey(P_local_files Local,int Index,const char * Section,const char * Key)
{
	int Result=0;
	if(Index!=-1)
	{
		if((Index>=0)&&(Index<MaxFiles))
		{
			P_pds_file File=&_Files->Files[Index];
			if(File->Handle!=-1)
			{
				fileID fID={File->Random,File->FileGen,(uint32_t)Index};
				if(AppropriateFile(Local,fID,filetype_Ini,0))
				{
					if(TXTRewind(Local,File))
					{
						int LocI=1;
						int LocI2;
						char * LocCh;
						char * LocCh2;
						int KeySize=strlen(Key);
						int SectionSize=strlen(Section);
						int Position;
						int Size;
						uint8_t InSection=0;
						while((!Result)&&(LocI==1))
						{
							LocI=TXTReadLn(Local,File,&LocCh,&Position,&Size);
							if(LocI)
							{
								if(InSection)
								{
									if(*LocCh=='[')
									{
										Result=1;
									}
									else
									{
										while(*LocCh==' ')
										{
											LocCh++;
										};
										LocCh2=strchr(LocCh,'=');
										if(LocCh2!=NULL)
										{
											do
											{
												LocCh2--;
											} while((LocCh2>LocCh)&&(*LocCh==' '));
											LocI2=(int)(LocCh2-LocCh)+1;
											if(LocI2==KeySize)
											{
												if(strncasecmp1250(LocCh,Key,LocI2)==0)
												{
													if(DeflateFile(Local,File->Handle,Position+Size,Size))
													{
														Result=1;
													}
												}
											}
										}
									}
								}
								else
								{
									if(*LocCh=='[')
									{
										do
										{
											LocCh++;
										} while(*LocCh==' ');
										LocCh2=strchr(LocCh,']');
										if(LocCh2!=NULL)
										{
											do
											{
												LocCh2--;
											} while((LocCh2>LocCh)&&(*LocCh==' '));
											LocI2=(int)(LocCh2-LocCh)+1;
											if(LocI2==SectionSize)
											{
												if(strncasecmp1250(LocCh,Section,LocI2)==0)
												{
													InSection=1;
												}
											}
										}
									}
								}
							}
						}
						if(LocI==2)
						{
							Result=1;
						}
					}
					else
					{
						Local->LastErrorCode=GetLastFileError(Local,err_ReadError);
					}
					UnAppropriateFile(fID);
				}
				else
				{
					Local->LastErrorCode=GetLastFileError(Local,err_Appropriation);
				}
			}
			else
			{
				Local->LastErrorCode=err_NotOpen;
			}
		}
		else
		{
			Local->LastErrorCode=err_BadDescriptor;
		}
	}
	else
	{
		Local->LastErrorCode=err_NotOpen;
	}
	return Result;
}

int DeleteIniSection(P_local_files Local,int Index,const char * Section)
{
	int Result=0;
	if(Index!=-1)
	{
		if((Index>=0)&&(Index<MaxFiles))
		{
			P_pds_file File=&_Files->Files[Index];
			if(File->Handle!=-1)
			{
				fileID fID={File->Random,File->FileGen,(uint32_t)Index};
				if(AppropriateFile(Local,fID,filetype_Ini,0))
				{
					if(TXTRewind(Local,File))
					{
						int LocI=1;
						int LocI2;
						char * LocCh;
						char * LocCh2;
						int SectionSize=strlen(Section);
						int Position;
						int Size;
						int DeletionPos=-1;
						uint8_t InSection=0;
						while((!Result)&&(LocI==1))
						{
							LocI=TXTReadLn(Local,File,&LocCh,&Position,&Size);
							if(LocI)
							{
								if(InSection)
								{
									if(*LocCh=='[')
									{
										Size=Position-DeletionPos;
										if(DeflateFile(Local,File->Handle,Position,Size))
										{
											Result=1;
										}
									}
								}
								else
								{
									if(*LocCh=='[')
									{
										do
										{
											LocCh++;
										} while(*LocCh==' ');
										LocCh2=strchr(LocCh,']');
										if(LocCh2!=NULL)
										{
											do
											{
												LocCh2--;
											} while((LocCh2>LocCh)&&(*LocCh==' '));
											LocI2=(int)(LocCh2-LocCh)+1;
											if(LocI2==SectionSize)
											{
												if(strncasecmp1250(LocCh,Section,LocI2)==0)
												{
													InSection=1;
													DeletionPos=Position;
												}
											}
										}
									}
								}
							}
						}
						if((LocI==2)&&(!Result))
						{
							if(DeletionPos>=0)
							{
								LocI=lseek(File->Handle,0,SEEK_END);
								if(LocI!=-1)
								{
									if(DeflateFile(Local,File->Handle,LocI,LocI-DeletionPos))
										{
											Result=1;
										}
								}
								else
								{
									Local->LastErrorCode=errno;
									Local->LastErrorCode=GetLastFileError(Local,err_SeekError);
								}
							}
							else
								Result=1;
						}
					}
					else
					{
						Local->LastErrorCode=GetLastFileError(Local,err_ReadError);
					}
					UnAppropriateFile(fID);
				}
				else
				{
					Local->LastErrorCode=GetLastFileError(Local,err_Appropriation);
				}
			}
			else
			{
				Local->LastErrorCode=err_NotOpen;
			}
		}
		else
		{
			Local->LastErrorCode=err_BadDescriptor;
		}
	}
	else
	{
		Local->LastErrorCode=err_NotOpen;
	}
	return Result;
}
