#ifndef ini_h
	#define ini_h

#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "semaphores.h"
#include "errcodes.h"
#include "win1250.h"
#include "files.h"

typedef char * P_char;

int OpenIniFile(P_local_files * Local,char * Key,char * SubKey,char * FileName,const char * Path);
int ParseIniParam(char * Params,int Size,P_char * Key,P_char * SubKey,P_char * Name,P_char * Section,P_char * IniKey,P_char * NextData);
int TXTRewind(P_local_files Local,P_pds_file File);
int TXTReadLn(P_local_files Local,P_pds_file File,P_char * Result,int * Offset,int * Size);
int GetFromIni(P_local_files Local,int Index,const char * Section,const char * Key,char * ResultValue,unsigned short MaxResSize);
int ExistInIni(P_local_files Local,int Index,const char * Section,const char * Key,uint8_t * ResultValue);
int GetIniSections(P_local_files Local,int Index,char * ResultValue,unsigned short MaxResSize);
int GetIniKeys(P_local_files Local,int Index,const char * Section,char * ResultValue,unsigned short MaxResSize);
int DistendFile(P_local_files Local,int Handle,int Offset,int Distend);
int DeflateFile(P_local_files Local,int Handle,int Offset,int Deflate);
int WriteSection(P_local_files Local,int Handle,const char * Section,int * Position);
int WriteIniData(P_local_files Local,int Handle,int Position,const char * Key,const char * Value);
int SetToIni(P_local_files Local,int Index,const char * Section,const char * Key,const char * Value);
int DeleteIniKey(P_local_files Local,int Index,const char * Section,const char * Key);
int DeleteIniSection(P_local_files Local,int Index,const char * Section);

#endif
