#ifndef filer_h
	#define filer_h

#include <stdint.h>
#include "messages.h"

#define MaxNrOfKeys 				16
#define CreatePageSize				62
#define MaxPageSize					62 // nesmi byt vetsi nez 255
#define MaxHeight					7
#define MaxRefListSize				3*(MaxHeight+1)
//#define SearchForSequentialDefault	1;

#pragma pack(push,1)

typedef struct IsamSmallInfoRec IsamSmallInfoRec,*P_IsamSmallInfoRec;

typedef struct DWord DWord,P_DWord;

struct DWord {
	unsigned short Lo,Hi;
};

struct IsamSmallInfoRec {
	int 					FirstFree;
	int 					NumberFree;
	int 					NumRec;
	int 					LenRec;
	union {
    	struct {
			unsigned short	NrOfKeys;
    		unsigned short	Dummy;
		};
		int					Gener5;
	};
	unsigned char			ADK;
} __attribute__((packed));

typedef struct IsamInfoRec IsamInfoRec,*P_IsamInfoRec;

struct IsamInfoRec {
	struct IsamSmallInfoRec	InfoRec;
	char					DummyFill;
	int						KeysUsed;
	unsigned short			PageSizeUsed;
	unsigned short			CodePage;
	unsigned short			ActualIndexVersion;
} __attribute__((packed));

typedef struct IsamSearchStep IsamSearchStep,*IsamSearchStepPtr;

struct IsamSearchStep {
	int				PageRef;
	uint8_t			ItemArrInd;
} __attribute__((packed));

typedef struct IsamDatIndDescr IsamDatIndDescr,*IsamDatIndDescrPtr;

struct IsamDatIndDescr {
	int				NumKeys;
	int				FirstFree;
	int				NumberFree;
	int				NumRec;
	int				LenRec;
	int				RootRef;
	int				Invalidator;
	unsigned short	UsedPageSize;
	uint8_t			AllowDupKeys;
//	uint8_t			InfoRecChanged;
	uint8_t			IRChangedSaveN;
//	uint8_t			FirstFreeChanged;
//	uint8_t			SearchForSequentialEnabled;
//	uint8_t			_SequentialOK;
	uint8_t			KeyLen;
	int				BlockOfs;
//	IsamSearchStep	_IsamPath[MaxHeight-1];
//	uint8_t			_PathInd;
	uint8_t			XlatKeys;
	unsigned short	KeyCodePage;
	unsigned short	KeyVersion;
} __attribute__((packed));

typedef struct IsamItem IsamItem,*IsamItemPtr;

struct IsamItem {
	int			DataRef;
	int			PageRef;
	IsamKeyStr	KeyStr;
};

typedef struct IsamPage IsamPage,*IsamPagePtr;

struct IsamPage {
	unsigned short	ItemsOnPage;
	int				BckwPageRef;
	IsamItem		ItemArray[MaxPageSize];
} __attribute__((packed));

typedef struct PreloadHeader PreloadHeader,*P_PreloadHeader;

struct PreloadHeader {
	uint16_t		PreloadSize;
	uint16_t        PreloadRecLen;
    uint16_t        PreloadCounter;
    uint16_t        PreloadResult;
} __attribute__((packed));

#pragma pack(pop)

#endif
