#ifndef filer_proc_h
	#define filer_proc_h

#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>

#include "errcodes.h"
#include "filer.h"
#include "files.h"

extern int KeyNr;

void PrintKey(IsamKeyStr * Key);
void CopyKeyStr(IsamKeyStr * ToKey,const IsamKeyStr * FromKey);
int CmpKeyStr(const IsamKeyStr& Key1,const IsamKeyStr& Key2);
IsamPagePtr GetIsamPagePtrFromBuffer(P_page_buffer PageBuffer);
P_page_buffer GetPageBufferFromIsamPagePtr(IsamPagePtr IPP);
void IsamUnPack(IsamPagePtr Page, unsigned short KeyL);
void IsamPack(IsamPagePtr Page, unsigned short KeyL);
int IsamGetPage(P_local_file File,int PRef,unsigned short Key,IsamPagePtr * IPgPtr);
int IsamWritePage(P_local_file File,P_page_buffer PageBuffer);
void XTrans(IsamKeyStr * s);
int IsamCompKeys(struct IsamKeyStr Key1,struct IsamKeyStr Key2,int DatRef1,int DatRef2,uint8_t Dup,uint8_t XLat);
void ValidateIndex(P_local_file File,unsigned short Key);
int IsValidIndex(P_local_file File,unsigned short Key);
int IsamClearKey(P_local_file File,unsigned short Key);
int _IsamFindKey(P_local_file File,unsigned short Key,int * UserDatRef,IsamKeyStr * UserKey);
int IsamFindKey(P_local_file File,unsigned short Key,int * UserDatRef,IsamKeyStr * UserKey);
int IsamNextKey(P_local_file File,unsigned short Key,int * UserDatRef,IsamKeyStr * UserKey);
int IsamNextDiffKey(P_local_file File,unsigned short Key,int * UserDatRef,IsamKeyStr * UserKey);
int IsamFindKeyAndRef(P_local_file File,unsigned short Key,int * UserDatRef,IsamKeyStr * UserKey,short NotFoundSearchDirection);
int IsamPrevKey(P_local_file File,unsigned short Key,int * UserDatRef,IsamKeyStr * UserKey);
int IsamPrevDiffKey(P_local_file File,unsigned short Key,int * UserDatRef,IsamKeyStr * UserKey);
int IsamSearchKey(P_local_file File,unsigned short Key,int * UserDatRef,IsamKeyStr * UserKey);
int IsamSearchKeyAndRef(P_local_file File,unsigned short Key,int * UserDatRef,IsamKeyStr * UserKey);
int IsamGetBlock(P_local_files Local,int Handle,int Offset,unsigned short int Length,void * Dest);
int IsamNewRec(P_local_file File,int * RefNr,unsigned short Ind);
int IsamAddRec(P_local_file File,int * RefNr,void * Source);
int IsamPutRec(P_local_file File,int RefNr,void * Source);
int IsamUpdatePage(P_local_file File,IsamPagePtr PgPtr);
int IsamNewPage(P_local_file File,int * PRef,IsamPagePtr * IPgPtr,unsigned short Key);
int IsamAddKey(P_local_file File,unsigned short Key,int UserDatRef,IsamKeyStr * UserKey);
int IsamGetApprRelPos(P_local_file File,unsigned short Key,unsigned short * RelPos,unsigned short Scale,IsamKeyStr * UserKey,int UserDatRef);
int IsamGetApprKeyAndRef(P_local_file File,unsigned short Key,unsigned short RelPos,unsigned short Scale,IsamKeyStr * UserKey,int * UserDatRef);
int IsamDeleteRecOrPage(P_local_file File,int RefNr,unsigned short Ind);
int IsamReturnPage(P_local_file File,IsamPagePtr PgPtr);
int IsamDeleteKey(P_local_file File,unsigned short Key,int UserDatRef,IsamKeyStr * UserKey);
int IsamDeleteRec(P_local_file File,int RefNr);
int KeyExists(P_local_file File,unsigned short Key,int UserDatRef,IsamKeyStr * UserKey,uint8_t * Result);

#endif
