#include "files.h"

int MaxFiles=init_MaxFilesServer;
char pdsDir[]="~/pds/";
char LogName[]="pds.log";
char DefaultKey[]="defaultkey"; // mel by byt vzdy delsi nez 8 znaku, at nekoliduje s pripadnym SubKey
char datExtension[]=".dat";	// pozor !!! delka datExtension a inxExtension musi byt vzdy shodna
char inxExtension[]=".inx";
char backupExtension[]=".bak";
char tmpExtension[]=".tmp";
char savExtension[]=".sav";
char ConfName[]="/etc/pds/pds.conf";
char PassFileName[]=".password";
char pdsID[]="PDS:";
uint8_t LockSegLevel=0;
time_t start_time=0;
uint8_t CheckIntegrity=0;

#ifdef __linux__
mode_t NewFileMode=S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH;
#elif defined(_WIN32) || defined(_WIN64)
mode_t NewFileMode=S_IRUSR|S_IWUSR;
#endif

int * _Files_Sorted;

pds_files * _Files;
//*int			shm_Files=0;
//*int			shm_Files_Sorted=0;
int         PreloadSize=DefaultPreloadSize;
int         PreloadEnabled=1;

int			_FilesSize;
int			SortedSize;

fileID NullFileID={0,0,0};

void ClearPdsFile(pds_file * pds)
{
	memset(pds,0,sizeof(pds_file));
	pds->Approp=-1;
	pds->Expectant=-1;
	pds->Handle=-1;
	pds->InxHandle=-1;
}

int GetLastFileError(P_local_files Local,int AltError)
{
	int Return=Local->LastErrorCode;
	if(!Return)
		Return=AltError;
	Local->LastErrorCode=0;
	return Return;
}

void SetLastFileError(P_local_files Local,int ErrNum,int AltError)
{
	if((Local->LastErrorCode=ErrNum)==0)
        Local->LastErrorCode=AltError;
}

int InitFiles(int Mode)
{
    if(_Files!=NULL)
        return 0;
    int MaxFiles=init_MaxFilesServer;
    if(Mode==mode_Client)
    {
        MaxFiles=init_MaxFilesClient;
    }
	_FilesSize=sizeof(pds_files)+sizeof(pds_file)*MaxFiles;
	/*
	shm_Files=shmget(IPC_PRIVATE,_FilesSize,IPC_CREAT|0600);
	if(shm_Files==-1)
		return 0;
	_Files=(pds_files*)shmat(shm_Files,NULL,0);
	if((_Files==NULL)||(_Files==(void *)-1))
		return 0;
	memset(_Files,0,_FilesSize);
	SortedSize=sizeof(int)*MaxFiles;
	shm_Files_Sorted=shmget(IPC_PRIVATE,SortedSize,IPC_CREAT|0600);
	if(shm_Files_Sorted==-1)
		return 0;
	_Files_Sorted=(int*)shmat(shm_Files_Sorted,NULL,0);
	if((_Files_Sorted==NULL)||(_Files_Sorted==(void *)-1))
		return 0;
	memset(_Files_Sorted,0,SortedSize);
    */

	_Files=(pds_files*)GetMem(_FilesSize);
	if(_Files==NULL)
		return 0;
	memset(_Files,0,_FilesSize);
	SortedSize=sizeof(int)*MaxFiles;
	_Files_Sorted=(int*)GetMem(SortedSize);
	memset(_Files_Sorted,0,SortedSize);

	int i;
	for(i=0;i<MaxFiles-1;i++)
	{
		ClearPdsFile(&_Files->Files[i]);
		_Files->Files[i].NextFree=i+1;
	}

	_Files->MaxKeys=init_MaxKeys;
	_Files->Keys=(pds_key*)GetMem(_Files->MaxKeys*sizeof(pds_key));
	if(_Files->Keys==NULL)
	{
	    return 0;
	}
	memset(_Files->Keys,0,_Files->MaxKeys*sizeof(pds_key));

/*
	shmdt(_Files_Sorted);_Files_Sorted=NULL;
	shmdt(_Files);_Files=NULL;
*/

	srand((unsigned)time(NULL));

	return MaxFiles;
}

void DoneFiles()
{
/*
	if(_Files!=NULL)
	{
		if(_Files_Sorted!=NULL)
		{
			shmdt(_Files_Sorted);
			_Files_Sorted=NULL;
		}
		shmdt(_Files);
		_Files=NULL;
	}
	if(!IAmChild())
	{
		if(shm_Files_Sorted>=0)
		{
			shmctl(shm_Files_Sorted,IPC_RMID,NULL);shm_Files_Sorted=0;
		}
		if(shm_Files>=0)
		{
			shmctl(shm_Files,IPC_RMID,NULL);shm_Files=0;
		}
	}
*/
    if(_Files!=NULL)
    {
        if(_Files->UseCount==0)
        {
            if(_Files_Sorted!=NULL)
            {
                FreeMem(_Files_Sorted);_Files_Sorted=NULL;
            }
            if(_Files!=NULL)
            {
                if(_Files->Keys!=NULL)
                    FreeMem(_Files->Keys);
                FreeMem(_Files);_Files=NULL;
            }
	    }
    }
}

const int		local_buffer_size=65536;

/*
P_local_files	_Local=NULL;
int				_Local_size;
int			 	max_local_files=0;
const int		local_buffer_size=65536;
char *		 	local_buffer=NULL;
void *			IndexBuffer=NULL;
int				IndexBufferSize=0;
*/

void CloseClient(int * client_sockfd)
{
	if(*client_sockfd!=-1)
	{
		close(*client_sockfd);
		*client_sockfd=-1;
	}
}

int CheckLocalIntegrity(P_local_files _Local)
{
    if(CheckIntegrity)
    {
        return 1;
    }

	int LocI;
	int LocI2=0;
	int LocI3=-1;
	LocI=_Local->FirstFree;
	InitLogBuffer(_Local);
	AddToLogBuffer(_Local,4,"_Local FreeItems: ");
	while((LocI!=-1)&&(LocI2<=_Local->max_local_files))
	{
		if(LocI!=_Local->FirstFree)
			AddToLogBuffer(_Local,4,",");
		AddToLogBuffer(_Local,4,"%d",LocI);
		if(_Local->Files[LocI].Index!=-1)
		{
			message(0,"%d chyba integrity lokalni tabulky souboru: volny zaznam ma platny index\n",getpid());
			return 0;
		}
		LocI2++;
		if(_Local->Files[LocI].PrevItem!=LocI3)
		{
			message(0,"%d chyba v zpetnem retezeni volnych polozek lokalni tabulky souboru\n",getpid());
			return 0;
		}
		LocI3=LocI;
		LocI=_Local->Files[LocI].NextItem;
	}
	if(LocI2>_Local->max_local_files)
	{
		message(0,"%d chyba integrity lokalni tabulky souboru: zacykleni volnych polozek\n",getpid());
		return 0;
	}
	if(LocI2+_Local->Opened!=_Local->max_local_files)
	{
		message(0,"%d chyba integrity lokalni tabulky souboru: volnych %d+otevrenych %d != %d\n",getpid(),LocI2,_Local->Opened,_Local->max_local_files);
		return 0;
	}
	LocI2=0;
	LocI3=-1;
	LocI=_Local->FirstOpen;
	message(4,"%s\n",_Local->LogBuffer);
	InitLogBuffer(_Local);
	AddToLogBuffer(_Local,4,"\n_Local OpenItems: ");
	while((LocI!=-1)&&(LocI2<=_Local->max_local_files))
	{
		if(LocI!=_Local->FirstOpen)
			AddToLogBuffer(_Local,4,",");
		AddToLogBuffer(_Local,4,"%d",LocI);
		if(_Local->Files[LocI].Index==-1)
		{
			message(0,"%d chyba integrity lokalni tabulky souboru: otevreny zaznam ma neplatny index\n",getpid());
			return 0;
		}
		LocI2++;
		if(_Local->Files[LocI].PrevItem!=LocI3)
		{
			message(0,"%d chyba v zpetnem retezeni volnych polozek lokalni tabulky souboru\n",getpid());
			return 0;
		}
		LocI3=LocI;
		LocI=_Local->Files[LocI].NextItem;
	}
	if(LocI2>_Local->max_local_files)
	{
		message(0,"%d chyba integrity lokalni tabulky souboru: zacykleni otevrenych souboru\n",getpid());
		return 0;
	}
	message(4,"%s\n",_Local->LogBuffer);
	return 1;
}

int CheckGlobalIntegrity(const char * specify)
{
    if(!CheckIntegrity)
        return 1;
    int Result=1;
    int LocI=0;
    int LocI2;
    while(LocI<MaxFiles)
    {
        P_pds_file PF=&_Files->Files[LocI];
        if(PF->FileGen)
        {
            if(!FindFile(PF->Key,PF->SubKey,PF->Name,PF->FileType,&LocI2))
            {
                Result=0;
                message(0,"%d Integrity error on global file table (%s). Key: %s SubKey: %s Name: %s\n",getpid(),specify,PF->Key,PF->SubKey,PF->Name);
            }
        }
        LocI++;
    }
    return Result;
}

int DoubleLocalFiles(P_local_files * Local)
{
	int new_max=(*Local)->max_local_files<<1;
	if(new_max<(*Local)->max_local_files)
		return 0;
	int new_Local_size=sizeof(local_files)+new_max*sizeof(local_file);
	P_local_files new_Local=(local_files *)GetMem(new_Local_size);
	if(new_Local==NULL)
		return 0;
	memset(new_Local,0,new_Local_size);
	memcpy(new_Local,*Local,(*Local)->_Local_size);
	int * new_Local_sorted=(int *)GetMem(new_max*sizeof(int));
	if(new_Local_sorted==NULL)
	{
		FreeMem(new_Local);
		return 0;
	}

	FreeMem(*Local);
	*Local=new_Local;
	(*Local)->_Local_size=new_Local_size;
	int FirstNew=new_max-(*Local)->max_local_files;
	int LocI;
	for(LocI=0;LocI<FirstNew;LocI++)
	{
		(*Local)->Files[LocI].MyFiles=*Local;
	}
	int LocI2=-1;
	for(LocI=FirstNew;LocI<new_max-1;LocI++)
	{
		(*Local)->Files[LocI].NextItem=LocI+1;
		(*Local)->Files[LocI].PrevItem=LocI2;
		(*Local)->Files[LocI].Index=-1;
		(*Local)->Files[LocI].MyFiles=*Local;
		LocI2=LocI;
	}
	(*Local)->Files[LocI].NextItem=(*Local)->FirstFree;
	if((*Local)->FirstFree!=-1)
		(*Local)->Files[(*Local)->FirstFree].PrevItem=LocI;
	(*Local)->Files[LocI].PrevItem=LocI2;
	(*Local)->Files[LocI].Index=-1;
    (*Local)->Files[LocI].MyFiles=*Local;
	(*Local)->FirstFree=FirstNew;
	(*Local)->max_local_files=new_max;
	return CheckLocalIntegrity(*Local);
}

void CloseAllLocalFiles(P_local_files _Local);

void LocalDoneFiles(P_local_files * Local)
{
    message(2,"%d LocalDoneFiles()\n",getpid());
	if(*Local!=NULL)
	{
	    if((*Local)->client_sockfd!=-1)
            CloseClient(&(*Local)->client_sockfd);
        if((*Local)->IndexBuffer!=NULL)
		{
			FreeMem((*Local)->IndexBuffer);(*Local)->IndexBuffer=NULL;(*Local)->IndexBufferSize=0;
		}
		if((*Local)->local_buffer!=NULL)
		{
			FreeMem((*Local)->local_buffer);
			(*Local)->local_buffer=NULL;
		}
		if((*Local)->IdentStr)
		{
			FreeMem((*Local)->IdentStr);
			(*Local)->IdentStr=NULL;
		}
		if(*Local!=NULL)
		{
			if((*Local)->SelfChild)
				(*Local)->SelfChild->Local=NULL;
			CloseAllLocalFiles(*Local);
			FreeMem(*Local);*Local=NULL;
		}
	}
}

int LocalInitFiles(P_local_files * Local)
{
    message(2,"%d LocalInitFiles()\n",getpid());
    if(*Local)
    {
        LocalDoneFiles(Local);
        message(2,"%d LocalInitFiles() Local exists: %x\n",getpid(),*Local);
    }

	int _max_local_files=MaxFiles>>4;
	if(_max_local_files==0)
		_max_local_files=MaxFiles;
	if(_max_local_files==0)
		return 0;

	int __Local_size=sizeof(local_files)+_max_local_files*sizeof(local_file);
	*Local=(local_files *)GetMem(__Local_size);
	if(*Local==NULL)
	{
		LocalDoneFiles(Local);
		return 0;
	}

	memset(*Local,0,__Local_size);

	(*Local)->max_local_files=_max_local_files;
	(*Local)->_Local_size=__Local_size;
	(*Local)->client_sockfd=-1;
	(*Local)->child_pid=getpid();
	(*Local)->MyKey=-1;
	(*Local)->AuthorizedKey=-1;

	(*Local)->local_buffer=(char *)GetMem(local_buffer_size);
	if((*Local)->local_buffer==NULL)
	{
		LocalDoneFiles(Local);
		return 0;
	}
	(*Local)->FirstOpen=-1;
	int LocI;
	int LocI2=-1;
	for(LocI=0;LocI<(*Local)->max_local_files-1;LocI++)
	{
		(*Local)->Files[LocI].NextItem=LocI+1;
		(*Local)->Files[LocI].PrevItem=LocI2;
		(*Local)->Files[LocI].Index=-1;
		(*Local)->Files[LocI].MyFiles=*Local;
		LocI2=LocI;
	}
	(*Local)->Files[LocI].NextItem=-1;
	(*Local)->Files[LocI].PrevItem=LocI2;
	(*Local)->Files[LocI].Index=-1;
    (*Local)->Files[LocI].MyFiles=*Local;

    time(&(*Local)->start);

	CheckLocalIntegrity(*Local);
	return 1;
}

int FindFile(char *Key,char *SubKey,char *FileName,unsigned short FileType,int *Index)
{
	int Result=0;
	int L=0;
	int H=_Files->Opened-1;
	int I,C;
	while(L<=H)
	{
		I=(L+H)>>1;
		C=strcmp((char *)&_Files->Files[_Files_Sorted[I]].Key,Key);
		if(C==0)
		{
			C=strcmp((char *)&_Files->Files[_Files_Sorted[I]].SubKey,SubKey);
			if(C==0)
			{
				C=strcmp((char *)&_Files->Files[_Files_Sorted[I]].Name,FileName);
				if(C==0)
				{
				    C=_Files->Files[_Files_Sorted[I]].FileType;
				    C-=FileType;
				}
			}
		}
		if(C<0)
		{
			L=I+1;
		}
		else
		{
			H=I-1;
			if(C==0)
			{
				Result=1;
				L=I;
			}
		}

	}
	*Index=L;
	return Result;
}

int AppropriateFile(P_local_files _Local,fileID fID,unsigned short Type,uint8_t ForWrite);
int UnAppropriateFile(fileID fID);

void FreePageBuffers(P_pds_file File)
{
    if((getpid()!=File->Approp)&&(File->Counter>1))
    {
        message(0,"%d uvolneni PageBuffers bez vyhrazeni souboru !!! Soubor: %s\n",getpid(),File->Name);
		return;
    }
    message(7,"%d uvolneni PageBuffers. Soubor: %s\n",getpid(),File->Name);
	if(File->PageBuffers!=NULL)
	{
		P_page_buffer PageBuffer=File->PageBuffers;
		P_page_buffer Next;
		File->PageBuffers=NULL;
		while(PageBuffer!=NULL)
		{
			Next=PageBuffer->Next;
            message(8,"%d uvolneni PageBuffer %x Next %x\n",getpid(),PageBuffer,Next);
			FreeMem(PageBuffer);
			PageBuffer=Next;
		}
	}
}

void CloseGlobalFile(int Index,uint8_t LockSemaphore)
{
    if(Index==-1)
    {
        return;
    }
	int LocI,LocI2;
	pid_t child_pid=getpid();
	if(LockSemaphore)
	{
		if(!semaphore_p(3,NULL))
			return;
	}

	P_pds_file GF=&_Files->Files[Index];

	if(GF->Counter==1)
	  FreePageBuffers(GF);

	message(2,"%d Close (%d) %s Type: %d\n",child_pid,GF->Counter,GF->Name,GF->FileType);
	GF->Counter--;
	if(GF->Counter)
	{
		if(GF->Locker==child_pid)
		{
			GF->Locker=0;
			GF->LockLevel=0;
		}
		if(GF->ReadLocker==child_pid)
		{
			GF->ReadLocker=0;
			GF->ReadLockLevel=0;
		}
	}
	else
	{
		if(FindFile(GF->Key,GF->SubKey,GF->Name,GF->FileType,&LocI))
		{
			LocI2=_Files->Opened-LocI-1;
            if(LocI2>0)
			{
				memmove(&_Files_Sorted[LocI],&_Files_Sorted[LocI+1],LocI2*sizeof(int));
			}
		}
		else
		{
		    message(0,"%d Error, file key: %s subkey: %s name: %s filetype: %d not found in sorted file list\n",child_pid,GF->Key,GF->SubKey,GF->Name,GF->FileType);
		}
		message(2,"%d Free %s\n",child_pid,GF->Name);
		if(GF->Handle!=-1)
		{
            /*
            if(GF->Flags&fileflags_DataLocked)
            {
                message(3,"%d Unlock data file Handle: %d Name: %s\n",child_pid,GF->Handle,GF->Name);
                UnlockFile(GF->Handle);
            }
			close(GF->Handle);
			*/
			CloseFileExclusive(GF->Handle);
		}
		switch(GF->FileType)
		{
            case filetype_Data:
            case filetype_LocalTempData:
            {
                if(GF->InxHandle!=-1)
                {
                    CloseIndex(GF);
                    if(GF->FileType==filetype_LocalTempData)
                    {
                        if(GF->RealIndexName!=NULL) remove(GF->RealIndexName);
                    }
                }
                if((GF->FileType==filetype_LocalTempData)&&(GF->Handle!=-1)&&(GF->RealName!=NULL))
                {
                    remove(GF->RealName);
                }
                P_pds_lock Lock=GF->FirstLock;
                P_pds_lock Next;
                while(Lock!=NULL)
                {
                    Next=Lock->NextLock;
                    FreeMem(Lock);
                    Lock=Next;
                }
                break;
            }
            case filetype_TempDat:
            {
                if((GF->Handle!=-1)&&(GF->RealName!=NULL))
                {
                    remove(GF->RealName);
                }
                break;
            }
		}
		if(GF->RealIndexName)
			FreeMem(GF->RealIndexName);
		if(GF->RealName)
			FreeMem(GF->RealName);
		if(GF->TXTBuffer)
			FreeMem(GF->TXTBuffer);
        if(GF->PreloadBuffer)
            FreeMem(GF->PreloadBuffer);
		ClearPdsFile(GF);
		GF->NextFree=_Files->FirstFree;
		_Files->FirstFree=Index;
		_Files->Opened--;
		CheckGlobalIntegrity("after close");
	}
/*
	printf("Seznam otevrenych souboru (%d):\n",_Files->Opened);
	LocI=0;
	while(LocI<_Files->Opened)
	{
		printf("  %s (%d)\n",_Files->Files[_Files_Sorted[LocI]].Name,_Files_Sorted[LocI]);
		LocI++;
	}
*/
	if(LockSemaphore)
	{
		if(!semaphore_v(3,NULL))
			return;
	}
}

int FindLock(P_local_file File,int RefNr,int *Index)
{
	int Result=0;
	int L=0;
	int H=File->ActLocks-1;
	int I,C;
	while(L<=H)
	{
		I=(L+H)>>1;
		C=File->MyLocks[I].RefNr-RefNr;
		if(C<0)
		{
			L=I+1;
		}
		else
		{
			H=I-1;
			if(C==0)
			{
				Result=1;
				L=I;
			}
		}

	}
	*Index=L;
	return Result;
}

P_pds_lock GetLockSector(P_local_files Local,P_pds_file pds,int sector,uint8_t Create)
{
	if(sector<0)
		return NULL;
	P_pds_lock Lock=pds->FirstLock;
	P_pds_lock Last=NULL;
	int ActSector=-1;
	while((Lock!=NULL)&&(ActSector<sector))
	{
		ActSector=Lock->Sector;
		if(ActSector==sector)
		{
			return Lock;
		}
		else
		if(ActSector<sector)
		{
			Last=Lock;
			Lock=Lock->NextLock;
		}
	}

	if(!Create)
		return NULL;

	int NewLockSize=sizeof(pds_lock)+pds->LockSegCount;
	P_pds_lock NewLock=(P_pds_lock)GetMem(NewLockSize);
	if(NewLock==NULL)
	{
		Local->LastErrorCode=err_LowMemory;
		return NULL;
	}
	if(Last!=NULL)
	{
		Last->NextLock=NewLock;
	}
	else
	{
		pds->FirstLock=NewLock;
	}
	memset(NewLock,0,NewLockSize);
	NewLock->NextLock=Lock;
	NewLock->Sector=sector;

	return NewLock;
}

int UnlockRec(P_local_file File,int RefNr,unsigned short All)
{
	int LocI;
	int LocI2;
	if(!FindLock(File,RefNr,&LocI))
	{
		message(1,"Attempt to unlock nonlocked record nr. %d in file %s\n",RefNr,_Files->Files[File->Index].Name);
		return 1;
	}
	if((!All)&&(File->MyLocks[LocI].Counter>1))
	{
		File->MyLocks[LocI].Counter--;
		return 1;
	}

	fileID fID;
	memset(&fID,0,sizeof(fileID));

	P_pds_file GF=&_Files->Files[File->Index];

	fID.Index=File->Index;
	fID.Random=GF->Random;
	fID.FileGen=GF->FileGen;

	if(!AppropriateFile(File->MyFiles,fID,filetype_Data,0))
		return 0;
	File->ActLocks--;
	LocI2=File->ActLocks-LocI;

	if(LocI2>0)
	{
		memmove(&File->MyLocks[LocI],&File->MyLocks[LocI+1],LocI2*sizeof(LockItem));
	}

	int Sector=RefNr>>GF->LockSectShift;

	P_pds_lock SectPoint=GetLockSector(File->MyFiles,GF,Sector,0);

	if(SectPoint!=NULL)
	{
		int Bajt=(RefNr&GF->LockSegMask)>>3;
		uint8_t Bit=RefNr&7;
		uint8_t Mask=1;
		if(Bit!=0)
			Mask<<=Bit;
		if((SectPoint->Locks[Bajt]&Mask)!=0)
		{
			SectPoint->Locked--;
			SectPoint->Locks[Bajt]&=~Mask;
		}
	}

	UnAppropriateFile(fID);
	return 1;
}

int UnlockAllRecs(P_local_file File)
{
	int LocI=0;
	int LocI2;
	while(LocI<File->ActLocks)
	{
		LocI2=File->ActLocks;
		UnlockRec(File,File->MyLocks[LocI].RefNr,1);
		if(LocI2==File->ActLocks)
			LocI++;
	}
	return (File->ActLocks!=0);
};

P_page_buffer GetPageBuffer(P_local_file File,unsigned short Key,int PRef)
{
    P_pds_file GF=&_Files->Files[File->Index];
    if(getpid()!=GF->Approp)
    {
		File->MyFiles->LastErrorCode=err_NoAppropriated;
		return NULL;
    }
	P_page_buffer PageBuffer=GF->PageBuffers;
	while(PageBuffer!=NULL)
	{
		if((PageBuffer->Valid)&&(PageBuffer->PRef==PRef)&&(PageBuffer->Key==Key))
		{
			return PageBuffer;
		}
		PageBuffer=PageBuffer->Next;
	}
	int Size=sizeof(IsamPage)+sizeof(page_buffer);
	PageBuffer=(P_page_buffer)GetMem(Size);
	if(PageBuffer==NULL)
	{
		File->MyFiles->LastErrorCode=err_LowMemory;
		return NULL;
	}
	memset(PageBuffer,0,Size);
	PageBuffer->PRef=PRef;
	PageBuffer->Key=Key;
	PageBuffer->Size=Size;
	PageBuffer->Next=GF->PageBuffers;
	GF->PageBuffers=PageBuffer;
    message(8,"%d novy PageBuffer %x u souboru %s (Next %x)\n",getpid(),PageBuffer,GF->Name,PageBuffer->Next);
	return PageBuffer;
}

void CloseLocalFile(P_local_files _Local,int Index)
{
	if(Index==-1)
		return;
	P_local_file File=&_Local->Files[Index];

	if(File->Index==-1)
		return;

	int LocI=File->Index;
	P_pds_file Global=&_Files->Files[LocI];

	int I;

	for(I=0;I<=31;I++)
	{
		if(File->Semaphores[I])
		{
			Global->Semaphores[I]&=~File->Semaphores[I];
		}
	}

	if(File->PrevItem==-1)
		_Local->FirstOpen=File->NextItem;
	else
		_Local->Files[File->PrevItem].NextItem=File->NextItem;
	if(File->NextItem!=-1)
		_Local->Files[File->NextItem].PrevItem=File->PrevItem;

	UnlockAllRecs(File);

	if(File->MyLocks!=NULL)
		FreeMem(File->MyLocks);

	memset(File,0,sizeof(local_file));
	File->Index=-1;
	File->NextItem=_Local->FirstFree;
	if(_Local->FirstFree!=-1)
		_Local->Files[_Local->FirstFree].PrevItem=Index;
	File->PrevItem=-1;
	File->MyFiles=_Local;
	_Local->FirstFree=Index;
	_Local->Opened--;

	if(_Local->Opened==0)
	{
	    if(_Local->MyKey!=-1)
	    {
            _Files->Keys[_Local->MyKey].UseCount--;
            message(2,"%d Snizeni pocitadla pouziti klice \"%s\" na %d\n",getpid(),_Files->Keys[_Local->MyKey].Key,_Files->Keys[_Local->MyKey].UseCount);
	    }
	    _Local->MyKey=-1;
	}

	CheckLocalIntegrity(_Local);

	CloseGlobalFile(LocI,1);
}

const char ValidFileNameChars[]="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz$%'`-@{}~!#()&_^.";

int IsValidFileName(char * FileName)
{
	if(*FileName=='.')
		return 0;
	while(*FileName)
	{
		if(strchr(ValidFileNameChars,*FileName)==NULL)
		{
			return 0;
		}
		FileName++;
	}
	return 1;
}

int ValidateFileName(char * FileName)
{
	if(!IsValidFileName(FileName))
		return 0;
	while(*FileName)
	{
		*FileName=(char)tolower(*FileName);
		FileName++;
	}
	return 1;
}

int IsamPutBlock(P_local_files Local,int Handle,int Offset,unsigned short int Length,void * Source)
{
	if(lseek(Handle,Offset,SEEK_SET)==Offset)
	{
		if(write(Handle,(void *)Source,Length)==Length)
		{
			return 1;
		}
		Local->LastErrorCode=errno;
		if(!Local->LastErrorCode)
			Local->LastErrorCode=err_ReadError;
	}
	else
	{
		Local->LastErrorCode=errno;
		if(!Local->LastErrorCode)
			Local->LastErrorCode=err_SeekError;
	}
	return 0;
}

int IsamPutDummyBlock(P_local_files Local,int Handle,int Ref,unsigned short Len)
{
	void * Buffer=GetMem(Len);
	if(Buffer==NULL)
	{
		Local->LastErrorCode=err_LowMemory;
		return 0;
	}
	memset(Buffer,0,Len);
	if(lseek(Handle,Ref,SEEK_SET)==Ref)
	{
		if(write(Handle,Buffer,Len)==Len)
		{
		    FreeMem(Buffer);
			return 1;
		}
		Local->LastErrorCode=errno;
		if(!Local->LastErrorCode)
			Local->LastErrorCode=err_WriteError;
	}
	else
	{
		Local->LastErrorCode=errno;
		if(!Local->LastErrorCode)
			Local->LastErrorCode=err_SeekError;
	}
    FreeMem(Buffer);
	return 0;
}

int IsamCopyInfoRecToIR(P_pds_file File,unsigned short KeyNr,IsamInfoRec * IR)
{
	memset(IR,0,sizeof(IsamInfoRec));
	unsigned short NrOfKeys=File->datInfo.NrOfKeys;
	if(KeyNr>NrOfKeys)
		return 0;
    IsamDatIndDescrPtr ID=&File->InxDescr[KeyNr];
    IR->InfoRec.FirstFree=ID->FirstFree;
    IR->InfoRec.NumberFree=ID->NumberFree;
    IR->InfoRec.NumRec=ID->NumRec;
    IR->InfoRec.LenRec=ID->LenRec;
    if(KeyNr==0)
    {
            IR->InfoRec.NrOfKeys=NrOfKeys;
            IR->InfoRec.ADK=0;
    }
    else
    {
            IR->InfoRec.Gener5=ID->RootRef;
            IR->InfoRec.ADK=ID->AllowDupKeys;
            IR->KeysUsed=ID->NumKeys;
            if(ID->XlatKeys)
            {
                    IR->CodePage=ID->KeyCodePage|0x8000;
            }
            else
            {
                    IR->CodePage=0;
            }
            IR->ActualIndexVersion=ID->KeyVersion;
            IR->PageSizeUsed=ID->UsedPageSize;
    }
	return 1;
}

int IsamPutInfoRec(P_local_files Local,P_pds_file File,unsigned short KeyNr,uint8_t IndFDamaged)
{
	IsamInfoRec IR;
	if(!IsamCopyInfoRecToIR(File,KeyNr,&IR))
		return 0;
	if(KeyNr==0)
	{
		IR.InfoRec.ADK=IndFDamaged;
		if(!IsamPutBlock(Local,File->Handle,0,sizeof(IsamSmallInfoRec),&IR))
			return 0;
	}
	else
	{
		if(!IsamPutBlock(Local,File->InxHandle,File->InxDescr[KeyNr].BlockOfs,sizeof(IsamInfoRec),&IR))
			return 0;
	}
	return 1;
}

int IsamInitDatFile(P_local_files Local,int Handle,unsigned short RecLen,unsigned short NrOfKeys)
{
	if(RecLen<sizeof(IsamSmallInfoRec))
	{
        Local->LastErrorCode=err_RecLenOutOfRange;
		return 0;
	}
	if(NrOfKeys>MaxNrOfKeys)
	{
		Local->LastErrorCode=err_InvalidNumOfKeys;
		return 0;
	}
	void * Buffer=GetMem(RecLen);
	if(Buffer==NULL)
	{
		Local->LastErrorCode=err_LowMemory;
		return 0;
	}
	memset(Buffer,0,RecLen);
	((IsamSmallInfoRec *)Buffer)->FirstFree=-1;
	((IsamSmallInfoRec *)Buffer)->LenRec=RecLen;
	((IsamSmallInfoRec *)Buffer)->NrOfKeys=NrOfKeys;

	if(lseek(Handle,0,SEEK_SET)==0)
	{
		if(write(Handle,Buffer,RecLen)!=RecLen)
		{
			FreeMem(Buffer);
			Local->LastErrorCode=errno;
			if(Local->LastErrorCode==0)
				Local->LastErrorCode=err_WriteError;
			return 0;
		}
	}
	else
	{
		FreeMem(Buffer);
		Local->LastErrorCode=errno;
		if(Local->LastErrorCode==0)
			Local->LastErrorCode=err_SeekError;
		return 0;
	}
	FreeMem(Buffer);
	return 1;
}

int CreateInxFileStructure(P_local_files Local,P_pds_file File)
{
	unsigned short I;
	char * Buffer=(char *)GetMem(File->BlockLen);
	if(Buffer==NULL)
		return 0;
	memset(Buffer,0,File->BlockLen);
	for(I=1;I<=File->datInfo.NrOfKeys;I++)
	{
		if(!IsamCopyInfoRecToIR(File,I,(IsamInfoRec *)&Buffer[File->InxDescr[I].BlockOfs]))
		{
			return 0;
		}
	}
	if(!IsamPutBlock(Local,File->InxHandle,0,File->BlockLen,(IsamInfoRec *)Buffer))
	{
		FreeMem(Buffer);
		return 0;
	}
	FreeMem(Buffer);
	return 1;
}

int IsamInitInxFile(P_local_files Local,P_pds_file File,P_InitNewDatFile NewInfo)
{
	if(NewInfo->NrOfKeys>0)
	{
		if(NewInfo->NrOfKeys>MaxNrOfKeys)
		{
			Local->LastErrorCode=err_InvalidNumOfKeys;
			return 0;
		}
		File->datInfo.NrOfKeys=NewInfo->NrOfKeys;
		IsamPutInfoRec(Local,File,0,0);
		File->MaxPages=0;
		File->BlockLen=0;
		unsigned short I;
		IsamDatIndDescrPtr IDD;
		P_InitNewInxFile INX;
		for(I=1;I<=NewInfo->NrOfKeys;I++)
		{
			IDD=(IsamDatIndDescrPtr)&File->InxDescr[I];
			INX=&NewInfo->Indexs[I-1];
			memset(IDD,0,sizeof(IsamDatIndDescr));
			IDD->KeyLen=INX->KeyLen;
			IDD->LenRec=(int)(9+IDD->KeyLen)*(int)CreatePageSize+(int)6;
			IDD->BlockOfs=File->BlockLen;
			File->BlockLen+=IDD->LenRec;
			IDD->UsedPageSize=CreatePageSize;
			IDD->FirstFree=-1;
			IDD->AllowDupKeys=NewInfo->Indexs[I-1].AllowDupKeys;
			IDD->XlatKeys=INX->XlatKeys;
			IDD->KeyCodePage=INX->CodePage;
			IDD->KeyVersion=INX->IndexVersion;
			message(2," Reset %s Index[%d] KeyLen: %d NumKeys: %d RootRef: %d Duplicates: %d XlatKeys %d\n",File->Name,I,IDD->KeyLen,IDD->NumKeys,IDD->RootRef,IDD->AllowDupKeys,IDD->XlatKeys);
		}
		if(!CreateInxFileStructure(Local,File))
		{
			return 0;
		}
	}
	return 1;
}

int ResetIndex(P_local_files Local,P_pds_file File,P_InitNewDatFile NewInfo)
{
    int Result=0;
    Local->LastErrorCode=0;
    if((NewInfo->RecSize==File->datInfo.LenRec)&&(NewInfo->NrOfKeys<=MaxNrOfKeys))
    {
        unsigned short I;
        for(I=0;(I<NewInfo->NrOfKeys)&&(!Local->LastErrorCode);I++)
        {
            if((NewInfo->Indexs[I].KeyLen>0)&&(NewInfo->Indexs[I].KeyLen<=MaxKeyLen))
            {
                if((NewInfo->Indexs[I].AllowDupKeys>1)||(NewInfo->Indexs[I].Dummy!=0))
                {
                    Local->LastErrorCode=err_BadParameters;
                }
            }
            else
            {
                Local->LastErrorCode=err_KeyLenOutOfRange;
            }
        }
    }
    else
    {
        if(NewInfo->RecSize==File->datInfo.LenRec)
            Local->LastErrorCode=err_TooManyKeys;
        else
            Local->LastErrorCode=err_RecLenOutOfRange;
    }
    if(Local->LastErrorCode==0)
    {
        if(File->InxHandle!=-1)
        {
            if(ftruncate(File->InxHandle,0)==0)
            {
                Result=IsamInitInxFile(Local,File,NewInfo);
            }
        }
        else
        {
            Local->LastErrorCode=err_BadParameters;
        }
    }
    return Result;
}

char * GetRealName(P_local_files Local,char *Key,char *SubKey,char *FileName,const char * Path,extensions Ext)
{
    if((Key==NULL)||(SubKey==NULL)||(FileName==NULL))
    {
		Local->LastErrorCode=err_BadParameters;
        return NULL;
    }
    if(!strlen(Key))
    {
		Local->LastErrorCode=err_BadParameters;
        return NULL;
    }
	if((!ValidateFileName(FileName))||(!ValidateFileName(Key))||(!ValidateFileName(SubKey)))
	{
		Local->LastErrorCode=err_BadParameters;
		return NULL;
	}

	int RealNameLen=0;
	RealNameLen+=strlen(Path);
	int LocI=strlen(Key);
	int LocI2=strlen(SubKey);
	int LocI3=strlen(FileName);
	if(LocI)
	{
		RealNameLen+=LocI;
	}
	else
	{
		RealNameLen+=strlen(DefaultKey);
	}
	if((LocI2)||(LocI3))
        RealNameLen++;
	if(LocI2)
	{
		RealNameLen+=LocI2;
		if(LocI3)
		{
		    RealNameLen++;
		}
	}
    RealNameLen+=LocI3;
    RealNameLen++; // ukoncovaci nula

	char * RealName=(char *)GetMem(RealNameLen);
	if(RealName==NULL)
	{
		Local->LastErrorCode=err_LowMemory;
		return NULL;
	}
	*RealName=0x00;
	strcat(RealName,Path);
	if(LocI)
	{
		strcat(RealName,Key);
	}
	else
	{
		strcat(RealName,DefaultKey);
	}
	if((LocI2)||(LocI3))
		strcat(RealName,"/");

	if(strlen(SubKey))
	{
		strcat(RealName,SubKey);
		if(LocI3)
			strcat(RealName,"/");
	}
	strcat(RealName,FileName);
	switch(Ext)
    {
        case ext_dat:
        {
            strcat(RealName,datExtension);
            break;
        }
        case ext_inx:
        {
            strcat(RealName,inxExtension);
            break;
        }
        case ext_tmp:
        {
            strcat(RealName,tmpExtension);
            break;
        }
        case ext_sav:
        {
            strcat(RealName,savExtension);
            break;
        }
        case ext_none:
        {
            break;
        }
    }

    return RealName;
}

int ExistFile(P_local_files Local,char *Key,char *SubKey,char *FileName,uint8_t * Exist,const char * Path)
{
	*Exist=0;
	char * RealName=GetRealName(Local,Key,SubKey,FileName,Path);
	if(RealName==NULL)
		return 0;

	struct stat FileStat;

	if(stat(RealName,&FileStat)==0)
	{
		*Exist=1;
	}
	else
	{
		if(errno!=2)
		{
			Local->LastErrorCode=errno;
			FreeMem(RealName);
			return 0;
		}
	}
	FreeMem(RealName);
	return 1;
}

int FileSize(P_local_files Local,char *Key,char *SubKey,char *FileName,int * Size,const char * Path)
{
	*Size=0;
	char * RealName=GetRealName(Local,Key,SubKey,FileName,Path);
	if(RealName==NULL)
		return 0;
	struct stat FileStat;

	if(stat(RealName,&FileStat)==0)
	{
		*Size=FileStat.st_size;
	}
	else
	{
		Local->LastErrorCode=errno;
		FreeMem(RealName);
		return 0;
	}
	FreeMem(RealName);
	return 1;
}

int CreateSubKey(P_local_files Local,char *Key,char *SubKey,const char * Path)
{
    uint8_t Exist;
    if(ExistFile(Local,Key,SubKey,(char *)"",&Exist,Path))
    {
        if(strlen(SubKey)==0)
        {
            Local->LastErrorCode=err_BadSubKey;
            return 0;
        }
        if(!Exist)
        {
            char * RealName=GetRealName(Local,Key,SubKey,(char *)"",Path);
            if(RealName==NULL)
                return 0;
#ifdef __LINUX__
            if(mkdir(RealName,DirFlagsS_IRWXU | S_IRWXG)!=0)
#else
            if(mkdir(RealName)!=0)
#endif
            {
                Local->LastErrorCode=errno;
                FreeMem(RealName);
                return 0;
            }
            FreeMem(RealName);
        }
        return 1;
    }
    return 0;
}

int GetFileInfo(P_local_files Local,char *Key,char *SubKey,char *FileName,FileInfoRec * FileInfo,const char * Path)
{
	memset(FileInfo,0,sizeof(*FileInfo));
	FileInfo->SizeOf=sizeof(*FileInfo);
	char * RealName=GetRealName(Local,Key,SubKey,FileName,Path);
	if(RealName==NULL)
		return 0;

	struct stat FileStat;

	if(stat(RealName,&FileStat)==0)
	{
		FileInfo->Size=FileStat.st_size;
		FileInfo->Time=FileStat.st_mtime;
		struct tm *Time;
		Time=localtime(&FileStat.st_mtime);
		if(Time->tm_year>=80)
		{
			FileInfo->MSTime=(long int)((Time->tm_sec >> 1)&0x1F) | ((Time->tm_min&0x3F) << 5) | ((Time->tm_hour&0x1F) << 11) |
							 ((Time->tm_mday&0x1F) << 16) | (((Time->tm_mon+1)&0xF) << 21) | (((Time->tm_year-80)&0x7F) << 25);
		}
	}
	else
	{
		Local->LastErrorCode=errno;
		FreeMem(RealName);
		return 0;
	}
	FreeMem(RealName);
	return 1;
}

int GetKeyIndex(P_local_files Local,char *Key,const char * Path)
{
    int i=strlen(Key);

    if((i>=KeyNameSize)||(i==0))
    {
        Local->LastErrorCode=err_BadPdsKey;
        return -1;
    }

    uint8_t ExistKey=0;

    if(!ExistFile(Local,Key,(char*)"",(char*)"",&ExistKey,Path))
    {
        Local->LastErrorCode=GetLastFileError(Local,err_Unspecified);
        return -1;
    }

    if(!ExistKey)
    {
        Local->LastErrorCode=err_KeyDirectoryNotExist;
        return -1;
    }

    for(i=0;i<_Files->ActKeys;i++)
    {
        if(strcmp(Key,_Files->Keys[i].Key)==0)
        {
            return i;
        }
    }
    if(_Files->ActKeys<_Files->MaxKeys)
    {
        message(2,"%d Prvni pouziti klice \"%s\"\n",getpid(),Key);
        i=_Files->ActKeys++;
        strcpy(_Files->Keys[i].Key,Key);
        return i;
    }
    else
    {
        int NewMaxKeys=_Files->MaxKeys<<1;
        if(NewMaxKeys<=_Files->MaxKeys)
        {
            Local->LastErrorCode=err_Unspecified;
            return -1;
        }
        pds_key * NewKeys=(pds_key*)GetMem(NewMaxKeys*sizeof(pds_key));
        if(NewKeys==NULL)
        {
            Local->LastErrorCode=err_LowMemory;
            return -1;
        }
        memset(NewKeys,0,NewMaxKeys*sizeof(pds_key));
        memcpy(NewKeys,_Files->Keys,_Files->MaxKeys*sizeof(pds_key));
        FreeMem(_Files->Keys);
        _Files->Keys=NewKeys;
        _Files->MaxKeys=NewMaxKeys;
        i=_Files->ActKeys++;
        strcpy(_Files->Keys[i].Key,Key);
        return i;
    }
    return -1;
}

int LockKey(P_local_files Local,char *Key,const char * Path)
{
    int UsedKey=GetKeyIndex(Local,Key,Path);
    int MyPid=getpid();
    int Result=0;
    if(UsedKey==-1)
        return 0;

    if(!((_Files->Keys[UsedKey].UseCount==0)||((_Files->Keys[UsedKey].UseCount==1)&&(Local->MyKey==UsedKey))))
    {
        Local->LastErrorCode=err_FileUsed;
        return 0;
    }
    if(_Files->Keys[UsedKey].Locker!=0)
    {
        if(_Files->Keys[UsedKey].Locker==MyPid)
        {
            _Files->Keys[UsedKey].LockCount++;
            return 1;
        }
        else
        {
            Local->LastErrorCode=err_FileLocked;
            return 0;
        }
    }
	if(semaphore_p(3,&Local->LastErrorCode))
	{
	    if((_Files->Keys[UsedKey].UseCount==0)||((_Files->Keys[UsedKey].UseCount==1)&&(Local->MyKey==UsedKey)))
	    {
            if(_Files->Keys[UsedKey].Locker==0)
            {
                _Files->Keys[UsedKey].Locker=MyPid;
                _Files->Keys[UsedKey].LockCount=0;
                message(2,"%d Lock key \"%s\" (index %d)\n",MyPid,_Files->Keys[UsedKey].Key,UsedKey);
                Result=1;
            }
            else
            {
                Local->LastErrorCode=err_FileLocked;
            }
	    }
	    else
	    {
            Local->LastErrorCode=err_FileUsed;
	    }
	    semaphore_v(3,&Local->LastErrorCode);
	}
    return Result;
}

int UnlockKey(P_local_files Local,char *Key,const char * Path)
{
    int UsedKey=GetKeyIndex(Local,Key,Path);
    int MyPid=getpid();
    int Result=0;
    if(UsedKey==-1)
        return 0;
    if(_Files->Keys[UsedKey].Locker==MyPid)
    {
        if (_Files->Keys[UsedKey].LockCount==0)
        {
            _Files->Keys[UsedKey].Locker=0;
            message(2,"%d Unlock key \"%s\" (index %d)\n",MyPid,_Files->Keys[UsedKey].Key,UsedKey);
        }
        else
        {
            _Files->Keys[UsedKey].LockCount--;
        }
        Result=1;
    }
    else
    {
        message(0,"%d Attempt to Unlock nonlocked key \"%s\" (index %d)\n",MyPid,_Files->Keys[UsedKey].Key,UsedKey);
        Local->LastErrorCode=err_BadParameters;
    }
    return Result;
}

int GetKeyPassword(P_local_files Local,char *Key,const char * Path)
{
    int LocI=GetKeyIndex(Local,Key,Path);
    if(LocI>=0)
    {
        if(!_Files->Keys[LocI].ValidPassword)
        {
            int PassFileNameLen=0;
            PassFileNameLen+=strlen(Path);
            int LocI2=strlen(Key);
            if(LocI2)
            {
                PassFileNameLen+=LocI2;
            }
            else
            {
                PassFileNameLen+=strlen(DefaultKey);
            }
            PassFileNameLen++; // lomitko
            PassFileNameLen+=strlen(PassFileName);
            PassFileNameLen++; // ukoncovaci nula
            char * RealName=(char *)GetMem(PassFileNameLen);
            if(RealName!=NULL)
            {
                *RealName='\0';
                strcat(RealName,Path);
                if(LocI2)
                {
                    strcat(RealName,Key);
                }
                else
                {
                    strcat(RealName,DefaultKey);
                }
                strcat(RealName,"/");
                strcat(RealName,PassFileName);

                int Handle=open(RealName,O_RDONLY|O_BINARY);

                if(Handle!=-1)
                {
                    LocI2=read(Handle,Local->local_buffer,local_buffer_size);
                    close(Handle);
                    if(LocI2>0)
                    {
                        char * LocCh=(char *) memchr(Local->local_buffer,0x0A,LocI2);
                        if(LocCh!=NULL)
                        {
                            while((LocCh>Local->local_buffer)&&(*LocCh<=' '))
                            {
                                *LocCh='\0';LocCh--;
                            }
                            LocCh=Local->local_buffer;
                            LocI2=strlen(LocCh);
                            while((LocI2>0)&&(*LocCh<=' '))
                            {
                                LocCh++;LocI2--;
                            }
                            if(LocI2>0)
                            {
                                MD5_CTX MD5;
                                MD5Init(&MD5);
                                MD5Update(&MD5,(unsigned char *)LocCh,LocI2);
                                MD5Final(_Files->Keys[LocI].Password_MD5,&MD5);
                                _Files->Keys[LocI].ValidPassword=1;
                            }
                            else
                            {
                                LocI=-1;
                            }
                        }
                        else
                        {
                            LocI=-1;
                        }
                    }
                    if(LocI2<0)
                    {
                        SetLastFileError(Local,errno,err_ReadError);
                        LocI=-1;
                    }
                    close(Handle);
                }
                else
                {
                    if(errno!=2) // jina chyba nez soubor neexistuje
                    {
                        SetLastFileError(Local,errno,err_OpenError);
                        LocI=-1;
                    }
                }

                FreeMem(RealName);
            }
            else
            {
                Local->LastErrorCode=err_LowMemory;
                LocI=-1;
            }
        }
    }
    return LocI;
}

int CompareKeyPassword(P_local_files Local,char *Key,void * MD5,const char * Path)
{
    int LocI=GetKeyPassword(Local,Key,Path);
    if(LocI>=0)
    {
        if(_Files->Keys[LocI].ValidPassword)
        {
            if(memcmp(MD5,&_Files->Keys[LocI].Password_MD5,16)!=0)
            {
                Local->LastErrorCode=err_AuthenticationFailed;
                LocI=-1;
            }
        }
    }
    return LocI;
}

int InitDatInfo(P_local_files Local,P_pds_file file)
{
    if(file->Handle==-1)
    {
        Local->LastErrorCode=err_FileNotOpen;
        return 0;
    }
    if(lseek(file->Handle,0,SEEK_SET)!=0)
    {
        Local->LastErrorCode=errno;
        return 0;
    }
    else
    if(read(file->Handle,&file->datInfo,sizeof(IsamSmallInfoRec))!=sizeof(file->datInfo))
    {
        Local->LastErrorCode=err_IsamReadError;
        return 0;
    }
    message(2,"RecLen: %d Records: %d Indexes: %d\n",file->datInfo.LenRec,file->datInfo.NumRec,file->datInfo.NrOfKeys);
    if(file->datInfo.NrOfKeys>MaxNrOfKeys)
    {
        Local->LastErrorCode=err_TooManyKeys;
        return 0;
    }
    memset(&file->InxDescr[0],0,sizeof(file->InxDescr[0]));
    file->InxDescr[0].FirstFree=file->datInfo.FirstFree;
    file->InxDescr[0].NumberFree=file->datInfo.NumberFree;
    file->InxDescr[0].NumRec=file->datInfo.NumRec;
    file->InxDescr[0].LenRec=file->datInfo.LenRec;
    return 1;
}

int InitInxInfo(P_local_files Local,P_pds_file file)
{
    errno=0;
    file->MaxPages=0;
    file->BlockLen=0;
    memset(&file->InxDescr,0,sizeof(file->InxDescr));
    file->InxDescr[0].FirstFree=file->datInfo.FirstFree;
    file->InxDescr[0].NumberFree=file->datInfo.NumberFree;
    file->InxDescr[0].NumRec=file->datInfo.NumRec;
    file->InxDescr[0].LenRec=file->datInfo.LenRec;
    file->NeedIndexBufferSize=Local->IndexBufferSize;

    IsamInfoRec	dummy_IR;
    int LocI,LocI2;

    for(LocI=1;LocI<=file->datInfo.NrOfKeys;LocI++)
    {
        file->InxDescr[LocI].BlockOfs=file->BlockLen;
        if(lseek(file->InxHandle,file->InxDescr[LocI].BlockOfs,SEEK_SET)!=file->InxDescr[LocI].BlockOfs)
        {
            Local->LastErrorCode=errno;
            return 0;
        }
        LocI2=read(file->InxHandle,&dummy_IR,sizeof(IsamInfoRec));
        if(LocI2!=sizeof(dummy_IR))
        {
            if(errno==0)
            {
                Local->LastErrorCode=err_IndexHeaderCorrupt;
            }
            else
            {
                printf("errno: %d\n",errno);
                Local->LastErrorCode=err_IsamReadError;
            }
            return 0;
        }
        else
        {
            file->InxDescr[LocI].FirstFree=dummy_IR.InfoRec.FirstFree;
            file->InxDescr[LocI].NumberFree=dummy_IR.InfoRec.NumberFree;
            file->InxDescr[LocI].NumRec=dummy_IR.InfoRec.NumRec;
            file->InxDescr[LocI].LenRec=dummy_IR.InfoRec.LenRec;
            if(file->InxDescr[LocI].LenRec>file->NeedIndexBufferSize)
                file->NeedIndexBufferSize=file->InxDescr[LocI].LenRec;
            file->InxDescr[LocI].RootRef=dummy_IR.InfoRec.Gener5;
            file->InxDescr[LocI].AllowDupKeys=dummy_IR.InfoRec.ADK;
            if((dummy_IR.CodePage&0x8000)!=0)
                file->InxDescr[LocI].XlatKeys=1;
            file->InxDescr[LocI].KeyCodePage=dummy_IR.CodePage&0x7FFF;
            file->InxDescr[LocI].NumKeys=dummy_IR.KeysUsed;
            file->InxDescr[LocI].KeyVersion=dummy_IR.ActualIndexVersion;
            file->InxDescr[LocI].UsedPageSize=dummy_IR.PageSizeUsed;
            if(file->InxDescr[LocI].UsedPageSize==0)
                file->InxDescr[LocI].UsedPageSize=CreatePageSize;
            if(file->InxDescr[LocI].UsedPageSize>MaxPageSize)
            {
                Local->LastErrorCode=err_PageSizeTooLong;
                return 0;
            }
            else
            {
                int CalcKeyL=(file->InxDescr[LocI].LenRec*(int)10000-(int)60000)/(int)file->InxDescr[LocI].UsedPageSize-(int)90000;
                if(((CalcKeyL/(int)10000)*(int)10000)!=CalcKeyL)
                {
                    Local->LastErrorCode=err_IndexHeaderCorrupt;
                    return 0;
                }
                else
                if((CalcKeyL>(int)MaxKeyLen*(int)10000)||(CalcKeyL<(int)10000))
                {
                    Local->LastErrorCode=err_MaxKeyLenIncompatible;
                    return 0;
                }
                else
                {
                    file->InxDescr[LocI].KeyLen=(unsigned short)(CalcKeyL/(int)10000);
                    file->BlockLen+=file->InxDescr[LocI].LenRec;
                    if(file->InxDescr[LocI].NumRec>file->MaxPages)
                    file->MaxPages=file->InxDescr[LocI].NumRec;
                    if(file->InxDescr[LocI].LenRec>file->NeedIndexBufferSize)
                        file->NeedIndexBufferSize=file->InxDescr[LocI].LenRec;
                }
            }
        }
    }
    return 1;
}

int OpenDat(P_local_files Local,P_pds_file file, char * name)
{
    if(file->FileType!=filetype_Data)
    {
        Local->LastErrorCode=err_BadFileType;
        return 0;
    }
    if(file->Handle!=-1)
    {
        Local->LastErrorCode=err_FileIsOpen;
        return 0;
    }
/*
    file->Handle=open(name,O_RDWR);
    if(file->Handle==-1)
    {
        Local->LastErrorCode=errno;
        return 0;
    }
    if(flock(file->Handle,LOCK_EX|LOCK_NB)!=0)
    {
        close(file->Handle);file->Handle=-1;
        Local->LastErrorCode=errno;
        message(3,"%d data lock error (Handle %d Name: %s)\n",getpid(),file->Handle,name,Local->LastErrorCode);
        return 0;
    }
*/
    file->Handle=OpenFileExclusive(name);
    if(file->Handle==-1)
    {
        Local->LastErrorCode=errno;
        return 0;
    }
    if(!InitDatInfo(Local,file))
    {
/*
        flock(file->Handle,LOCK_UN|LOCK_NB);
        close(file->Handle);
*/
        CloseFileExclusive(file->Handle);
        file->Handle=-1;
        return 0;
    }
    file->Flags|=fileflags_DataLocked;
    message(3,"%d data lock was successfull (Handle %d Name: %s)\n",getpid(),file->Handle,name);
    return 1;
}

int OpenInx(P_local_files Local,P_pds_file file, char * name)
{
    if(file->FileType!=filetype_Data)
    {
        Local->LastErrorCode=err_BadFileType;
        return 0;
    }
    if(file->InxHandle!=-1)
    {
        Local->LastErrorCode=err_FileIsOpen;
        return 0;
    }
    if(file->Handle==-1)
    {
        Local->LastErrorCode=err_FileNotOpen;
        return 0;
    }
/*
    file->InxHandle=open(name,O_RDWR);
    if(file->InxHandle==-1)
    {
        Local->LastErrorCode=errno;
        return 0;
    }
    if(flock(file->InxHandle,LOCK_EX|LOCK_NB)!=0)
    {
        close(file->InxHandle);file->InxHandle=-1;
        Local->LastErrorCode=errno;
        message(3,"%d index lock error (Handle %d Name: %s errno: %s)\n",getpid(),file->InxHandle,name,Local->LastErrorCode);
        return 0;
    }
*/
    file->Handle=OpenFileExclusive(name);
    if(file->Handle==-1)
    {
        Local->LastErrorCode=errno;
        return 0;
    }
    if(!InitInxInfo(Local,file))
    {
/*
        flock(file->InxHandle,LOCK_UN|LOCK_NB);
        close(file->InxHandle);file->InxHandle=-1;
*/
        CloseFileExclusive(file->InxHandle);
        file->InxHandle=-1;
        return 0;
    }
    file->Flags|=fileflags_IndexLocked;
    message(3,"%d index lock was successfull (Handle %d Name: %s)\n",getpid(),file->InxHandle,name);
    return 1;
}

/*
int LockData(P_local_files Local,P_pds_file file)
{
    int Result=0;
    if(file->Handle==-1)
        return 0;
    if(file->Flags&fileflags_DataLocked)
        return 1;
    if(flock(file->Handle,LOCK_EX|LOCK_NB)==0)
    {
        file->Flags|=fileflags_DataLocked;
        message(3,"%d data lock was successfull (Handle %d Name: %s)\n",getpid(),file->Handle,file->Name);
        Result=1;
    }
    else
    {
        Local->LastErrorCode=errno;
        message(3,"%d data lock error (Handle %d Name: %s)\n",getpid(),file->Handle,file->Name,Local->LastErrorCode);
    }
    return Result;
}

int LockIndex(P_local_files Local,P_pds_file file)
{
    int Result=0;
    if(file->InxHandle==-1)
        return 0;
    if(file->Flags&fileflags_IndexLocked)
        return 1;
    if(flock(file->InxHandle,LOCK_EX|LOCK_NB)==0)
    {
        file->Flags|=fileflags_IndexLocked;
        message(3,"%d index lock was successfull (Handle %d Name: %s)\n",getpid(),file->InxHandle,file->Name);
        Result=1;
    }
    else
    {
        Local->LastErrorCode=errno;
        message(3,"%d index lock error (Handle %d Name: %s errno: %s)\n",getpid(),file->InxHandle,file->Name,Local->LastErrorCode);
    }
    return Result;
}

int UnLockIndex(P_pds_file file)
{
    if(file->InxHandle==-1)
        return 0;
    if(file->Flags&fileflags_IndexLocked)
    {
        message(3,"%d Unlock index file Handle: %d Name: %s\n",getpid(),file->InxHandle,file->Name);
        flock(file->InxHandle,LOCK_UN|LOCK_NB);
        file->Flags&=~fileflags_IndexLocked;
    }
    return 1;
}

*/

int CloseIndex(P_pds_file file)
{
    if(file->InxHandle==-1)
        return 0;
//    UnLockIndex(file);
    close(file->InxHandle);
    file->InxHandle=-1;
    return 1;
}

int AllocLocalHandle(P_local_files * Local,int Index)
{
    if((*Local)->Opened==(*Local)->max_local_files)
    {
        if(!DoubleLocalFiles(Local))
        {
            return -1;
        }
    }
	int	LocalIndex=-1;
    if((*Local)->Opened<(*Local)->max_local_files)
    {
        LocalIndex=(*Local)->FirstFree;
		if(LocalIndex!=-1)
		{
			(*Local)->FirstFree=(*Local)->Files[LocalIndex].NextItem;
			if((*Local)->FirstFree!=-1)
				(*Local)->Files[(*Local)->FirstFree].PrevItem=-1;

			memset(&(*Local)->Files[LocalIndex],0,sizeof(local_file));
			(*Local)->Files[LocalIndex].Index=Index;
			if((*Local)->FirstOpen!=-1)
				(*Local)->Files[(*Local)->FirstOpen].PrevItem=LocalIndex;
			(*Local)->Files[LocalIndex].NextItem=(*Local)->FirstOpen;
			(*Local)->Files[LocalIndex].PrevItem=-1;
			(*Local)->Files[LocalIndex].MyFiles=*Local;
			(*Local)->FirstOpen=LocalIndex;
			(*Local)->Opened++;
		}
    }
    return LocalIndex;
}

// ******* OpenFile ******* //

int OpenFile(P_local_files * Local,char * Key,char *SubKey,char *FileName,unsigned short FileType,uint8_t NewAllowed,uint8_t Truncate,P_InitNewDatFile NewInfo,const char * Path)
{
	pid_t child_pid=getpid();
	int LocI;

	if((FileType==filetype_Data)&&(NewAllowed)&&(NewInfo==NULL))
	{
		(*Local)->LastErrorCode=err_BadParameters;
		return -1;
	}
	if(((FileType==filetype_TempDat)||(FileType==filetype_LocalTempData))&&(NewInfo==NULL))
	{
		(*Local)->LastErrorCode=err_BadParameters;
		return -1;
	}
	if((!ValidateFileName(FileName))||(!ValidateFileName(Key))||(!ValidateFileName(SubKey)))
	{
		(*Local)->LastErrorCode=err_BadParameters;
		return -1;
	}
	if((*Local)->MyKey!=-1)
	{
	    if(uint8_t(*Key)!=0)
        {
            if(strcmp(Key,_Files->Keys[(*Local)->MyKey].Key)!=0)
            {
                (*Local)->LastErrorCode=err_MultiKeyProhibited;
                return -1;
            }
        }
	}
	else
	{
        if(((*Local)->AuthorizedKey==-1)||(GetKeyIndex(*Local,Key,Path)!=(*Local)->AuthorizedKey))
        {
            LocI=GetKeyPassword(*Local,Key,Path);
            if(LocI>=0)
            {
                if(_Files->Keys[LocI].ValidPassword)
                {
                    (*Local)->LastErrorCode=err_KeySecured;
                    return -1;
                }
            }
        }
	}
	if(!semaphore_p(3,&(*Local)->LastErrorCode))
		return -1;
    int UsedKey=(*Local)->MyKey;
	if(UsedKey==-1)
	{
	    UsedKey=GetKeyIndex(*Local,Key,Path);
	    if(UsedKey==-1)
	    {
            (*Local)->LastErrorCode=GetLastFileError(*Local,err_Unspecified);
	        semaphore_v(3,&(*Local)->LastErrorCode);
	        return -1;
	    }
	    (*Local)->AuthorizedKey=UsedKey;
	}
	if((_Files->Keys[UsedKey].Locker!=0)&&(_Files->Keys[UsedKey].Locker!=child_pid))
	{
	    (*Local)->LastErrorCode=err_FileLocked;
        semaphore_v(3,&(*Local)->LastErrorCode);
        return -1;
	}
	int Index=-1;
	int SortedIndex=-1;
	int LocalIndex=-1;
	P_pds_file ActFile=NULL;
	if(FindFile(Key,SubKey,FileName,FileType,&SortedIndex))
	{
		Index=_Files_Sorted[SortedIndex];
	}
	if((FileType!=filetype_TempDat)&&(FileType!=filetype_LocalTempData)&&(Index!=-1))
	{
		if((_Files->Files[Index].FileType==FileType)||((_Files->Files[Index].FileType==filetype_Ini)&&(FileType==filetype_RAW)))
		{
			if(Truncate)
			{
				Index=-1;
				(*Local)->LastErrorCode=err_FileUsed;
			}
			else
			{
				_Files->Files[Index].Counter++;
				ActFile=&_Files->Files[Index];
			}
		}
		else
		{
			Index=-1;
			(*Local)->LastErrorCode=err_BadFileType;
		}
	}
	else
	{
		if(_Files->FirstFree>=0)
		{
			LocI=_Files->FirstFree;
			_Files->FirstFree=_Files->Files[LocI].NextFree;
			ClearPdsFile(&_Files->Files[LocI]);
			strncpy((char *)&_Files->Files[LocI].Key,Key,32);
			strncpy((char *)&_Files->Files[LocI].SubKey,SubKey,8);
			strncpy((char *)&_Files->Files[LocI].Name,FileName,12);

			char * NamePoint=_Files->Files[LocI].Name;
			char * TempName=NULL;

			if((FileType==filetype_TempDat)||((FileType==filetype_LocalTempData)))
			{
                char TempExt[]=".tmp.XXXXXX";
                int TempSize=strlen(NamePoint)+strlen(TempExt)+1;
                TempName=(char*)GetMem(TempSize);
                if(TempName!=NULL)
                {
                    strcpy(TempName,NamePoint);
                    strcat(TempName,TempExt);
                }
                NamePoint=TempName;
			}
            if(NamePoint!=NULL)
            {
                CheckGlobalIntegrity("before open");
                _Files->Files[LocI].FileType=FileType;
                _Files->Files[LocI].Counter=1;
                _Files->Generation++;
                _Files->Files[LocI].FileGen=_Files->Generation;
                _Files->Files[LocI].Random=1+rand()%65534;
                message(2,"%d First open %s (globalni index %d, sorted index: %d) FileType %d RandID %d\n",child_pid,FileName,LocI,SortedIndex,FileType,_Files->Files[LocI].Random);
                if(_Files->Opened>SortedIndex)
                {
                    memmove(&_Files_Sorted[SortedIndex+1],&_Files_Sorted[SortedIndex],(_Files->Opened-SortedIndex)*sizeof(int));
                }
                _Files_Sorted[SortedIndex]=LocI;
                _Files->Opened++;
                Index=LocI;
                int RealNameLen=0;
                switch(FileType)
                {
                    case filetype_Data:
                    case filetype_TempDat:
                    case filetype_LocalTempData:
                    {
                        uint8_t IAmCreateData=0;
                        RealNameLen+=strlen(Path)+strlen(NamePoint)+1;
                        if(FileType==filetype_Data)
                        {
                            RealNameLen+=strlen(datExtension);
                        }
                        if(FileType!=filetype_LocalTempData)
                        {
                            LocI=strlen(_Files->Files[Index].Key);
                            if(LocI)
                                RealNameLen+=LocI+1;
                            else
                            if(strlen(Path)==0)
                                RealNameLen+=strlen(DefaultKey)+1;
                            LocI=strlen(_Files->Files[Index].SubKey);
                            if(LocI)
                                RealNameLen+=LocI+1;
                        }
                        char * RealName=(char *)GetMem(RealNameLen);
                        if(RealName==NULL)
                        {
                            CloseGlobalFile(Index,0);
                            Index=-1;
                        }
                        else
                        {
                            memset(RealName,0,1);
                            strcat(RealName,Path);
                            if(FileType!=filetype_LocalTempData)
                            {
                                if(strlen(_Files->Files[Index].Key))
                                {
                                    strcat(RealName,_Files->Files[Index].Key);
                                    strcat(RealName,"/");
                                }
                                else
                                if(strlen(Path)==0)
                                {
                                    strcat(RealName,DefaultKey);
                                    strcat(RealName,"/");
                                }
                                if(strlen(_Files->Files[Index].SubKey))
                                {
                                    strcat(RealName,_Files->Files[Index].SubKey);
                                    strcat(RealName,"/");
                                }
                            }
                            strcat(RealName,NamePoint);
                            if((FileType==filetype_TempDat)||(FileType==filetype_LocalTempData))
                            {
                                _Files->Files[Index].Handle=mkstemp(RealName);
                                if(_Files->Files[Index].Handle!=-1)
                                {
                                    if(IsamInitDatFile(*Local,_Files->Files[Index].Handle,NewInfo->RecSize,NewInfo->NrOfKeys))
                                    {
                                        IAmCreateData=1;
                                    }
                                    else
                                    {
                                        CloseGlobalFile(Index,0);
                                        Index=-1;
                                    }
                                }
                            }
                            else
                            {
                                strcat(RealName,datExtension);
                                if(Truncate)
                                {
                                    message(1,"%d Truncate DataFile %s\n",getpid(),RealName);
                                    _Files->Files[Index].Handle=open(RealName,O_CREAT|O_RDWR|O_TRUNC|O_EXCL|O_BINARY,NewFileMode);
                                    if(_Files->Files[Index].Handle!=-1)
                                    {
                                        if(IsamInitDatFile(*Local,_Files->Files[Index].Handle,NewInfo->RecSize,NewInfo->NrOfKeys))
                                        {
                                            IAmCreateData=1;
                                        }
                                        else
                                        {
                                            CloseGlobalFile(Index,0);
                                            Index=-1;
                                        }
                                    }
                                }
                                else
                                    _Files->Files[Index].Handle=open(RealName,O_RDWR|O_BINARY);
                                if((_Files->Files[Index].Handle==-1)&&(errno==2)&&(NewAllowed))
                                {
                                    if(index_semaphore_p(Index))
                                    {
                                        _Files->Files[Index].Handle=open(RealName,O_CREAT|O_EXCL|O_RDWR|O_TRUNC|O_BINARY,NewFileMode);
                                        if(_Files->Files[Index].Handle!=-1)
                                        {
                                            IAmCreateData=1;
                                            _Files->Files[Index].Locker=child_pid;
                                            _Files->Files[Index].LockLevel++;
                                        }
                                        index_semaphore_v(Index);
                                        if(_Files->Files[Index].Handle!=-1)
                                        {
                                            if(IsamInitDatFile(*Local,_Files->Files[Index].Handle,NewInfo->RecSize,NewInfo->NrOfKeys))
                                            {
                                                IAmCreateData=1;
                                            }
                                            else
                                            {
                                                CloseGlobalFile(Index,0);
                                                Index=-1;
                                            }
                                        }
                                        else
                                        {
                                            Index=-1;
                                        }
                                    }
                                }
                            }
                            if(Index!=-1)
                            {
                                if(_Files->Files[Index].Handle==-1)
                                {
                                    (*Local)->LastErrorCode=errno;
                                    message(0,"%d Nelze otevrit soubor %s chyba %d\n",getpid(),RealName,errno);
                                    CloseGlobalFile(Index,0);
                                    Index=-1;
                                }
                                else
                                {
                                    ActFile=&_Files->Files[Index];
                                    message(2,"%d Soubor %s otevren. Deskriptor: %d\n",getpid(),RealName,ActFile->Handle);
                                    if(!InitDatInfo(*Local,ActFile))
                                    {
                                        CloseGlobalFile(Index,0);
                                        Index=-1;
                                    }
                                }
                                if(Index!=-1)
                                {
                                    if(FileType==filetype_Data)
                                    {
                                        LocI=strlen(RealName)+1;

                                        _Files->Files[Index].RealName=(char*)GetMem(LocI);
                                        if(_Files->Files[Index].RealName)
                                          strcpy(_Files->Files[Index].RealName,RealName);
                                        char * LocPCh=RealName;
                                        LocPCh+=strlen(RealName)-strlen(datExtension);
                                        memcpy(LocPCh,inxExtension,strlen(inxExtension));
                                        if(IAmCreateData)
                                        {
                                            if(_Files->Files[Index].datInfo.NrOfKeys==NewInfo->NrOfKeys)
                                            {
                                                _Files->Files[Index].InxHandle=open(RealName,O_CREAT|O_RDWR|O_TRUNC|O_EXCL|O_BINARY,NewFileMode);
                                                if(_Files->Files[Index].InxHandle!=-1)
                                                {
                                                    if(!IsamInitInxFile(*Local,&_Files->Files[Index],NewInfo))
                                                    {
                                                        CloseGlobalFile(Index,0);
                                                        Index=-1;
                                                    }
                                                }
                                            }
                                            else
                                            {
                                                (*Local)->LastErrorCode=err_KeyGap;
                                                CloseGlobalFile(Index,0);
                                                Index=-1;
                                            }
                                        }
                                        else
                                            _Files->Files[Index].InxHandle=open(RealName,O_RDWR|O_BINARY);
                                        if(Index!=-1)
                                        {
                                            if((_Files->Files[Index].InxHandle==-1)&&(NewAllowed)&&(errno==2))
                                            {
                                                _Files->Files[Index].InxHandle=open(RealName,O_CREAT|O_EXCL|O_RDWR|O_TRUNC|O_BINARY,NewFileMode);
                                                if(_Files->Files[Index].Handle!=-1)
                                                {
                                                    if(!IsamInitInxFile(*Local,&_Files->Files[Index],NewInfo))
                                                    {
                                                        CloseGlobalFile(Index,0);
                                                        Index=-1;
                                                    }
                                                }
                                            }
                                            if((Index==-1)||(_Files->Files[Index].InxHandle==-1))
                                            {
                                                message(0,"Nelze otevrit soubor %s chyba %d\n",RealName,errno);
                                                (*Local)->LastErrorCode=errno;
                                                if(Index!=-1)
                                                {
                                                    CloseGlobalFile(Index,0);
                                                    Index=-1;
                                                }
                                            }
                                            else
                                            {
                                                if(!InitInxInfo(*Local,&_Files->Files[Index]))
                                                {
                                                    if((*Local)->LastErrorCode==err_IndexHeaderCorrupt)
                                                    {
                                                        CloseIndex(&_Files->Files[Index]);
                                                        remove(RealName);
                                                    }
                                                    CloseGlobalFile(Index,0);
                                                    Index=-1;
                                                }
                                                if(Index==-1)
                                                {
                                                    message(0,"Chyba %d pri otevreni souboru %s\n",(*Local)->LastErrorCode,RealName);
                                                    if((*Local)->LastErrorCode==err_IndexHeaderCorrupt)
                                                    {
                                                        (*Local)->LastErrorCode=2;
                                                    }
                                                }
                                                else
                                                {
                                                    message(2,"Soubor %s otevren. Deskriptor: %d\n",RealName,_Files->Files[Index].InxHandle);
                                                }
                                            }
                                        }
                                    }
                                    else
                                    if((FileType==filetype_LocalTempData)&&(IAmCreateData))
                                    {
                                        LocI=strlen(RealName)+1;
                                        _Files->Files[Index].RealName=(char*)GetMem(LocI);
                                        if(_Files->Files[Index].RealName)
                                          strcpy(_Files->Files[Index].RealName,RealName);

                                        LocI=strlen(Path)+strlen(NamePoint)+1;
                                        _Files->Files[Index].RealIndexName=(char*)GetMem(LocI);
                                        memset(_Files->Files[Index].RealIndexName,0,1);
                                        strcat(_Files->Files[Index].RealIndexName,Path);
                                        strcat(_Files->Files[Index].RealIndexName,NamePoint);

                                        if(_Files->Files[Index].datInfo.NrOfKeys==NewInfo->NrOfKeys)
                                        {
                                            _Files->Files[Index].InxHandle=mkstemp(_Files->Files[Index].RealIndexName);
                                            if(_Files->Files[Index].InxHandle!=-1)
                                            {
                                                if(!IsamInitInxFile(*Local,&_Files->Files[Index],NewInfo))
                                                {
                                                    CloseGlobalFile(Index,0);
                                                    Index=-1;
                                                }
                                            }
                                            else
                                            {
                                                message(0,"Nelze otevrit soubor %s chyba %d\n",RealName,errno);
                                                (*Local)->LastErrorCode=errno;
                                                CloseGlobalFile(Index,0);
                                                Index=-1;
                                            }
                                        }
                                        else
                                        {
                                            (*Local)->LastErrorCode=err_KeyGap;
                                            CloseGlobalFile(Index,0);
                                            Index=-1;
                                        }

                                        if(Index!=-1)
                                        {
                                            if(!InitInxInfo(*Local,&_Files->Files[Index]))
                                            {
                                                CloseGlobalFile(Index,0);
                                                Index=-1;
                                            }
                                            else
                                            {
                                                message(2,"Docasny index %s otevren. Deskriptor: %d\n",_Files->Files[Index].RealIndexName,_Files->Files[Index].InxHandle);
                                            }
                                        }
                                    }
                                    else
                                    {
                                        message(2,"Soubor %s otevren. Deskriptor: %d\n",RealName,_Files->Files[Index].InxHandle);
                                        _Files->Files[Index].RealName=RealName;RealName=NULL;
                                    }
                                }
                            }
                            if(RealName)
                            {
                                FreeMem(RealName);
                                RealName=NULL;
                            }
                        }
                        break;
                    }
                    case filetype_RAW: // RAW
                    case filetype_Ini: // Ini
                    {
                        _Files->Files[Index].FileType=FileType;
                        RealNameLen+=strlen(Path)+strlen(_Files->Files[Index].Name)+1;
                        LocI=strlen(_Files->Files[Index].Key);
                        if(LocI)
                            RealNameLen+=LocI+1;
                        else
                            RealNameLen+=strlen(DefaultKey)+1;
                        LocI=strlen(_Files->Files[Index].SubKey);
                        if(LocI)
                            RealNameLen+=LocI+1;
                        char * RealName=(char *)GetMem(RealNameLen);
                        if(RealName==NULL)
                        {
                            CloseGlobalFile(Index,0);
                            Index=-1;
                        }
                        else
                        {
                            memset(RealName,0,1);
                            strcat(RealName,Path);
                            if(strlen(_Files->Files[Index].Key))
                            {
                                strcat(RealName,_Files->Files[Index].Key);
                                strcat(RealName,"/");
                            }
                            else
                            {
                                strcat(RealName,DefaultKey);
                                strcat(RealName,"/");
                            }
                            if(strlen(_Files->Files[Index].SubKey))
                            {
                                strcat(RealName,_Files->Files[Index].SubKey);
                                strcat(RealName,"/");
                            }
                            strcat(RealName,_Files->Files[Index].Name);
                            if(Truncate)
                              _Files->Files[Index].Handle=open(RealName,O_CREAT|O_EXCL|O_RDWR|O_TRUNC|O_BINARY,NewFileMode);
                            else
                              _Files->Files[Index].Handle=open(RealName,O_RDWR|O_BINARY);
                            if(_Files->Files[Index].Handle==-1)
                            {
                                if((errno==2)&&(NewAllowed))
                                {
                                    if(index_semaphore_p(Index))
                                    {
                                        _Files->Files[Index].Handle=open(RealName,O_CREAT|O_EXCL|O_RDWR|O_TRUNC|O_BINARY,NewFileMode);
                                        if(_Files->Files[Index].Handle!=-1)
                                        {
                                            _Files->Files[Index].Locker=child_pid;
                                            _Files->Files[Index].LockLevel++;
                                        }
                                        index_semaphore_v(Index);
                                    }
                                }
                            }
                            if(_Files->Files[Index].Handle==-1)
                            {
                                (*Local)->LastErrorCode=errno;
                                message(0,"Nelze otevrit soubor %s chyba %d\n",RealName,errno);
                                if(Index!=-1)
                                    CloseGlobalFile(Index,0);
                                Index=-1;
                                FreeMem(RealName);RealName=NULL;
                            }
                            else
                            {
                                if(Truncate)
                                {
                                    _Files->Files[Index].Locker=child_pid;
                                    _Files->Files[Index].LockLevel++;
                                }
                                InitLogBuffer(*Local);
                                if(FileType==filetype_RAW)
                                    AddToLogBuffer(*Local,2,"RAW");
                                else
                                    AddToLogBuffer(*Local,2,"INI");
                                message(2,"%s soubor %s otevren. Deskriptor: %d FileType: %d\n",(*Local)->LogBuffer,RealName,_Files->Files[Index].Handle,_Files->Files[Index].FileType);
                                _Files->Files[Index].RealName=RealName;RealName=NULL;
                            }
                        }
                        break;
                    }
                    default:
                    {
                        CloseGlobalFile(Index,0);
                        Index=-1;
                        (*Local)->LastErrorCode=err_BadFileType;
                        break;
                    }
                }
                if(TempName!=NULL)
                    FreeMem(TempName);
            }
            else
            {
                Index=-1;
                (*Local)->LastErrorCode=err_LowMemory;
            }
		}
		else
		{
		    (*Local)->LastErrorCode=err_NoFreeFileHandles;
		}
	}
	if(!semaphore_v(3,&(*Local)->LastErrorCode))
	{
		if(Index>=0)
			CloseGlobalFile(Index,0);
		return -1;
	}
	if(Index>=0)
	{
		if(FileType==filetype_Ini)
		{
			int LocI=(*Local)->FirstOpen;
			while(LocI!=-1)
			{
				if(Index==(*Local)->Files[LocI].Index)
				{
					_Files->Files[Index].Counter--;
					return LocI;
				}
				LocI=(*Local)->Files[LocI].NextItem;
			}
		}
		int PreOpened=(*Local)->Opened;
		LocalIndex=AllocLocalHandle(Local,Index);
		if(LocalIndex!=-1)
		{
            if(!PreOpened)
            {
			    _Files->Keys[UsedKey].UseCount++;
                message(2,"%d Zvyseni pocitadla pouziti klice \"%s\" na %d\n",getpid(),_Files->Keys[UsedKey].Key,_Files->Keys[UsedKey].UseCount);
			}
			if((*Local)->MyKey==-1)
            {
                (*Local)->MyKey=UsedKey;
            }
			if((FileType==filetype_Data)||(FileType==filetype_LocalTempData))
			{
				for(LocI=1;LocI<=ActFile->datInfo.NrOfKeys;LocI++)
					{
						(*Local)->Files[LocalIndex].IndexArr[LocI].PathInd=0;
						(*Local)->Files[LocalIndex].IndexArr[LocI].SequentialOK=0;
					}
				if(ActFile->NeedIndexBufferSize>(*Local)->IndexBufferSize)
				{
					void * NewIndexBuffer=GetMem(ActFile->NeedIndexBufferSize);
					if(NewIndexBuffer==NULL)
					{
						(*Local)->LastErrorCode=err_LowMemory;
						CloseLocalFile(*Local,LocalIndex);
						LocalIndex=-1;Index=-1;
					}
					else
					{
						if((*Local)->IndexBuffer)
							FreeMem((*Local)->IndexBuffer);
						(*Local)->IndexBuffer=NewIndexBuffer;
						(*Local)->IndexBufferSize=ActFile->NeedIndexBufferSize;
					}
				}
			}
		}
		else
		{
			if(Index!=-1)
				CloseGlobalFile(Index,1);
			Index=-1;
		}
	}
	if(Index!=-1)
		return LocalIndex;
	else
		return Index;
}

// ******* OpenFileDirect ******* //

int OpenFileDirect(P_local_files * Local,const char * _RealName,const char * _FileName,unsigned short FileType,uint8_t NewAllowed,uint8_t Truncate,uint8_t ReadOnly)
{
	pid_t child_pid=getpid();

    if((FileType!=filetype_Ini)&&(FileType!=filetype_RAW))
    {
		(*Local)->LastErrorCode=err_BadParameters;
		return -1;
    }
	if(_RealName==NULL)
	{
		(*Local)->LastErrorCode=err_BadParameters;
		return -1;
	}
	if(strlen(_RealName)==0)
	{
		(*Local)->LastErrorCode=err_BadParameters;
		return -1;
	}
	if(!semaphore_p(3,&(*Local)->LastErrorCode))
		return -1;
	int Index=-1;
	int LocalIndex=-1;
	int LocI;

	char Key[]=".Direct.";
	char SubKey[]="";

    char * RealName=CloneStr(_RealName);
    if(RealName==NULL)
    {
        return -1;
    }
    char * FileName=CloneStr(_FileName);
    if(FileName==NULL)
    {
        StrDispose(&RealName);
        return -1;
    }

    if(FindFile(Key,SubKey,FileName,FileType,&Index))
    {
        Index=_Files_Sorted[Index];
        if(_Files->Files[Index].FileType==FileType)
        {
            if(Truncate)
            {
                Index=-1;
                (*Local)->LastErrorCode=err_FileUsed;
            }
            else
            {
                _Files->Files[Index].Counter++;
            }
        }
        else
        {
            Index=-1;
            (*Local)->LastErrorCode=err_BadFileType;
        }
    }
    else
    {
        if(_Files->FirstFree>=0)
        {
            CheckGlobalIntegrity("before open direct");
            LocI=_Files->FirstFree;
            _Files->FirstFree=_Files->Files[LocI].NextFree;
            ClearPdsFile(&_Files->Files[LocI]);
            strncpy((char *)&_Files->Files[LocI].Key,Key,32);
            strncpy((char *)&_Files->Files[LocI].SubKey,SubKey,8);
            strncpy((char *)&_Files->Files[LocI].Name,FileName,12);

            _Files->Files[LocI].FileType=FileType;
            _Files->Files[LocI].Counter=1;
            _Files->Generation++;
            _Files->Files[LocI].FileGen=_Files->Generation;
            _Files->Files[LocI].Random=1+rand()%65534;
            message(2,"First direct open %s (globalni index %d) FileType %d RandID %d\n",FileName,LocI,FileType,_Files->Files[LocI].Random);
            if(_Files->Opened>Index)
            {
                memmove(&_Files_Sorted[Index+1],&_Files_Sorted[Index],(_Files->Opened-Index)*sizeof(int));
            }
            _Files_Sorted[Index]=LocI;
            _Files->Opened++;
            Index=LocI;

            _Files->Files[Index].FileType=FileType;
            LocI=strlen(_Files->Files[Index].Key);
            if(Truncate)
              _Files->Files[Index].Handle=open(RealName,O_CREAT|O_EXCL|O_RDWR|O_TRUNC|O_BINARY,NewFileMode);
            else
            {
              int Flags=O_RDWR|O_BINARY;
              if(ReadOnly)
                Flags=O_RDONLY|O_BINARY;
              _Files->Files[Index].Handle=open(RealName,Flags);
            }
            if(_Files->Files[Index].Handle==-1)
            {
                if((errno==2)&&(NewAllowed))
                {
                    if(index_semaphore_p(Index))
                    {
                        _Files->Files[Index].Handle=open(RealName,O_CREAT|O_EXCL|O_RDWR|O_TRUNC|O_BINARY,NewFileMode);
                        if(_Files->Files[Index].Handle!=-1)
                        {
                            _Files->Files[Index].Locker=child_pid;
                            _Files->Files[Index].LockLevel++;
                        }
                        index_semaphore_v(Index);
                    }
                }
            }
            if(_Files->Files[Index].Handle==-1)
            {
                if(errno)
                (*Local)->LastErrorCode=errno;
                if(errno!=2)
                    message(0,"Nelze otevrit soubor %s chyba %d\n",RealName,errno);
                CloseGlobalFile(Index,0);
                Index=-1;
            }
            else
            {
                if(Truncate)
                {
                    _Files->Files[Index].Locker=child_pid;
                    _Files->Files[Index].LockLevel++;
                }
                InitLogBuffer(*Local);
                if(FileType==filetype_RAW)
                    AddToLogBuffer(*Local,2,"RAW");
                else
                    AddToLogBuffer(*Local,2,"INI");
                message(2,"%s soubor %s otevren. Deskriptor: %d FileType: %d\n",(*Local)->LogBuffer,RealName,_Files->Files[Index].Handle,_Files->Files[Index].FileType);
                int RNL=strlen(RealName)+1;
                _Files->Files[Index].RealName=(char*)GetMem(RNL);
                if(_Files->Files[Index].RealName==NULL)
                {
                    (*Local)->LastErrorCode=err_LowMemory;
                    CloseGlobalFile(Index,0);
                    Index=-1;
                }
                else
                {
                    memcpy(_Files->Files[Index].RealName,RealName,RNL);
                }
            }
        }
        else
        {
            (*Local)->LastErrorCode=err_NoFreeFileHandles;
        }
    }
    if(!semaphore_v(3,&(*Local)->LastErrorCode))
    {
        if(Index>=0)
            CloseGlobalFile(Index,0);
        StrDispose(&FileName);
        StrDispose(&RealName);
        return -1;
    }
    if(Index>=0)
    {
        if(FileType==filetype_Ini)
        {
            int LocI=(*Local)->FirstOpen;
            while(LocI!=-1)
            {
                if(Index==(*Local)->Files[LocI].Index)
                {
                    _Files->Files[Index].Counter--;
                    StrDispose(&FileName);
                    StrDispose(&RealName);
                    return LocI;
                }
                LocI=(*Local)->Files[LocI].NextItem;
            }
        }

        LocalIndex=AllocLocalHandle(Local,Index);
        if(LocalIndex==-1)
        {
            if(Index!=-1)
                CloseGlobalFile(Index,1);
            Index=-1;
        }
    }

    StrDispose(&FileName);
    StrDispose(&RealName);

	if(Index!=-1)
		return LocalIndex;
	else
		return Index;
}

// ******* CloneFile ******* //

int CloneFile(P_local_files * Local,fileID fID,unsigned short fileType)
{
	int Index=-1;
	if(AppropriateLocalFile(*Local,fID,fileType,1,pds_CloneFile))
	{
        int UsedKey=(*Local)->MyKey;
        if(UsedKey!=-1)
        {
            if(semaphore_p(3,&(*Local)->LastErrorCode))
            {
                Index=AllocLocalHandle(Local,(*Local)->Files[fID.Index].Index);
                if(Index>=0)
                {
                    _Files->Files[(*Local)->Files[fID.Index].Index].Counter++;
                }
                if(!semaphore_v(3,&(*Local)->LastErrorCode))
                {
                    if(Index>=0)
                        CloseLocalFile(*Local,Index);
                    Index=-1;
                }
            }
        }
	}
	return Index;
}

void CloseAllLocalFiles(P_local_files _Local)
{
	if(_Local)
	{
        message(2,"%d CloseAllLocalFiles (%d)\n",getpid(),_Local->Opened);
		int LocI;
		while(_Local->FirstOpen!=-1)
		{
			LocI=_Local->FirstOpen;
   			CloseLocalFile(_Local,_Local->FirstOpen);
			if(LocI==_Local->FirstOpen)
			{
				message(0,"%d Nelze uzavrit vsechny soubory !\n",getpid());
				break;
			}
		}
		if(_Files)
		{
			message(2,"%d LocalOpenTable: %d OpenTable: %d\n",getpid(),_Local->Opened,_Files->Opened);
		}
	}
}

int CheckFileID(fileID fID)
{
	if(((int)fID.Index>=0)&&((int)fID.Index<MaxFiles))
	{
		if((fID.Random==_Files->Files[fID.Index].Random)&&(fID.FileGen==_Files->Files[fID.Index].FileGen))
			return 1;
	}
	return 0;
}

int CheckLocalFileID(P_local_files _Local,fileID fID,unsigned short int msgID)
{
	if(((int)fID.Index<_Local->max_local_files)&&((int)fID.Index>=0))
	{
		int Index=_Local->Files[fID.Index].Index;
		if((Index>=0)&&(Index<MaxFiles))
		{
			if((fID.Random==_Files->Files[Index].Random)&&(fID.FileGen==_Files->Files[Index].FileGen))
			{
			    if(msgID)
			    {
			        switch(msgID)
			        {
			            case pds_NextKey:
			            {
			                _Local->Files[fID.Index].PrevPreCount=0;
			                if(_Local->Files[fID.Index].NextPreCount<0xff)
			                {
                                _Local->Files[fID.Index].NextPreCount++;
			                }
			            }
			            case pds_PrevKey:
			            {
			                if(_Local->Files[fID.Index].PrevPreCount<0xff)
			                {
                                _Local->Files[fID.Index].PrevPreCount++;
			                }
			                _Local->Files[fID.Index].NextPreCount=0;
			            }
			            case pds_LockRec:
			            case pds_UnlockRec:
			            case pds_IndexCount:
			            case pds_TotalRecs:
			            case pds_FreeRecs:
			            case pds_CloneFile:
			            {
			                break;
			            }
			            default:
			            {
			                _Local->Files[fID.Index].PrevPreCount=0;
			                _Local->Files[fID.Index].NextPreCount=0;
			                break;
			            }
			        }
			        _Local->PrevPreCount=_Local->Files[fID.Index].PrevPreCount;
			        _Local->NextPreCount=_Local->Files[fID.Index].NextPreCount;
			    }
				return 1;
			}
			message(0,"%d Pozadavek na neplatny soubor (LocalIndex=%d, Index=%d, Random=[%d,%d], Filegen=[%d,%d])\n",getpid(),fID.Index,Index,fID.Random,_Files->Files[Index].Random,fID.FileGen,_Files->Files[Index].FileGen);
		}
		else
		{
			message(0,"%d Pozadavek na neplatny soubor (LocalIndex=%d, Index=%d)\n",getpid(),fID.Index,Index);
		}
	}
	else
	{
		message(0,"%d Pozadavek na neplatny soubor (LocalIndex=%d)\n",getpid(),fID.Index);
	}
	return 0;
}

int LocalIndexToGlobal(P_local_files _Local,P_fileID fID,unsigned short int msgID)
{
	if((int)fID->Index<_Local->max_local_files)
	{
		if(CheckLocalFileID(_Local,*fID,msgID))
		{
			if(_Local->Files[fID->Index].Index!=-1)
			{
				fID->Index=_Local->Files[fID->Index].Index;
				return 1;
			}
		}
	}
	return 0;
}

int AppropriateFile(P_local_files Local,fileID fID,unsigned short Type,uint8_t ForWrite)
{
	if(!CheckFileID(fID))
	{
		Local->LastErrorCode=err_BadDescriptor;
		return 0;
	}
	int Index=fID.Index;
	pid_t child_pid=getpid();
	if(_Files->Files[Index].FileType!=Type)
	{
        message(0,"%d BadFileType, potreba %d skutecnost %d pro globalni index %d name %s\n",child_pid,Type,_Files->Files[Index].FileType,Index,_Files->Files[Index].Name);
		Local->LastErrorCode=err_BadFileType;
		return 0;
	}
	if(_Files->Files[Index].Approp==child_pid)
	{
		_Files->Files[Index].AppropLevel++;
		return 1;
	}
	if(!index_semaphore_p(Index))   // uzamceni semaforu pro vyhrazovani souboru
	{
		Local->LastErrorCode=err_Semaphores;
		return 0;
	}
	if((_Files->Files[Index].Locker!=0)&&(_Files->Files[Index].Locker!=child_pid))  // soubor je uzamcen jinym procesem
	{
		Local->LastErrorCode=err_FileLocked;
		index_semaphore_v(Index);
		return 0;
	}
	if(ForWrite)
	{
		if((_Files->Files[Index].ReadLocker!=0)&&(_Files->Files[Index].ReadLocker!=child_pid)) // soubor je uzamcen proti zapisu jinym procesem
		{
			Local->LastErrorCode=err_FileLocked;
			index_semaphore_v(Index);
			return 0;
		}
	}
	if(_Files->Files[Index].Approp==-1) // soubor neni nikym vyhrazen a lze provest jeho vyhrazeni
	{
		_Files->Files[Index].Approp=getpid();
		_Files->Files[Index].AppropLevel=1;
		index_semaphore_v(Index);
	}
#ifndef LOCAL
	else // soubor je momentalne vyhrazen
	{
		status_message msg;
		pid_t Mypid=child_pid;
		if(_Files->Files[Index].Approp==Mypid) // soubor je vyhrazen aktualnim vlaknem
		{
			_Files->Files[Index].AppropLevel++;
			index_semaphore_v(Index);
			return 1;
		}
		int res_msg;
		if(_Files->Files[Index].Expectant==-1) // soubor je vyhrazen jinym vlaknem, ale zadne vlakno neceka na jeho uvolneni
		{
			_Files->Files[Index].Expectant=Mypid;
		}
		else // soubor je vyhrazen jinym vlaknem, a na uvolneni jiz ceka dalsi vlakno
		{
			memset(&msg,0,sizeof(msg));
			msg.message_type=_Files->Files[Index].Expectant;
			msg.sign=valid_sign;
			msg.status=file_next_expectant;
    		msg.pid=Mypid;
			if(msgsnd(msg_id,&msg,status_message_size,0)!=0)
			{
				index_semaphore_v(Index);
				return 0;
			}
            message(5,"%d odeslana zprava pro zarazeni procesu %d do fronty cekajicich na vyhrazeni souboru %d procesu %\n",Mypid,Mypid,Index,_Files->Files[Index].Expectant);
		}
		index_semaphore_v(Index);
		message(5,"%d ocekavani vyhrazeni souboru %d\n",Mypid,Index);
		pid_t Expectant=-1;
		while(1)
		{
			res_msg=msgrcv(msg_id,&msg,status_message_size,Mypid,0);
	  		if(res_msg==-1)
  			{
				return 0;
	  		}
			else
			if((res_msg==status_message_size)&&(msg.sign==valid_sign))
			{
				switch(msg.status)
				{
					case file_appropriated:
					{
						message(5,"%d soubor %d vyhrazen\n",Mypid,Index);
						return 1;
						break;
					}
					case file_next_expectant:
					{
						if(Expectant==-1)
						{
							Expectant=msg.pid;
                            message(5,"%d zarazeni procesu %d do fronty cekajicich na vyhrazeni souboru %d\n",Mypid,msg.pid,Index);
						}
						else
						{
							msg.message_type=Expectant;
							if(msgsnd(msg_id,&msg,status_message_size,0)!=0)
							{
								msg.message_type=msg.pid;
								msg.status=file_fatalerror;
								if(msgsnd(msg_id,&msg,status_message_size,0)!=0)
								{
									message(0,"%d Fatalni chyba pri retezeni vyhrazovani souboru %d\n",Mypid,Index);
								}
							}
                            message(5,"%d preposlana zprava pro zarazeni procesu %d do fronty cekajicich na vyhrazeni souboru %d procesu %\n",Mypid,msg.pid,Index,Expectant);
						}
						break;
					}
					case file_fatalerror:
					{
						message(0,"%d nelze vyhradit soubor %d (Navracen fatalerror)\n",Mypid,Index);
						return 0;
						break;
					}
					case file_setexpectant:
					{
						message(5,"%d set Expectant %d\n",Mypid,Expectant);
						_Files->Files[Index].Expectant=Expectant;
						Expectant=-1;
						msg.message_type=msg.pid;
						msg.status=file_expectantok;
    					msg.pid=Mypid;
						if(msgsnd(msg_id,&msg,status_message_size,0)!=0)
						{
							message(0,"%d Fatalni chyba ! Nepodarilo se odeslat potvrzovaci zpravu vyhrazovateli\n",Mypid);
						}
						break;
					}
					default:
					{
						message(0,"%d neocekavana zprava %d pri cekani na vyhrazeni souboru %d\n",Mypid,msg.status,Index);
					}
				}
			}
		}
	}
#else
    else
    {
        return 0;
    }
#endif
	return 1;
}

int UnAppropriateFile(fileID fID)
{
	if(!CheckFileID(fID))
		return 0;
	int Index=fID.Index;
	pid_t child_pid=getpid();
	if(_Files->Files[Index].Approp!=child_pid)
	{
		return 0;
	}

	if((_Files->Files[Index].Approp==child_pid)&&(_Files->Files[Index].AppropLevel>1))
	{
		_Files->Files[Index].AppropLevel--;
		return 1;
	}
	if(! index_semaphore_p(Index))
		return 0;
	FreePageBuffers(&_Files->Files[Index]);
	_Files->Files[Index].AppropLevel--;
	if(_Files->Files[Index].AppropLevel)
	{
		index_semaphore_v(Index);
		return 1;
	}
#ifndef LOCAL
	status_message msg;
	pid_t Mypid=child_pid;
	int res_msg;
	pid_t Expectant;
	int OK=0;
	Expectant=_Files->Files[Index].Expectant;
	_Files->Files[Index].Approp=Expectant;
	if(Expectant!=-1)
	{
		_Files->Files[Index].AppropLevel++;
		message(5,"%d uvolneni vyhrazeneho souboru %d\n",Mypid,Index);
		memset(&msg,0,sizeof(msg));
		msg.message_type=Expectant;
		msg.sign=valid_sign;
		msg.status=file_setexpectant;
		msg.pid=Mypid;
		if(msgsnd(msg_id,&msg,status_message_size,0)==0)
		{
			while(!OK)
			{
				res_msg=msgrcv(msg_id,&msg,status_message_size,Mypid,0);
  				if(res_msg==-1)
				{
					message(0,"%d Fatalni chyba ! Nelze prijmout zpravu o nastaveni dalsiho cekatele na soubor %d",Mypid,Index);
					OK++;
 					}
				else
				if((res_msg==status_message_size)&&(msg.sign==valid_sign))
				{
					if(msg.status==file_expectantok)
					{
						OK++;
					}
					else
					{
						message(0,"%d neocekavana zprava %d pri cekani na nastaveni dalsiho cekatele na soubor %d\n",Mypid,msg.status,Index);
					}
				}
			}
		}
		else
		{
			message(0,"%d Fatalni chyba ! Nepodarilo se odeslat zpravu cekateli %d na vyhrazeni souboru %d\n",Mypid,Expectant,Index);
			_Files->Files[Index].Expectant=-1;
		}
		index_semaphore_v(Index);
		memset(&msg,0,sizeof(msg));
		msg.message_type=Expectant;
		msg.sign=valid_sign;
		msg.status=file_appropriated;
		msg.pid=Mypid;
		if(msgsnd(msg_id,&msg,status_message_size,0)!=0)
		{
			message(0,"%d Fatalni chyba ! Nepodarilo se cekatele %d informovat o na vyhrazeni souboru %d\n",Mypid,Expectant,Index);
		}
		return 1;
	}
	index_semaphore_v(Index);
	return 1;
#else
	index_semaphore_v(Index);
	return 0;
#endif
}

int AppropriateLocalFile(P_local_files _Local,fileID fID,unsigned short Type,uint8_t ForWrite,unsigned short int msgID)
{
	if(CheckLocalFileID(_Local,fID,msgID))
	{
		fID.Index=_Local->Files[fID.Index].Index;
		return AppropriateFile(_Local,fID,Type,ForWrite);
	}
	_Local->LastErrorCode=err_BadDescriptor;
	return 0;
}

int UnAppropriateLocalFile(P_local_files _Local,fileID fID)
{
	if(CheckLocalFileID(_Local,fID,0))
	{
		fID.Index=_Local->Files[fID.Index].Index;
		int Result=UnAppropriateFile(fID);
		return Result;
	}
	_Local->LastErrorCode=err_BadDescriptor;
	return 0;
}

int LockRec(P_local_files _Local,fileID fID,int RefNr)
{
	int LocI;
	int LocI2;
	if(RefNr<0)
	{
		_Local->LastErrorCode=err_BadRecNum;
		return 0;
	}
	P_local_file local=&_Local->Files[fID.Index];
	if(local->MyLocks==NULL)
	{
		local->MyLocks=(LockItem *)GetMem(16*sizeof(LockItem));
		if(local->MyLocks==NULL)
		{
			_Local->LastErrorCode=err_LowMemory;
			return 0;
		}
		local->MaxLocks=16;
		local->ActLocks=0;
	}

	int LockIndex=0;

	if(FindLock(local,RefNr,&LockIndex))
	{
		local->MyLocks[LockIndex].Counter++;
		return 1;
	}

	if(local->MaxLocks==local->ActLocks)
	{
		LocI=local->MaxLocks<<1;
		P_LockItem NewLocks=(LockItem *)GetMem(LocI*sizeof(LockItem));
		if(NewLocks==NULL)
		{
			_Local->LastErrorCode=err_LowMemory;
			return 0;
		}
		if(local->ActLocks!=0)
			memcpy(NewLocks,local->MyLocks,local->ActLocks*sizeof(LockItem));
		FreeMem(local->MyLocks);
		local->MyLocks=NewLocks;
		local->MaxLocks=LocI;
	}

	if(!AppropriateLocalFile(_Local,fID,filetype_Data,1,0))
		return 0;
	P_pds_file pds=&_Files->Files[local->Index];
	if(! pds->LockSegLevel)
	{
		pds->LockSegLevel=LockSegLevel;
		if((pds->LockSegLevel<10)||(pds->LockSegLevel>25))
			pds->LockSegLevel=default_LockSegLevel;
		pds->LockSegCount=1;
		int mask=8;
		pds->LockSegMask=mask;
		pds->LockSectShift=3;
		LocI=0;
		LocI2=pds->datInfo.NumRec<<1; // sektor minimalne 2x tolik nez je soucasny pocet vet = /8*2 = /4
		while((LocI<pds->LockSegLevel)||((LocI2>pds->LockSegCount)&&(pds->LockSegMask<0xFFFFFF8)))
		{
			pds->LockSegMask=pds->LockSegMask|mask;
			mask<<=1;
		  	pds->LockSegCount=pds->LockSegCount<<1;
			pds->LockSectShift++;
			LocI++;
		}
	}

	int Sector=RefNr>>pds->LockSectShift;

	P_pds_lock SectPoint;

	SectPoint=GetLockSector(_Local,pds,Sector,1);

	if(SectPoint==NULL)
	{
		UnAppropriateLocalFile(_Local,fID);
		return 0;
	}

	int Bajt=(RefNr&pds->LockSegMask)>>3;
	uint8_t Bit=RefNr&7;
	uint8_t Mask=1;
	if(Bit!=0)
		Mask<<=Bit;

	if((SectPoint->Locks[Bajt]&Mask)!=0)
	{
		_Local->LastErrorCode=err_LockRecordFailed;
		UnAppropriateLocalFile(_Local,fID);
		return 0;
	}
	SectPoint->Locks[Bajt]|=Mask;
	SectPoint->Locked++;
	UnAppropriateLocalFile(_Local,fID);
	LocI=local->ActLocks-LockIndex;
	if(LocI>0)
		memmove(&local->MyLocks[LockIndex+1],&local->MyLocks[LockIndex],LocI*sizeof(LockItem));
	memset(&local->MyLocks[LockIndex],0,sizeof(LockItem));
	local->MyLocks[LockIndex].Counter++;
	local->MyLocks[LockIndex].RefNr=RefNr;
	local->ActLocks++;
	return 1;
}

int RecIsLocked(P_local_file File,int RefNr,uint8_t * Result)
{
	*Result=0;
	int LocI;
	if(FindLock(File,RefNr,&LocI))
	{
		*Result=1;
		return 1;
	}

	P_pds_file GF=&_Files->Files[File->Index];

	fileID fID;
	memset(&fID,0,sizeof(fileID));
	fID.Index=File->Index;
	fID.Random=GF->Random;
	fID.FileGen=GF->FileGen;
	if(!AppropriateFile(File->MyFiles,fID,filetype_Data,0))
		return 0;

	int Sector=RefNr>>GF->LockSectShift;

	P_pds_lock SectPoint=GF->FirstLock;

	SectPoint=GetLockSector(File->MyFiles,GF,Sector,0);
	if(SectPoint!=NULL)
	{
		int Bajt=(RefNr&GF->LockSegMask)>>3;
		uint8_t Bit=RefNr&7;
		uint8_t Mask=1;
		if(Bit!=0)
			Mask<<=Bit;
		if((SectPoint->Locks[Bajt]&Mask)!=0)
		{
			*Result=1;
		}
	}
	UnAppropriateFile(fID);
	return 1;
}
// 0sssssss|ssssssBB|BBBBBBBB|BBBBBbbb

#ifdef LOCAL

int SendWait(int client_sockfd,int SendCounter,unsigned short Progress)
{
    return 1;
}

#else

int _send(int client_sockfd,void * Data,int Size)
{
	int Result;
    while(((Result=send(client_sockfd,Data,Size,0))==-1)&&(errno==EINTR)) continue;
	return Result;
}

int Send(int client_sockfd,void * Data,int Size)
{
	((P_ResultMsg)Data)->Size=Size;
	return _send(client_sockfd,Data,Size);
}

int SendOK(int client_sockfd,int SendCounter)
{
	ResultMsg ResMsg;
	memset(&ResMsg,0,sizeof(ResultMsg));
	ResMsg.counter=SendCounter;
	ResMsg.Size=sizeof(ResMsg);
	if(Send(client_sockfd,&ResMsg,sizeof(ResMsg))==-1)
	{
		return 0;
	}
	return 1;
}

int SendWait(int client_sockfd,int SendCounter,unsigned short Progress)
{
	ResultMsg ResMsg;
	memset(&ResMsg,0,sizeof(ResultMsg));
	ResMsg.counter=SendCounter;
	if(Progress<=10000)
	{
        ResMsg.ResultCode=Progress;
        ResMsg.Flags=rm_Flags_WaitMessage|rm_Flags_Progress;
	}
	else
	{
        ResMsg.Flags=rm_Flags_WaitMessage;
	}
    ResMsg.Size=sizeof(ResMsg);
	if(Send(client_sockfd,&ResMsg,sizeof(ResMsg))==-1)
	{
		return 0;
	}
	return 1;
}

int SendFile(P_local_files Local,int SendCounter,int FileHandle)
{
    int Result=0;
    MD5_CTX MD5;
    int SegmentSize=PacketDataSize-sizeof(ResultMsg)-sizeof(int)-sizeof(int);
    void * Buffer=GetMem(PacketDataSize);
    if(Buffer!=NULL)
    {
        memset(Buffer,0,PacketDataSize);
        off_t TotalSize=lseek(FileHandle,0,SEEK_END);
        if(TotalSize!=(off_t)-1)
        {
            if(lseek(FileHandle,0,SEEK_SET)!=(off_t)-1)
            {
                int Readed;
                int * ActPos=(int*)((char *)Buffer+sizeof(ResultMsg));
                int * FileSize=(int*)((char *)Buffer+sizeof(ResultMsg)+sizeof(int));
                unsigned char * DataBuffer=(unsigned char*)((char *)Buffer+sizeof(ResultMsg)+sizeof(int)+sizeof(int));
                *FileSize=TotalSize;
                MD5Init(&MD5);
                do
                {
                    Readed=read(FileHandle,DataBuffer,SegmentSize);
                    if(Readed>0)
                    {
                        MD5Update(&MD5,DataBuffer,Readed);
                        memset(Buffer,0,sizeof(ResultMsg));
                        ((P_ResultMsg)Buffer)->counter=SendCounter;
                        ((P_ResultMsg)Buffer)->Flags=rm_Flags_File;
                        ((P_ResultMsg)Buffer)->Size=PacketDataSize-(SegmentSize-Readed);
                        if(Send(Local->client_sockfd,Buffer,((P_ResultMsg)Buffer)->Size)==-1)
                        {
                            SetLastFileError(Local,errno,err_SendFileError);
                            FreeMem(Buffer);
                            return 0;
                        }
                        (*ActPos)+=Readed;
                    }
                } while(Readed==SegmentSize);
                if(Readed==-1)
                {
                    SetLastFileError(Local,errno,err_ReadError);
                }
                else
                if(*ActPos==!*FileSize)
                {
                    SetLastFileError(Local,err_FileSizeMismatch,err_ReadError);
                }
                else
                {
                    memset(Buffer,0,sizeof(ResultMsg)+16);
                    ((P_ResultMsg)Buffer)->counter=SendCounter;
                    ((P_ResultMsg)Buffer)->Flags=rm_Flags_MD5;
                    ((P_ResultMsg)Buffer)->Size=sizeof(ResultMsg)+16;
                    MD5Final((unsigned char*)ActPos,&MD5);
                    InitLogBuffer(Local);
                    unsigned int i;
                    for(i=0;i<16;i++)
                        AddToLogBuffer(Local,0,"%02x",((unsigned char*)ActPos)[i]);
                    message(0,"%d Odeslan archivni soubor (delka: %d MD5: %s)\n",getpid(),TotalSize,Local->LogBuffer);

                    if(Send(Local->client_sockfd,Buffer,((P_ResultMsg)Buffer)->Size)==-1)
                    {
                        SetLastFileError(Local,errno,err_SendFileError);
                    }
                    else
                    {
                        Result=1;
                    }
                }
            }
            else
            {
                SetLastFileError(Local,errno,err_SeekError);
            }
        }
        else
        {
            SetLastFileError(Local,errno,err_SeekError);
        }
        FreeMem(Buffer);
    }
    return Result;
}

int Rearchive(P_local_files Local,char * Key, char * SubKey,int Archive,int TestOnly,const char * Path)
{
    int result=0;
    Local->LastErrorCode=0;
    off_t ArchiveSize=lseek(Archive,0,SEEK_END);
    ArchiveHead Head;
    char FileName[13];
    int Counter=0;
    unsigned int FilePos=0;
    unsigned char MD5digest[16];
    char * RealName;
    char * LocStr;
    time_t ActTime;
    unsigned short Progress=10000; /* 100% * 100 */
    int Rearchive=-1;
    int LocI;
    if(ArchiveSize!=(off_t)-1)
    {
        if(lseek(Archive,0,SEEK_SET)==0)
        {
            uint8_t OK=1;
            do
            {
                if(FilePos<ArchiveSize)
                {
                    if(Local->client_sockfd)
                    {
                        ActTime=time(NULL);
                        if((ActTime!=Local->ProgressTime)&&(Local->LastErrorCode==0))
                        {
                            Local->ProgressTime=ActTime;
                            if(ArchiveSize)
                            {
                                Progress=(int)((double)FilePos/ArchiveSize*10000);
                            }
                            SendWait(Local->client_sockfd,Local->ActCounter,Progress);
                        }
                    }
                    if(read(Archive,&Head,sizeof(ArchiveHead))==sizeof(ArchiveHead))
                    {
                        FilePos+=sizeof(ArchiveHead);
                        if((Head.StartOfHead==1)&&(Head.Count==(uint32_t)++Counter)&&(Head.NameLength<sizeof(FileName))&&(FilePos+Head.PackedSize<(unsigned int)ArchiveSize))
                        {
                            if(read(Archive,FileName,Head.NameLength+1)==Head.NameLength+1)
                            {
                                FilePos+=Head.NameLength+1;
                                if(strlen(FileName)==Head.NameLength)
                                {
                                    StrToLower(FileName);
                                    RealName=GetRealName(Local,Key,SubKey,(char *)&FileName,Path);
                                    if(RealName!=NULL)
                                    {
                                        if(!TestOnly)
                                        {
                                            message(2,"Rearchive file %s Length: %d\n",RealName,Head.Size);
                                            Rearchive=open(RealName,O_CREAT|O_RDWR|O_TRUNC,NewFileMode);
                                            if(Rearchive!=-1)
                                            {
                                                LocStr=RealName;
                                                LocI=strlen(RealName);
                                                if(LocI>4)
                                                {
                                                    LocStr+=LocI-4;
                                                    if(memcmp(LocStr,".dat",4)==0)
                                                    {
                                                        memcpy(LocStr,".inx",4);
                                                        remove(RealName);
                                                        message(2,"Delete index %s\n",RealName);
                                                    }
                                                }
                                            }
                                            else
                                            {
                                                OK=0;
                                                SetLastFileError(Local,errno,err_CreateError);
                                            }
                                        }
                                        FreeMem(RealName);
                                        if(OK)
                                        {
                                            if(Decode(Local,Archive,Rearchive,(char *)&MD5digest))
                                            {
                                                if(memcmp(MD5digest,Head.MD5,16))
                                                {
                                                    FilePos+=Head.PackedSize;
                                                    if(FilePos!=lseek(Archive,FilePos,SEEK_SET))
                                                    {
                                                        OK=0;
                                                        SetLastFileError(Local,errno,err_CorruptedFile);
                                                    }
                                                }
                                                else
                                                {
                                                    OK=0;
                                                    SetLastFileError(Local,GetLastFileError(Local,err_CorruptedFile),err_CorruptedFile);
                                                }
                                            }
                                            else
                                            {
                                                OK=0;
                                                SetLastFileError(Local,GetLastFileError(Local,err_CorruptedFile),err_CorruptedFile);
                                            }
                                            if(Rearchive!=-1)
                                            {
                                                close(Rearchive);
                                            }
                                        }
                                    }
                                    else
                                    {
                                        OK=0;
                                        SetLastFileError(Local,GetLastFileError(Local,err_BadParameters),err_BadParameters);
                                    }
                                }
                                else
                                {
                                    OK=0;
                                    SetLastFileError(Local,err_CorruptedFile,err_CorruptedFile);
                                }
                            }
                            else
                            {
                                OK=0;
                                SetLastFileError(Local,errno,err_ReadError);
                            }
                        }
                        else
                        {
                            OK=0;
                            SetLastFileError(Local,err_CorruptedFile,err_CorruptedFile);
                        }
                    }
                    else
                    {
                        OK=0;
                        SetLastFileError(Local,errno,err_ReadError);
                    }
                }
                else
                {
                    OK=0;
                    result=1;
                }
            } while(OK);
        }
        else
        {
            SetLastFileError(Local,errno,err_SeekError);
        }
    }
    else
    {
        SetLastFileError(Local,errno,err_SeekError);
    }
    return result;
}

int TestArchive(P_local_files Local,char * Key, char * SubKey,int Archive,const char * Path)
{
    return Rearchive(Local,Key,SubKey,Archive,1,Path);
}

int ExtractArchive(P_local_files Local,char * Key, char * SubKey,int Archive,const char * Path)
{
    return Rearchive(Local,Key,SubKey,Archive,0,Path);
}

#endif // LOCAL

void InitLogBuffer(P_local_files Local)
{
    *Local->LogBuffer='\0';
}

void AddToLogBuffer(P_local_files Local,int level,const char* format, ... )
{
    if(level<=DebugLevel)
    {
        va_list args;
        va_start(args,format);
        char * BufPoint=Local->LogBuffer;
        int LocI=strlen(BufPoint);
        BufPoint+=LocI;
        LocI=StrBufferSize-LocI;
        if(LocI>0)
        {
            vsnprintf(BufPoint,LocI,format,args);
        }
        va_end(args);
    }
}

void InitStrBuffer(char * StrBuffer)
{
    *StrBuffer='\0';
}

void AddToStrBuffer(char * StrBuffer,int level,const char* format, ... )
{
    if(level<=DebugLevel)
    {
        va_list args;
        va_start(args,format);
        char * BufPoint=StrBuffer;
        int LocI=strlen(BufPoint);
        BufPoint+=LocI;
        LocI=StrBufferSize-LocI;
        if(LocI>0)
        {
            vsnprintf(BufPoint,LocI,format,args);
        }
        va_end(args);
    }
}

int GetRec(P_local_files _Local,fileID fID,int RefNr,void * Buffer,int BufferSize,uint8_t IgnoreLock)
{
    int Result=0;
    _Local->LastErrorCode=0;
    int LocI3=fID.Index;
    if(LocalIndexToGlobal(_Local,&fID,0)!=0)
    {
        P_pds_file ActFile=&_Files->Files[fID.Index];
        int LocI=ActFile->Handle;
        if(LocI!=-1)
        {
            int LocI2=RefNr;
            if((LocI2>0)&&(LocI2<=(ActFile->InxDescr[0].NumRec))&&(ActFile->datInfo.LenRec<=BufferSize))
            {
                uint8_t OK=1;
                int LocI4;
                uint8_t IsLocked=0;
                if(!FindLock(&_Local->Files[LocI3],LocI2,&LocI4))
                {
                    if(RecIsLocked(&_Local->Files[LocI3],LocI2,&IsLocked))
                    {
                        if(IsLocked)
                        {
                            if(!IgnoreLock)
                            {
                                _Local->LastErrorCode=err_Error;
                                OK=0;
                            }
                        }
                    }
                    else
                        OK=0;
                }
                if(OK)
                {
                    LocI2=ActFile->datInfo.LenRec*LocI2;
                    if(lseek(LocI,LocI2,SEEK_SET)==LocI2)
                    {
                        LocI2=read(LocI,Buffer,ActFile->datInfo.LenRec);
                        if(LocI2==ActFile->datInfo.LenRec)
                        {
                            if((IsLocked)&&(IgnoreLock))
                                _Local->LastErrorCode=err_DataRecordIsLocked;
                            Result=1;
                        }
                        else
                        {
                            _Local->LastErrorCode=err_ReadError;
                        }
                    }
                    else
                    {
                        _Local->LastErrorCode=err_SeekError;
                    }
                }
            }
            else
            {
                _Local->LastErrorCode=err_BadParameters;
            }
        }
        else
        {
            _Local->LastErrorCode=err_NotOpen;
        }
    }
    else
    {
        _Local->LastErrorCode=err_BadDescriptor;
    }
    return Result;
}

int PutRec(P_local_files _Local,fileID fID,int RefNr,void * Buffer)
{
    int Result=0;
    _Local->LastErrorCode=0;

    int LocI3=fID.Index;
    if(LocalIndexToGlobal(_Local,&fID,0))
    {
        P_pds_file ActFile=&_Files->Files[fID.Index];
        int LocI=ActFile->Handle;
        if(LocI!=-1)
        {
            int LocI2=RefNr;
            if((LocI2>0)&&(LocI2<=(ActFile->InxDescr[0].NumRec)))
            {
                uint8_t OK=1;
                int LocI4;
                if(!FindLock(&_Local->Files[LocI3],LocI2,&LocI4))
                {
                    uint8_t IsLocked;
                    if(RecIsLocked(&_Local->Files[LocI3],LocI2,&IsLocked))
                    {
                        if(IsLocked)
                        {
                            _Local->LastErrorCode=err_Error;
                            OK=0;
                        }
                    }
                    else
                        OK=0;
                }
                if(OK)
                {
                    LocI2=ActFile->datInfo.LenRec*LocI2;
                    if(lseek(LocI,LocI2,SEEK_SET)==LocI2)
                    {
                        LocI2=write(LocI,Buffer,ActFile->datInfo.LenRec);
                        if(LocI2==ActFile->datInfo.LenRec)
                        {
                            Result=1;
                        }
                        else
                        {
                            _Local->LastErrorCode=err_WriteError;
                        }
                    }
                    else
                    {
                        _Local->LastErrorCode=err_SeekError;
                    }
                }
            }
            else
            {
                _Local->LastErrorCode=err_BadParameters;
            }
        }
        else
        {
            _Local->LastErrorCode=err_NotOpen;
        }
    }
    else
    {
        _Local->LastErrorCode=err_BadDescriptor;
    }
    return Result;
}

int GetBlock(P_local_files _Local,fileID fID,unsigned int Offset,unsigned int Size,void * Dest)
{
    int Result=0;
    _Local->LastErrorCode=0;
    int LocI3=fID.Index;
    if(LocalIndexToGlobal(_Local,&fID,0)!=0)
    {
        P_pds_file ActFile=&_Files->Files[fID.Index];
        int LocI=ActFile->Handle;
        if(LocI!=-1)
        {
            int LocI2=Offset/ActFile->datInfo.LenRec;
            int LocI4=Offset&ActFile->datInfo.LenRec;
            if((LocI2>=0)&&(LocI2<=(ActFile->InxDescr[0].NumRec))&&((long)Size+LocI4<=ActFile->datInfo.LenRec))
            {
                uint8_t OK=1;
                uint8_t IsLocked=0;
                if(!FindLock(&_Local->Files[LocI3],LocI2,&LocI4))
                {
                    if(RecIsLocked(&_Local->Files[LocI3],LocI2,&IsLocked))
                    {
                        if(IsLocked)
                        {
                            _Local->LastErrorCode=err_Error;
                            OK=0;
                        }
                    }
                    else
                        OK=0;
                }
                if(OK)
                {
                    if(lseek(LocI,Offset,SEEK_SET)==(long)Offset)
                    {
                        LocI2=read(LocI,Dest,Size);
                        if(LocI2==(long)Size)
                        {
                            Result=1;
                        }
                        else
                        {
                            _Local->LastErrorCode=err_ReadError;
                        }
                    }
                    else
                    {
                        _Local->LastErrorCode=err_SeekError;
                    }
                }
            }
            else
            {
                _Local->LastErrorCode=err_BadParameters;
            }
        }
        else
        {
            _Local->LastErrorCode=err_NotOpen;
        }
    }
    else
    {
        _Local->LastErrorCode=err_BadDescriptor;
    }
    return Result;
}

int PutBlock(P_local_files _Local,fileID fID,unsigned int Offset,unsigned int Size,const void * Src)
{
    int Result=0;
    _Local->LastErrorCode=0;
    int LocI3=fID.Index;
    if(LocalIndexToGlobal(_Local,&fID,0)!=0)
    {
        P_pds_file ActFile=&_Files->Files[fID.Index];
        int LocI=ActFile->Handle;
        if(LocI!=-1)
        {
            int LocI2=Offset/ActFile->datInfo.LenRec;
            int LocI4=Offset&ActFile->datInfo.LenRec;
            if((LocI2>=0)&&(LocI2<=(ActFile->InxDescr[0].NumRec))&&((long)Size+LocI4<=ActFile->datInfo.LenRec))
            {
                uint8_t OK=1;
                uint8_t IsLocked=0;
                if(!FindLock(&_Local->Files[LocI3],LocI2,&LocI4))
                {
                    if(RecIsLocked(&_Local->Files[LocI3],LocI2,&IsLocked))
                    {
                        if(IsLocked)
                        {
                            _Local->LastErrorCode=err_Error;
                            OK=0;
                        }
                    }
                    else
                        OK=0;
                }
                if(OK)
                {
                    if(lseek(LocI,Offset,SEEK_SET)==(long)Offset)
                    {
                        LocI2=write(LocI,Src,Size);
                        if(LocI2==(long)Size)
                        {
                            Result=1;
                        }
                        else
                        {
                            _Local->LastErrorCode=err_WriteError;
                        }
                    }
                    else
                    {
                        _Local->LastErrorCode=err_SeekError;
                    }
                }
            }
            else
            {
                _Local->LastErrorCode=err_BadParameters;
            }
        }
        else
        {
            _Local->LastErrorCode=err_NotOpen;
        }
    }
    else
    {
        _Local->LastErrorCode=err_BadDescriptor;
    }
    return Result;
}

int OpenFileExclusive(const char * Name)
{
    int Handle;
#ifdef __linux__
    Handle=open(Name,O_RDWR);
    if(Handle!=-1)
    {
        if(flock(Handle,LOCK_EX|LOCK_NB)!=0)
        {
            close(Handle);Handle=-1;
            message(3,"%d data lock error (Handle %d Name: %s)\n",getpid(),file->Handle,name,Local->LastErrorCode);
        }
    }
#elif _WIN32 || _WIN64
    Handle=open(Name,O_RDWR|O_EXCL|O_BINARY);
#endif
    return Handle;
}

void CloseFileExclusive(int Handle)
{
    if(Handle!=-1)
    {
#ifdef __linux__
        flock(Handle,LOCK_UN|LOCK_NB);
#endif
        close(Handle);
    }
}

fileID GetLocalFileID(P_local_files _Local,int Index)
{
    fileID fID={0,0,0xffffffff};
    if((Index<_Local->max_local_files)&&(Index>=0))
    {
		int GlobalIndex=_Local->Files[Index].Index;
		if((GlobalIndex>=0)&&(GlobalIndex<MaxFiles))
		{
		    fID.Index=Index;
			fID.Random=_Files->Files[GlobalIndex].Random;
			fID.FileGen=_Files->Files[GlobalIndex].FileGen;
		}
    }
    return fID;
}

fileID GetFileID(P_local_files _Local,int Index)
{
    fileID fID={0,0,0xffffffff};
    if((Index<_Local->max_local_files)&&(Index>=0))
    {
		int GlobalIndex=_Local->Files[Index].Index;
		if((GlobalIndex>=0)&&(GlobalIndex<MaxFiles))
		{
		    fID.Index=GlobalIndex;
			fID.Random=_Files->Files[GlobalIndex].Random;
			fID.FileGen=_Files->Files[GlobalIndex].FileGen;
		}
    }
    return fID;
}

char * GetFileName(P_local_files _Local,int Index)
{
    if((Index<_Local->max_local_files)&&(Index>=0))
    {
		int GlobalIndex=_Local->Files[Index].Index;
		if((GlobalIndex>=0)&&(GlobalIndex<MaxFiles))
		{
		    return _Files->Files[GlobalIndex].RealName;
		}
    }
    return NULL;
}
