#include "messages.h"
#include "semaphores.h"

const int valid_sign=0x074d7707;

int msg_id=-1;

int Live=1;
int ThreadsLive=1;
int DebugLevel=1;
uint8_t LogMode=0;

struct VersionRec Version={0,0,0};

const int status_message_size=sizeof(status_message)-sizeof(long int);

void message(int level,const char* format, ... )
{
    if(level<=DebugLevel)
    {
        unsigned short SemError=0;
        semaphore_p(semaphore_log,&SemError);
        va_list args;
        va_start(args,format);
        if(LogMode==2)
        {
            syslog(0,format,args);
        }
        else
        {
            struct tm *time_now;
            time_t secs_now;

            time(&secs_now);
            time_now=localtime(&secs_now);

            char Stamp[80]="";

            strftime(Stamp,sizeof(Stamp),"[%d.%m.%Y %H:%M:%S] ",time_now);

            printf("%s ",Stamp);
            vprintf(format, args);
            fflush(NULL);
        }
        va_end(args);
        if(!SemError)
            semaphore_v(semaphore_log,&SemError);
    }
}

int StrTime(time_t Time,char * Buffer,int BufferSize)
{
    if(!Time)
    {
        if(BufferSize)
        {
            *Buffer='\0';
        }
        return 0;
    }
    struct tm *time_now;
    time_now=localtime(&Time);
    return strftime(Buffer,BufferSize,"%d.%m.%Y %H:%M:%S",time_now);
}

int StrUptime(time_t Time,char * Buffer,int BufferSize)
{
    time_t ActTime;
    time(&ActTime);
    ActTime-=Time;
    int Days=ActTime/86400;
    ActTime=abs(ActTime);
    ActTime-=abs(Days)*86400;
    unsigned short int Hours=ActTime/3600;
    ActTime-=Hours*3600;
    unsigned short int Mins=ActTime/60;
    ActTime-=Mins*60;
    unsigned short int Secs=ActTime;
    return snprintf(Buffer,BufferSize,"%d days %u:%02u:%02u",Days,Hours,Mins,Secs);
}
