#ifndef semaphores_h
	#define semaphores_h

#include <stdio.h>
#ifdef __linux__
  #include <sys/sem.h>
#endif // __linux__

#ifdef LOCAL
    #include <wx/thread.h>
#endif // LOCAL

#include <unistd.h>
#include <string.h>
#include "semun.h"

#include "errcodes.h"
#include "messages.h"

#define MaxSemaphores		6

#define semaphore_process           0
#define semaphore_thread_create     1
#define semaphore_thread            2
#define semaphore_files             3
#define semaphore_log               4
#define semaphore_malloc            5

#ifndef SEMMSL
	#define SEMMSL				250
#endif

extern int sem_id;
extern pid_t parent_pid;
#ifdef __linux__
  extern uid_t uid;
  extern uid_t gid;
#endif
extern uint8_t UseSemaphores;

int semaphore_p(int sem_num,unsigned short * ErrAddr);
int index_semaphore_p(int Index);
int semaphore_v(int sem_num,unsigned short * ErrAddr);
int index_semaphore_v(int Index);
int set_semvalue(int sem_num);
void del_semvalue();
int InitSemaphores();
int IAmChild();
void DoneSemaphores();
void CancelThreadSemaphores(pid_t thread_pid);

void * GetMem(size_t size);
void FreeMem(void * ptr);
void * ReallocMem(void * ptr,size_t newsize);

#endif
