#include "childs.h"

unsigned short TrivialErrorList[TrivialErrors]= // musi byt zadano do pole vzestupne, pri prohledavani se pouziva aproximace
                    {
						err_KeyNotFound,err_DataRecordIsLocked,err_KeyOrLargeNotFound,err_KeyForDeleteNotFound,
						err_CannotDuplicateKey,err_NoLargerKeyFound,err_NoSmallerKeyFound_,err_NoLargerKeyFound_,
						err_NoSmallerKeyFound,err_IndexEmpty_,err_IndexEmpty,err_LockRecordFailed,err_FileUsed,
						err_FileLocked
					};

int MaxOut=7;
int TimeOut=17;

char compilation_date[]= __DATE__;
char compilation_time[]= __TIME__;

pds_params * Params=NULL;
pds_childs * _Childs=NULL;

/*******/

P_pds_child AllocChild();

void ChildsStatus()
{
    if(DebugLevel>=3)
    {
        char StrBuffer[StrBufferSize];
        InitStrBuffer(StrBuffer);
        AddToStrBuffer(StrBuffer,3,"Status: FreeChilds: %d [",_Childs->FreeChilds);
        P_pds_child child=_Childs->FirstFree;
        P_pds_child lastchild=NULL;
        int counter=0;
        while(child!=NULL)
        {
            if(counter!=0)
                AddToStrBuffer(StrBuffer,3,",");
            if(child->PrevChild!=lastchild)
                AddToStrBuffer(StrBuffer,3,"!");
            AddToStrBuffer(StrBuffer,3,"%d",child->pid);
            counter++;
            lastchild=child;
            child=child->NextChild;
        }
        message(3,"%s] %d\n",StrBuffer,counter);
        InitStrBuffer(StrBuffer);
        AddToStrBuffer(StrBuffer,3,"Status: Busy: %d [",_Childs->BusyChilds);
        child=_Childs->Busy;
        lastchild=NULL;
        counter=0;
        while(child!=NULL)
        {
            if(counter!=0)
                AddToStrBuffer(StrBuffer,3,",");
            if(child->PrevChild!=lastchild)
                AddToStrBuffer(StrBuffer,3,"!");
            AddToStrBuffer(StrBuffer,3,"%d",child->pid);
            counter++;
            lastchild=child;
            child=child->NextChild;
        }
        message(3,"%s] %d\n",StrBuffer,counter);
    }
}


// Inicializace //

void DoneParams()
{
    if(Params!=NULL)
    {
        if(Params->path!=NULL)
            FreeMem(Params->path);
        if(Params->Local!=NULL)
            LocalDoneFiles(&Params->Local);
        if(Params->access)
            FreeMem(Params->access);
        if(Params->LogName!=NULL)
            FreeMem(Params->LogName);
        FreeMem(Params);
    }
}

int GetParams()
{
    int Result=0;

    Params->port=DefaultPort;
    Params->Echo=1;
    Params->Http=1;
    Params->httpport=DefaultHTTPPort;
    Params->NewFileMode=NewFileMode;
    Params->CheckIntegrity=CheckIntegrity;
    Params->LogMode=LogMode;

    int LocI;
    unsigned int LocU=0;

    for(LocI=0;LocI<=32;LocI++)
    {
        Params->masks[LocI]=LocU;
        LocU=(LocU>>1)|0x80000000;
    }

    int Conf=OpenFileDirect(&Params->Local,ConfName,"ConfigFile",filetype_Ini,0,0,1);
    if(Conf!=-1)
    {
        Result=1;
        int ConfG=Params->Local->Files[Conf].Index;
        char * Buffer=GetMem(ParamBufSize);
        if(Buffer)
        {
            char * Buffer2=GetMem(ParamBufSize);
            if(Buffer2)
            {
                if(GetFromIni(Params->Local,ConfG,"Server","TimeOuts",Buffer,ParamBufSize))
                {
                    if(EOF!=sscanf(Buffer,"%d",&LocI))
                    {
                        if((LocI>=0)&&(LocI<=0xffff))
                            MaxOut=LocI;
                    }
                }
                if(GetFromIni(Params->Local,ConfG,"Server","TimeOut",Buffer,ParamBufSize))
                {
                    if(EOF!=sscanf(Buffer,"%d",&LocI))
                    {
                        if((LocI>=0)&&(LocI<=0xffff))
                            TimeOut=LocI;
                    }
                }
                if(GetFromIni(Params->Local,ConfG,"Server","Port",Buffer,ParamBufSize))
                {
                    if(EOF!=sscanf(Buffer,"%d",&LocI))
                    {
                        if((LocI>=0)&&(LocI<=0xffff))
                            Params->port=LocI;
                    }
                }
                if(GetFromIni(Params->Local,ConfG,"Server","HttpPort",Buffer,ParamBufSize))
                {
                    if(EOF!=sscanf(Buffer,"%d",&LocI))
                    {
                        if((LocI>=0)&&(LocI<=0xffff))
                            Params->httpport=LocI;
                    }
                }
                if(!Params->httpport)
                {
                    Params->Http=0;
                }
                if(GetFromIni(Params->Local,ConfG,"Server","Debug",Buffer,ParamBufSize))
                {
                    if(EOF!=sscanf(Buffer,"%d",&LocI))
                    {
                        if((LocI>=0)&&(LocI<=0xffff))
                            DebugLevel=LocI;
                    }
                }
                if(GetFromIni(Params->Local,ConfG,"Server","NewFileMode",Buffer,ParamBufSize))
                {
                    if(EOF!=sscanf(Buffer,"%o",&LocI))
                    {
                        if((LocI&(S_IRUSR|S_IWUSR))==(S_IRUSR|S_IWUSR))
                            Params->NewFileMode=LocI;
                    }
                }
                NewFileMode=Params->NewFileMode;
                if(GetFromIni(Params->Local,ConfG,"Server","CheckIntegrity",Buffer,ParamBufSize))
                {
                    if(EOF!=sscanf(Buffer,"%d",&LocI))
                    {
                        if((LocI>=0)&&(LocI<=0xffff))
                        {
                            if(LocI>0)
                                Params->CheckIntegrity=1;
                            else
                                Params->CheckIntegrity=0;
                        }
                    }
                }
                CheckIntegrity=Params->CheckIntegrity;
                if(GetFromIni(Params->Local,ConfG,"Server","Echo",Buffer,ParamBufSize))
                {
                    if(EOF!=sscanf(Buffer,"%d",&LocI))
                    {
                        if((LocI>=0)&&(LocI<=0xffff))
                        {
                            if(LocI>0)
                                Params->Echo=1;
                            else
                                Params->Echo=0;
                        }
                    }
                }
                if(GetFromIni(Params->Local,ConfG,"Server","Name",Buffer,ParamBufSize))
                {
                    if(EOF!=sscanf(Buffer,"%s",Buffer2))
                    {
                        memset(&Params->Name,0,sizeof(Params->Name));
                        strncpy((char *)&Params->Name,Buffer2,sizeof(Params->Name)-1);
                    }
                }
                if(Params->path==NULL)
                {
                    if(GetFromIni(Params->Local,ConfG,"Server","Path",Buffer,ParamBufSize))
                    {
                        if(EOF!=sscanf(Buffer,"%s",Buffer2))
                        {
                            LocI=strlen(Buffer2);
                            int LocI2;
                            if(LocI)
                            {
                                char * LocStr=Buffer2;
                                char * FromStr=Buffer2;
                                char * HomeDir=NULL;
                                LocStr+=LocI-1;
                                LocI2=LocI;
                                if(*LocStr!='/')
                                    LocI2++;
                                if(Buffer2[0]=='~')
                                {
                                    FromStr++;
                                    HomeDir=getenv("HOME");
                                    LocI2+=strlen(HomeDir)-1;   // odecita se jedna kvuli ignorovani znaku ~
                                }
                                LocI2++; // ukoncujici nula
                                Params->path=GetMem(LocI2);
                                if(Params->path)
                                {
                                    char * ToStr=Params->path;
                                    if(Buffer2[0]=='~')
                                    {
                                        LocI2=strlen(HomeDir);
                                        memcpy(ToStr,HomeDir,LocI2);
                                        ToStr+=LocI2;
                                    }
                                    LocI2=strlen(FromStr);
                                    memcpy(ToStr,FromStr,LocI2);
                                    ToStr+=LocI2;
                                    if(*LocStr!='/')
                                    {
                                        *ToStr='/';
                                        ToStr++;
                                    }
                                    *ToStr='\0';
                                    syslog(0,"PDS start on path from .conf file: %s\n",Params->path);
                                }
                                else
                                {
                                    Result=0;
                                }
                            }
                        }
                    }
                }
                if((Params->path)&&(GetFromIni(Params->Local,ConfG,"Server","Log",Buffer,ParamBufSize)))
                {
                    if(Params->LogName!=NULL)
                    {
                        FreeMem(Params->LogName);
                        Params->LogName=NULL;
                    }
                    if(EOF!=sscanf(Buffer,"%s",Buffer2))
                    {
                        LocI=strlen(Buffer2);
                        int LocI2;
                        if(!LocI)
                        {
                            strcpy(Buffer2,LogName);
                            LocI=strlen(Buffer2);
                        }
                        if(LocI)
                        {
                            char * LocStr=Buffer2;
                            if(*LocStr=='-')
                            {
                                Params->LogMode=1;
                            }
                            else
                            if(*LocStr=='+')
                            {
                                Params->LogMode=2;
                            }
                            else
                            {
                                if(strchr(LocStr,'/'))  // obsahuje cestu
                                {
                                    LocI++; // ukoncujici nula
                                    Params->LogName=GetMem(LocI);
                                    if(Params->LogName)
                                    {
                                        memcpy(Params->LogName,LocStr,LocI);
                                    }
                                    else
                                    {
                                        Result=0;
                                    }
                                }
                                else
                                {
                                    int LocI3=strlen(Params->path);
                                    LocI2=LocI+LocI3+1;
                                    Params->LogName=GetMem(LocI2);
                                    if(Params->LogName)
                                    {
                                        char * ToStr=Params->LogName;
                                        memcpy(ToStr,Params->path,LocI3);
                                        ToStr+=LocI3;
                                        memcpy(ToStr,LocStr,LocI+1);
                                    }
                                    else
                                    {
                                        Result=0;
                                    }
                                }
                            }
                        }
                    }
                }
                LogMode=Params->LogMode;
                if(GetIniKeys(Params->Local,ConfG,"Access",Buffer,ParamBufSize))
                {
                    char * KeyPoint=Buffer;
                    unsigned int ip[4];
                    unsigned int mask;
                    int ScanRes;

                    int MaxAccessList=256;
                    int ActAccessList=0;
                    pds_accesslist * AccessList=GetMem(MaxAccessList*sizeof(pds_accesslist));
                    if(AccessList)
                    {
                        while((*KeyPoint!='\0')&&(Result))
                        {
                            ScanRes=sscanf(KeyPoint,"%u.%u.%u.%u/%u",&ip[0],&ip[1],&ip[2],&ip[3],&mask);
                            if((ScanRes==4)||(ScanRes==5))
                            {
                                if(ScanRes==4)
                                    mask=32;
                                if((mask<=32)&&((ip[0]&0xffffff00)==0)&&((ip[1]&0xffffff00)==0)&&((ip[2]&0xffffff00)==0)&&((ip[3]&0xffffff00)==0))
                                {
                                    if(GetFromIni(Params->Local,ConfG,"Access",KeyPoint,Buffer2,ParamBufSize))
                                    {
                                        if(ActAccessList==MaxAccessList)
                                        {
                                            int NewMaxAccessList=MaxAccessList<<1;
                                            pds_accesslist * NewAccessList=GetMem(NewMaxAccessList*sizeof(pds_accesslist));
                                            if(NewAccessList)
                                            {
                                                memcpy(NewAccessList,AccessList,ActAccessList*sizeof(pds_accesslist));
                                                FreeMem(AccessList);
                                                AccessList=NewAccessList;
                                                MaxAccessList=NewMaxAccessList;
                                            }
                                            else
                                            {
                                                Result=0;
                                            }
                                        }
                                        if(ActAccessList<MaxAccessList)
                                        {
                                            AccessList[ActAccessList].ip8[3]=ip[0];
                                            AccessList[ActAccessList].ip8[2]=ip[1];
                                            AccessList[ActAccessList].ip8[1]=ip[2];
                                            AccessList[ActAccessList].ip8[0]=ip[3];
                                            AccessList[ActAccessList].mask=mask;
                                            AccessList[ActAccessList].allow=0;
                                            if((uint8_t)GetBooleanFromStr(Buffer2,1))
                                              AccessList[ActAccessList].allow|=allow_pds;
                                            char * Buffer3=strrchr(Buffer2,',');
                                            if(Buffer3)
                                            {
                                              Buffer3++;
                                              if((uint8_t)GetBooleanFromStr(Buffer3,0))
                                                AccessList[ActAccessList].allow|=allow_http;
                                            }
                                            ActAccessList++;
                                        }
                                        else
                                        {
                                            Result=0;
                                        }
                                    }
                                }
                            }
                            KeyPoint+=strlen(KeyPoint)+1;
                        }
                        if(ActAccessList)
                        {
                            if(Params->access!=NULL)
                            {
                                FreeMem(Params->access);
                                Params->access=NULL;
                            }
                            Params->access=GetMem(ActAccessList*sizeof(pds_accesslist));
                            if(Params->access)
                            {
                                memcpy(Params->access,AccessList,ActAccessList*sizeof(pds_accesslist));
                                Params->access_count=ActAccessList;
                            }
                            else
                            {
                                Result=0;
                            }
                        }
                        FreeMem(AccessList);
                    }
                    else
                    {
                        Result=0;
                    }
                }
                FreeMem(Buffer2);
            }
            FreeMem(Buffer);
        }
        else
        {
            Result=0;
        }
        CloseLocalFile(Params->Local,Conf);
    }
    return Result;
}

int InitParams()
{
    int Result=1;
    if(Params==NULL)
    {
        Params=GetMem(sizeof(pds_params));
        if(Params==NULL)
            return 0;
        memset(Params,0,sizeof(pds_params));
        if(!LocalInitFiles(&Params->Local))
        {
            DoneParams();
            return 0;
        }
        Result=GetParams();
        if(!Params->path)
        {
            int LocI=0;
            char * LocPCh=pdsDir;
            char * HomeDir=NULL;
            char * ToStr=NULL;
            if(LocPCh[0]=='~')
            {
                LocPCh++;
                HomeDir=getenv("HOME");
                LocI+=strlen(HomeDir);
            }
            LocI+=strlen(LocPCh);
            Params->path=GetMem(LocI);
            if(Params->path)
            {
                ToStr=Params->path;
                if(HomeDir)
                {
                    LocI=strlen(HomeDir);
                    memcpy(ToStr,HomeDir,LocI);
                    ToStr+=LocI;
                }
                LocI=strlen(LocPCh);
                memcpy(ToStr,LocPCh,LocI);
                ToStr+=LocI;
                *ToStr='\0';
                syslog(0,"PDS start on default path: %s\n",Params->path);
            }
            else
            {
                Result=0;
            }
        }
    }
    return Result;
}

int InitChilds()
{
	if(InitFiles(mode_Server)==0)
		return 0;

	int MaxChilds=CHILD_MAX;

	_Childs=(pds_childs*)GetMem(sizeof(pds_childs)+sizeof(pds_child)*MaxChilds);
	if(_Childs!=NULL)
	{
		memset(_Childs,0,sizeof(pds_childs)+sizeof(pds_child)*MaxChilds);
		parent_pid=getpid();
		uid=geteuid();
		gid=getegid();

		_Childs->MaxChilds=MaxChilds;
		_Childs->ChildsCount=0;
		_Childs->FreeChilds=0;
		_Childs->BusyChilds=0;
		_Childs->FirstFree=NULL;
		_Childs->Busy=NULL;

		_Childs->Unused=&_Childs->childs[0];
		int i=0;
		P_pds_child PrevChild=NULL;
		while(i<MaxChilds)
  		{
			_Childs->childs[i].PrevChild=PrevChild;
			PrevChild=&_Childs->childs[i];
	  		i++;
			if(i<MaxChilds)
			{
				PrevChild->NextChild=&_Childs->childs[i];
			}
		}

		msg_id=msgget(IPC_PRIVATE,0666|IPC_CREAT);
		if(msg_id==-1)
		{
		    message(0,"Selhalo vytvoreni fronty ...(errno=%d %d)\n",errno,ENOSPC);
			fprintf(stderr, "Selhalo vytvoreni fronty ...(errno=%d %d)\n",errno,ENOSPC);fflush(NULL);
			return 0;
		}
	}
  	return InitParams();
};

// Ukonceni

pid_t GetFreeChildpid()
{
	pid_t child_pid=getpid();
	int res_msg;
	status_message msg;
	memset(&msg,0,sizeof(msg));
	msg.message_type=parent_pid;
	msg.sign=valid_sign;
	msg.status=child_allocfree;
    msg.pid=child_pid;
	if(msgsnd(msg_id,&msg,status_message_size,0)==0)
	{
		while(1)
		{
            while(((res_msg=msgrcv(msg_id,&msg,status_message_size,child_pid,0))==-1)&&(errno==EINTR)) continue;
			if((res_msg==status_message_size)&&(msg.sign==valid_sign))
			{
				if(msg.status==child_returnfree)
				{
					return msg.pid;
				}
			}
		}
	}
	return 0;
}

int CountStrings(char * buffer,int size)
{
	int result=0;
	while(size)
	{
		size--;
		if(buffer[size]==26)
		{
			result=0;
		}
		else
		if(!buffer[size])
			result++;
	}
	return result;
}

void InitResultHead(P_ResultMsg ResMsg,int counter)
{
	memset(ResMsg,0,sizeof(ResultMsg));
	ResMsg->counter=counter;
}

int IsTrivialError(unsigned short Error)
{
	int L=0;
	int U=TrivialErrors-1;
	while(L<=U)
	{
		int P=(L+U)>>1;
		if(Error==TrivialErrorList[P])
		{
			return 1;
		}
		else
		if(TrivialErrorList[P]>Error)
		{
			U=P-1;
		}
		else
		{
			L=P+1;
		}
	}
	return 0;
}

int SendError(int client_sockfd,unsigned short ErrNum,int SendCounter,const char * FuncName)
{
	ResultMsg ResMsg;
	memset(&ResMsg,0,sizeof(ResMsg));
	if(ErrNum==0)
		ErrNum=(unsigned short)err_Unspecified;
	if(!IsTrivialError(ErrNum))
	{
		if(KeyNr>0)
		{
            message(0,"%d return error %d in function %s key %d\n",getpid(),ErrNum,FuncName,KeyNr);
		}
		else
		{
			message(0,"%d return error %d in function %s\n",getpid(),ErrNum,FuncName);
		}
	}
	ResMsg.ResultCode=ErrNum;
	ResMsg.counter=SendCounter;
	ResMsg.Size=sizeof(ResMsg);
	if(Send(client_sockfd,&ResMsg,sizeof(ResMsg))==-1)
	{
		return 0;
	}
	return 1;
}

int ReceiveFile(P_local_files Local,int FileHandle)
{
    off_t StartFilePos=lseek(FileHandle,0,SEEK_CUR);
    if(StartFilePos==(off_t)-1)
    {
        SetLastFileError(Local,errno,err_SeekError);
        return 0;
    }
    int ReceiveFileResult=0;
    char * buffer=GetMem(bufsize);
    if(buffer)
    {
        int BufCount=0;
        char * BufPoint=buffer;
        fd_set testfds;
        struct timeval timeout;
        int outcount=0;
        int result;
        int LocI=0;
        int readcount;
        off_t ActFilePos;
        uint8_t AllOK=1;
        char * MessageData=buffer;
        MessageData+=sizeof(message_head);
        char * DataPoint=MessageData;
        DataPoint+=sizeof(TransferFileMsg);
        char * LocPoint;
        int DataSize;
        uint8_t NeedNormalize;
        MD5_CTX MD5;
        MD5Init(&MD5);
        while((ThreadsLive)&&(*(Local->LiveSocket))&&(AllOK))
        {
            Local->SelfChild->LastActive=time(NULL);
            testfds=Local->clientfds;
            memset(&timeout,0,sizeof(timeout));
            timeout.tv_sec=TimeOut;
            while(((result=select(FD_SETSIZE,&testfds,NULL,NULL,&timeout))==-1)&&(errno==EINTR)) continue;
            switch(result)
            {
                case 0:
                {
                    outcount++;
                    if(outcount>MaxOut)
                    {
                        *(Local->LiveSocket)=0;
                        CloseClient(&Local->client_sockfd);
                    }
                    break;
                }
                case -1:
                {
                    *(Local->LiveSocket)=0;
                    CloseClient(&Local->client_sockfd);
                    break;
                }
                default:
                {
                    if(FD_ISSET(Local->client_sockfd,&testfds))
                    {
                        outcount=0;
                        LocI=bufsize-BufCount;
                        if(LocI<=0)
                        {
                            message(0,"%d ReceiveFile: Preplneni bufferu pro zpravy ...\n",Local->SelfChild->pid);
                            BufCount=0;
                            BufPoint=(char *)buffer;
                            LocI=bufsize;
                        }
                        while(((readcount=recv(Local->client_sockfd,BufPoint,LocI,0))==-1)&&(errno==EINTR)) continue;
                        switch(readcount)
                        {
                            case 0:
                            {
                                message(0,"%d ReceiveFile: precteno 0 bajtu ...\n",Local->SelfChild->pid);
                                *(Local->LiveSocket)=0;
                                CloseClient(&Local->client_sockfd);
                                break;
                            }
                            case -1:
                            {
                                message(0,"%d ReceiveFile: chyba socketu ...\n",Local->SelfChild->pid);
                                *(Local->LiveSocket)=0;
                                CloseClient(&Local->client_sockfd);
                                break;
                            }
                            default:
                            {
                                if((readcount>=sizeof(struct message_head))||(BufCount!=0))
                                {
                                    BufCount+=readcount;
                                    if(BufCount>=((P_child_message)buffer)->head.message_size+(int) sizeof(struct message_head))
                                    {
                                        BufPoint=(char *)buffer;
                                        NeedNormalize=((P_child_message)buffer)->head.message_size+(int) sizeof(struct message_head)>BufCount;
                                        if(((P_child_message)buffer)->head.message_id==pds_File)
                                        {
                                            ActFilePos=lseek(FileHandle,0,SEEK_CUR);
                                            if(ActFilePos!=(off_t)-1)
                                            {
                                                if(((P_TransferFileMsg)MessageData)->FilePos==-1)
                                                {
                                                    AllOK=0;
                                                    if(((P_TransferFileLastMsg)MessageData)->FileSize==-1)
                                                    {
                                                        Local->LastErrorCode=err_Abort;
                                                    }
                                                    else
                                                    if(ActFilePos-StartFilePos==((P_TransferFileLastMsg)MessageData)->FileSize)
                                                    {
                                                        unsigned char digest[16];
                                                        MD5Final(digest,&MD5);
                                                        if(memcmp(&digest,&((P_TransferFileLastMsg)MessageData)->MD5Digest,16))
                                                        {
                                                            message(2,"%d File received OK, Length %d Bytes\n",Local->child_pid,((P_TransferFileLastMsg)MessageData)->FileSize);
                                                            ReceiveFileResult=1;
                                                        }
                                                        else
                                                        {
                                                            Local->LastErrorCode=err_MD5ChecksumMismatch;
                                                        }
                                                    }
                                                    else
                                                    {
                                                        Local->LastErrorCode=err_ReceiveFileFailed;
                                                    }
                                                }
                                                else
                                                {
                                                    if(ActFilePos-StartFilePos==((P_TransferFileMsg)MessageData)->FilePos)
                                                    {
                                                        DataSize=((P_child_message)buffer)->head.message_size-sizeof(TransferFileMsg);
                                                        if(write(FileHandle,DataPoint,DataSize)==DataSize)
                                                        {
                                                            MD5Update(&MD5,(unsigned char *)DataPoint,DataSize);
                                                            SendOK(Local->client_sockfd,((P_message_head)buffer)->counter);
                                                        }
                                                        else
                                                        {
                                                            SetLastFileError(Local,errno,err_WriteError);
                                                            AllOK=0;
                                                        }
                                                    }
                                                    else
                                                    {
                                                        Local->LastErrorCode=err_ReceiveFileFailed;
                                                        AllOK=0;
                                                    }
                                                }
                                            }
                                            else
                                            {
                                                SetLastFileError(Local,errno,err_SeekError);
                                                AllOK=0;
                                            }
                                        }
                                        else
                                        {
                                            message(0,"%d Unwanted message %d in ReceiveFile\n",((P_child_message)buffer)->head.message_id,Local->SelfChild->pid);
                                            Local->LastErrorCode=err_UnwantedMessage;
                                            AllOK=0;
                                        }
                                        if(NeedNormalize)
                                        {
                                            LocPoint=buffer;
                                            LocI=((P_child_message)buffer)->head.message_size+(int) sizeof(struct message_head);
                                            LocPoint+=LocI;
                                            BufCount-=LocI;
                                            if(BufCount>0)
                                            {
                                                memmove(buffer,LocPoint,BufCount);
                                            }
                                            else
                                                BufCount=0;
                                        }
                                        else
                                        {
                                            BufCount=0;
                                        }
                                    }
                                    else
                                    {
                                        BufPoint+=readcount;
                                    }
                                }
                                break;
                            }
                        }
                    }
                    break;
                }
            }
        }
        FreeMem(buffer);
    }
    else
    {
        Local->LastErrorCode=err_LowMemory;
    }

    if(ReceiveFileResult)
        SendOK(Local->client_sockfd,((P_message_head)buffer)->counter);
    else
        SendError(Local->client_sockfd,GetLastFileError(Local,err_Unspecified),((P_message_head)buffer)->counter,Local->FuncName);

    return ReceiveFileResult;
}

int InitPreload(P_pds_file File,void * Data,int Size)
{
    File->PreloadValid=0;
    if((PreloadEnabled)&&(PreloadSize>0)&&(File->FileType==0)&&(File->Handle!=-1)&&(local_buffer_size>=File->datInfo.LenRec))
    {
        if(File->PreloadBuffer==NULL)
        {
            if(PreloadSize<65520)
            {
                File->PreloadBufferSize=PreloadSize;
                File->PreloadBuffer=GetMem(File->PreloadBufferSize);
            }
        }
        int MinimumBufferSize=sizeof(PreloadHeader)+4+1+256+File->datInfo.LenRec+Size;
        if((File->PreloadBuffer!=NULL)&&(File->PreloadBufferSize>MinimumBufferSize))
        {
            memset(File->PreloadBuffer,0,File->PreloadBufferSize);
            File->PreloadFree=File->PreloadBufferSize;
            File->PreloadBufferPos=File->PreloadBuffer;
            if(File->PreloadFree>=Size)
            {
                ((P_ResultMsg)Data)->Size=Size;
                memcpy(File->PreloadBufferPos,Data,Size);
                File->PreloadBufferPos+=Size;
                File->PreloadFree-=Size;
                if(File->PreloadFree>=(int)sizeof(PreloadHeader))
                {
                    File->PreloadHead=File->PreloadBufferPos;
                    File->PreloadHead->PreloadRecLen=File->datInfo.LenRec;
                    File->PreloadBufferPos+=sizeof(PreloadHeader);
                    File->PreloadFree-=sizeof(PreloadHeader);
                    File->PreloadValid++;
                    return 1;
                }
            }
        }
    }
    return 0;
}

int AddPreload(P_pds_file File,int RecNum,IsamKeyStr * Key,void * Data,uint8_t IsLocked)
{
    if(File->PreloadValid)
    {
        int Size=4+1+File->PreloadHead->PreloadRecLen+Key->Length+1;
        if(File->PreloadFree>=Size)
        {
            (*(uint32_t *)(File->PreloadBufferPos))=(uint32_t)RecNum;
            File->PreloadBufferPos+=sizeof(uint32_t);
            (*(uint8_t *)(File->PreloadBufferPos))=IsLocked;
            File->PreloadBufferPos+=sizeof(uint8_t);
            memcpy(File->PreloadBufferPos,Data,File->PreloadHead->PreloadRecLen);
            File->PreloadBufferPos+=File->PreloadHead->PreloadRecLen;
            memcpy(File->PreloadBufferPos,Key,Key->Length+1);
            File->PreloadBufferPos+=Key->Length+1;
            File->PreloadFree-=Size;
            File->PreloadHead->PreloadCounter++;
            return 1;
        }
    }
    return 0;
}

int PreloadFreeMem(P_pds_file File)
{
    if(File->PreloadValid)
    {
        int Size=4+1+File->PreloadHead->PreloadRecLen+sizeof(IsamKeyStr)+1;
        if(File->PreloadFree>=Size)
        {
            return 1;
        }
    }
    return 0;
}

#

void Preload(P_local_files * Local,P_local_file File,int KeyNr,int RecNum,IsamKeyStr Key,uint8_t Function)
{
	P_pds_file ActFile=&_Files->Files[File->Index];
    int OK=1;
    int LocI=0;
    uint8_t IsLocked=0;
    int MaxPreloadItems=max_Preload_Items;

    if(Function==pds_PrevKey)
    {
        LocI=(*Local)->PrevPreCount>>1;
    }
    else
    if(Function==pds_NextKey)
    {
        LocI=(*Local)->NextPreCount>>1;
    }
    while((LocI>0)&&((MaxPreloadItems&0x7fffc000)==0))
    {
        MaxPreloadItems<<=1;
        LocI--;
    }

    if(!MaxPreloadItems)
        MaxPreloadItems=INT_MAX;
    while((OK)&&(MaxPreloadItems)&&(PreloadFreeMem(ActFile)))
    {
        MaxPreloadItems--;
        if(!FindLock(File,RecNum,&LocI))
        {
            if(!RecIsLocked(File,RecNum,&IsLocked))
            {
                OK=0;
            }
        }
        if(OK)
        {
            LocI=ActFile->datInfo.LenRec*RecNum;
            if(lseek(ActFile->Handle,LocI,SEEK_SET)==LocI)
            {
                LocI=read(ActFile->Handle,(*Local)->local_buffer,ActFile->datInfo.LenRec);
                if(LocI==ActFile->PreloadHead->PreloadRecLen)
                {
                    OK=AddPreload(ActFile,RecNum,&Key,(*Local)->local_buffer,IsLocked);
                    if(OK)
                    {
                        if(PreloadFreeMem(ActFile)&&(MaxPreloadItems))
                        {
                            switch(Function)
                            {
                                case preload_NextKey:
                                {
                                    if(!IsamNextKey(File,KeyNr,&RecNum,&Key))
                                    {
                                        ActFile->PreloadHead->PreloadResult=GetLastFileError(*Local,err_Unspecified);
                                        OK=0;
                                    }
                                    break;
                                }
                                case preload_PrevKey:
                                {
                                    if(!IsamPrevKey(File,KeyNr,&RecNum,&Key))
                                    {
                                        ActFile->PreloadHead->PreloadResult=GetLastFileError(*Local,err_Unspecified);
                                        OK=0;
                                    }
                                    break;
                                }
                                case preload_FindKey:
                                case preload_FindKeyAndRef:
                                case preload_SearchKey:
                                default:
                                {
                                    OK=0;
                                }
                            }
                        }
                        else
                        {
                            OK=0;
                        }
                    }
                    else
                    {
                        ActFile->PreloadHead->PreloadResult=err_PreloadError;
                    }
                }
                else
                {
                    OK=0;
                }
            }
            else
            {
                OK=0;
            }
        }
    }
}

int DonePreload(int client_sockfd,P_pds_file File)
{
    if(File->PreloadValid)
    {
        File->PreloadValid=0;
        if(File->PreloadHead->PreloadCounter>0)
        {
            ((P_ResultMsg)File->PreloadBuffer)->Flags|=1;
            File->PreloadHead->PreloadSize=File->PreloadBufferSize-File->PreloadFree;
            return _send(client_sockfd,File->PreloadBuffer,((P_ResultMsg)File->PreloadBuffer)->Size+File->PreloadHead->PreloadSize);
        }
        else
        {
            return _send(client_sockfd,File->PreloadBuffer,((P_ResultMsg)File->PreloadBuffer)->Size);
        }
    }
    return 0;
}

// ******** ******** ******** ******** ******** ******** ********
int ChildAction(P_child_message msg,void * buffer,int size,P_local_files * Local)
{
    /*
	if(_Files==NULL)
	{
		_Files=(pds_files*)shmat(shm_Files,NULL,0);
		if((_Files==NULL)||(_Files==(void *)-1))
			return -1;
	}
	if(_Files_Sorted==NULL)
	{
		_Files_Sorted=(int*)shmat(shm_Files_Sorted,NULL,0);
		if((_Files_Sorted==NULL)||(_Files_Sorted==(void *)-1))
			return -1;
	}
    */

	char * LocCh1=NULL;
	char * LocCh2=NULL;
	char * LocCh3=NULL;
	(*Local)->FuncName="";

	int LocI,LocI2,LocI3;
	int Counter;
	P_pds_file ActFile=NULL;
	fileID * fID;
	KeyNr=-1;
	(*Local)->LastMessage=msg->head.message_id;
	(*Local)->Messages++;
	_Files->TotalMessages++;

/*	if(msg->head.message_id!=pds_Message)
	{
		printf("Function ID: %d\n",msg->head.message_id);
	}
*/
	switch(msg->head.message_id)
	{
		case pds_ReadRec:	// ReadRec
		case pds_GetRec:	// GetRec
		{
			uint8_t Get;
			if(msg->head.message_id==pds_GetRec)
			{
				(*Local)->FuncName="GetRec";
				Get=1;
			}
			else
			{
				(*Local)->FuncName="ReadRec";
				Get=0;
			}
			LocI3=((FilerDatMsg1 *)&msg->message)->ID.Index;
			if(!LocalIndexToGlobal(*Local,&((FilerDatMsg1 *)&msg->message)->ID,msg->head.message_id))
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			else
			if(AppropriateFile(*Local,((FilerDatMsg1 *)&msg->message)->ID,filetype_Data,Get))
			{
				ActFile=&_Files->Files[((FilerDatMsg1 *)&msg->message)->ID.Index];
				LocI=ActFile->Handle;
				if(LocI!=-1)
				{
					LocI2=((FilerDatMsg1 *)&msg->message)->RefNr;
					if((LocI2>0)&&(LocI2<=(ActFile->InxDescr[0].NumRec))&&(ActFile->datInfo.LenRec<=(int)(local_buffer_size-sizeof(ResultMsg))))
					{
						uint8_t OK=1;
						int LocI4;
						uint8_t IsLocked=0;
						if(!FindLock(&(*Local)->Files[LocI3],LocI2,&LocI4))
						{
							if(RecIsLocked(&(*Local)->Files[LocI3],LocI2,&IsLocked))
							{
								if(IsLocked)
								{
									if(Get)
									{
										(*Local)->LastErrorCode=err_Error;
										OK=0;
									}
								}
							}
							else
								OK=0;
						}
						if(OK)
						{
							LocI2=ActFile->datInfo.LenRec*LocI2;
							if(lseek(LocI,LocI2,SEEK_SET)==LocI2)
							{
								LocCh1=(*Local)->local_buffer;
								LocCh1+=sizeof(ResultMsg);
								LocI2=read(LocI,LocCh1,ActFile->datInfo.LenRec);
								if(LocI2==ActFile->datInfo.LenRec)
								{
									memset((*Local)->local_buffer,0,sizeof(ResultMsg));
									if((IsLocked)&&(!Get))
										((ResultMsg *)(*Local)->local_buffer)->ResultCode=err_DataRecordIsLocked;
									((ResultMsg *)(*Local)->local_buffer)->counter=msg->head.counter;
									if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultMsg)+LocI2)==-1)
									{
										return -1;
									}
								}
								else
								{
									(*Local)->LastErrorCode=errno;
									SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_ReadError),msg->head.counter,(*Local)->FuncName);
								}
							}
							else
							{
								(*Local)->LastErrorCode=errno;
								SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_SeekError),msg->head.counter,(*Local)->FuncName);
							}
						}
						else
						{
							SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
						}
					}
					else
					{
						(*Local)->LastErrorCode=err_BadParameters;
						message(0,"Bad parameters in function %s, RefNr: %d, NumRec: %d\n",(*Local)->FuncName,LocI2,ActFile->InxDescr[0].NumRec);
						SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_SeekError),msg->head.counter,(*Local)->FuncName);
					}
				}
				else
				{
					SendError((*Local)->client_sockfd,err_NotOpen,msg->head.counter,(*Local)->FuncName);
				}
				UnAppropriateFile(((FilerDatMsg1 *)&msg->message)->ID);
			}
			else
			{
				LocI=((FilerDatMsg1 *)&msg->message)->ID.Index;
				SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_NextKey: // NextKey
		{
			(*Local)->FuncName="NextKey";
			fID=&((P_FilerInxMsg1)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				LocI=((P_FilerInxMsg1)msg->message)->KeyNr;
				int KeyNr=LocI;
				if((LocI>0)&&(LocI<=_Files->Files[(*Local)->Files[fID->Index].Index].datInfo.NrOfKeys))
				{
					if(AppropriateLocalFile(*Local,*fID,filetype_Data,0,0))
					{
						IsamKeyStr KeyStr;
                        ActFile=&_Files->Files[(*Local)->Files[fID->Index].Index];
						if((*Local)->Files[fID->Index].IndexArr[LocI].PathInd==0)
						{
							(*Local)->Files[fID->Index].IndexArr[LocI].SequentialOK=1;
						}
						if(IsamNextKey(&(*Local)->Files[fID->Index],LocI,&LocI2,&KeyStr))
						{
							LocI=sizeof(int)+sizeof(char)+KeyStr.Length;
							InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
							((ResultInxMsg1 *)(*Local)->local_buffer)->RefNr=LocI2;
							CopyKeyStr(&((ResultInxMsg1 *)(*Local)->local_buffer)->KeyStr,&KeyStr);
                            if(InitPreload(ActFile,(*Local)->local_buffer,sizeof(ResultMsg)+LocI))
                            {
                                Preload(Local,&(*Local)->Files[fID->Index],KeyNr,LocI2,KeyStr,preload_NextKey);
                                if(!DonePreload((*Local)->client_sockfd,ActFile))
                                {
                                    SendError((*Local)->client_sockfd,err_PreloadError,msg->head.counter,(*Local)->FuncName);
                                }
                            }
                            else
							if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultMsg)+LocI)==-1)
							{
								return -1;
							}
						}
						else
						{
							SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
						}
						UnAppropriateLocalFile(*Local,*fID);
					}
					else
					{
						SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
					}
				}
				else
				{
					SendError((*Local)->client_sockfd,err_BadKey,msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_PrevKey: // PrevKey
		{
			(*Local)->FuncName="PrevKey";
			fID=&((P_FilerInxMsg1)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				LocI=((P_FilerInxMsg1)msg->message)->KeyNr;
				if((LocI>0)&&(LocI<=_Files->Files[(*Local)->Files[fID->Index].Index].datInfo.NrOfKeys))
				{
					if(AppropriateLocalFile(*Local,*fID,filetype_Data,0,0))
					{
                        ActFile=&_Files->Files[(*Local)->Files[fID->Index].Index];
						IsamKeyStr KeyStr;
						if(IsamPrevKey(&(*Local)->Files[fID->Index],LocI,&LocI2,&KeyStr))
						{
							LocI=sizeof(int)+sizeof(char)+KeyStr.Length;
							InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
							((ResultInxMsg1 *)(*Local)->local_buffer)->RefNr=LocI2;
							CopyKeyStr(&((ResultInxMsg1 *)(*Local)->local_buffer)->KeyStr,&KeyStr);
                            if(InitPreload(ActFile,(*Local)->local_buffer,sizeof(ResultMsg)+LocI))
                            {
                                Preload(Local,&(*Local)->Files[fID->Index],KeyNr,LocI2,KeyStr,preload_PrevKey);
                                if(!DonePreload((*Local)->client_sockfd,ActFile))
                                {
                                    SendError((*Local)->client_sockfd,err_PreloadError,msg->head.counter,(*Local)->FuncName);
                                }
                            }
                            else
							if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultMsg)+LocI)==-1)
							{
								return -1;
							}
						}
						else
						{
							SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
						}
						UnAppropriateLocalFile(*Local,*fID);
					}
					else
					{
						SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
					}
				}
				else
				{
					SendError((*Local)->client_sockfd,err_BadKey,msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_FindKey: // FindKey
		{
			(*Local)->FuncName="FindKey";
			IsamKeyStr KeyStr;
			IsamKeyStr KeyStr2;
			fID=&((P_FilerInxMsg2)&msg->message)->ID;
            if(AppropriateLocalFile(*Local,*fID,filetype_Data,0,msg->head.message_id))
            {
                ActFile=&_Files->Files[(*Local)->Files[fID->Index].Index];
                LocI=((P_FilerInxMsg2)msg->message)->KeyNr;
                CopyKeyStr(&KeyStr,(P_IsamKeyStr)&((P_FilerInxMsg2)msg->message)->KeyLen);
                if((LocI>0)&&(LocI<=_Files->Files[(*Local)->Files[fID->Index].Index].datInfo.NrOfKeys))
                {
                    LocI2=0;
                    LocI3=IsamFindKey(&(*Local)->Files[fID->Index],LocI,&LocI2,&KeyStr);
                    if(LocI3)
                    {
                        InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
                        ((ResultInxMsg2 *)(*Local)->local_buffer)->RefNr=LocI2;
                        if(InitPreload(ActFile,(*Local)->local_buffer,sizeof(ResultInxMsg2)))
                        {
                            Preload(Local,&(*Local)->Files[fID->Index],KeyNr,LocI2,KeyStr,preload_FindKey);
                            if(!DonePreload((*Local)->client_sockfd,ActFile))
                            {
                                SendError((*Local)->client_sockfd,err_PreloadError,msg->head.counter,(*Local)->FuncName);
                            }
                        }
                        else
                        if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultInxMsg2))==-1)
                        {
                            return -1;
                        }
                    }
                    else
                    {
                        if(((*Local)->LastErrorCode==0)||((int)((*Local)->LastErrorCode/100)==102))
                        {
                            (*Local)->LastErrorCode=err_KeyNotFound;
                        }
                        SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                    }
                }
                else
                {
                    SendError((*Local)->client_sockfd,err_BadKey,msg->head.counter,(*Local)->FuncName);
                }
                UnAppropriateLocalFile(*Local,*fID);
            }
            else
            {
                SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
            }
			break;
		}
		case pds_FindKeyAndRef: // FindKeyAndRef
		{
			(*Local)->FuncName="FindKeyAndRef";
			IsamKeyStr KeyStr;
			fID=&((P_FilerInxMsg3)&msg->message)->ID;
			if(AppropriateLocalFile(*Local,*fID,filetype_Data,0,msg->head.message_id))
			{
                ActFile=&_Files->Files[(*Local)->Files[fID->Index].Index];
                LocI=((P_FilerInxMsg3)msg->message)->KeyNr;
                LocI2=((P_FilerInxMsg3)msg->message)->RefNr;
                CopyKeyStr(&KeyStr,(P_IsamKeyStr)&((P_FilerInxMsg3)msg->message)->KeyLen);
                if((LocI>0)&&(LocI<=_Files->Files[(*Local)->Files[fID->Index].Index].datInfo.NrOfKeys))
                {
                    if(IsamFindKeyAndRef(&(*Local)->Files[fID->Index],LocI,&LocI2,&KeyStr,((P_FilerInxMsg3)msg->message)->Direction))
                    {
                        LocI=sizeof(int)+sizeof(char)+KeyStr.Length;
                        InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
                        ((ResultInxMsg1 *)(*Local)->local_buffer)->RefNr=LocI2;
                        CopyKeyStr(&((ResultInxMsg1 *)(*Local)->local_buffer)->KeyStr,&KeyStr);
                        if(InitPreload(ActFile,(*Local)->local_buffer,sizeof(ResultMsg)+LocI))
                        {
                            Preload(Local,&(*Local)->Files[fID->Index],KeyNr,LocI2,KeyStr,preload_FindKeyAndRef);
                            if(!DonePreload((*Local)->client_sockfd,ActFile))
                            {
                                SendError((*Local)->client_sockfd,err_PreloadError,msg->head.counter,(*Local)->FuncName);
                            }
                        }
                        else
                        if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultMsg)+LocI)==-1)
                        {
                            return -1;
                        }
                    }
                    else
                    {
                        SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                    }
                }
                else
                {
                    SendError((*Local)->client_sockfd,err_BadKey,msg->head.counter,(*Local)->FuncName);
                }
                UnAppropriateLocalFile(*Local,*fID);
			}
			else
			{
                SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_SearchKey: // SearchKey
		{
			(*Local)->FuncName="SearchKey";
			IsamKeyStr KeyStr;
			fID=&((P_FilerInxMsg2)&msg->message)->ID;
			if(AppropriateLocalFile(*Local,*fID,filetype_Data,0,msg->head.message_id))
			{
                ActFile=&_Files->Files[(*Local)->Files[fID->Index].Index];
                LocI=((P_FilerInxMsg2)msg->message)->KeyNr;
                CopyKeyStr(&KeyStr,(P_IsamKeyStr)&((P_FilerInxMsg2)msg->message)->KeyLen);
                if((LocI>0)&&(LocI<=_Files->Files[(*Local)->Files[fID->Index].Index].datInfo.NrOfKeys))
                {
                    LocI2=0;
                    if(IsamSearchKey(&(*Local)->Files[fID->Index],LocI,&LocI2,&KeyStr))
                    {
                        LocI=sizeof(int)+sizeof(char)+KeyStr.Length;
                        InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
                        ((ResultInxMsg1 *)(*Local)->local_buffer)->RefNr=LocI2;
                        CopyKeyStr(&((ResultInxMsg1 *)(*Local)->local_buffer)->KeyStr,&KeyStr);
                        if(InitPreload(ActFile,(*Local)->local_buffer,sizeof(ResultMsg)+LocI))
                        {
                            Preload(Local,&(*Local)->Files[fID->Index],KeyNr,LocI2,KeyStr,preload_SearchKey);
                            if(!DonePreload((*Local)->client_sockfd,ActFile))
                            {
                                SendError((*Local)->client_sockfd,err_PreloadError,msg->head.counter,(*Local)->FuncName);
                            }
                        }
                        else
                        if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultMsg)+LocI)==-1)
                        {
                            return -1;
                        }
                    }
                    else
                    {
                        if(((*Local)->LastErrorCode==0)||((int)((*Local)->LastErrorCode/100)==102))
                        {
                            (*Local)->LastErrorCode=err_KeyNotFound;
                        }
                        SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                    }
                }
                else
                {
                    SendError((*Local)->client_sockfd,err_BadKey,msg->head.counter,(*Local)->FuncName);
                }
                UnAppropriateLocalFile(*Local,*fID);
            }
			else
			{
                SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_SearchKeyAndRef: // SearchKeyAndRef
		{
			(*Local)->FuncName="SearchKeyAndRef";
			IsamKeyStr KeyStr;
			fID=&((P_FilerInxMsg4)&msg->message)->ID;
			if(AppropriateLocalFile(*Local,*fID,filetype_Data,0,msg->head.message_id))
			{
				LocI=((P_FilerInxMsg4)msg->message)->KeyNr;
				LocI2=((P_FilerInxMsg4)msg->message)->RefNr;
				CopyKeyStr(&KeyStr,(P_IsamKeyStr)&((P_FilerInxMsg4)msg->message)->KeyLen);
				if((LocI>0)&&(LocI<=_Files->Files[(*Local)->Files[fID->Index].Index].datInfo.NrOfKeys))
				{
					if(IsamSearchKeyAndRef(&(*Local)->Files[fID->Index],LocI,&LocI2,&KeyStr))
					{
						LocI=sizeof(int)+sizeof(char)+KeyStr.Length;
						InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
						((ResultInxMsg1 *)(*Local)->local_buffer)->RefNr=LocI2;
						CopyKeyStr(&((ResultInxMsg1 *)(*Local)->local_buffer)->KeyStr,&KeyStr);
						if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultMsg)+LocI)==-1)
						{
							return -1;
						}
					}
					else
					{
						SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
					}
				}
				else
				{
					SendError((*Local)->client_sockfd,err_BadKey,msg->head.counter,(*Local)->FuncName);
				}
                UnAppropriateLocalFile(*Local,*fID);
			}
			else
			{
                SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_ClearKey: // ClearKey
		{
			(*Local)->FuncName="ClearKey";
			fID=&((P_FilerInxMsg1)&msg->message)->ID;
			if(AppropriateLocalFile(*Local,*fID,filetype_Data,0,msg->head.message_id))
			{
				LocI=((P_FilerInxMsg1)msg->message)->KeyNr;
				if(IsamClearKey(&(*Local)->Files[fID->Index],LocI))
				{
					SendOK((*Local)->client_sockfd,msg->head.counter);
				}
				else
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
				}
                UnAppropriateLocalFile(*Local,*fID);
			}
			else
			{
                SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_LockRec: // LockRec
		{
			(*Local)->FuncName="LockRec";
			fID=&((P_FilerDatMsg1)&msg->message)->ID;

			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				if(LockRec(*Local,*fID,((P_FilerDatMsg1)&msg->message)->RefNr))
				{
					SendOK((*Local)->client_sockfd,msg->head.counter);
				}
				else
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_RecIsLocked: // RecIsLocked
		{
			(*Local)->FuncName="RecIsLocked";
			fID=&((P_FilerDatMsg1)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				if(RecIsLocked(&(*Local)->Files[fID->Index],((P_FilerDatMsg1)&msg->message)->RefNr,&((ResultMsg1 *)(*Local)->local_buffer)->Result))
				{
					InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
					if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultMsg1))==-1)
					{
						return -1;
					}
				}
				else
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_UnlockRec: // UnlockRec
		{
			(*Local)->FuncName="UnlockRec";
			fID=&((P_FilerDatMsg1)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				if(UnlockRec(&(*Local)->Files[fID->Index],((P_FilerDatMsg1)&msg->message)->RefNr,0))
				{
					SendOK((*Local)->client_sockfd,msg->head.counter);
				}
				else
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_UnlockAllRecs: // UnlockAllRec
		{
			(*Local)->FuncName="UnlockAllRecs";
			fID=(fileID *)&msg->message;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				if(UnlockAllRecs(&(*Local)->Files[fID->Index]))
				{
					SendOK((*Local)->client_sockfd,msg->head.counter);
				}
				else
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_PutRec:
		{
			(*Local)->FuncName="PutRec";
			LocI3=((FilerDatMsg1 *)&msg->message)->ID.Index;
			if(!LocalIndexToGlobal(*Local,&((FilerDatMsg1 *)&msg->message)->ID,msg->head.message_id))
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			else
			{
			if(AppropriateFile(*Local,((FilerDatMsg1 *)&msg->message)->ID,filetype_Data,1))
			{
				ActFile=&_Files->Files[((FilerDatMsg1 *)&msg->message)->ID.Index];
				LocI=ActFile->Handle;
				if(LocI!=-1)
				{
					LocI2=((FilerDatMsg1 *)&msg->message)->RefNr;
					if((LocI2>0)&&(LocI2<=(ActFile->InxDescr[0].NumRec))&&((int)msg->head.message_size-(int)sizeof(FilerDatMsg1)==(int)ActFile->datInfo.LenRec))
					{
						uint8_t OK=1;
						int LocI4;
						if(!FindLock(&(*Local)->Files[LocI3],LocI2,&LocI4))
						{
							uint8_t IsLocked;
							if(RecIsLocked(&(*Local)->Files[LocI3],LocI2,&IsLocked))
							{
								if(IsLocked)
								{
									(*Local)->LastErrorCode=err_Error;
									OK=0;
								}
							}
							else
								OK=0;
						}
						if(OK)
						{
							LocI2=ActFile->datInfo.LenRec*LocI2;
							if(lseek(LocI,LocI2,SEEK_SET)==LocI2)
							{
								LocCh1=(char *)&msg->message;
								LocCh1+=sizeof(FilerDatMsg1);
								LocI2=write(LocI,LocCh1,ActFile->datInfo.LenRec);
								if(LocI2==ActFile->datInfo.LenRec)
								{
									SendOK((*Local)->client_sockfd,msg->head.counter);
								}
								else
								{
									(*Local)->LastErrorCode=errno;
									SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_WriteError),msg->head.counter,(*Local)->FuncName);
								}
							}
							else
							{
								(*Local)->LastErrorCode=errno;
								SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_SeekError),msg->head.counter,(*Local)->FuncName);
							}
						}
						else
						{
							SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
						}
					}
					else
					{
						(*Local)->LastErrorCode=err_BadParameters;
						SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_SeekError),msg->head.counter,(*Local)->FuncName);
					}
				}
				else
				{
					SendError((*Local)->client_sockfd,err_NotOpen,msg->head.counter,(*Local)->FuncName);
				}
				UnAppropriateFile(((FilerDatMsg1 *)&msg->message)->ID);
			}
			else
			{
				SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
			}
			}
			break;
		}
		case pds_UsedKeys: // UsedKeys
		{
			(*Local)->FuncName="UsedKeys";
			fID=&((P_FilerInxMsg1)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				LocI=((P_FilerInxMsg1)msg->message)->KeyNr;
				if((LocI>0)&&(LocI<=_Files->Files[(*Local)->Files[fID->Index].Index].datInfo.NrOfKeys))
				{
					IsamDatIndDescr * IDI=&_Files->Files[(*Local)->Files[fID->Index].Index].InxDescr[LocI];
					InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
					((ResultInxMsg2 *)(*Local)->local_buffer)->RefNr=IDI->NumKeys;
					if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultInxMsg2))==-1)
					{
						return -1;
					}
				}
				else
				{
					SendError((*Local)->client_sockfd,err_BadKey,msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_UsedRecs: // UsedRecs
		{
			(*Local)->FuncName="UsedRecs";
			fID=&((P_FilerMsg)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				IsamDatIndDescr * IDI=&_Files->Files[(*Local)->Files[fID->Index].Index].InxDescr[0];
				InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
				((ResultInxMsg2 *)(*Local)->local_buffer)->RefNr=IDI->NumRec-IDI->NumberFree;
				if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultInxMsg2))==-1)
				{
					return -1;
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_Lock: // Lock
		{
			(*Local)->FuncName="Lock";
			if(msg->head.message_size==sizeof(fileID))
			{
				fID=(fileID *)&msg->message;
				unsigned short fileType=_Files->Files[(*Local)->Files[fID->Index].Index].FileType;
				if(AppropriateLocalFile(*Local,*fID,fileType,1,msg->head.message_id))
				{
					if(_Files->Files[(*Local)->Files[fID->Index].Index].Locker==(*Local)->child_pid)
						_Files->Files[(*Local)->Files[fID->Index].Index].LockLevel++;
					else
					{
						_Files->Files[(*Local)->Files[fID->Index].Index].Locker=(*Local)->child_pid;
						_Files->Files[(*Local)->Files[fID->Index].Index].LockLevel=1;
					}
					UnAppropriateLocalFile(*Local,*fID);
					SendOK((*Local)->client_sockfd,msg->head.counter);
				}
				else
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
				}
			}
			break;
		}
		case pds_Unlock: // Unlock
		{
			(*Local)->FuncName="UnLock";
			if(msg->head.message_size==sizeof(fileID))
			{
				fID=(fileID *)&msg->message;
				unsigned short fileType=_Files->Files[(*Local)->Files[fID->Index].Index].FileType;
				if(AppropriateLocalFile(*Local,*fID,fileType,0,msg->head.message_id))
				{
					if(_Files->Files[(*Local)->Files[fID->Index].Index].Locker==(*Local)->child_pid)
					{
						_Files->Files[(*Local)->Files[fID->Index].Index].LockLevel--;
						if(!_Files->Files[(*Local)->Files[fID->Index].Index].LockLevel)
						  _Files->Files[(*Local)->Files[fID->Index].Index].Locker=0;
					}
					if(_Files->Files[(*Local)->Files[fID->Index].Index].ReadLocker==(*Local)->child_pid)
					{
						_Files->Files[(*Local)->Files[fID->Index].Index].ReadLockLevel--;
						if(!_Files->Files[(*Local)->Files[fID->Index].Index].ReadLockLevel)
						  _Files->Files[(*Local)->Files[fID->Index].Index].ReadLocker=0;
					}
					UnAppropriateLocalFile(*Local,*fID);
					SendOK((*Local)->client_sockfd,msg->head.counter);
				}
				else
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
				}
			}
			break;
		}
		case pds_ReadLock: // ReadLock
		{
			(*Local)->FuncName="ReadLock";
			if(msg->head.message_size==sizeof(fileID))
			{
				fID=(fileID *)&msg->message;
				unsigned short fileType=_Files->Files[(*Local)->Files[fID->Index].Index].FileType;
				if(AppropriateLocalFile(*Local,*fID,fileType,1,msg->head.message_id))
				{
					if(_Files->Files[(*Local)->Files[fID->Index].Index].ReadLocker==(*Local)->child_pid)
						_Files->Files[(*Local)->Files[fID->Index].Index].ReadLockLevel++;
					else
					{
						_Files->Files[(*Local)->Files[fID->Index].Index].ReadLocker=(*Local)->child_pid;
						_Files->Files[(*Local)->Files[fID->Index].Index].ReadLockLevel=1;
					}
					UnAppropriateLocalFile(*Local,*fID);
					SendOK((*Local)->client_sockfd,msg->head.counter);
				}
				else
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
				}
			}
			break;
		}
		case pds_AddRec: // AddRec
		{
			(*Local)->FuncName="AddRec";
			fileID localID=((FilerMsg *)&msg->message)->ID;
			if(!LocalIndexToGlobal(*Local,&((FilerMsg *)&msg->message)->ID,msg->head.message_id))
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			else
			{
				ActFile=&_Files->Files[((FilerMsg *)&msg->message)->ID.Index];
				if(msg->head.message_size-ActFile->datInfo.LenRec==8)
				{
					if(AppropriateFile(*Local,((FilerMsg *)&msg->message)->ID,ActFile->FileType,1))
					{
						P_local_file LocalFile=&(*Local)->Files[localID.Index];
						LocI=ActFile->Handle;
						if(LocI!=-1)
						{
							if(ActFile->FileType==filetype_Data)
							{
								LocCh1=(char *)&msg->message;
								LocCh1+=8;
								if(IsamAddRec(LocalFile,&LocI,(void *)LocCh1))
								{
									InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
									((ResultInxMsg2 *)(*Local)->local_buffer)->RefNr=LocI;
									if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultInxMsg2))==-1)
									{
										return -1;
									}
								}
								else
								{
									SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
								}
							}
							else
							{
								SendError((*Local)->client_sockfd,err_BadFileType,msg->head.counter,(*Local)->FuncName);
							}
						}
						else
						{
							SendError((*Local)->client_sockfd,err_NotOpen,msg->head.counter,(*Local)->FuncName);
						}
						UnAppropriateFile(((FilerDatMsg2 *)&msg->message)->ID);
					}
					else
					{
						SendError((*Local)->client_sockfd,err_Appropriation,msg->head.counter,(*Local)->FuncName);
					}
				}
			}
			break;
		}
		case pds_AddKey: // AddKey
		{
			(*Local)->FuncName="AddKey";
			IsamKeyStr KeyStr;
			fID=&((P_FilerInxMsg4)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				LocI=((P_FilerInxMsg4)msg->message)->KeyNr;
				if((LocI>0)&&(LocI<=_Files->Files[(*Local)->Files[fID->Index].Index].datInfo.NrOfKeys))
				{
					if(((P_FilerInxMsg4)msg->message)->KeyLen<=_Files->Files[(*Local)->Files[fID->Index].Index].InxDescr[LocI].KeyLen)
					{
						if(AppropriateLocalFile(*Local,((FilerInxMsg4 *)&msg->message)->ID,filetype_Data,1,0))
						{
							CopyKeyStr(&KeyStr,(P_IsamKeyStr)&((P_FilerInxMsg4)msg->message)->KeyLen);
							if(IsamAddKey(&(*Local)->Files[fID->Index],LocI,((P_FilerInxMsg4)msg->message)->RefNr,&KeyStr))
							{
								SendOK((*Local)->client_sockfd,msg->head.counter);
							}
							else
							{
								SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_CannotDuplicateKey),msg->head.counter,(*Local)->FuncName);
							}
							UnAppropriateLocalFile(*Local,((FilerInxMsg4 *)&msg->message)->ID);
						}
						else
						{
							SendError((*Local)->client_sockfd,err_Appropriation,msg->head.counter,(*Local)->FuncName);
						}
					}
					else
					{
						SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_KeyTooLong),msg->head.counter,(*Local)->FuncName);
					}
				}
				else
				{
					SendError((*Local)->client_sockfd,err_BadKey,msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_AddRecord: // AddRecord
		{
			(*Local)->FuncName="AddRecord";
			fID=&((FilerMsg *)&msg->message)->ID;
			if(AppropriateLocalFile(*Local,*fID,filetype_Data,0,msg->head.message_id))
			{
                ActFile=&_Files->Files[(*Local)->Files[fID->Index].Index];
				LocI3=msg->head.message_size-sizeof(FilerMsg)-ActFile->datInfo.LenRec;
                LocI=ActFile->datInfo.NrOfKeys;
				if(LocI3>=LocI)
				{
                    LocCh1=msg->message;
                    LocCh1+=sizeof(FilerMsg);
                    LocCh1+=ActFile->datInfo.LenRec;
                    (*Local)->LastErrorCode=0;
                    while((LocI)&&(!(*Local)->LastErrorCode))
                    {
                        LocI--;
                        if(((P_IsamKeyStr)LocCh1)->Length<LocI3)
                        {
                            LocI2=((P_IsamKeyStr)LocCh1)->Length+1;
                            LocI3-=LocI2;
                            if(LocI3>0)
                                LocCh1+=LocI2;
                            else
                            if(LocI3<0)
                            {
                                (*Local)->LastErrorCode=err_BadParameters;
                            }
                        }
                        else
                        {
                            (*Local)->LastErrorCode=err_BadParameters;
                        }
                    }
                    if(LocI3!=0)
                    {
                        (*Local)->LastErrorCode=err_BadParameters;
                    }
                    if(!(*Local)->LastErrorCode)
                    {
                        LocCh1=msg->message;
                        LocCh1+=sizeof(FilerMsg);
                        int RefNr=0;
                        P_local_file LocalFile=&(*Local)->Files[fID->Index];
                        if(IsamAddRec(LocalFile,&RefNr,(void *)LocCh1))
                        {
                            LocCh1+=ActFile->datInfo.LenRec;
                            LocI=0;
                            IsamKeyStr KeyStr;
                            while((LocI<ActFile->datInfo.NrOfKeys)&&(!(*Local)->LastErrorCode))
                            {
                                LocI++;
                                CopyKeyStr(&KeyStr,(P_IsamKeyStr)LocCh1);
                                if(!IsamAddKey(LocalFile,LocI,RefNr,&KeyStr))
                                {
                                    (*Local)->LastErrorCode=GetLastFileError(*Local,err_CannotDuplicateKey);
                                    LocI3=(*Local)->LastErrorCode;
                                    LocCh1=msg->message;
                                    LocCh1+=sizeof(FilerMsg);
                                    LocCh1+=ActFile->datInfo.LenRec;
                                    int LocI4=0;
                                    while(LocI4+1<LocI)
                                    {
                                        LocI4++;
                                        CopyKeyStr(&KeyStr,(P_IsamKeyStr)LocCh1);
                                        IsamDeleteKey(LocalFile,LocI4,RefNr,&KeyStr);
                                        LocCh1+=((P_IsamKeyStr)LocCh1)->Length+1;
                                    }
                                    (*Local)->LastErrorCode=LocI3;
                                }
                                else
                                {
                                    if(LocI<ActFile->datInfo.NrOfKeys)
                                        LocCh1+=((P_IsamKeyStr)LocCh1)->Length+1;
                                }
                            }

                            if((LocI==ActFile->datInfo.NrOfKeys)&&(!(*Local)->LastErrorCode))
                            {
                                InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
								((ResultInxMsg2 *)(*Local)->local_buffer)->RefNr=RefNr;
								if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultInxMsg2))==-1)
                                {
                                    return -1;
                                }
                            }
                            else
                            {
                                LocI3=(*Local)->LastErrorCode;
                                IsamDeleteRecOrPage(LocalFile,RefNr,0);
                                (*Local)->LastErrorCode=LocI3;
                                SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                            }
                        }
                        else
                        {
                            SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_CannotDuplicateKey),msg->head.counter,(*Local)->FuncName);
                        }
                    }
                    else
                    {
                        SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                    }
				}
				else
				{
                    SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
				}
                UnAppropriateLocalFile(*Local,*fID);
			}
			else
			{
				SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_ModifyRecord: // ModifyRecord
		{
			(*Local)->FuncName="ModifyRecord";
			fID=&((FilerInxMsg7 *)&msg->message)->ID;
			if(AppropriateLocalFile(*Local,*fID,filetype_Data,0,msg->head.message_id))
			{
                P_local_file LocalFile=&(*Local)->Files[fID->Index];
                ActFile=&_Files->Files[LocalFile->Index];
				LocI3=msg->head.message_size-sizeof(FilerInxMsg7)-ActFile->datInfo.LenRec;
				LocI=((P_FilerInxMsg7)msg->message)->KeyNr;
                LocCh1=msg->message;
                LocCh1+=sizeof(FilerInxMsg7);
                LocCh1+=ActFile->datInfo.LenRec;
                (*Local)->LastErrorCode=0;
                while((LocI)&&(!(*Local)->LastErrorCode))
                {
                    LocI--;
                    if((((P_MultiAddKey)LocCh1)->KeyNr>0)||(((P_MultiAddKey)LocCh1)->KeyNr<=ActFile->datInfo.NrOfKeys))
                    {
                        LocI2=(int)((char *)&((P_MultiAddKey)LocCh1)->Key.Data - LocCh1)+((P_MultiAddKey)LocCh1)->Key.Length;
                        if(LocI2<LocI3)
                        {
                            LocI3-=LocI2;
                            LocCh1+=LocI2;
                            LocI2=((P_IsamKeyStr)LocCh1)->Length+1;
                            if(LocI2<=LocI3)
                            {
                                LocI3-=LocI2;
                                LocCh1+=LocI2;
                            }
                        }
                        else
                        {
                            (*Local)->LastErrorCode=err_BadParameters;
                        }
                    }
                    else
                    {
                        (*Local)->LastErrorCode=err_BadKey;
                    }
                }
                if((LocI==0)&&(!(*Local)->LastErrorCode))
                {
                    LocI=ActFile->Handle;
                    if(LocI!=-1)
                    {
                        LocI2=((FilerInxMsg7 *)&msg->message)->RefNr;
                        if((LocI2>0)&&(LocI2<=(ActFile->InxDescr[0].NumRec)))
                        {
                            uint8_t OK=1;
                            int LocI4;
                            if(!FindLock(LocalFile,LocI2,&LocI4))
                            {
                                uint8_t IsLocked;
                                if(RecIsLocked(LocalFile,LocI2,&IsLocked))
                                {
                                    if(IsLocked)
                                    {
                                        (*Local)->LastErrorCode=err_DataRecordIsLocked;
                                        OK=0;
                                    }
                                }
                                else
                                    OK=0;
                            }
                            if(OK)
                            {
                                LocI2=ActFile->datInfo.LenRec*((FilerInxMsg7 *)&msg->message)->RefNr;
                                if(lseek(LocI,LocI2,SEEK_SET)==LocI2)
                                {
                                    LocI2=read(ActFile->Handle,(*Local)->local_buffer,ActFile->datInfo.LenRec);
                                    if(LocI2==ActFile->datInfo.LenRec)
                                    {
                                        LocI2=ActFile->datInfo.LenRec*((FilerInxMsg7 *)&msg->message)->RefNr;
                                        if(lseek(LocI,LocI2,SEEK_SET)==LocI2)
                                        {
                                            LocCh1=(char *)&msg->message;
                                            LocCh1+=sizeof(FilerInxMsg7);
                                            LocI2=write(ActFile->Handle,LocCh1,ActFile->datInfo.LenRec);
                                            if(LocI2==ActFile->datInfo.LenRec)
                                            {
                                                LocCh1+=LocI2;
                                                LocI=0;
                                                IsamKeyStr KeyStr;
                                                int LocI5;
                                                int OKDeleted=0;
                                                int OKAdded=0;
                                                while((LocI<((P_FilerInxMsg7)msg->message)->KeyNr)&&(!(*Local)->LastErrorCode))
                                                {
                                                    LocI++;
                                                    LocI2=(int)((char *)&((P_MultiAddKey)LocCh1)->Key.Data - LocCh1)+((P_MultiAddKey)LocCh1)->Key.Length;
                                                    LocI5=((P_MultiAddKey)LocCh1)->KeyNr;
                                                    CopyKeyStr(&KeyStr,&((P_MultiAddKey)LocCh1)->Key);
                                                    if(IsamDeleteKey(LocalFile,LocI5,((FilerInxMsg7 *)&msg->message)->RefNr,&KeyStr))
                                                    {
                                                        OKDeleted++;
                                                        LocCh1+=LocI2;
                                                        CopyKeyStr(&KeyStr,(P_IsamKeyStr)LocCh1);
                                                        if(IsamAddKey(LocalFile,LocI5,((FilerInxMsg7 *)&msg->message)->RefNr,&KeyStr))
                                                        {
                                                            OKAdded++;
                                                            LocCh1+=((P_IsamKeyStr)LocCh1)->Length+1;
                                                        }
                                                        else
                                                        {
                                                            (*Local)->LastErrorCode=GetLastFileError(*Local,err_CannotDuplicateKey);
                                                        }
                                                    }
                                                    else
                                                    {
                                                        (*Local)->LastErrorCode=GetLastFileError(*Local,err_Unspecified);
                                                    }
                                                }
                                                if((*Local)->LastErrorCode)
                                                {
                                                    LocI3=(*Local)->LastErrorCode;
                                                    LocI2=ActFile->datInfo.LenRec*((FilerInxMsg7 *)&msg->message)->RefNr;
                                                    if(lseek(ActFile->Handle,LocI2,SEEK_SET)==LocI2)
                                                    {
                                                        LocI2=write(ActFile->Handle,(*Local)->local_buffer,ActFile->datInfo.LenRec); // undo datove vety
                                                        if(LocI2==ActFile->datInfo.LenRec)
                                                        {
                                                            IsamKeyStr KeyStr2;
                                                            LocCh1=(char *)&msg->message;
                                                            LocCh1+=sizeof(FilerInxMsg7);
                                                            LocCh1+=LocI2;
                                                            LocI4=0;
                                                            while(LocI4<LocI)   // undo zmen v indexech
                                                            {
                                                                LocI4++;
                                                                LocI2=(int)((char *)&((P_MultiAddKey)LocCh1)->Key.Data - LocCh1)+((P_MultiAddKey)LocCh1)->Key.Length;
                                                                LocI5=((P_MultiAddKey)LocCh1)->KeyNr;
                                                                CopyKeyStr(&KeyStr,&((P_MultiAddKey)LocCh1)->Key);
                                                                LocCh1+=LocI2;
                                                                CopyKeyStr(&KeyStr2,(P_IsamKeyStr)LocCh1);
                                                                LocCh1+=((P_IsamKeyStr)LocCh1)->Length+1;
                                                                if(OKAdded)
                                                                {
                                                                    OKAdded--;
                                                                    if(!IsamDeleteKey(LocalFile,LocI5,((FilerInxMsg7 *)&msg->message)->RefNr,&KeyStr2))
                                                                    {
                                                                        message(0,"%d Undo v %s selhalo pri ruseni klice (errno %d)\n",getpid(),(*Local)->FuncName,errno);
                                                                    }
                                                                }
                                                                if(OKDeleted)
                                                                {
                                                                    OKDeleted--;
                                                                    if(!IsamAddKey(LocalFile,LocI5,((FilerInxMsg7 *)&msg->message)->RefNr,&KeyStr))
                                                                    {
                                                                        message(0,"%d Undo v %s selhalo pri ruseni klice (errno %d)\n",getpid(),(*Local)->FuncName,errno);
                                                                    }
                                                                }
                                                            }
                                                        }
                                                        else
                                                        {
                                                            message(0,"%d Undo v %s selhalo pri obnove vety (errno %d)\n",getpid(),(*Local)->FuncName,errno);
                                                        }
                                                    }
                                                    (*Local)->LastErrorCode=LocI3;
                                                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                                                }
                                                else
                                                {
                                                    SendOK((*Local)->client_sockfd,msg->head.counter);
                                                }
                                            }
                                            else
                                            {
                                                (*Local)->LastErrorCode=errno;
                                                SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_WriteError),msg->head.counter,(*Local)->FuncName);
                                            }
                                        }
                                        else
                                        {
                                            (*Local)->LastErrorCode=errno;
                                            SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_SeekError),msg->head.counter,(*Local)->FuncName);
                                        }
                                    }
                                    else
                                    {
                                        (*Local)->LastErrorCode=errno;
                                        SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_ReadError),msg->head.counter,(*Local)->FuncName);
                                    }
                                }
                                else
                                {
                                    (*Local)->LastErrorCode=errno;
                                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_SeekError),msg->head.counter,(*Local)->FuncName);
                                }
                            }
                            else
                            {
                                SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                            }
                        }
                        else
                        {
                            (*Local)->LastErrorCode=err_BadParameters;
                            SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_SeekError),msg->head.counter,(*Local)->FuncName);
                        }
                    }
                    else
                    {
                        SendError((*Local)->client_sockfd,err_NotOpen,msg->head.counter,(*Local)->FuncName);
                    }

                }
                else
                {
                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_BadParameters),msg->head.counter,(*Local)->FuncName);
                }
                UnAppropriateLocalFile(*Local,*fID);
			}
			else
			{
				SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_DeleteRecord: // DeleteRecord
		{
			(*Local)->FuncName="DeleteRecord";
			fID=&((FilerDatMsg1 *)&msg->message)->ID;
			if(AppropriateLocalFile(*Local,*fID,filetype_Data,0,msg->head.message_id))
			{
                P_local_file LocalFile=&(*Local)->Files[fID->Index];
                ActFile=&_Files->Files[LocalFile->Index];
				LocI3=msg->head.message_size-sizeof(FilerDatMsg1)-ActFile->datInfo.LenRec;
                LocI=ActFile->datInfo.NrOfKeys;
				if(LocI3>=LocI)
				{
                    LocCh1=msg->message;
                    LocCh1+=sizeof(FilerDatMsg1);
                    LocCh1+=ActFile->datInfo.LenRec;
                    (*Local)->LastErrorCode=0;
                    while((LocI)&&(!(*Local)->LastErrorCode))
                    {
                        LocI--;
                        if(((P_IsamKeyStr)LocCh1)->Length<LocI3)
                        {
                            LocI2=((P_IsamKeyStr)LocCh1)->Length+1;
                            LocI3-=LocI2;
                            if(LocI3>0)
                                LocCh1+=LocI2;
                            else
                            if(LocI3<0)
                                (*Local)->LastErrorCode=err_BadParameters;
                        }
                        else
                        {
                            (*Local)->LastErrorCode=err_BadParameters;
                        }
                    }
                    if(LocI3!=0)
                        (*Local)->LastErrorCode=err_BadParameters;
                    if(!(*Local)->LastErrorCode)
                    {
                        LocI2=((P_FilerDatMsg1)msg->message)->RefNr;
                        uint8_t OK=1;
                        int LocI4;
                        if(!FindLock(LocalFile,LocI2,&LocI4))
                        {
                            uint8_t IsLocked;
                            if(RecIsLocked(LocalFile,LocI2,&IsLocked))
                            {
                                if(IsLocked)
                                {
                                    (*Local)->LastErrorCode=err_DataRecordIsLocked;
                                    OK=0;
                                }
                            }
                            else
                                OK=0;
                        }
                        if(OK)
                        {
                            LocCh1=msg->message;
                            LocCh1+=sizeof(FilerDatMsg1);
                            LocI2=ActFile->datInfo.LenRec*((FilerInxMsg7 *)&msg->message)->RefNr;
                            if(lseek(ActFile->Handle,LocI2,SEEK_SET)==LocI2)
                            {
                                LocI2=read(ActFile->Handle,(*Local)->local_buffer,ActFile->datInfo.LenRec);
                                if(LocI2==ActFile->datInfo.LenRec)
                                {
                                    if(memcmp((*Local)->local_buffer,LocCh1,ActFile->datInfo.LenRec)==0)
                                    {
                                        LocCh1+=ActFile->datInfo.LenRec;
                                        if(IsamDeleteRecOrPage(LocalFile,((P_FilerDatMsg1)msg->message)->RefNr,0))
                                        {
                                            LocI=0;
                                            IsamKeyStr KeyStr;
                                            while((LocI<ActFile->datInfo.NrOfKeys)&&(!(*Local)->LastErrorCode))
                                            {
                                                LocI++;
                                                CopyKeyStr(&KeyStr,(P_IsamKeyStr)LocCh1);
                                                if(!IsamDeleteKey(LocalFile,LocI,((P_FilerDatMsg1)msg->message)->RefNr,&KeyStr))
                                                {
                                                    message(0,"%d Pri vymazu vety %d za pomoci %s selhalo ruseni klice (ErrorCode %d)\n",getpid(),((P_FilerDatMsg1)msg->message)->RefNr,(*Local)->FuncName,(*Local)->LastErrorCode);
                                                }
                                                if(LocI<ActFile->datInfo.NrOfKeys)
                                                    LocCh1+=((P_IsamKeyStr)LocCh1)->Length+1;
                                            }
                                        }
                                        else
                                        {
                                            (*Local)->LastErrorCode=err_Unspecified;
                                        }
                                    }
                                    else
                                    {
                                        (*Local)->LastErrorCode=err_RecordModified;
                                    }
                                }
                                else
                                {
                                    (*Local)->LastErrorCode=errno;
                                    (*Local)->LastErrorCode=GetLastFileError(*Local,err_ReadError);
                                }
                            }
                            else
                            {
                                (*Local)->LastErrorCode=errno;
                                (*Local)->LastErrorCode=GetLastFileError(*Local,err_ReadError);
                            }
                        }
                        else
                        {
                            (*Local)->LastErrorCode=GetLastFileError(*Local,err_Unspecified);
                        }
                        if((LocI==ActFile->datInfo.NrOfKeys)&&(!(*Local)->LastErrorCode))
                        {
                            SendOK((*Local)->client_sockfd,msg->head.counter);
                        }
                        else
                        {
                            SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                        }
                    }
                    else
                    {
                        SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                    }
                }
                else
                {
                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_BadParameters),msg->head.counter,(*Local)->FuncName);
                }
                UnAppropriateLocalFile(*Local,*fID);
			}
			else
			{
				SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_GetRelPos: // GetRelPos
		{
			(*Local)->FuncName="GetRelPos";
			IsamKeyStr KeyStr;
			fID=&((P_FilerInxMsg5)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				if(AppropriateLocalFile(*Local,*fID,filetype_Data,0,0))
				{
                    LocI=((P_FilerInxMsg5)msg->message)->KeyNr;
                    unsigned short RelPos;
                    CopyKeyStr(&KeyStr,(P_IsamKeyStr)&((P_FilerInxMsg5)msg->message)->KeyLen);
                    if((LocI>0)&&(LocI<=_Files->Files[(*Local)->Files[fID->Index].Index].datInfo.NrOfKeys))
                    {
                        LocI2=((P_FilerInxMsg5)msg->message)->RefNr;
                        if(IsamGetApprRelPos(&(*Local)->Files[fID->Index],LocI,&RelPos,((P_FilerInxMsg5)msg->message)->Scale,&KeyStr,LocI2))
                        {
                            InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
                            ((ResultInxMsg3 *)(*Local)->local_buffer)->WResult=RelPos;
                            if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultInxMsg3))==-1)
                            {
                                UnAppropriateLocalFile(*Local,*fID);
                                return -1;
                            }
                        }
                        else
                        {
                            SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                        }
                    }
                    else
                    {
                        SendError((*Local)->client_sockfd,err_BadKey,msg->head.counter,(*Local)->FuncName);
                    }
                    UnAppropriateLocalFile(*Local,*fID);
				}
                else
                {
                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
                }
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_GetKeyInRelPos: // GetKeyInRelPos
		{
			(*Local)->FuncName="GetKeyInRelPos";
			IsamKeyStr KeyStr;
			fID=&((P_FilerInxMsg6)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				if(AppropriateLocalFile(*Local,*fID,filetype_Data,0,0))
				{
                    LocI=((P_FilerInxMsg6)msg->message)->KeyNr;
                    CopyKeyStr(&KeyStr,(P_IsamKeyStr)&((P_FilerInxMsg5)msg->message)->KeyLen);
                    if((LocI>0)&&(LocI<=_Files->Files[(*Local)->Files[fID->Index].Index].datInfo.NrOfKeys))
                    {
                        LocI2=0;
                        if(IsamGetApprKeyAndRef(&(*Local)->Files[fID->Index],LocI,((P_FilerInxMsg6)msg->message)->RelPos,((P_FilerInxMsg6)msg->message)->Scale,&KeyStr,&LocI2))
                        {
                            LocI=sizeof(int)+sizeof(char)+KeyStr.Length;
                            InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
                            ((ResultInxMsg1 *)(*Local)->local_buffer)->RefNr=LocI2;
                            CopyKeyStr(&((ResultInxMsg1 *)(*Local)->local_buffer)->KeyStr,&KeyStr);
                            if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultMsg)+LocI)==-1)
                            {
                                UnAppropriateLocalFile(*Local,*fID);
                                return -1;
                            }
                        }
                        else
                        {
                            SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                        }
                    }
                    else
                    {
                        SendError((*Local)->client_sockfd,err_BadKey,msg->head.counter,(*Local)->FuncName);
                    }
                    UnAppropriateLocalFile(*Local,*fID);
				}
                else
                {
                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
                }
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_NextDiffKey: // NextDiffKey
		{
			(*Local)->FuncName="NextDiffKey";
			IsamKeyStr KeyStr;
			IsamKeyStr SaveKeyStr;
			fID=&((P_FilerInxMsg2)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				if(AppropriateLocalFile(*Local,*fID,filetype_Data,0,0))
				{
                    LocI=((P_FilerInxMsg2)msg->message)->KeyNr;
                    CopyKeyStr(&KeyStr,(P_IsamKeyStr)&((P_FilerInxMsg2)msg->message)->KeyLen);
                    if((LocI>0)&&(LocI<=_Files->Files[(*Local)->Files[fID->Index].Index].datInfo.NrOfKeys))
                    {
                        (*Local)->LastErrorCode=0;
                        uint8_t Compenzation=1;
                        uint8_t _xLat=_Files->Files[(*Local)->Files[fID->Index].Index].InxDescr[LocI].XlatKeys;
                        while(Compenzation)
                        {
                            Compenzation=0;
                            LocI3=_Files->Files[(*Local)->Files[fID->Index].Index].InxDescr[LocI].KeyLen;
                            if(KeyStr.Length<LocI3)
                            {
                                KeyStr.Data[KeyStr.Length]=0;
                                KeyStr.Length++;
                            }
                            else
                            {
                                uint8_t Znak=(uint8_t)KeyStr.Data[LocI3-1];
                                if(Znak!=255)
                                {
                                    if((_xLat)&&(LocI3>1)&&(((Znak=='H')||(Znak=='h'))&&((KeyStr.Data[LocI3-2]=='C')||(KeyStr.Data[LocI3-2]=='c'))))
                                    {
                                        if(KeyStr.Data[LocI3-2]=='C')
                                          KeyStr.Data[LocI3-2]='I'; else KeyStr.Data[LocI3-2]='i';
                                        KeyStr.Data[LocI3-1]=0;
                                    }
                                    else
                                    {
                                        KeyStr.Data[LocI3-1]++;
                                    }
                                }
                                else
                                {
                                    while(((uint8_t)KeyStr.Data[LocI3-1]==255)&&(LocI3>0))
                                    {
                                        KeyStr.Data[LocI3-1]=0;
                                        LocI3--;
                                    }
                                    if(LocI3==0)
                                    {
                                        (*Local)->LastErrorCode=err_NoLargerKeyFound;
                                    }
                                    else
                                    {
                                        KeyStr.Data[LocI3-1]++;
                                    }
                                }
                            }
                            if((*Local)->LastErrorCode==0)
                            {
                                LocI2=0;
                                CopyKeyStr(&SaveKeyStr,&KeyStr);
                                if(IsamSearchKey(&(*Local)->Files[fID->Index],LocI,&LocI2,&KeyStr))
                                {
                                    IsamKeyStr _tempKey;
                                    IsamKeyStr _tempKey2;
                            	    CopyKeyStr(&_tempKey,&KeyStr);
                            	    CopyKeyStr(&_tempKey2,&SaveKeyStr);
                            	    if(_xLat)
                            	    {
                                        XTrans(&_tempKey);XTrans(&_tempKey2);
                            	    }

                                    if(CmpKeyStr(&_tempKey2,&_tempKey)>=0)
                                    {
                                        CopyKeyStr(&KeyStr,&SaveKeyStr);
                                        Compenzation=1;
                                    }
                                    else
                                    {
                                        LocI=sizeof(int)+sizeof(char)+KeyStr.Length;
                                        InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
                                        ((ResultInxMsg1 *)(*Local)->local_buffer)->RefNr=LocI2;
                                        CopyKeyStr(&((ResultInxMsg1 *)(*Local)->local_buffer)->KeyStr,&KeyStr);
                                        if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultMsg)+LocI)==-1)
                                        {
                                            UnAppropriateLocalFile(*Local,*fID);
                                            return -1;
                                        }
                                    }
                                }
                                else
                                {
                                    if(((*Local)->LastErrorCode==0)||((int)((*Local)->LastErrorCode/100)==102))
                                    {
                                        (*Local)->LastErrorCode=err_KeyNotFound;
                                    }
                                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                                }
                            }
                            else
                            {
                                SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                            }
                        }
                    }
                    else
                    {
                        SendError((*Local)->client_sockfd,err_BadKey,msg->head.counter,(*Local)->FuncName);
                    }
                    UnAppropriateLocalFile(*Local,*fID);
				}
                else
                {
                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
                }
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_PrevDiffKey: // PrevDiffKey
		{
			(*Local)->FuncName="PrevDiffKey";
			IsamKeyStr KeyStr;
			IsamKeyStr SaveKeyStr;
			fID=&((P_FilerInxMsg2)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				if(AppropriateLocalFile(*Local,*fID,filetype_Data,0,0))
				{
                    LocI=((P_FilerInxMsg2)msg->message)->KeyNr;
                    CopyKeyStr(&KeyStr,(P_IsamKeyStr)&((P_FilerInxMsg2)msg->message)->KeyLen);
                    CopyKeyStr(&SaveKeyStr,&KeyStr);
                    if((LocI>0)&&(LocI<=_Files->Files[(*Local)->Files[fID->Index].Index].datInfo.NrOfKeys))
                    {
                        LocI2=0;
                        LocI3=IsamSearchKey(&(*Local)->Files[fID->Index],LocI,&LocI2,&KeyStr);
                        if((LocI3)&&(((*Local)->LastErrorCode==0)||((int)((*Local)->LastErrorCode/100)==102)))
                        {
                            while(1)
                            {
                                if(IsamPrevKey(&(*Local)->Files[fID->Index],LocI,&LocI2,&KeyStr))
                                {
                                    if(CmpKeyStr(&SaveKeyStr,&KeyStr)>0)
                                    {
                                        LocI=sizeof(int)+sizeof(char)+KeyStr.Length;
                                        InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
                                        ((ResultInxMsg1 *)(*Local)->local_buffer)->RefNr=LocI2;
                                        CopyKeyStr(&((ResultInxMsg1 *)(*Local)->local_buffer)->KeyStr,&KeyStr);
                                        if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultMsg)+LocI)==-1)
                                        {
                                            UnAppropriateLocalFile(*Local,*fID);
                                            return -1;
                                        }
                                    }
                                    break;
                                }
                                else
                                {
                                    if((*Local)->LastErrorCode==err_NoSmallerKeyFound)
                                        (*Local)->LastErrorCode=err_NoSmallerKeyFound_;
                                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                                    break;
                                }
                            }
                        }
                        else
                        {
                            SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                        }
                    }
                    else
                    {
                        SendError((*Local)->client_sockfd,err_BadKey,msg->head.counter,(*Local)->FuncName);
                    }
                    UnAppropriateLocalFile(*Local,*fID);
				}
                else
                {
                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
                }
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_DeleteKey: // DeleteKey
		{
			(*Local)->FuncName="DeleteKey";
			IsamKeyStr KeyStr;
			fID=&((P_FilerInxMsg4)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				LocI=((P_FilerInxMsg4)msg->message)->KeyNr;
				if((LocI>0)&&(LocI<=_Files->Files[(*Local)->Files[fID->Index].Index].datInfo.NrOfKeys))
				{
					if(((P_FilerInxMsg4)msg->message)->KeyLen<=_Files->Files[(*Local)->Files[fID->Index].Index].InxDescr[LocI].KeyLen)
					{
						if(AppropriateLocalFile(*Local,((FilerInxMsg4 *)&msg->message)->ID,filetype_Data,1,0))
						{
							CopyKeyStr(&KeyStr,(P_IsamKeyStr)&((P_FilerInxMsg4)msg->message)->KeyLen);
							if(IsamDeleteKey(&(*Local)->Files[fID->Index],LocI,((P_FilerInxMsg4)msg->message)->RefNr,&KeyStr))
							{
								SendOK((*Local)->client_sockfd,msg->head.counter);
							}
							else
							{
								SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_KeyForDeleteNotFound),msg->head.counter,(*Local)->FuncName);
							}
							UnAppropriateLocalFile(*Local,((FilerInxMsg4 *)&msg->message)->ID);
						}
						else
						{
							SendError((*Local)->client_sockfd,err_Appropriation,msg->head.counter,(*Local)->FuncName);
						}
					}
					else
					{
						SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_KeyTooLong),msg->head.counter,(*Local)->FuncName);
					}
				}
				else
				{
					SendError((*Local)->client_sockfd,err_BadKey,msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_DeleteRec: // DeleteRec
		{
			(*Local)->FuncName="DeleteRec";
			fID=&((P_FilerDatMsg1)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				if((((P_FilerDatMsg1)&msg->message)->RefNr<=0)||
					(((P_FilerDatMsg1)&msg->message)->RefNr>_Files->Files[(*Local)->Files[fID->Index].Index].InxDescr[0].NumRec))
				{
					SendError((*Local)->client_sockfd,err_BadRecNumToDelete,msg->head.counter,(*Local)->FuncName);
				}
				else
				if(AppropriateLocalFile(*Local,*fID,filetype_Data,1,0))
				{
					uint8_t Action=0;
					if(FindLock(&(*Local)->Files[fID->Index],((P_FilerDatMsg1)&msg->message)->RefNr,&LocI))
					{
						Action=1;
					}
					else
					{
						uint8_t Lock;
						if(RecIsLocked(&(*Local)->Files[fID->Index],((P_FilerDatMsg1)&msg->message)->RefNr,&Lock))
						{
							if(Lock)
							{
								SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_LockRecordFailed),msg->head.counter,(*Local)->FuncName);
							}
							else
							{
								Action=1;
							}
						}
						else
						{
							SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
						}
					}
					if(Action)
					{
						if(IsamDeleteRecOrPage(&(*Local)->Files[fID->Index],((P_FilerDatMsg1)&msg->message)->RefNr,0))
						{
							SendOK((*Local)->client_sockfd,msg->head.counter);
						}
						else
						{
							SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
						}
					}
					UnAppropriateLocalFile(*Local,*fID);
				}
				else
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_BadDescriptor),msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_OpenFile: // Openfile
		{
			(*Local)->FuncName="OpenFile";
			LocCh1=(char *)&msg->message;
			unsigned short fileType=(unsigned short) *LocCh1;
			LocCh1+=2;
			if(CountStrings(LocCh1,msg->head.message_size-2)==3)
			{
				LocCh2=LocCh1+strlen(LocCh1)+1;
				LocCh3=LocCh2+strlen(LocCh2)+1;
				message(2,"%d OpenFile Key=%s SubKey=%s Name=%s (type %d)\n",(*Local)->child_pid,LocCh1,LocCh2,LocCh3,fileType);
				LocI=OpenFile(Local,LocCh1,LocCh2,LocCh3,fileType,0,0,NULL,Params->path);
				if(LocI==-1)
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
				}
				else
				{
					InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
					LocI2=(*Local)->Files[LocI].Index;
					message(2,"Index %d Random %d FileGen %d\n",LocI,_Files->Files[LocI2].Random,_Files->Files[LocI2].FileGen);
					((ResultMsg2 *)(*Local)->local_buffer)->ID.Random=_Files->Files[LocI2].Random;
					((ResultMsg2 *)(*Local)->local_buffer)->ID.FileGen=_Files->Files[LocI2].FileGen;
					((ResultMsg2 *)(*Local)->local_buffer)->ID.Index=LocI;
                    LocI3=sizeof(ResultMsg2);
					if(fileType==filetype_Data)
					{
						((ResultMsg2 *)(*Local)->local_buffer)->DataSize=(unsigned short)_Files->Files[LocI2].datInfo.LenRec;
						LocCh3=(*Local)->local_buffer;
						LocCh3+=LocI3;
						IsamDatIndDescr * IDI=&_Files->Files[LocI2].InxDescr[0];
						*((int32_t *)LocCh3)=IDI->NumRec-IDI->NumberFree;
						LocCh3+=sizeof(int32_t);LocI3+=sizeof(uint32_t);
						*((uint16_t *)LocCh3)=_Files->Files[LocI2].datInfo.NrOfKeys;
						LocCh3+=sizeof(uint16_t);LocI3+=sizeof(uint16_t);

  						P_KeyInfoRec PKIR=(P_KeyInfoRec)LocCh3;
						int LocI4=0;
						while(LocI4<_Files->Files[LocI2].datInfo.NrOfKeys)
						{
                            IDI=&_Files->Files[LocI2].InxDescr[LocI4+1];
                            PKIR[LocI4].KeyLen=IDI->KeyLen;
                            PKIR[LocI4].AllowDupKeys=IDI->AllowDupKeys;
                            PKIR[LocI4].KeyCodePage=IDI->KeyCodePage;
                            PKIR[LocI4].IndexVersion=IDI->KeyVersion;
                            PKIR[LocI4].UsedKeys=IDI->NumKeys;
                            LocI4++;
						}
						LocI3+=sizeof(KeyInfoRec)*_Files->Files[LocI2].datInfo.NrOfKeys;
					}
					if(Send((*Local)->client_sockfd,(*Local)->local_buffer,LocI3)==-1)
					{
						return -1;
					}
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_ExistFile: // ExistFile
		{
			(*Local)->FuncName="ExistFile";
			LocCh1=(char *)&msg->message;
			if(CountStrings(LocCh1,msg->head.message_size)==3)
			{
				LocCh2=LocCh1+strlen(LocCh1)+1;
				LocCh3=LocCh2+strlen(LocCh2)+1;
				uint8_t Exist=0;
				if(ExistFile(*Local,LocCh1,LocCh2,LocCh3,&Exist,Params->path))
				{
					InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
					((ResultMsg1 *)(*Local)->local_buffer)->Result=Exist;
					if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultMsg1))==-1)
					{
						return -1;
					}
				}
				else
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_FileSize: // FileSize
		{
			(*Local)->FuncName="FileSize";
			LocCh1=(char *)&msg->message;
			if(CountStrings(LocCh1,msg->head.message_size)==3)
			{
				LocCh2=LocCh1+strlen(LocCh1)+1;
				LocCh3=LocCh2+strlen(LocCh2)+1;
				LocI=0;
				if(FileSize(*Local,LocCh1,LocCh2,LocCh3,&LocI,Params->path))
				{
					InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
					((ResultMsg3 *)(*Local)->local_buffer)->Result=LocI;
					if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultMsg3))==-1)
					{
						return -1;
					}
				}
				else
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_KeyExists: // KeyExists
		{
			(*Local)->FuncName="KeyExists";
			IsamKeyStr KeyStr;
			fID=&((P_FilerInxMsg4)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				if(AppropriateLocalFile(*Local,*fID,filetype_Data,1,0))
				{
                    LocI=((P_FilerInxMsg4)msg->message)->KeyNr;
                    LocI2=((P_FilerInxMsg4)msg->message)->RefNr;
                    CopyKeyStr(&KeyStr,(P_IsamKeyStr)&((P_FilerInxMsg4)msg->message)->KeyLen);
                    if((LocI>0)&&(LocI<=_Files->Files[(*Local)->Files[fID->Index].Index].datInfo.NrOfKeys))
                    {
                        uint8_t Result;
                        if(KeyExists(&(*Local)->Files[fID->Index],LocI,LocI2,&KeyStr,&Result))
                        {
                            LocI=sizeof(int)+sizeof(char)+KeyStr.Length;
                            InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
                            ((ResultMsg1 *)(*Local)->local_buffer)->Result=Result;
                            if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultMsg1))==-1)
                            {
                                UnAppropriateLocalFile(*Local,*fID);
                                return -1;
                            }
                        }
                        else
                        {
                            SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                        }
                    }
                    else
                    {
                        SendError((*Local)->client_sockfd,err_BadKey,msg->head.counter,(*Local)->FuncName);
                    }
                    UnAppropriateLocalFile(*Local,*fID);
				}
				else
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_Semaphore: // Semaphore
		{
			(*Local)->FuncName="Semaphore";
			if(msg->head.message_size==sizeof(FilerDatMsg3))
			{
				fID=&((FilerDatMsg3 *)&msg->message)->ID;
				if(AppropriateLocalFile(*Local,*fID,_Files->Files[(*Local)->Files[fID->Index].Index].FileType,1,msg->head.message_id))
				{
					LocI=((FilerDatMsg3 *)&msg->message)->Byte1;
					LocI2=LocI>>3;
					LocI&=7;
					uint8_t LocB=1;
					if(LocI)
						LocB<<=LocI;
					if(((FilerDatMsg3 *)&msg->message)->Byte2)
					{
						if(((*Local)->Files[fID->Index].Semaphores[LocI2]&LocB)==0)
						{
							if(_Files->Files[(*Local)->Files[fID->Index].Index].Semaphores[LocI2]==0)
							{
								(*Local)->Files[fID->Index].Semaphores[LocI2]|=LocB;
								_Files->Files[(*Local)->Files[fID->Index].Index].Semaphores[LocI2]|=LocB;
								SendOK((*Local)->client_sockfd,msg->head.counter);
							}
							else
							{
								SendError((*Local)->client_sockfd,err_LockRecordFailed,msg->head.counter,(*Local)->FuncName);
							}
						}
						else
						{
							SendOK((*Local)->client_sockfd,msg->head.counter);
						}
					}
					else
					{
						if(((*Local)->Files[fID->Index].Semaphores[LocI2]&LocB)!=0)
						{
							LocB=~LocB;
							(*Local)->Files[fID->Index].Semaphores[LocI2]&=LocB;
							if(_Files->Files[(*Local)->Files[fID->Index].Index].Semaphores[LocI2]!=0)
							{
								_Files->Files[(*Local)->Files[fID->Index].Index].Semaphores[LocI2]&=LocB;
							}
						}
						SendOK((*Local)->client_sockfd,msg->head.counter);
					}
					UnAppropriateLocalFile(*Local,*fID);
				}
				else
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_CloseFile: // CloseFile
		{
			(*Local)->FuncName="CloseFile";
			if(msg->head.message_size==sizeof(fileID))
			{
				fID=(fileID *)&msg->message;
				if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
				{
					CloseLocalFile(*Local,fID->Index);
					SendOK((*Local)->client_sockfd,msg->head.counter);
				}
				else
				{
					SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_GetBlock: // GetBlock
		{
			(*Local)->FuncName="GetBlock";
			fileID localID=((FilerDatMsg2 *)&msg->message)->ID;
			if(!LocalIndexToGlobal(*Local,&((FilerDatMsg2 *)&msg->message)->ID,msg->head.message_id))
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			else
			{
				ActFile=&_Files->Files[((FilerDatMsg2 *)&msg->message)->ID.Index];
				if(AppropriateFile(*Local,((FilerDatMsg2 *)&msg->message)->ID,ActFile->FileType,0))
				{
					P_local_file LocalFile=&(*Local)->Files[localID.Index];
					LocI=ActFile->Handle;
					if(LocI!=-1)
					{
						LocI2=((FilerDatMsg2 *)&msg->message)->Offset;
						LocI3=((FilerDatMsg2 *)&msg->message)->Len;
						uint8_t DoIt=0;
						if(ActFile->FileType==filetype_Data)
						{
                            if(ActFile->Locker==(*Local)->child_pid) // rezim pri uzamcenem souboru
                            {
                                if(LocI3+LocI2<=ActFile->datInfo.LenRec) // cteni systemovych dat v nulte vete
                                {
                                    DoIt=1;
                                }
                                else
                                if((LocI3>0)&&(LocI3%ActFile->datInfo.LenRec==0)) // pocatek musi byt na pocatku vety
                                {
                                    if((LocI2>0)&&(LocI2%ActFile->datInfo.LenRec==0)) // delka musi byt nasobkem delky vety
                                    {
                                        if(LocI2+LocI3<=((ActFile->datInfo.NumRec+1)*ActFile->datInfo.LenRec))
                                        {
                                            DoIt=1;
                                        }
                                        else
                                        {
                                            SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
                                        }
                                    }
                                    else
                                    {
                                        SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
                                    }
                                }
                                else
                                {
                                    SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
                                }
                            }
							else
							{
                                uint8_t IsLock=0;
                                int RecNr=((FilerDatMsg2 *)&msg->message)->Offset/ActFile->datInfo.LenRec;
                                int Dummy;
                                if(! RecIsLocked(LocalFile,RecNr,&IsLock))
                                {
                                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                                }
                                else
                                {
                                    if(IsLock)
                                    {
                                        if(FindLock(LocalFile,RecNr,&Dummy))
                                        {
                                            IsLock=0;
                                        }
                                        else
                                        {
                                            SendError((*Local)->client_sockfd,err_FileLocked,msg->head.counter,(*Local)->FuncName);
                                        }
                                    }
                                    if(!IsLock)
                                    {
                                        if((LocI3<=ActFile->datInfo.LenRec)&&(LocI2+LocI3<=((ActFile->datInfo.NumRec+1)*ActFile->datInfo.LenRec)))
                                        {
                                            DoIt=1;
                                        }
                                        else
                                        {
                                            SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
                                        }
                                    }
                                }
							}
						}
						else
						if((ActFile->FileType==filetype_RAW)||(ActFile->FileType==filetype_Ini))
						{
							DoIt=1;
						}
						else
						{
							SendError((*Local)->client_sockfd,err_BadFileType,msg->head.counter,(*Local)->FuncName);
						}

						if(DoIt)
						{
							if((LocI2>=0)&&(LocI3>0)&&(LocI3<=(int)((int)local_buffer_size-sizeof(ResultMsg))))
							{
								if(lseek(LocI,LocI2,SEEK_SET)==LocI2)
								{
									LocCh1=(*Local)->local_buffer;
									LocCh1+=sizeof(ResultMsg);
									LocI2=read(LocI,LocCh1,LocI3);
									if(LocI2==LocI3)
									{
										memset((*Local)->local_buffer,0,sizeof(ResultMsg));
										((ResultMsg *)(*Local)->local_buffer)->counter=msg->head.counter;
										if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultMsg)+LocI2)==-1)
										{
											return -1;
										}
									}
									else
									{
										(*Local)->LastErrorCode=errno;
										SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_ReadError),msg->head.counter,(*Local)->FuncName);
									}
								}
								else
								{
									(*Local)->LastErrorCode=errno;
									SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_SeekError),msg->head.counter,(*Local)->FuncName);
								}
							}
							else
							{
								SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
							}
						}
					}
					else
					{
						SendError((*Local)->client_sockfd,err_NotOpen,msg->head.counter,(*Local)->FuncName);
					}
					UnAppropriateFile(((FilerDatMsg2 *)&msg->message)->ID);
				}
				else
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
				}
			}
			break;
		}
		case pds_PutBlock: // PutBlock
		{
			(*Local)->FuncName="PutBlock";
			fileID localID=((FilerDatMsg2 *)&msg->message)->ID;
			if(!LocalIndexToGlobal(*Local,&((FilerDatMsg2 *)&msg->message)->ID,msg->head.message_id))
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			else
			{
				if(msg->head.message_size-((FilerDatMsg2 *)&msg->message)->Len==14)
				{
					ActFile=&_Files->Files[((FilerDatMsg2 *)&msg->message)->ID.Index];
					if(AppropriateFile(*Local,((FilerDatMsg2 *)&msg->message)->ID,ActFile->FileType,1))
					{
						P_local_file LocalFile=&(*Local)->Files[localID.Index];
						LocI=ActFile->Handle;
						if(LocI!=-1)
						{
							if(ActFile->FileType==filetype_Data)
							{
								uint8_t IsLock;
								LocI2=((FilerDatMsg2 *)&msg->message)->Offset/ActFile->datInfo.LenRec;
								if(! RecIsLocked(LocalFile,LocI2,&IsLock))
								{
									SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
								}
								else
								{
									if(IsLock)
									{
										if(FindLock(LocalFile,LocI2,&LocI3))
										{
											IsLock=0;
										}
										else
										{
											SendError((*Local)->client_sockfd,err_FileLocked,msg->head.counter,(*Local)->FuncName);
										}
									}
									if(!IsLock)
									{
										LocI2=((FilerDatMsg2 *)&msg->message)->Offset;
										LocI3=((FilerDatMsg2 *)&msg->message)->Len;
										if(	(LocI2>=0)&&
											(LocI2+LocI3<=((ActFile->datInfo.NumRec+1)*ActFile->datInfo.LenRec))&&
											(LocI3>0)&&(LocI3<=ActFile->datInfo.LenRec)&&
											(ActFile->datInfo.LenRec<=(int)(local_buffer_size-sizeof(ResultMsg))))
										{
											if(lseek(LocI,LocI2,SEEK_SET)==LocI2)
											{
												LocCh1=(char *)&msg->message;
												LocCh1+=sizeof(FilerDatMsg2);
												LocI2=write(LocI,LocCh1,LocI3);
												if(LocI2==LocI3)
												{
													SendOK((*Local)->client_sockfd,msg->head.counter);
												}
												else
												{
													(*Local)->LastErrorCode=errno;
													SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_WriteError),msg->head.counter,(*Local)->FuncName);
												}
											}
											else
											{
												(*Local)->LastErrorCode=errno;
												SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_SeekError),msg->head.counter,(*Local)->FuncName);
											}
										}
										else
										{
											(*Local)->LastErrorCode=err_BadParameters;
											SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_SeekError),msg->head.counter,(*Local)->FuncName);
										}
									}
								}
							}
							else
							if(ActFile->FileType==filetype_RAW)
							{
								LocI2=((FilerDatMsg2 *)&msg->message)->Offset;
								LocI3=((FilerDatMsg2 *)&msg->message)->Len;
								if(lseek(LocI,LocI2,SEEK_SET)==LocI2)
								{
									LocCh1=(char *)&msg->message;
									LocCh1+=sizeof(FilerDatMsg2);
									LocI2=write(LocI,LocCh1,LocI3);
									if(LocI2==LocI3)
									{
										SendOK((*Local)->client_sockfd,msg->head.counter);
									}
									else
									{
										(*Local)->LastErrorCode=errno;
										SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_WriteError),msg->head.counter,(*Local)->FuncName);
									}
								}
								else
								{
									(*Local)->LastErrorCode=errno;
									SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_SeekError),msg->head.counter,(*Local)->FuncName);
								}
							}
							else
							{
								SendError((*Local)->client_sockfd,err_BadFileType,msg->head.counter,(*Local)->FuncName);
							}
						}
						else
						{
							SendError((*Local)->client_sockfd,err_NotOpen,msg->head.counter,(*Local)->FuncName);
						}
						UnAppropriateFile(((FilerDatMsg2 *)&msg->message)->ID);
					}
					else
					{
						SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
					}
				}
				else
				{
					SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
				}
			}
			break;
		}
		case pds_IsOnlyMyWS: // IsOnlyMyWS
		{
			(*Local)->FuncName="IsOnlyMyWS";
			fID=&((P_FilerMsg)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				LocI=sizeof(uint8_t);
				InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
				((ResultMsg1 *)(*Local)->local_buffer)->Result=_Files->Files[(*Local)->Files[fID->Index].Index].Counter==1;
				if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultMsg)+LocI)==-1)
				{
					return -1;
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_SeekEOF: // SeekEOF
		{
			(*Local)->FuncName="SeekEOF";
			fileID localID=((FilerMsg *)&msg->message)->ID;
			if(CheckLocalFileID(*Local,localID,msg->head.message_id))
			{
				ActFile=&_Files->Files[(*Local)->Files[localID.Index].Index];
				if((ActFile->FileType==filetype_RAW)||(ActFile->FileType==filetype_Ini))
				{
					if(AppropriateLocalFile(*Local,localID,ActFile->FileType,0,0))
					{
						LocI=ActFile->Handle;
						if(LocI!=-1)
						{
							LocI2=lseek(LocI,0,SEEK_END);
							if(LocI2!=-1)
							{
								InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
								((ResultInxMsg2 *)(*Local)->local_buffer)->RefNr=LocI2;
								if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultInxMsg2))==-1)
								{
									return -1;
								}
							}
							else
							{
								(*Local)->LastErrorCode=errno;
								SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_SeekError),msg->head.counter,(*Local)->FuncName);
							}
						}
						else
						{
							SendError((*Local)->client_sockfd,err_NotOpen,msg->head.counter,(*Local)->FuncName);
						}
						UnAppropriateLocalFile(*Local,localID);
					}
					else
					{
						SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
					}
				}
				else
				{
					SendError((*Local)->client_sockfd,err_BadFileType,msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_CreateFile: // CreateFile
		{
			(*Local)->FuncName="CreateFile";
			LocCh1=(char *)&msg->message;
			unsigned short fileType=(unsigned short) *LocCh1;
			LocCh1+=2;
			if(CountStrings(LocCh1,msg->head.message_size-2)==3)
			{
				uint8_t Error=0;
				LocI2=2;
				LocI=strlen(LocCh1)+1;
				LocI2+=LocI;
				LocCh2=LocCh1+LocI;
				LocI=strlen(LocCh2)+1;
				LocI2+=LocI;
				LocCh3=LocCh2+LocI;
				message(1,"CreateFile %s (type %d)\n",LocCh3,fileType);
				P_InitNewDatFile NewInfo=NULL;
				if(fileType==filetype_Data)
				{
					LocI=strlen(LocCh3)+1;
					LocI2+=LocI;
					char * LocCh4=LocCh3+LocI;
					if(*LocCh4==26)
					{
						LocI2++;
						LocCh4++;
						NewInfo=(P_InitNewDatFile)LocCh4;
						if(msg->head.message_size-LocI2==(int)(sizeof(InitNewDatFile)+NewInfo->NrOfKeys*sizeof(InitNewInxFile)))
						{
							if(NewInfo->RecSize>=sizeof(IsamSmallInfoRec))
							{
								if(NewInfo->NrOfKeys<=MaxNrOfKeys)
								{
									unsigned short I;
									for(I=0;(I<NewInfo->NrOfKeys)&&(!Error);I++)
									{
										if((NewInfo->Indexs[I].KeyLen>0)&&(NewInfo->Indexs[I].KeyLen<=MaxKeyLen))
										{
											if((NewInfo->Indexs[I].AllowDupKeys>1)||(NewInfo->Indexs[I].Dummy!=0))
											{
												SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
												Error=1;
											}
										}
										else
										{
											SendError((*Local)->client_sockfd,err_KeyLenOutOfRange,msg->head.counter,(*Local)->FuncName);
											Error=1;
										}
									}
								}
								else
								{
									SendError((*Local)->client_sockfd,err_TooManyKeys,msg->head.counter,(*Local)->FuncName);
									Error=1;
								}
							}
							else
							{
								SendError((*Local)->client_sockfd,err_RecLenOutOfRange,msg->head.counter,(*Local)->FuncName);
								Error=1;
							}
						}
						else
						{
							SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
							Error=1;
						}
					}
					else
					{
						SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
						Error=1;
					}
				}
				if(!Error)
				{
					LocI=OpenFile(Local,LocCh1,LocCh2,LocCh3,fileType,1,0,NewInfo,Params->path);
					Counter=msg->head.counter;
					memset(buffer,0,sizeof(ResultMsg));
					((ResultMsg *)buffer)->counter=Counter;
					if(LocI==-1)
					{
						((ResultMsg *)buffer)->ResultCode=(unsigned short)GetLastFileError(*Local,err_Unspecified);
					}
					else
					{
						LocI2=(*Local)->Files[LocI].Index;
						message(2,"Index %d Random %d FileGen %d\n",LocI,_Files->Files[LocI2].Random,_Files->Files[LocI2].FileGen);
						((ResultMsg2 *)buffer)->ID.Random=_Files->Files[LocI2].Random;
						((ResultMsg2 *)buffer)->ID.FileGen=_Files->Files[LocI2].FileGen;
						((ResultMsg2 *)buffer)->ID.Index=LocI;
						if(fileType==filetype_Data)
							((ResultMsg2 *)buffer)->DataSize=(unsigned short)_Files->Files[LocI2].datInfo.LenRec;
					}
					if(Send((*Local)->client_sockfd,buffer,sizeof(ResultMsg2))==-1)
					{
						return -1;
					}
				}
			}
			break;
		}
		case pds_ResetFile: // ResetFile
		{
			(*Local)->FuncName="ResetFile";
			LocCh1=(char *)&msg->message;
			unsigned short fileType=(unsigned short) *LocCh1;
			LocCh1+=2;
			if(CountStrings(LocCh1,msg->head.message_size-2)==3)
			{
				uint8_t Error=0;
				LocI2=2;
				LocI=strlen(LocCh1)+1;
				LocI2+=LocI;
				LocCh2=LocCh1+LocI;
				LocI=strlen(LocCh2)+1;
				LocI2+=LocI;
				LocCh3=LocCh2+LocI;
				message(1,"ResetFile %s (type %d)\n",LocCh3,fileType);
				P_InitNewDatFile NewInfo=NULL;
				if(fileType==filetype_Data)
				{
					LocI=strlen(LocCh3)+1;
					LocI2+=LocI;
					char * LocCh4=LocCh3+LocI;
					if(*LocCh4==26)
					{
						LocI2++;
						LocCh4++;
						NewInfo=(P_InitNewDatFile)LocCh4;
						if(msg->head.message_size-LocI2==(int)(sizeof(InitNewDatFile)+NewInfo->NrOfKeys*sizeof(InitNewInxFile)))
						{
							if(NewInfo->RecSize>=sizeof(IsamSmallInfoRec))
							{
								if(NewInfo->NrOfKeys<=MaxNrOfKeys)
								{
									unsigned short I;
									for(I=0;(I<NewInfo->NrOfKeys)&&(!Error);I++)
									{
										if((NewInfo->Indexs[I].KeyLen>0)&&(NewInfo->Indexs[I].KeyLen<=MaxKeyLen))
										{
											if((NewInfo->Indexs[I].AllowDupKeys>1)||(NewInfo->Indexs[I].Dummy!=0))
											{
												SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
												Error=1;
											}
										}
										else
										{
											SendError((*Local)->client_sockfd,err_KeyLenOutOfRange,msg->head.counter,(*Local)->FuncName);
											Error=1;
										}
									}
								}
								else
								{
									SendError((*Local)->client_sockfd,err_TooManyKeys,msg->head.counter,(*Local)->FuncName);
									Error=1;
								}
							}
							else
							{
								SendError((*Local)->client_sockfd,err_RecLenOutOfRange,msg->head.counter,(*Local)->FuncName);
								Error=1;
							}
						}
						else
						{
							SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
							Error=1;
						}
					}
					else
					{
						SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
						Error=1;
					}
				}
				if(!Error)
				{
					LocI=OpenFile(Local,LocCh1,LocCh2,LocCh3,fileType,1,1,NewInfo,Params->path);
					Counter=msg->head.counter;
					memset(buffer,0,sizeof(ResultMsg));
					((ResultMsg *)buffer)->counter=Counter;
					if(LocI==-1)
					{
						((ResultMsg *)buffer)->ResultCode=(unsigned short)GetLastFileError(*Local,err_Unspecified);
					}
					else
					{
						LocI2=(*Local)->Files[LocI].Index;
						message(2,"Index %d Random %d FileGen %d\n",LocI,_Files->Files[LocI2].Random,_Files->Files[LocI2].FileGen);
						((ResultMsg2 *)buffer)->ID.Random=_Files->Files[LocI2].Random;
						((ResultMsg2 *)buffer)->ID.FileGen=_Files->Files[LocI2].FileGen;
						((ResultMsg2 *)buffer)->ID.Index=LocI;
						if(fileType==filetype_Data)
							((ResultMsg2 *)buffer)->DataSize=(unsigned short)_Files->Files[LocI2].datInfo.LenRec;
					}
					if(Send((*Local)->client_sockfd,buffer,sizeof(ResultMsg2))==-1)
					{
						return -1;
					}
				}
			}
			break;
		}
		case pds_IAmLocker: // IAmLocker
		{
			(*Local)->FuncName="IAmLocker";
			fID=&((P_FilerMsg)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				LocI=sizeof(uint8_t);
				InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
				((ResultMsg1 *)(*Local)->local_buffer)->Result=_Files->Files[(*Local)->Files[fID->Index].Index].Locker==(*Local)->child_pid;
				if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultMsg)+LocI)==-1)
				{
					return -1;
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_IAmReadLocker: // IAmReadLocker
		{
			(*Local)->FuncName="IAmReadLocker";
			fID=&((P_FilerMsg)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				LocI=sizeof(uint8_t);
				InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
				((ResultMsg1 *)(*Local)->local_buffer)->Result=_Files->Files[(*Local)->Files[fID->Index].Index].ReadLocker==(*Local)->child_pid;
				if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultMsg)+LocI)==-1)
				{
					return -1;
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_IndexCount: // IndexCount
		{
			(*Local)->FuncName="IndexCount";
			fID=&((P_FilerMsg)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				if(_Files->Files[(*Local)->Files[fID->Index].Index].FileType==filetype_Data)
				{
					InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
					((ResultInxMsg3 *)(*Local)->local_buffer)->WResult=_Files->Files[(*Local)->Files[fID->Index].Index].datInfo.NrOfKeys;
					if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultInxMsg3))==-1)
					{
						return -1;
					}
				}
				else
				{
					SendError((*Local)->client_sockfd,err_BadFileType,msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_TotalRecs: // TotalRecs
		{
			(*Local)->FuncName="TotalRecs";
			fID=&((P_FilerMsg)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				IsamDatIndDescr * IDI=&_Files->Files[(*Local)->Files[fID->Index].Index].InxDescr[0];
				InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
				((ResultInxMsg2 *)(*Local)->local_buffer)->RefNr=IDI->NumRec+1;
				if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultInxMsg2))==-1)
				{
					return -1;
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_FreeRecs: // FreeRecs
		{
			(*Local)->FuncName="FreeRecs";
			fID=&((P_FilerMsg)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				IsamDatIndDescr * IDI=&_Files->Files[(*Local)->Files[fID->Index].Index].InxDescr[0];
				InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
				((ResultInxMsg2 *)(*Local)->local_buffer)->RefNr=IDI->NumberFree;
				if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultInxMsg2))==-1)
				{
					return -1;
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_MultiAddKey: // MultiAddKey
		{
			(*Local)->FuncName="MultiAddKey";
			fID=&((P_FilerInxMsg7)&msg->message)->ID;
			if(AppropriateLocalFile(*Local,*fID,filetype_Data,0,msg->head.message_id))
			{
				LocI3=msg->head.message_size-sizeof(FilerInxMsg7);
				LocI=((P_FilerInxMsg7)msg->message)->KeyNr;
				LocCh1=msg->message;
				LocCh1+=sizeof(FilerInxMsg7);
				(*Local)->LastErrorCode=0;
                while((LocI)&&(!(*Local)->LastErrorCode))
                {
                    LocI--;
                    if((((P_MultiAddKey)LocCh1)->KeyNr>0)||(((P_MultiAddKey)LocCh1)->KeyNr<=_Files->Files[(*Local)->Files[fID->Index].Index].datInfo.NrOfKeys))
                    {
                        LocI2=(int)((char *)&((P_MultiAddKey)LocCh1)->Key.Data - LocCh1)+((P_MultiAddKey)LocCh1)->Key.Length;
                        LocI3-=LocI2;
                        if(LocI3>0)
                            LocCh1+=LocI2;
                        else
                        if(LocI3<0)
                            (*Local)->LastErrorCode=err_BadParameters;

                    }
                    else
                    {
                        (*Local)->LastErrorCode=err_BadKey;
                    }
                }

                if(LocI3!=0)
                    (*Local)->LastErrorCode=err_BadParameters;
                if(!(*Local)->LastErrorCode)
                {
                    LocI=((P_FilerInxMsg7)msg->message)->KeyNr;
                    int LocI4=LocI;
                    LocCh1=msg->message;
                    LocCh1+=sizeof(FilerInxMsg7);
                    IsamKeyStr KeyStr;
                    while((LocI)&&(!(*Local)->LastErrorCode))
                    {
                        LocI2=(char *)&((P_MultiAddKey)LocCh1)->Key.Data - LocCh1+((P_MultiAddKey)LocCh1)->Key.Length;
						CopyKeyStr(&KeyStr,&((P_MultiAddKey)LocCh1)->Key);
						if(!IsamAddKey(&(*Local)->Files[fID->Index],((P_MultiAddKey)LocCh1)->KeyNr,((P_FilerInxMsg7)msg->message)->RefNr,&KeyStr))
						{
                            (*Local)->LastErrorCode=GetLastFileError(*Local,err_CannotDuplicateKey);
                            LocI3=(*Local)->LastErrorCode;
                            LocCh1=msg->message;
                            LocCh1+=sizeof(FilerInxMsg7);
                            while(LocI<LocI4)
                            {
                                LocI++;
                                LocI2=(char *)&((P_MultiAddKey)LocCh1)->Key.Data - LocCh1+((P_MultiAddKey)LocCh1)->Key.Length;
                                CopyKeyStr(&KeyStr,&((P_MultiAddKey)LocCh1)->Key);
                                IsamDeleteKey(&(*Local)->Files[fID->Index],((P_MultiAddKey)LocCh1)->KeyNr,((P_FilerInxMsg7)msg->message)->RefNr,&KeyStr);
                                LocCh1+=LocI2;
                            }
                            (*Local)->LastErrorCode=LocI3;
						}
						else
						{
                            LocI--;
                            if(LocI)
                                LocCh1+=LocI2;
						}
                    }
                    if((!LocI)&&(!(*Local)->LastErrorCode))
                    {
						SendOK((*Local)->client_sockfd,msg->head.counter);
                    }
                    else
                    {
						SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                    }
                }
                else
                {
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                }
                UnAppropriateLocalFile(*Local,*fID);
			}
			else
			{
				SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_Message: // Message
		{
			(*Local)->FuncName="Message";
			if(msg->head.message_size==(unsigned short int)strlen((char *)&msg->message)+1)
			{
				message(1,"%d Message: %s\n",(*Local)->child_pid,msg->message);
				SendOK((*Local)->client_sockfd,msg->head.counter);
			}
			else
			{
				message(1,"%d Bad message\n",(*Local)->child_pid);
				SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_GetIndexInfo: // GetIndexInfo
		{
			(*Local)->FuncName="GetIndexInfo";
			fID=&((P_FilerInxMsg1)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				LocI=((P_FilerInxMsg1)msg->message)->KeyNr;
				if((LocI>0)&&(LocI<=_Files->Files[(*Local)->Files[fID->Index].Index].datInfo.NrOfKeys))
				{
					IsamDatIndDescrPtr IDI=&_Files->Files[(*Local)->Files[fID->Index].Index].InxDescr[LocI];
					InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
					((ResultInxMsg4 *)(*Local)->local_buffer)->KeyLen=IDI->KeyLen;
					((ResultInxMsg4 *)(*Local)->local_buffer)->AllowDupKeys=IDI->AllowDupKeys;
					((ResultInxMsg4 *)(*Local)->local_buffer)->KeyCodePage=IDI->KeyCodePage;
					((ResultInxMsg4 *)(*Local)->local_buffer)->IndexVersion=IDI->KeyVersion;
					if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultInxMsg4))==-1)
					{
						return -1;
					}
				}
				else
				{
					SendError((*Local)->client_sockfd,err_BadKey,msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_GetFromIni: // GetFromIni
		{
			(*Local)->FuncName="GetFromIni";
			char * LocCh4=NULL;
			char * LocCh5=NULL;
			char * LocCh6=NULL;
			if(ParseIniParam((char *)&msg->message,msg->head.message_size,&LocCh1,&LocCh2,&LocCh3,&LocCh4,&LocCh5,&LocCh6)==5)
			{
				LocI=OpenIniFile(Local,LocCh1,LocCh2,LocCh3,Params->path);
				if(LocI!=-1)
				{
					LocCh6=(char *)&((P_ResultMsg1)(*Local)->local_buffer)->Result;
					if(GetFromIni(*Local,LocI,LocCh4,LocCh5,LocCh6,local_buffer_size-sizeof(ResultMsg)))
					{
						InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);

						if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultMsg)+strlen(LocCh6)+1)==-1)
						{
							return -1;
						}
					}
					else
					{
						SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
					}
				}
				else
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_BadDescriptor),msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_SetToIni: // SetToIni
		{
			(*Local)->FuncName="SetToIni";
			char * LocCh4=NULL;
			char * LocCh5=NULL;
			char * LocCh6=NULL;
			if(ParseIniParam((char *)&msg->message,msg->head.message_size,&LocCh1,&LocCh2,&LocCh3,&LocCh4,&LocCh5,&LocCh6)==6)
			{
				LocI=OpenIniFile(Local,LocCh1,LocCh2,LocCh3,Params->path);
				if(LocI!=-1)
				{
					if(SetToIni(*Local,LocI,LocCh4,LocCh5,LocCh6))
					{
						SendOK((*Local)->client_sockfd,msg->head.counter);
					}
					else
					{
						SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
					}
				}
				else
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_BadDescriptor),msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_ExistInIni: // ExistInIni
		{
			(*Local)->FuncName="ExistInIni";
			char * LocCh4=NULL;
			char * LocCh5=NULL;
			char * LocCh6=NULL;
			if(ParseIniParam((char *)&msg->message,msg->head.message_size,&LocCh1,&LocCh2,&LocCh3,&LocCh4,&LocCh5,&LocCh6)==5)
			{
				LocI=OpenIniFile(Local,LocCh1,LocCh2,LocCh3,Params->path);
				if(LocI!=-1)
				{
					if(ExistInIni(*Local,LocI,LocCh4,LocCh5,&((P_ResultMsg1)(*Local)->local_buffer)->Result))
					{
						InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
						if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultMsg1))==-1)
						{
							return -1;
						}
					}
					else
					{
						SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
					}
				}
				else
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_BadDescriptor),msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_GetIniSections: // GetIniSections
		{
			(*Local)->FuncName="GetIniSections";
			if(ParseIniParam((char *)&msg->message,msg->head.message_size,&LocCh1,&LocCh2,&LocCh3,NULL,NULL,NULL)==3)
			{
				LocI=OpenIniFile(Local,LocCh1,LocCh2,LocCh3,Params->path);
				if(LocI!=-1)
				{
					LocCh3=(char *)&((P_ResultMsg1)(*Local)->local_buffer)->Result;
					LocI=GetIniSections(*Local,LocI,LocCh3,local_buffer_size-sizeof(ResultMsg));
					if(LocI>=0)
					{
						InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
						if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultMsg)+LocI)==-1)
						{
							return -1;
						}
					}
					else
					{
						SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
					}
				}
				else
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_BadDescriptor),msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_GetIniKeys: // GetIniKeys
		{
			(*Local)->FuncName="GetIniKeys";
			char * LocCh4;
			if(ParseIniParam((char *)&msg->message,msg->head.message_size,&LocCh1,&LocCh2,&LocCh3,&LocCh4,NULL,NULL)==4)
			{
				LocI=OpenIniFile(Local,LocCh1,LocCh2,LocCh3,Params->path);
				if(LocI!=-1)
				{
					LocCh3=(char *)&((P_ResultMsg1)(*Local)->local_buffer)->Result;
					LocI=GetIniKeys(*Local,LocI,LocCh4,LocCh3,local_buffer_size-sizeof(ResultMsg));
					if(LocI>=0)
					{
						InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
						if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultMsg)+LocI)==-1)
						{
							return -1;
						}
					}
					else
					{
						SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
					}
				}
				else
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_BadDescriptor),msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_DeleteIniKey: // DeleteIniKey
		{
			(*Local)->FuncName="DeleteIniKey";
			char * LocCh4=NULL;
			char * LocCh5=NULL;
			if(ParseIniParam((char *)&msg->message,msg->head.message_size,&LocCh1,&LocCh2,&LocCh3,&LocCh4,&LocCh5,NULL)==5)
			{
				LocI=OpenIniFile(Local,LocCh1,LocCh2,LocCh3,Params->path);
				if(LocI!=-1)
				{
					if(DeleteIniKey(*Local,LocI,LocCh4,LocCh5))
					{
						SendOK((*Local)->client_sockfd,msg->head.counter);
					}
					else
					{
						SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
					}
				}
				else
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_BadDescriptor),msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_DeleteIniSection: // DeleteIniSection
		{
			(*Local)->FuncName="DeleteIniSection";
			char * LocCh4=NULL;
			if(ParseIniParam((char *)&msg->message,msg->head.message_size,&LocCh1,&LocCh2,&LocCh3,&LocCh4,NULL,NULL)==4)
			{
				LocI=OpenIniFile(Local,LocCh1,LocCh2,LocCh3,Params->path);
				if(LocI!=-1)
				{
					if(DeleteIniSection(*Local,LocI,LocCh4))
					{
						SendOK((*Local)->client_sockfd,msg->head.counter);
					}
					else
					{
						SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
					}
				}
				else
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_BadDescriptor),msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_ResetIndex: // ResetIndex
		{
			(*Local)->FuncName="ResetIndex";
			if(msg->head.message_size>=sizeof(fileID)+2)
			{
				fID=(fileID *)&msg->message;
				if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
				{
					if(AppropriateLocalFile(*Local,*fID,filetype_Data,1,0))
					{
						P_pds_file GF=&_Files->Files[(*Local)->Files[fID->Index].Index];
						LocCh1=(char *)&msg->message;
						LocCh1+=sizeof(fileID);
						P_InitNewDatFile NewInfo=(P_InitNewDatFile)LocCh1;
						(*Local)->LastErrorCode=0;
						if(msg->head.message_size==sizeof(fileID)+sizeof(InitNewDatFile)+sizeof(InitNewInxFile)*NewInfo->NrOfKeys)
						{
							if((NewInfo->RecSize==GF->datInfo.LenRec)&&(NewInfo->NrOfKeys<=MaxNrOfKeys))
							{
								unsigned short I;
								for(I=0;(I<NewInfo->NrOfKeys)&&(!(*Local)->LastErrorCode);I++)
								{
									if((NewInfo->Indexs[I].KeyLen>0)&&(NewInfo->Indexs[I].KeyLen<=MaxKeyLen))
									{
										if((NewInfo->Indexs[I].AllowDupKeys>1)||(NewInfo->Indexs[I].Dummy!=0))
										{
											(*Local)->LastErrorCode=err_BadParameters;
										}
									}
									else
									{
										(*Local)->LastErrorCode=err_KeyLenOutOfRange;
									}
								}
							}
							else
							{
								if(NewInfo->RecSize==GF->datInfo.LenRec)
									(*Local)->LastErrorCode=err_TooManyKeys;
								else
									(*Local)->LastErrorCode=err_RecLenOutOfRange;
							}
						}
						else
						{
							(*Local)->LastErrorCode=err_BadParameters;
						}

						if((*Local)->LastErrorCode==0)
						{
							if(ftruncate(_Files->Files[(*Local)->Files[fID->Index].Index].InxHandle,0)==0)
							{
								if(IsamInitInxFile(*Local,GF,NewInfo))
								{
									SendOK((*Local)->client_sockfd,msg->head.counter);
								}
								else
								{
									SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
								}
							}
							else
							{
								(*Local)->LastErrorCode=errno;
								SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_TruncateError),msg->head.counter,(*Local)->FuncName);
							}
						}
						else
						{
							SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
						}
						UnAppropriateLocalFile(*Local,*fID);
					}
					else
					{
						SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
					}
				}
			}
			break;
		}
		case pds_Identify: //Identify
		{
			(*Local)->FuncName="Identify";
			if((*Local)->IdentStr)
			{
				FreeMem((*Local)->IdentStr);
				(*Local)->IdentStr=NULL;
				(*Local)->IdentStrSize=0;
			}
			LocI=CountStrings((char *)&msg->message,msg->head.message_size);
			if(LocI>=3)
			{
				(*Local)->IdentStr=(char *)GetMem(msg->head.message_size);
				if((*Local)->IdentStr)
				{
					SendOK((*Local)->client_sockfd,msg->head.counter);
					(*Local)->IdentStrSize=msg->head.message_size;
					(*Local)->IdentStrCount=LocI;
					memcpy((*Local)->IdentStr,&msg->message,(*Local)->IdentStrSize);
					LocCh1=(*Local)->IdentStr;
					LocCh2=LocCh1+strlen(LocCh1)+1;
					LocCh3=LocCh2+strlen(LocCh2)+1;
					message(1,"%d IDENT [%s] [%s] na [%s]\n",(*Local)->child_pid,LocCh1,LocCh2,LocCh3);
				}
				else
				{
					SendError((*Local)->client_sockfd,err_LowMemory,msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_GetFileInfo: // GetFileInfo
		{
			(*Local)->FuncName="GetFileInfo";
			LocCh1=(char *)&msg->message;
			if(CountStrings(LocCh1,msg->head.message_size)==3)
			{
				LocCh2=LocCh1+strlen(LocCh1)+1;
				LocCh3=LocCh2+strlen(LocCh2)+1;
				FileInfoRec FIR;
				if(GetFileInfo(*Local,LocCh1,LocCh2,LocCh3,&FIR,Params->path))
				{
					InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
					((ResultMsg4 *)(*Local)->local_buffer)->FileInfo=FIR;
					if(Send((*Local)->client_sockfd,(*Local)->local_buffer,sizeof(ResultMsg4))==-1)
					{
						return -1;
					}
				}
				else
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_CreateSubKey: // CreateSubKey
		{
			(*Local)->FuncName="CreateSubKey";
			LocCh1=(char *)&msg->message;
			if(CountStrings(LocCh1,msg->head.message_size)==2)
			{
				LocCh2=LocCh1+strlen(LocCh1)+1;
				if(CreateSubKey(*Local,LocCh1,LocCh2,Params->path))
				{
					SendOK((*Local)->client_sockfd,msg->head.counter);
					message(1,"%d Create SubKey \"%s\" on key \"%s\"\n",(*Local)->child_pid,LocCh1,LocCh2);
				}
				else
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_CreateArchive: // CreateArchive
		{
			(*Local)->FuncName="CreateArchive";
			(*Local)->ActCounter=msg->head.counter;
            LocI=msg->head.message_size;
			LocCh1=(char *)&msg->message;
			if(LockKey(*Local,LocCh1,Params->path))
			{
			    uint8_t KeyIsLocked=1;
                LocI-=strlen(LocCh1)+1;
                time_t ActTime;
                (*Local)->ProgressTime=time(NULL);
                if(LocI>0)
                {
                    LocCh2=LocCh1+strlen(LocCh1)+1;
                    if((ValidateFileName(LocCh1))&&(ValidateFileName(LocCh2)))
                    {
                        LocI-=strlen(LocCh2)+1;
                        if(LocI>=(int)sizeof(int)+1)
                        {
                            LocCh3=LocCh2+strlen(LocCh2)+1;
                            LocI2=*((short int *)LocCh3);
                            char * LocCh4=LocCh3+sizeof(short int)+LocI2-1;
                            if(*LocCh4==0)
                            {
                                LocCh3+=sizeof(short int);
                                DIR * KeyDir;
                                struct dirent * DirEntry;
                                char * KeyDirName=GetRealName(*Local,LocCh1,"","",Params->path);
                                if(KeyDirName!=NULL)
                                {
                                    (*Local)->DisableCheckFreeze=1;
                                    if((KeyDir=opendir(KeyDirName))!=NULL)
                                    {
                                        message(4,"%d Directory: %s\n",(*Local)->child_pid,KeyDirName);
                                        int MaxKeyDirItems=MinDirItems;
                                        int ActKeyDirItem=0;
                                        DirItem * KeyDirItems=GetMem(MaxKeyDirItems*sizeof(DirItem));
                                        if(KeyDirItems!=NULL)
                                        {
                                            errno=0;
                                            while(((DirEntry=readdir(KeyDir))!=NULL)&&(errno==0))
                                            {
                                                if (DirEntry->d_type==0x08)
                                                {
                                                    if(ActKeyDirItem==MaxKeyDirItems)
                                                    {
                                                        int NewMaxKeyDirItems=MaxKeyDirItems<<1;
                                                        if(NewMaxKeyDirItems>MaxKeyDirItems)
                                                        {
                                                            message(4,"%d Double buffer to %d\n",(*Local)->child_pid,NewMaxKeyDirItems);
                                                            DirItem * NewKeyDirItems=GetMem(NewMaxKeyDirItems*sizeof(DirItem));
                                                            if(NewKeyDirItems!=NULL)
                                                            {
                                                                memcpy(NewKeyDirItems,KeyDirItems,MaxKeyDirItems*sizeof(DirItem));
                                                                FreeMem(KeyDirItems);
                                                                KeyDirItems=NewKeyDirItems;
                                                                MaxKeyDirItems=NewMaxKeyDirItems;
                                                            }
                                                        }
                                                    }
                                                    if(ActKeyDirItem<MaxKeyDirItems)
                                                    {
                                                        strncpy((char*)&KeyDirItems[ActKeyDirItem].Name,(char*)&DirEntry->d_name,NAME_MAX-1);
                                                        KeyDirItems[ActKeyDirItem].Name[NAME_MAX-1]='\0';
                                                        KeyDirItems[ActKeyDirItem].UseFlags=0;
                                                        if(FileSize(*Local,LocCh1,"",DirEntry->d_name,&KeyDirItems[ActKeyDirItem].Size,Params->path))
                                                        {
                                                            message(4,"%d DirEntry: %s\n",(*Local)->child_pid,KeyDirItems[ActKeyDirItem].Name);
                                                            ActKeyDirItem++;
                                                        }
                                                    }
                                                }
                                                ActTime=time(NULL);
                                                if(ActTime!=(*Local)->ProgressTime)
                                                {
                                                    (*Local)->ProgressTime=ActTime;
                                                    SendWait((*Local)->client_sockfd,msg->head.counter,0);
                                                }
                                            }
                                            if(errno==0)
                                            {
                                                char * SubKeyDirName=GetRealName(*Local,LocCh1,LocCh2,"",Params->path);
                                                if(SubKeyDirName!=NULL)
                                                {
                                                    message(4,"%d SubDirectory: %s\n",(*Local)->child_pid,SubKeyDirName);
                                                    DirItem * SubKeyDirItems=NULL;
                                                    int MaxSubKeyDirItems=MaxKeyDirItems;
                                                    int ActSubKeyDirItem=0;
                                                    if(strlen(LocCh2)==0)
                                                    {
                                                        ActSubKeyDirItem=ActKeyDirItem;
                                                        SubKeyDirItems=KeyDirItems;
                                                    }
                                                    else
                                                    {
                                                        SubKeyDirItems=GetMem(MaxSubKeyDirItems*sizeof(DirItem));
                                                    }
                                                    if(SubKeyDirItems!=NULL)
                                                    {
                                                        if(KeyDirItems!=SubKeyDirItems)
                                                        {
                                                            closedir(KeyDir);
                                                            if((KeyDir=opendir(SubKeyDirName))!=NULL)
                                                            {
                                                                errno=0;
                                                                while(((DirEntry=readdir(KeyDir))!=NULL)&&(errno==0))
                                                                {
                                                                    if(DirEntry->d_type==0x08)
                                                                    {
                                                                        if(ActSubKeyDirItem==MaxSubKeyDirItems)
                                                                        {
                                                                            int NewMaxSubKeyDirItems=MaxSubKeyDirItems<<1;
                                                                            if(NewMaxSubKeyDirItems>MaxSubKeyDirItems)
                                                                            {
                                                                                message(4,"%d Double buffer to %d\n",(*Local)->child_pid,NewMaxSubKeyDirItems);
                                                                                DirItem * NewSubKeyDirItems=GetMem(NewMaxSubKeyDirItems*sizeof(DirItem));
                                                                                if(NewSubKeyDirItems!=NULL)
                                                                                {
                                                                                    memcpy(NewSubKeyDirItems,SubKeyDirItems,MaxSubKeyDirItems*sizeof(DirItem));
                                                                                    FreeMem(SubKeyDirItems);
                                                                                    SubKeyDirItems=NewSubKeyDirItems;
                                                                                    MaxSubKeyDirItems=NewMaxSubKeyDirItems;
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                    if(ActSubKeyDirItem<MaxSubKeyDirItems)
                                                                    {
                                                                        strncpy((char*)&SubKeyDirItems[ActSubKeyDirItem].Name,(char*)&DirEntry->d_name,NAME_MAX-1);
                                                                        SubKeyDirItems[ActSubKeyDirItem].Name[NAME_MAX-1]='\0';
                                                                        SubKeyDirItems[ActSubKeyDirItem].UseFlags=0;
                                                                        if(FileSize(*Local,LocCh1,LocCh2,DirEntry->d_name,&SubKeyDirItems[ActSubKeyDirItem].Size,Params->path))
                                                                        {
                                                                            message(4,"%d SubDirEntry: %s\n",(*Local)->child_pid,SubKeyDirItems[ActSubKeyDirItem].Name);
                                                                            ActSubKeyDirItem++;
                                                                        }
                                                                    }
                                                                    ActTime=time(NULL);
                                                                    if(ActTime!=(*Local)->ProgressTime)
                                                                    {
                                                                        (*Local)->ProgressTime=ActTime;
                                                                        SendWait((*Local)->client_sockfd,msg->head.counter,0);
                                                                    }
                                                                }
                                                            }
                                                        }
                                                        if(errno==0)
                                                        {
                                                            DirItem * UseDirItems=NULL;
                                                            int UsedItems;

                                                            (*Local)->LastErrorCode=0;
                                                            unsigned long long AllSize=0;

                                                            LocI3=LocI2;
                                                            char * LocCh3save=LocCh3;

                                                            while((LocI3>0)&&(*LocCh3!='\0')&&((*Local)->LastErrorCode==0))
                                                            {
                                                                LocCh4=LocCh3;
                                                                while(*LocCh4)
                                                                {
                                                                    *LocCh4=(char)tolower(*LocCh4);
                                                                    LocCh4++;
                                                                }
                                                                message(4,"%d Pending: %s\n",(*Local)->child_pid,LocCh3);
                                                                LocCh4=LocCh3;
                                                                if(*LocCh4=='>')
                                                                {
                                                                    UseDirItems=SubKeyDirItems;
                                                                    UsedItems=ActSubKeyDirItem;

                                                                    LocCh4++;
                                                                }
                                                                else
                                                                {
                                                                    UseDirItems=KeyDirItems;
                                                                    UsedItems=ActKeyDirItem;
                                                                    if(*LocCh4=='<')
                                                                        LocCh4++;
                                                                }
                                                                while(UsedItems>0)
                                                                {
                                                                    UsedItems--;
                                                                    if(UseDirItems[UsedItems].UseFlags==0)
                                                                    {
                                                                        if(fnmatch(LocCh4,(char*)&UseDirItems[UsedItems].Name,0)==0)
                                                                        {
                                                                            message(4,"%d found: %s\n",(*Local)->child_pid,UseDirItems[UsedItems].Name);
                                                                            AllSize+=UseDirItems[UsedItems].Size;
                                                                        }
                                                                    }
                                                                }
                                                                LocI3-=strlen(LocCh3)+1;
                                                                LocCh3+=strlen(LocCh3)+1;
                                                            }

                                                            (*Local)->TotalProgress=AllSize;
                                                            unsigned long long DonedSize=0;
                                                            LocI3=LocI2;LocCh3=LocCh3save;

                                                            ArchiveHead AHead;
                                                            int FileCount=0;

                                                            char * ActSubKey;
                                                            char tempname[]="/tmp/pds_archive_XXXXXXXXXX";
                                                            int InputArchive;
                                                            int OutputArchive=mkstemp(tempname);
                                                            if(OutputArchive>=0)
                                                            {
                                                                message(2,"%d Create temporary archive file %s\n",(*Local)->child_pid,tempname);
                                                                while((LocI3>0)&&(*LocCh3!='\0')&&((*Local)->LastErrorCode==0))
                                                                {
                                                                    LocCh4=LocCh3;
                                                                    while(*LocCh4)
                                                                    {
                                                                        *LocCh4=(char)tolower(*LocCh4);
                                                                        LocCh4++;
                                                                    }
                                                                    LocCh4=LocCh3;
                                                                    if(*LocCh4=='>')
                                                                    {
                                                                        UseDirItems=SubKeyDirItems;
                                                                        UsedItems=ActSubKeyDirItem;
                                                                        ActSubKey=LocCh2;
                                                                        LocCh4++;
                                                                    }
                                                                    else
                                                                    {
                                                                        UseDirItems=KeyDirItems;
                                                                        UsedItems=ActKeyDirItem;
                                                                        ActSubKey="";
                                                                        if(*LocCh4=='<')
                                                                            LocCh4++;
                                                                    }

                                                                    unsigned short Progress=10000; /* 100% * 100 */
                                                                    while((UsedItems>0)&&((*Local)->LastErrorCode==0))
                                                                    {
                                                                        UsedItems--;
                                                                        if(UseDirItems[UsedItems].UseFlags==0)
                                                                        {
                                                                            if(fnmatch(LocCh4,(char*)&UseDirItems[UsedItems].Name,0)==0)
                                                                            {
                                                                                message(4,"%d compressing: %s\n",(*Local)->child_pid,UseDirItems[UsedItems].Name);
                                                                                char * ActualFileName=GetRealName(*Local,LocCh1,ActSubKey,UseDirItems[UsedItems].Name,Params->path);
                                                                                if(ActualFileName!=NULL)
                                                                                {
                                                                                    InputArchive=open(ActualFileName,O_RDONLY);
                                                                                    if(InputArchive>=0)
                                                                                    {
                                                                                        message(4,"%d open: %s\n",(*Local)->child_pid,ActualFileName);
                                                                                        off_t ActFilePos=lseek(OutputArchive,0,SEEK_CUR);
                                                                                        if(ActFilePos!=(off_t)-1)
                                                                                        {
                                                                                            memset(&AHead,0,sizeof(AHead));
                                                                                            AHead.Count=++FileCount;
                                                                                            AHead.StartOfHead=0x01;
                                                                                            AHead.Size=UseDirItems[UsedItems].Size;
                                                                                            AHead.NameLength=strlen(UseDirItems[UsedItems].Name);
                                                                                            if(write(OutputArchive,&AHead,sizeof(ArchiveHead))==sizeof(ArchiveHead))
                                                                                            {
                                                                                                if(write(OutputArchive,UseDirItems[UsedItems].Name,AHead.NameLength+1)==AHead.NameLength+1)
                                                                                                {
                                                                                                    (*Local)->ActProgress=DonedSize;
                                                                                                    if(Encode(*Local,InputArchive,OutputArchive,(char*)&AHead.MD5))
                                                                                                    {
                                                                                                        off_t PostFilePos=lseek(OutputArchive,0,SEEK_CUR);
                                                                                                        if(PostFilePos!=(off_t)-1)
                                                                                                        {
                                                                                                            if(lseek(OutputArchive,ActFilePos,SEEK_SET)==ActFilePos)
                                                                                                            {
                                                                                                                AHead.PackedSize=PostFilePos-ActFilePos-sizeof(ArchiveHead)-AHead.NameLength-1;
                                                                                                                if(write(OutputArchive,&AHead,sizeof(ArchiveHead))==sizeof(ArchiveHead))
                                                                                                                {
                                                                                                                    if(lseek(OutputArchive,PostFilePos,SEEK_SET)!=PostFilePos)
                                                                                                                    {
                                                                                                                        SetLastFileError(*Local,errno,err_SeekError);
                                                                                                                    }
                                                                                                                }
                                                                                                                else
                                                                                                                {
                                                                                                                    SetLastFileError(*Local,errno,err_WriteError);
                                                                                                                }
                                                                                                            }
                                                                                                            else
                                                                                                            {
                                                                                                                SetLastFileError(*Local,errno,err_SeekError);
                                                                                                            }
                                                                                                        }
                                                                                                        else
                                                                                                        {
                                                                                                            SetLastFileError(*Local,errno,err_SeekError);
                                                                                                        }
                                                                                                    }
                                                                                                    else
                                                                                                    {
                                                                                                        SetLastFileError(*Local,(*Local)->LastErrorCode,err_PackError);
                                                                                                    }
                                                                                                }
                                                                                                else
                                                                                                {
                                                                                                    SetLastFileError(*Local,errno,err_WriteError);
                                                                                                }
                                                                                            }
                                                                                            else
                                                                                            {
                                                                                                SetLastFileError(*Local,errno,err_WriteError);
                                                                                            }
                                                                                        }
                                                                                        else
                                                                                        {
                                                                                            SetLastFileError(*Local,errno,err_SeekError);
                                                                                        }
                                                                                        close(InputArchive);
                                                                                    }
                                                                                    else
                                                                                    {
                                                                                        (*Local)->LastErrorCode=GetLastFileError(*Local,err_OpenError);
                                                                                    }
                                                                                    DonedSize+=UseDirItems[UsedItems].Size;
                                                                                    ActTime=time(NULL);
                                                                                    if((ActTime!=(*Local)->ProgressTime)&&((*Local)->LastErrorCode==0))
                                                                                    {
                                                                                        (*Local)->ProgressTime=ActTime;
                                                                                        if(AllSize)
                                                                                        {
                                                                                            Progress=(int)((double)DonedSize/AllSize*10000);
                                                                                        }
                                                                                        if(!SendWait((*Local)->client_sockfd,msg->head.counter,Progress))
                                                                                        {
                                                                                            (*Local)->LastErrorCode=GetLastFileError(*Local,err_SendWaitError);
                                                                                            SendError((*Local)->client_sockfd,(*Local)->LastErrorCode,msg->head.counter,(*Local)->FuncName);
                                                                                        }
                                                                                    }
                                                                                    FreeMem(ActualFileName);
                                                                                }
                                                                                else
                                                                                {
                                                                                    (*Local)->LastErrorCode=GetLastFileError(*Local,err_Unspecified);
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                    LocI3-=strlen(LocCh3)+1;
                                                                    LocCh3+=strlen(LocCh3)+1;
                                                                }
                                                                message(2,"%d Total size: %lud Bytes LastErrorCode=%d\n",(*Local)->child_pid,AllSize,(*Local)->LastErrorCode);
                                                                if((*Local)->LastErrorCode==0)
                                                                {
                                                                    memset(&AHead,0,sizeof(AHead));
                                                                    AHead.Count=++FileCount;
                                                                    AHead.StartOfHead=0x01;
                                                                    AHead.Size=-1;
                                                                    AHead.NameLength=0;
                                                                    if(write(OutputArchive,&AHead,sizeof(ArchiveHead))==sizeof(ArchiveHead))
                                                                    {
                                                                        if(write(OutputArchive,&AHead.NameLength,1)==1)
                                                                        {
                                                                            if(UnlockKey(*Local,LocCh1,Params->path))
                                                                                KeyIsLocked=0;
                                                                            if(SendFile(*Local,msg->head.counter,OutputArchive))
                                                                            {
                                                                                SendOK((*Local)->client_sockfd,msg->head.counter);
                                                                            }
                                                                            else
                                                                            {
                                                                                SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_SendFileError),msg->head.counter,(*Local)->FuncName);
                                                                            }
                                                                        }
                                                                        else
                                                                        {
                                                                            SetLastFileError(*Local,errno,err_WriteError);
                                                                            SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                                                                        }
                                                                    }
                                                                    else
                                                                    {
                                                                        SetLastFileError(*Local,errno,err_WriteError);
                                                                        SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                                                                    }
                                                                }
                                                                else
                                                                {
                                                                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                                                                }
                                                                close(OutputArchive);
                                                                remove(tempname);
                                                            }
                                                            else
                                                            {
                                                                (*Local)->LastErrorCode=errno;
                                                                SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_CreateError),msg->head.counter,(*Local)->FuncName);
                                                            }
                                                        }
                                                        else
                                                        {
                                                            (*Local)->LastErrorCode=errno;
                                                            SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_DirectoryError),msg->head.counter,(*Local)->FuncName);
                                                        }
                                                        if(SubKeyDirItems!=KeyDirItems)
                                                            FreeMem(SubKeyDirItems);
                                                    }
                                                    else
                                                    {
                                                        SendError((*Local)->client_sockfd,err_LowMemory,msg->head.counter,(*Local)->FuncName);
                                                    }
                                                }
                                                else
                                                {
                                                    SendError((*Local)->client_sockfd,err_LowMemory,msg->head.counter,(*Local)->FuncName);
                                                }
                                            }
                                            else
                                            {
                                                (*Local)->LastErrorCode=errno;
                                                SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_DirectoryError),msg->head.counter,(*Local)->FuncName);
                                            }
                                            FreeMem(KeyDirItems);
                                        }
                                        else
                                        {
                                            SendError((*Local)->client_sockfd,err_LowMemory,msg->head.counter,(*Local)->FuncName);
                                        }
                                        if(KeyDir!=NULL)
                                            closedir(KeyDir);
                                    }
                                    else
                                    {
                                        (*Local)->LastErrorCode=errno;
                                        message(1,"%d opendir failed. Directory: %s ErrorCode=%d\n",(*Local)->child_pid,KeyDirName,(*Local)->LastErrorCode);
                                        SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_DirectoryError),msg->head.counter,(*Local)->FuncName);
                                    }
                                    (*Local)->DisableCheckFreeze=0;
                                    FreeMem(KeyDirName);
                                }
                                else
                                {
                                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                                }
                            }
                            else
                            {
                                SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
                            }
                        }
                        else
                        {
                            SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
                        }
                    }
                    else
                    {
                        SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
                    }
                }
                else
                {
                    SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
                }
                if(KeyIsLocked)
                    UnlockKey(*Local,LocCh1,Params->path);
			}
			else
			{
                SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_InternalLockingError),msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_ExtractArchive: // ExtractArchive
		{
			(*Local)->FuncName="ExtractArchive";
			(*Local)->ActCounter=msg->head.counter;
            LocI=msg->head.message_size;
			LocCh1=(char *)&msg->message;
			if(ValidateFileName(LocCh1))
			{
                if(LockKey(*Local,LocCh1,Params->path))
                {
                    uint8_t KeyIsLocked=1;
                    LocI-=strlen(LocCh1)+1;
                    (*Local)->ProgressTime=time(NULL);
                    if(LocI>0)
                    {
                        LocCh2=LocCh1+strlen(LocCh1)+1;
                        if(ValidateFileName(LocCh2))
                        {
                            LocCh3=LocCh2+strlen(LocCh2)+1;
                            char tempname[]="/tmp/pds_rearchive_XXXXXXXXXX";
                            int OutputArchive=mkstemp(tempname);
                            if(OutputArchive>=0)
                            {
                                SendOK((*Local)->client_sockfd,msg->head.counter);
                                message(2,"%d Start receive file LocalName: %s RemoteName: %s\n",(*Local)->child_pid,tempname,LocCh3);
                                if(ReceiveFile(*Local,OutputArchive))
                                {
                                    (*Local)->ProgressTime=time(NULL);
                                    if(TestArchive(*Local,LocCh1,LocCh2,OutputArchive,Params->path))
                                    {
                                        if(ExtractArchive(*Local,LocCh1,LocCh2,OutputArchive,Params->path))
                                        {
                                            SendOK((*Local)->client_sockfd,msg->head.counter);
                                        }
                                        else
                                        {
                                            SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_RearchiveError),msg->head.counter,(*Local)->FuncName);
                                        }
                                    }
                                    else
                                    {
                                        SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_CorruptedFile),msg->head.counter,(*Local)->FuncName);
                                    }
                                }
                                else
                                {
                                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_ReceiveFileFailed),msg->head.counter,(*Local)->FuncName);
                                }
                                close(OutputArchive);
                            }
                            else
                            {
                                (*Local)->LastErrorCode=errno;
                                SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_CreateError),msg->head.counter,(*Local)->FuncName);
                            }
                        }
                        else
                        {
                            SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
                        }
                    }
                    else
                    {
                        SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
                    }
                    if(KeyIsLocked)
                        UnlockKey(*Local,LocCh1,Params->path);
                }
                else
                {
                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_InternalLockingError),msg->head.counter,(*Local)->FuncName);
                }
			}
            else
            {
                SendError((*Local)->client_sockfd,err_BadParameters,msg->head.counter,(*Local)->FuncName);
            }
			break;
		}
		case pds_ChangeStructure: // ChangeStructure
		{
			(*Local)->FuncName="ChangeStructure";
			fID=&((P_FilerDatMsg4)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
                LocI=((P_FilerDatMsg4)msg->message)->NewLen;
			    if((LocI>=sizeof(IsamSmallInfoRec))&&(LocI<=local_buffer_size))
			    {
                    if(AppropriateLocalFile(*Local,*fID,filetype_Data,1,0))
                    {
                        uint8_t IsClosed=0;
                        (*Local)->DisableCheckFreeze=1;
                        P_pds_file OldF=&_Files->Files[(*Local)->Files[fID->Index].Index];

                        if(OldF->Counter==1) // ma otevreno pouze aktualni proces
                        {
                            if(OldF->datInfo.LenRec<LocI)
                            {
                                InitNewDatFile DatInfo;
                                memset(&DatInfo,0,sizeof(DatInfo));
                                DatInfo.RecSize=LocI;
                                DatInfo.NrOfKeys=OldF->datInfo.NrOfKeys;

                                message(1,"%d Change structure from RecLen %d to %d file: %s\n",(*Local)->child_pid,OldF->datInfo.LenRec,LocI,OldF->RealName);

                                LocI2=OpenFile(Local,OldF->Key,OldF->SubKey,OldF->Name,filetype_TempDat,0,0,&DatInfo,Params->path);
                                if(LocI2==-1)
                                {
                                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                                }
                                else
                                {
                                    P_pds_file NewF=&_Files->Files[(*Local)->Files[LocI2].Index];

                                    LocI3=OldF->InxDescr[0].NumRec;

                                    memset((*Local)->local_buffer,0,LocI);

                                    if(lseek(OldF->Handle,OldF->datInfo.LenRec,SEEK_SET)==OldF->datInfo.LenRec)
                                    {
                                        if(lseek(NewF->Handle,LocI,SEEK_SET)==LocI)
                                        {
                                            (*Local)->ProgressTime=time(NULL);
                                            time_t ActTime;
                                            unsigned short Progress=10000;
                                            while(LocI3>0)
                                            {
                                                if(read(OldF->Handle,(*Local)->local_buffer,OldF->datInfo.LenRec)==OldF->datInfo.LenRec)
                                                {
                                                    if(write(NewF->Handle,(*Local)->local_buffer,LocI)==LocI)
                                                    {
                                                        LocI3--;
                                                        ActTime=time(NULL);
                                                        if((ActTime!=(*Local)->ProgressTime)&&((*Local)->LastErrorCode==0))
                                                        {
                                                            (*Local)->ProgressTime=ActTime;
                                                            if(OldF->InxDescr[0].NumRec)
                                                            {
                                                                Progress=(int)((double)(OldF->InxDescr[0].NumRec-LocI3)/OldF->InxDescr[0].NumRec*10000);
                                                            }
                                                            SendWait((*Local)->client_sockfd,msg->head.counter,Progress);
                                                        }
                                                    }
                                                    else
                                                    {
                                                        SetLastFileError(*Local,errno,err_WriteError);
                                                        break;
                                                    }
                                                }
                                                else
                                                {
                                                    SetLastFileError(*Local,errno,err_ReadError);
                                                    break;
                                                }
                                            }
                                            if(LocI3==0)
                                            {
                                                NewF->InxDescr[0]=OldF->InxDescr[0];
                                                NewF->InxDescr[0].LenRec=LocI;
                                                if(IsamPutInfoRec(*Local,NewF,0,0))
                                                {
                                                    int BakNameLen=strlen(OldF->RealName)+strlen(backupExtension);
                                                    if(BakNameLen<=local_buffer_size)
                                                    {
                                                        strcpy((*Local)->local_buffer,OldF->RealName);
                                                        strcat((*Local)->local_buffer,backupExtension);
                                                        LocI3=remove((*Local)->local_buffer);
                                                        if((LocI3==0)||(errno==2))
                                                        {
                                                            close(OldF->Handle);OldF->Handle=-1;
                                                            if(rename(OldF->RealName,(*Local)->local_buffer)==0)
                                                            {
                                                                close(NewF->Handle);NewF->Handle=-1;
                                                                if(rename(NewF->RealName,OldF->RealName)==0)
                                                                {
                                                                    SendOK((*Local)->client_sockfd,msg->head.counter);
                                                                }
                                                                else
                                                                {
                                                                    SetLastFileError(*Local,errno,err_RenameError);
                                                                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_RenameError),msg->head.counter,(*Local)->FuncName);
                                                                }
                                                            }
                                                            else
                                                            {
                                                                SetLastFileError(*Local,errno,err_RenameError);
                                                                SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_RenameError),msg->head.counter,(*Local)->FuncName);
                                                            }
                                                        }
                                                        else
                                                        {
                                                            SetLastFileError(*Local,errno,err_RemoveError);
                                                            SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_RemoveError),msg->head.counter,(*Local)->FuncName);
                                                        }
                                                    }
                                                    else
                                                    {
                                                        SendError((*Local)->client_sockfd,err_LowMemory,msg->head.counter,(*Local)->FuncName);
                                                    }
                                                }
                                                else
                                                {
                                                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_WriteError),msg->head.counter,(*Local)->FuncName);
                                                }
                                            }
                                            else
                                            {
                                                SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_ChangeStructure),msg->head.counter,(*Local)->FuncName);
                                            }
                                        }
                                        else
                                        {
                                            (*Local)->LastErrorCode=errno;
                                            SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_SeekError),msg->head.counter,(*Local)->FuncName);
                                        }
                                    }
                                    else
                                    {
                                        (*Local)->LastErrorCode=errno;
                                        SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_SeekError),msg->head.counter,(*Local)->FuncName);
                                    }
                                    CloseLocalFile(*Local,LocI2);
                                    CloseLocalFile(*Local,fID->Index);
                                    IsClosed++;
                                }
                            }
                            else
                            {
                                SendError((*Local)->client_sockfd,err_NewRecLenNotGreater,msg->head.counter,(*Local)->FuncName);
                            }
                        }
                        else
                        {
                            SendError((*Local)->client_sockfd,err_FileLocked,msg->head.counter,(*Local)->FuncName);
                        }
                        if(!IsClosed)
                        {
                          UnAppropriateLocalFile(*Local,*fID);
                        }
                        (*Local)->DisableCheckFreeze=0;
                    }
                    else
                    {
                        SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
                    }
                }
                else
                {
                    SendError((*Local)->client_sockfd,err_RecLenOutOfRange,msg->head.counter,(*Local)->FuncName);
                }
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_Authentication: // Authentication
		{
			(*Local)->FuncName="Authentication";
			LocCh1=(char *)&msg->message;
			LocCh2=LocCh1;
			LocCh2+=strlen(LocCh1)+1;
			LocI=CompareKeyPassword(*Local,LocCh1,LocCh2,Params->path);
			if(LocI>=0)
			{
                (*Local)->MyKey=LocI;
                (*Local)->AuthorizedKey=LocI;
                SendOK((*Local)->client_sockfd,msg->head.counter);
			}
			else
			{
                SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		case pds_CloseAllFiles: // CloseAllFiles
		{
			(*Local)->FuncName="CloseAllFiles";
            CloseAllLocalFiles(*Local);
            SendOK((*Local)->client_sockfd,msg->head.counter);
			break;
		}
		case pds_GetVersion: // GetVersion
		{
			(*Local)->FuncName="GetVersion";
			LocI=sizeof(VersionRecMsg);
			LocI+=strlen(compilation_date)+strlen(compilation_time)+2;
            if(LocI<=local_buffer_size)
            {
                memset((P_ResultMsg)(*Local)->local_buffer,0,LocI);
                InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
                ((P_ResultMsg)(*Local)->local_buffer)->Size=LocI;
                LocCh1=(*Local)->local_buffer;
                ((P_VersionRecMsg)(*Local)->local_buffer)->Major=version_major;
                ((P_VersionRecMsg)(*Local)->local_buffer)->Minor=version_minor;
                ((P_VersionRecMsg)(*Local)->local_buffer)->Revision=version_revision;
                LocCh1+=sizeof(VersionRecMsg);
                memcpy(LocCh1,compilation_date,strlen(compilation_date)+1);
                LocCh1+=strlen(compilation_date)+1;
                memcpy(LocCh1,compilation_time,strlen(compilation_time)+1);
                if(Send((*Local)->client_sockfd,(*Local)->local_buffer,LocI)==-1)
                {
                    return -1;
                }
            }
            else
            {
                SendError((*Local)->client_sockfd,err_RecLenOutOfRange,msg->head.counter,(*Local)->FuncName);
            }
		    break;
		}
		case pds_RebuildFile: // RebuildFile
		{
			(*Local)->FuncName="RebuildFile";
			fID=&((P_FilerMsg)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
                if(AppropriateLocalFile(*Local,*fID,filetype_Data,0,msg->head.message_id))
                {
                    ActFile=&_Files->Files[(*Local)->Files[fID->Index].Index];
                    if(ActFile->FileType==filetype_Data)
                    {
                        if(ActFile->Locker==(*Local)->child_pid) // soubor musi byt uzamceny
                        {
                            if(ActFile->Counter==1) // soubor nesmi byt pouzivat nikym jinym
                            {
                                (*Local)->DisableCheckFreeze=1;
                                P_pds_file OldF=&_Files->Files[(*Local)->Files[fID->Index].Index];

                                InitNewDatFile DatInfo;
                                memset(&DatInfo,0,sizeof(DatInfo));
                                LocI=OldF->datInfo.LenRec;
                                DatInfo.RecSize=LocI;
                                DatInfo.NrOfKeys=OldF->datInfo.NrOfKeys;

                                message(1,"%d Rebuild file: %s\n",(*Local)->child_pid,OldF->RealName);

                                LocI2=OpenFile(Local,OldF->Key,OldF->SubKey,OldF->Name,filetype_TempDat,0,0,&DatInfo,Params->path);
                                if(LocI2==-1)
                                {
                                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                                }
                                else
                                {
                                    P_pds_file NewF=&_Files->Files[(*Local)->Files[LocI2].Index];

                                    LocI3=OldF->InxDescr[0].NumRec;

                                    int LocI4=lseek(OldF->Handle,0,SEEK_END);

                                    if(LocI4!=(off_t)-1)
                                    {
                                        if(LocI3>LocI4/LocI-1)
                                            LocI3=LocI4/LocI-1;
                                        LocI4=0;
                                        if(lseek(OldF->Handle,LocI,SEEK_SET)==OldF->datInfo.LenRec)
                                        {
                                            if(lseek(NewF->Handle,LocI,SEEK_SET)==LocI)
                                            {
                                                (*Local)->ProgressTime=time(NULL);
                                                time_t ActTime;
                                                unsigned short Progress=10000;
                                                while(LocI3>0)
                                                {
                                                    if(read(OldF->Handle,(*Local)->local_buffer,LocI)==LocI)
                                                    {
                                                        if((((P_IntArr)(*Local)->local_buffer)->int0==(int32_t)0)||(((P_IntArr)(*Local)->local_buffer)->int1!=(int32_t)-1)) // pouze nevymazane vety
                                                        {
                                                            if(write(NewF->Handle,(*Local)->local_buffer,LocI)==LocI)
                                                            {
                                                                LocI4++;
                                                                ActTime=time(NULL);
                                                                if((ActTime!=(*Local)->ProgressTime)&&((*Local)->LastErrorCode==0))
                                                                {
                                                                    (*Local)->ProgressTime=ActTime;
                                                                    if(OldF->InxDescr[0].NumRec)
                                                                    {
                                                                        Progress=(int)((double)(OldF->InxDescr[0].NumRec-LocI3)/OldF->InxDescr[0].NumRec*10000);
                                                                    }
                                                                    SendWait((*Local)->client_sockfd,msg->head.counter,Progress);
                                                                }
                                                            }
                                                            else
                                                            {
                                                                SetLastFileError(*Local,errno,err_WriteError);
                                                                break;
                                                            }
                                                        }
                                                        LocI3--;
                                                    }
                                                    else
                                                    {
                                                        SetLastFileError(*Local,errno,err_ReadError);
                                                        break;
                                                    }
                                                }
                                                if(LocI3==0)
                                                {
                                                    NewF->InxDescr[0]=OldF->InxDescr[0];
                                                    NewF->InxDescr[0].LenRec=LocI;
                                                    NewF->InxDescr[0].NumRec=LocI4;
                                                    NewF->InxDescr[0].FirstFree=-1;
                                                    NewF->InxDescr[0].NumberFree=0;

                                                    if(IsamPutInfoRec(*Local,NewF,0,0))
                                                    {
                                                        int BakNameLen=strlen(OldF->RealName)+strlen(backupExtension);
                                                        if(BakNameLen<=local_buffer_size)
                                                        {
                                                            strcpy((*Local)->local_buffer,OldF->RealName);
                                                            strcat((*Local)->local_buffer,backupExtension);
                                                            LocI3=remove((*Local)->local_buffer);
                                                            if((LocI3==0)||(errno==2))
                                                            {
                                                                close(OldF->Handle);OldF->Handle=-1;
                                                                if(rename(OldF->RealName,(*Local)->local_buffer)==0)
                                                                {
                                                                    close(NewF->Handle);NewF->Handle=-1;
                                                                    if(rename(NewF->RealName,OldF->RealName)==0)
                                                                    {
                                                                        OldF->Handle=open(OldF->RealName,O_RDWR);
                                                                        if(OldF->Handle!=-1)
                                                                        {
                                                                            OldF->InxDescr[0]=NewF->InxDescr[0];
                                                                            if(ftruncate(OldF->InxHandle,0)==0)
                                                                            {
                                                                                LocI3=sizeof(InitNewDatFile)+sizeof(InitNewInxFile)*OldF->datInfo.NrOfKeys;
                                                                                P_InitNewDatFile NewInfo=GetMem(LocI3);
                                                                                if(NewInfo)
                                                                                {
                                                                                    memset(NewInfo,0,LocI3);
                                                                                    NewInfo->RecSize=LocI;
                                                                                    NewInfo->NrOfKeys=OldF->datInfo.NrOfKeys;
                                                                                    LocI3=0;
                                                                                    while(LocI3<OldF->datInfo.NrOfKeys)
                                                                                    {
                                                                                        NewInfo->Indexs[LocI3].KeyLen=OldF->InxDescr[LocI3+1].KeyLen;
                                                                                        NewInfo->Indexs[LocI3].AllowDupKeys=OldF->InxDescr[LocI3+1].AllowDupKeys;
                                                                                        NewInfo->Indexs[LocI3].XlatKeys=OldF->InxDescr[LocI3+1].XlatKeys;
                                                                                        NewInfo->Indexs[LocI3].CodePage=OldF->InxDescr[LocI3+1].KeyCodePage;
                                                                                        NewInfo->Indexs[LocI3].IndexVersion=OldF->InxDescr[LocI3+1].KeyVersion;
                                                                                        LocI3++;
                                                                                    }
                                                                                    if(IsamInitInxFile(*Local,OldF,NewInfo))
                                                                                    {
                                                                                        SendOK((*Local)->client_sockfd,msg->head.counter);
                                                                                    }
                                                                                    else
                                                                                    {
                                                                                        SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
                                                                                    }
                                                                                    FreeMem(NewInfo);
                                                                                }
                                                                                else
                                                                                {
                                                                                    SendError((*Local)->client_sockfd,err_LowMemory,msg->head.counter,(*Local)->FuncName);
                                                                                }
                                                                            }
                                                                            else
                                                                            {
                                                                                (*Local)->LastErrorCode=errno;
                                                                                SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_TruncateError),msg->head.counter,(*Local)->FuncName);
                                                                            }
                                                                        }
                                                                        else
                                                                        {
                                                                            SetLastFileError(*Local,errno,err_OpenError);
                                                                            SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_OpenError),msg->head.counter,(*Local)->FuncName);
                                                                        }
                                                                    }
                                                                    else
                                                                    {
                                                                        SetLastFileError(*Local,errno,err_RenameError);
                                                                        SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_RenameError),msg->head.counter,(*Local)->FuncName);
                                                                    }
                                                                }
                                                                else
                                                                {
                                                                    SetLastFileError(*Local,errno,err_RenameError);
                                                                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_RenameError),msg->head.counter,(*Local)->FuncName);
                                                                }
                                                            }
                                                            else
                                                            {
                                                                SetLastFileError(*Local,errno,err_RemoveError);
                                                                SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_RemoveError),msg->head.counter,(*Local)->FuncName);
                                                            }
                                                        }
                                                        else
                                                        {
                                                            SendError((*Local)->client_sockfd,err_LowMemory,msg->head.counter,(*Local)->FuncName);
                                                        }
                                                    }
                                                    else
                                                    {
                                                        SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_WriteError),msg->head.counter,(*Local)->FuncName);
                                                    }
                                                }
                                                else
                                                {
                                                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Rebuild),msg->head.counter,(*Local)->FuncName);
                                                }
                                            }
                                            else
                                            {
                                                (*Local)->LastErrorCode=errno;
                                                SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_SeekError),msg->head.counter,(*Local)->FuncName);
                                            }
                                        }
                                        else
                                        {
                                            (*Local)->LastErrorCode=errno;
                                            SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_SeekError),msg->head.counter,(*Local)->FuncName);
                                        }
                                    }
                                    else
                                    {
                                        (*Local)->LastErrorCode=errno;
                                        SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_SeekError),msg->head.counter,(*Local)->FuncName);
                                    }
                                    CloseLocalFile(*Local,LocI2);
                                }
                                (*Local)->DisableCheckFreeze=0;
                            }
                            else
                            {
                                SendError((*Local)->client_sockfd,err_FileUsed,msg->head.counter,(*Local)->FuncName);
                            }
                        }
                        else
                        {
                            SendError((*Local)->client_sockfd,err_FileNotLocked,msg->head.counter,(*Local)->FuncName);
                        }
                    }
                    else
                    {
                        SendError((*Local)->client_sockfd,err_BadFileType,msg->head.counter,(*Local)->FuncName);
                    }
                    UnAppropriateLocalFile(*Local,*fID);
                }
                else
                {
                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
                }
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
		    break;
		}
		case pds_ChangeFile: // ChangeFile
		{
			(*Local)->FuncName="ChangeFile";
			(*Local)->ActCounter=msg->head.counter;
			fID=&((P_FilerDatMsg5)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
                if(AppropriateLocalFile(*Local,*fID,filetype_Data,0,msg->head.message_id))
                {
                    ActFile=&_Files->Files[(*Local)->Files[fID->Index].Index];
                    if(ActFile->FileType==filetype_Data)
                    {
                        if(ActFile->Locker==(*Local)->child_pid) // soubor musi byt uzamceny
                        {
                            if(ActFile->Counter==1) // soubor nesmi byt pouzivat nikym jinym
                            {
                                if(ActFile->RealName)
                                {

                                    int StripNameLen=strlen(ActFile->RealName)-strlen(datExtension);
                                    if(StripNameLen>1)
                                    {
                                        char * StripName=GetMem(StripNameLen+1);
                                        if(StripName)
                                        {
                                            strncpy(StripName,ActFile->RealName,StripNameLen);
                                            char * tmppoint=StripName;
                                            tmppoint+=StripNameLen;
                                            *tmppoint='\0';
                                            int tmplen=strlen(StripName);
                                            tmplen+=strlen(tmpExtension);
                                            tmplen++;
                                            char * tmpname=GetMem(tmplen);
                                            if(tmpname)
                                            {
                                                strcpy(tmpname,StripName);
                                                strcat(tmpname,tmpExtension);
                                                int tmpfile=open(tmpname,O_CREAT|O_RDWR|O_TRUNC,Params->NewFileMode);
                                                if(tmpfile!=-1)
                                                {
                                                    int tmp2len=strlen(tmpname);
                                                    tmp2len+=strlen(tmpExtension);
                                                    tmp2len++;
                                                    char * tmp2name=GetMem(tmp2len);
                                                    if(tmp2name)
                                                    {
                                                        strcpy(tmp2name,tmpname);
                                                        strcat(tmp2name,tmpExtension);
                                                        SendOK((*Local)->client_sockfd,msg->head.counter);
                                                        (*Local)->DisableCheckFreeze=1;
                                                        if(ReceiveFile(*Local,tmpfile))
                                                        {
                                                            uint8_t OK=0;
                                                            if((((P_FilerDatMsg5)&msg->message)->Type&changefile_Packed)!=0)
                                                            {
                                                                int tmp2file=open(tmp2name,O_CREAT|O_RDWR|O_TRUNC,Params->NewFileMode);
                                                                if(tmp2file!=-1)
                                                                {
                                                                    unsigned char MD5Digest[16];
                                                                    if(lseek(tmpfile,0,SEEK_SET)==0)
                                                                    {
                                                                        if(Decode(*Local,tmpfile,tmp2file,(char *)&MD5Digest))
                                                                        {
                                                                            if(memcmp(&MD5Digest,&((P_FilerDatMsg5)&msg->message)->MD5,16)==0)
                                                                            {
                                                                                close(tmpfile);tmpfile=-1;
                                                                                close(tmp2file);tmp2file=-1;
                                                                                if(remove(tmpname)==0)
                                                                                {
                                                                                    if(rename(tmp2name,tmpname)==0)
                                                                                    {
                                                                                        OK=1;
                                                                                    }
                                                                                    else
                                                                                    {
                                                                                        SetLastFileError(*Local,errno,err_RenameError);
                                                                                        SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_RenameError),msg->head.counter,(*Local)->FuncName);
                                                                                    }
                                                                                }
                                                                                else
                                                                                {
                                                                                    SetLastFileError(*Local,errno,err_RemoveError);
                                                                                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_RemoveError),msg->head.counter,(*Local)->FuncName);
                                                                                }
                                                                            }
                                                                            else
                                                                            {
                                                                                SendError((*Local)->client_sockfd,err_CorruptedFile,msg->head.counter,(*Local)->FuncName);
                                                                            }
                                                                        }
                                                                        else
                                                                        {
                                                                            SendError((*Local)->client_sockfd,err_CorruptedFile,msg->head.counter,(*Local)->FuncName);
                                                                        }
                                                                    }
                                                                    else
                                                                    {
                                                                        SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_SeekError),msg->head.counter,(*Local)->FuncName);
                                                                    }
                                                                    if(tmp2file!=-1)
                                                                    {
                                                                        close(tmp2file);remove(tmp2name);
                                                                    }
                                                                }
                                                                else
                                                                {
                                                                    (*Local)->LastErrorCode=errno;
                                                                    SendError((*Local)->client_sockfd,err_CreateError,msg->head.counter,(*Local)->FuncName);
                                                                }
                                                            }
                                                            else
                                                            {
                                                                OK=1;
                                                            }
                                                            if(OK)
                                                            {
                                                                close(tmpfile);tmpfile=-1;
                                                                OK=0;
                                                                switch(((P_FilerDatMsg5)&msg->message)->Type&(~changefile_Packed))
                                                                {
                                                                    case changefile_Dat:
                                                                    {
                                                                        int datlen=strlen(ActFile->RealName);
                                                                        datlen+=strlen(datExtension);
                                                                        datlen++;
                                                                        char * datname=GetMem(datlen);
                                                                        if(datname)
                                                                        {
                                                                            strcpy(datname,ActFile->RealName);
                                                                            strcat(datname,datExtension);
                                                                            int baklen=strlen(ActFile->RealName);
                                                                            baklen+=strlen(backupExtension);
                                                                            baklen++;
                                                                            char * bakname=GetMem(baklen);
                                                                            if(bakname)
                                                                            {
                                                                                if(rename(datname,bakname)==0)
                                                                                {
                                                                                    close(ActFile->Handle);ActFile->Handle=-1;
                                                                                    if(rename(tmpname,datname))
                                                                                    {
                                                                                        if(OpenDat(*Local,ActFile,datname))
                                                                                        {
                                                                                            OK=1;
                                                                                        }
                                                                                        else
                                                                                        {
                                                                                            CloseGlobalFile((*Local)->Files[fID->Index].Index,0);
                                                                                            SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_OpenError),msg->head.counter,(*Local)->FuncName);
                                                                                        }
                                                                                    }
                                                                                    else
                                                                                    {
                                                                                        SetLastFileError(*Local,errno,err_RenameError);
                                                                                        SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_RenameError),msg->head.counter,(*Local)->FuncName);
                                                                                    }
                                                                                }
                                                                                else
                                                                                {
                                                                                    SetLastFileError(*Local,errno,err_RenameError);
                                                                                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_RenameError),msg->head.counter,(*Local)->FuncName);
                                                                                }
                                                                                FreeMem(bakname);
                                                                            }
                                                                            else
                                                                            {
                                                                                SendError((*Local)->client_sockfd,err_LowMemory,msg->head.counter,(*Local)->FuncName);
                                                                            }
                                                                            FreeMem(datname);
                                                                        }
                                                                        else
                                                                        {
                                                                            SendError((*Local)->client_sockfd,err_LowMemory,msg->head.counter,(*Local)->FuncName);
                                                                        }
                                                                        break;
                                                                    }
                                                                    case changefile_Inx:
                                                                    {
                                                                        int inxlen=strlen(StripName);
                                                                        inxlen+=strlen(inxExtension);
                                                                        inxlen++;
                                                                        char * inxname=GetMem(inxlen);
                                                                        if(inxname)
                                                                        {
                                                                            strcpy(inxname,StripName);
                                                                            strcat(inxname,inxExtension);
                                                                            close(ActFile->InxHandle);ActFile->InxHandle=-1;
                                                                            LocI=remove(inxname);
                                                                            if((LocI!=-1)||(errno=2))
                                                                            {
                                                                                if(rename(tmpname,inxname)==0)
                                                                                {
                                                                                    if(OpenInx(*Local,ActFile,inxname))
                                                                                    {
                                                                                        OK=1;
                                                                                    }
                                                                                    else
                                                                                    {
                                                                                        CloseGlobalFile((*Local)->Files[fID->Index].Index,0);
                                                                                        SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_OpenError),msg->head.counter,(*Local)->FuncName);
                                                                                    }
                                                                                }
                                                                                else
                                                                                {
                                                                                    SetLastFileError(*Local,errno,err_RenameError);
                                                                                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_RenameError),msg->head.counter,(*Local)->FuncName);
                                                                                }
                                                                            }
                                                                            else
                                                                            {
                                                                                SetLastFileError(*Local,errno,err_RemoveError);
                                                                                SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_RemoveError),msg->head.counter,(*Local)->FuncName);
                                                                            }
                                                                            FreeMem(inxname);
                                                                        }
                                                                        else
                                                                        {
                                                                            SendError((*Local)->client_sockfd,err_LowMemory,msg->head.counter,(*Local)->FuncName);
                                                                        }
                                                                        break;
                                                                    }
                                                                    default:
                                                                    {
                                                                        SendError((*Local)->client_sockfd,err_BadFileType,msg->head.counter,(*Local)->FuncName);
                                                                        break;
                                                                    }
                                                                }
                                                                if(OK)
                                                                {
                                                                    SendOK((*Local)->client_sockfd,msg->head.counter);
                                                                }
                                                                else
                                                                {
                                                                    remove(tmpname);
                                                                }
                                                            }
                                                            if(tmpfile!=-1)
                                                            {
                                                                close(tmpfile);remove(tmpname);tmpfile=-1;
                                                            }
                                                        }
                                                        else
                                                        {
                                                            close(tmpfile);remove(tmpname);tmpfile=-1;
                                                            // zprava se odesilat nemusi, zpravu odesila ReceiveFile
                                                        }
                                                        (*Local)->DisableCheckFreeze=0;
                                                        FreeMem(tmp2name);
                                                    }
                                                    else
                                                    {
                                                        close(tmpfile);
                                                        SendError((*Local)->client_sockfd,err_LowMemory,msg->head.counter,(*Local)->FuncName);
                                                    }
                                                }
                                                else
                                                {
                                                    (*Local)->LastErrorCode=errno;
                                                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_CreateError),msg->head.counter,(*Local)->FuncName);
                                                }
                                                FreeMem(tmpname);
                                            }
                                            else
                                            {
                                                SendError((*Local)->client_sockfd,err_LowMemory,msg->head.counter,(*Local)->FuncName);
                                            }
                                        }
                                        else
                                        {
                                            SendError((*Local)->client_sockfd,err_LowMemory,msg->head.counter,(*Local)->FuncName);
                                        }
                                    }
                                    else
                                    {
                                        SendError((*Local)->client_sockfd,err_InvalidFile,msg->head.counter,(*Local)->FuncName);
                                    }
                                }
                                else
                                {
                                    SendError((*Local)->client_sockfd,err_InvalidFile,msg->head.counter,(*Local)->FuncName);
                                }
                            }
                            else
                            {
                                SendError((*Local)->client_sockfd,err_FileUsed,msg->head.counter,(*Local)->FuncName);
                            }
                        }
                        else
                        {
                            SendError((*Local)->client_sockfd,err_FileNotLocked,msg->head.counter,(*Local)->FuncName);
                        }
                    }
                    else
                    {
                        SendError((*Local)->client_sockfd,err_BadFileType,msg->head.counter,(*Local)->FuncName);
                    }
                    UnAppropriateLocalFile(*Local,*fID);
                }
                else
                {
                    SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Appropriation),msg->head.counter,(*Local)->FuncName);
                }
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
		    break;
		}
		case pds_GetTime: // GetTime
		{
			(*Local)->FuncName="GetVersion";
			LocI=sizeof(TimeRecMsg);
            if(LocI<=local_buffer_size)
            {
                memset((P_ResultMsg)(*Local)->local_buffer,0,LocI);
                InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
                ((P_ResultMsg)(*Local)->local_buffer)->Size=LocI;

                struct tm *time_now;
                time_t secs_now;
                time(&secs_now);
                time_now=localtime(&secs_now);

                ((P_TimeRecMsg)(*Local)->local_buffer)->TimeStamp=secs_now;
                ((P_TimeRecMsg)(*Local)->local_buffer)->year=time_now->tm_year+1900;
                ((P_TimeRecMsg)(*Local)->local_buffer)->month=time_now->tm_mon+1;
                ((P_TimeRecMsg)(*Local)->local_buffer)->day=time_now->tm_mday;
                ((P_TimeRecMsg)(*Local)->local_buffer)->hour=time_now->tm_hour;
                ((P_TimeRecMsg)(*Local)->local_buffer)->min=time_now->tm_min;
                ((P_TimeRecMsg)(*Local)->local_buffer)->sec=time_now->tm_sec;
                if(((P_TimeRecMsg)(*Local)->local_buffer)->sec>59)
                  ((P_TimeRecMsg)(*Local)->local_buffer)->sec=59;
                ((P_TimeRecMsg)(*Local)->local_buffer)->wday=time_now->tm_wday;
                ((P_TimeRecMsg)(*Local)->local_buffer)->yday=time_now->tm_yday;
                ((P_TimeRecMsg)(*Local)->local_buffer)->isdst=time_now->tm_isdst;
                char Buf[8];
                strftime(Buf,sizeof(Buf),"%z",time_now);
                LocI2=0;
                if(EOF!=sscanf(Buf,"%d",&LocI3))
                {
                    LocI2=abs(LocI3);
                    LocI2=LocI2/100*60+LocI2%100;
                    if(LocI3<0)
                      LocI2=-LocI2;
                }
                ((P_TimeRecMsg)(*Local)->local_buffer)->TZMinutesOffset=LocI2;
                strftime(((P_TimeRecMsg)(*Local)->local_buffer)->TimeZoneName,sizeof(((P_TimeRecMsg)(*Local)->local_buffer)->TimeZoneName),"%Z",time_now);
                if(Send((*Local)->client_sockfd,(*Local)->local_buffer,LocI)==-1)
                {
                    return -1;
                }
            }
            else
            {
                SendError((*Local)->client_sockfd,err_RecLenOutOfRange,msg->head.counter,(*Local)->FuncName);
            }
		    break;
		}
		case pds_CloneFile: // pds_CloneFile
		{
			(*Local)->FuncName="CloneFile";
			fID=&((P_FilerMsg)&msg->message)->ID;
			if(CheckLocalFileID(*Local,*fID,msg->head.message_id))
			{
				LocI=CloneFile(Local,*fID);
				if(LocI==-1)
				{
					SendError((*Local)->client_sockfd,GetLastFileError(*Local,err_Unspecified),msg->head.counter,(*Local)->FuncName);
				}
				else
				{
					InitResultHead((P_ResultMsg)(*Local)->local_buffer,msg->head.counter);
					LocI2=(*Local)->Files[LocI].Index;
					((ResultMsg2 *)(*Local)->local_buffer)->ID.Random=_Files->Files[LocI2].Random;
					((ResultMsg2 *)(*Local)->local_buffer)->ID.FileGen=_Files->Files[LocI2].FileGen;
					((ResultMsg2 *)(*Local)->local_buffer)->ID.Index=LocI;
                    LocI3=sizeof(ResultMsg2);
					if(Send((*Local)->client_sockfd,(*Local)->local_buffer,LocI3)==-1)
					{
						return -1;
					}
				}
			}
			else
			{
				SendError((*Local)->client_sockfd,err_BadDescriptor,msg->head.counter,(*Local)->FuncName);
			}
			break;
		}
		default:
		{
			(*Local)->FuncName="Unknown";
			message(1,"%d Neznama funkce: ID %d\n",getpid(),msg->head.message_id);
			SendError((*Local)->client_sockfd,err_UnknownFunction,msg->head.counter,(*Local)->FuncName);
			break;
		}
	}
	(*Local)->FuncName="";
	return 0;
}

void PrintBuffer(P_local_files Local,char * Buffer,int Size)
{
	int Line;
	int Offset=0;
	while(Size>0)
	{
		if(Size>16)
			Line=16;
		else
			Line=Size;
        InitLogBuffer(Local);
		AddToLogBuffer(Local,7,"%4x:",Offset);
		Size-=Line;
		Offset+=Line;
		while(Line>0)
		{
			AddToLogBuffer(Local,7," %02X",(unsigned char)*Buffer);
			Buffer++;
			Line--;
		}
		message(9,"%s\n",Local->LogBuffer);
	}
}

// ******* ******* ******* ******* ******* ******* ******* //

P_pds_child SearchChild(pid_t ChildPid)
{
	if(semaphore_p(2,NULL))
	{
		P_pds_child	child=_Childs->Busy;
		while(child!=NULL)
		{
			if(child->pid==ChildPid)
			{
				semaphore_v(2,NULL);
				return child;
			}
			child=child->NextChild;
		}
		child=_Childs->FirstFree;
		while(child!=NULL)
		{
			if(child->pid==ChildPid)
			{
				semaphore_v(2,NULL);
				return child;
			}
			child=child->NextChild;
		}
		semaphore_v(2,NULL);
	}
	return NULL;
}

int Allow(unsigned long int addr,uint8_t mask,int Default)
{
    int Result=Default;
    if(Params->access)
    {
        int LocI;
        uint32_t LocU=htonl(addr);
        for(LocI=0;LocI<Params->access_count;LocI++)
        {
            if((LocU&Params->masks[Params->access[LocI].mask])==(Params->access[LocI].ip&Params->masks[Params->access[LocI].mask]))
            {
                if((Params->access[LocI].allow&mask)!=0)
                  Result=1;
                else
                  Result=0;
            }
        }
    }
    return Result;
}

int ChildProc(void *data)
{
    _Files->UseCount++;

	seteuid(uid);
	setegid(gid);

	P_local_files _Local=NULL;

	int client_sockfd=-1;
	pid_t child_pid=getpid();

    message(3,"%d ChildProc\n",child_pid);
	status_message msg;
	int res_msg;
	memset(&msg,0,sizeof(msg));
	msg.message_type=parent_pid;
	msg.sign=valid_sign;
	msg.status=child_create;
	msg.pid=child_pid;
	void* buffer=NULL;
	int readcount;
	P_pds_child SelfChild=NULL;
    fd_set testfds;

	if(msgsnd(msg_id,&msg,status_message_size,0)==0)
	{
		message(3,"Odeslana zprava o vytvoreni %d\n",child_pid);
		semaphore_v(1,NULL);
		buffer=GetMem(bufsize);
		if(buffer)
		{
			int active=1;
			while((active)&&(ThreadsLive))
            {
                res_msg=msgrcv(msg_id,&msg,status_message_size,child_pid,0);
                if(res_msg==-1)
                {
                    if(errno!=4)
                    {
                        message(3,"%d nejsou dalsi zpravy ...\n",child_pid);
                        break;
                    }
                }
                if(res_msg==status_message_size)
                {
                    message(3,"%d Child prijima zpravu %d\n",child_pid,msg.status);
                    switch(msg.status)
                    {
                        case child_exit:
                        {
                            active=0;
                            break;
                        }
                        case child_server:
                        {
                            message(3,"%d Cekam na spojeni\n",child_pid);

                            struct sockaddr_in client_address;
                            socklen_t client_len = sizeof(client_address);
                            int server_sockfd=msg.data;
                            pid_t free_child_pid;

                            int IAmAcceptor=0;

                            SelfChild=SearchChild(child_pid);

                            if(SelfChild)
                            {
                                IAmAcceptor=1;
                            }
                            else
                            {
                                message(0,"%d Chyba !!! Nemuzu se najit v seznamu zamestnanych vlaken\n",getpid());
                            }

                            while((IAmAcceptor)&&(ThreadsLive))
                            {
                                client_sockfd=accept(server_sockfd,(struct sockaddr *)&client_address,&client_len);

                                message(3,"%d Prichozi spojeni %d\n",getpid(),client_sockfd);
                                if(client_sockfd>=0)
                                {
                                    if(Allow(client_address.sin_addr.s_addr,allow_pds,1))
                                    {
                                        int LocI = 1;
                                        setsockopt(client_sockfd,SOL_TCP,TCP_NODELAY,&LocI,sizeof(LocI));
                                        LocI=0;
                                        setsockopt(client_sockfd,SOL_TCP,TCP_CORK,&LocI,sizeof(LocI));

                                        free_child_pid=GetFreeChildpid();
                                        if(free_child_pid==0)
                                        {
                                            CloseClient(&client_sockfd);
                                        }
                                        else
                                        {
                                            message(3,"%d Predani cekani na spojeni %d\n",getpid(),free_child_pid);
                                            memset(&msg,0,sizeof(msg));
                                            msg.message_type=free_child_pid;
                                            msg.sign=valid_sign;
                                            msg.status=child_server;
                                            msg.data=server_sockfd;
                                            if(msgsnd(msg_id,&msg,status_message_size,0)!=0)
                                            {
                                                message(3,"%d Nepodarilo se predat cekani na spojeni %d\n",child_pid,free_child_pid);
                                                CloseClient(&client_sockfd);
                                                break;
                                            }

                                            message(1,"%d Prijeti spojeni od %s:%d\n",getpid(),inet_ntoa(client_address.sin_addr),client_address.sin_port);

                                            if(LocalInitFiles(&_Local))
                                            {
                                                _Local->client_sockfd=client_sockfd;
                                                SelfChild->Local=_Local;
                                                _Local->SelfChild=SelfChild;
                                                _Local->ip=htonl(client_address.sin_addr.s_addr);
                                                _Local->port=client_address.sin_port;
                                                IAmAcceptor=0;
                                                uint8_t LiveSocket=1;
                                                _Local->LiveSocket=&LiveSocket;
                                                int result;
                                                struct timeval timeout;
                                                int outcount=0;

                                                _send(client_sockfd,"PDS server\n",12);

                                                FD_ZERO(&_Local->clientfds);
                                                FD_SET(client_sockfd,&_Local->clientfds);

                                                char * BufPoint=(char *)buffer;
                                                int BufCount=0;
                                                int LocI;

                                                while((LiveSocket)&&(ThreadsLive))
                                                {
                                                    SelfChild->LastActive=time(NULL);
                                                    testfds=_Local->clientfds;
                                                    memset(&timeout,0,sizeof(timeout));
                                                    timeout.tv_sec=TimeOut;
                                                    while(((result=select(FD_SETSIZE,&testfds,NULL,NULL,&timeout))==-1)&&(errno==EINTR)) continue;
                                                    if(result==-1)
                                                    {
                                                        LiveSocket=0;
                                                        //CloseClient(&client_sockfd);
                                                        //_Local->client_sockfd=client_sockfd;
                                                        break;
                                                    }
                                                    else
                                                    if(result==0)
                                                    {
                                                        outcount++;
                                                        if(outcount>MaxOut)
                                                        {
                                                            LiveSocket=0;
                                                            //CloseClient(&client_sockfd);
                                                            //_Local->client_sockfd=client_sockfd;
                                                            message(0,"%d Klient %s:%d nereaguje, ukoncuji ...\n",child_pid,inet_ntoa(client_address.sin_addr),client_address.sin_port);
                                                        }
                                                        else
                                                        {
                                                            if(outcount>(MaxOut>>1))
                                                            {
                                                                message(1,"%d Timeout (%d) od %s:%d\n",child_pid,outcount,inet_ntoa(client_address.sin_addr),client_address.sin_port);
                                                            }
                                                            _send(client_sockfd,"ping\n",5);
                                                        }
                                                    }
                                                    else
                                                    if(FD_ISSET(client_sockfd,&testfds))
                                                    {
                                                        outcount=0;
                                                        LocI=bufsize-BufCount;
                                                        if(LocI<=0)
                                                        {
                                                            message(0,"%d Preplneni bufferu pro zpravy ...\n",child_pid);
                                                            BufCount=0;
                                                            BufPoint=(char *)buffer;
                                                            LocI=bufsize;
                                                        }
                                                        while(((readcount=recv(client_sockfd,BufPoint,LocI,0))==-1)&&(errno==EINTR)) continue;
                                                        switch(readcount)
                                                        {
                                                            case 0:
                                                            {
                                                                message(0,"%d precteno 0 bajtu (posledni zprava %d) ...\n",child_pid,_Local->LastMessage);
                                                                LiveSocket=0;
                                                                //CloseClient(&client_sockfd);
                                                                //_Local->client_sockfd=client_sockfd;
                                                                break;
                                                            }
                                                            case -1:
                                                            {
                                                                message(0,"%d chyba socketu %d ...\n",child_pid,msg.data);
                                                                LiveSocket=0;
                                                                //CloseClient(&client_sockfd);
                                                                //_Local->client_sockfd=client_sockfd;
                                                                break;
                                                            }
                                                            default:
                                                            {
                                                                BufCount+=readcount;
                                                                if(BufCount>=(int) sizeof(struct message_head))
                                                                {
                                                                    if(((P_child_message)buffer)->head.message_size+(int) sizeof(struct message_head)==BufCount)
                                                                    {
                                                                        BufCount=0;
                                                                        BufPoint=(char *)buffer;
                                                                        ChildAction((child_message *)buffer,buffer,bufsize,&_Local);
                                                                    }
                                                                    else
                                                                    if(((P_child_message)buffer)->head.message_size+(int) sizeof(struct message_head)>BufCount)
                                                                    {
                                                                        BufPoint+=readcount;
                                                                    }
                                                                    else
                                                                    {
                                                                        message(0,"%d prilis dlouha zprava, koncim ... (Ocekavana delka=%d, prijato=%d, id=%d)\n",getpid(),((P_child_message)buffer)->head.message_size+(int) sizeof(struct message_head),BufCount,((child_message *)buffer)->head.message_id);
                                                                        PrintBuffer(_Local,(char *)buffer,BufCount);
                                                                        LiveSocket=0;
                                                                        //CloseClient(&client_sockfd);
                                                                        //_Local->client_sockfd=client_sockfd;
                                                                    }
                                                                }
                                                                else
                                                                {
                                                            	    if((BufCount==5)&&(strncmp((const char *)buffer,"pong\n",5)==0))
                                                            	    {
                                                                        BufCount=0;
                                                                        BufPoint=(char *)buffer;
                                                            	    }
                                                            	    else
                                                            	    {
                                                                	BufPoint+=readcount;
                                                            	    }
                                                                }
                                                                break;
                                                            }
                                                        }
                                                    }
                                                }
                                                LocalDoneFiles(&_Local);
                                            }
                                            else
                                            {
                                                CloseClient(&client_sockfd);
                                            }
                                        }
                                    }
                                    else
                                    {
                                        message(0,"%d Pokus o spojeni z nepovolene adresy %s:%d\n",getpid(),inet_ntoa(client_address.sin_addr),client_address.sin_port);
                                        CloseClient(&client_sockfd);
                                    }
                                }
                                else
                                {
                                    break;
                                }
                            }
                            break;
                        }
                        case child_echoserver:
                        {

                            struct sockaddr_in echo_address;
                            struct sockaddr_storage client_address;
                            socklen_t client_len = sizeof(client_address);

                            int echo_sockfd=socket(AF_INET,SOCK_DGRAM,0);
                            int numbytes;

                            echo_address.sin_family = AF_INET;
                            echo_address.sin_addr.s_addr = htonl(INADDR_ANY);
                            echo_address.sin_port = htons(Params->port);
                            int echo_len=sizeof(echo_address);
                            int NameLen=strlen(Params->Name);

                            snprintf(buffer,bufsize,"%u.%u.%u:",Version.major,Version.minor,Version.revision);

                            int pdsNameLen=strlen(pdsID)+NameLen+strlen(buffer)+1;
                            char * pdsName=GetMem(pdsNameLen);
                            if(pdsName)
                            {
                                strcpy(pdsName,pdsID);
                                strcat(pdsName,buffer);
                                strcat(pdsName,Params->Name);
                                if(bind(echo_sockfd,(struct sockaddr *)&echo_address,echo_len)==0)
                                {
                                    while(ThreadsLive)
                                    {
                                        if ((numbytes=recvfrom(echo_sockfd,buffer,bufsize-1,0,(struct sockaddr *)&client_address,&client_len))!=-1)
                                        {
                                            message(3,"%d Echo pro %s:%d (chyba c.%d)\n",child_pid,inet_ntoa(((struct sockaddr_in*)&client_address)->sin_addr),((struct sockaddr_in*)&client_address)->sin_port,errno);
                                            if((numbytes==0)||((numbytes==NameLen)&&(memcmp(&Params->Name,buffer,NameLen)==0)))
                                            {
                                                if(Allow(((struct sockaddr_in*)&client_address)->sin_addr.s_addr,allow_pds,1))
                                                {
                                                    if(sendto(echo_sockfd,pdsName,pdsNameLen-1,0,(struct sockaddr *)&client_address,client_len)==-1)
                                                    {
                                                        message(0,"%d Nelze odeslat echo pro %s:%d (chyba c.%d)\n",child_pid,inet_ntoa(((struct sockaddr_in*)&client_address)->sin_addr),((struct sockaddr_in*)&client_address)->sin_port,errno);
                                                    }
                                                }
                                            }
                                        }
                                        else
                                        {
                                            if(errno!=4)
                                            {
                                                break;
                                            }
                                        }
                                    }
                                }
                                else
                                {
                                    message(0,"'bind' pro echo server selhal ...\n");
                                }
                                FreeMem(pdsName);
                            }
                        }
                        case child_httpserver:
                        {
                            message(3,"%d Cekam na http spojeni\n",child_pid);

                            struct sockaddr_in client_address;
                            socklen_t client_len = sizeof(client_address);
                            int http_sockfd=msg.data;
                            pid_t free_child_pid;

                            int IAmAcceptor=0;

                            SelfChild=SearchChild(child_pid);

                            if(SelfChild)
                            {
                                IAmAcceptor=1;
                            }
                            else
                            {
                                message(0,"%d Chyba !!! Nemuzu se najit v seznamu zamestnanych vlaken\n",getpid());
                            }

                            while((IAmAcceptor)&&(ThreadsLive))
                            {
                                client_sockfd=accept(http_sockfd,(struct sockaddr *)&client_address,&client_len);

                                message(3,"%d Prichozi http spojeni %d\n",getpid(),client_sockfd);
                                if(client_sockfd>=0)
                                {
                                    if(Allow(client_address.sin_addr.s_addr,allow_http,0))
                                    {
                                        int LocI = 1;
                                        setsockopt(client_sockfd,SOL_TCP,TCP_NODELAY,&LocI,sizeof(LocI));
                                        LocI=0;
                                        setsockopt(client_sockfd,SOL_TCP,TCP_CORK,&LocI,sizeof(LocI));

                                        free_child_pid=GetFreeChildpid();
                                        if(free_child_pid!=0)
                                        {
                                            message(3,"%d Predani cekani na spojeni %d\n",getpid(),free_child_pid);
                                            memset(&msg,0,sizeof(msg));
                                            msg.message_type=free_child_pid;
                                            msg.sign=valid_sign;
                                            msg.status=child_httpserver;
                                            msg.data=http_sockfd;
                                            if(msgsnd(msg_id,&msg,status_message_size,0)!=0)
                                            {
                                                message(3,"%d Nepodarilo se predat cekani na spojeni %d\n",child_pid,free_child_pid);
                                                break;
                                            }
                                            else
                                            {
                                                message(2,"%d Prijeti http spojeni od %s:%d\n",getpid(),inet_ntoa(client_address.sin_addr),client_address.sin_port);

                                                SelfChild->Local=NULL;
                                                IAmAcceptor=0;
                                                uint8_t LiveSocket=1;
                                                int result;
                                                struct timeval timeout;
                                                int outcount=0;
                                                fd_set clientfds;

                                                FD_ZERO(&clientfds);
                                                FD_SET(client_sockfd,&clientfds);

                                                char * BufPoint=(char *)buffer;
                                                int BufCount=0;
                                                int LocI;

                                                while((LiveSocket)&&(ThreadsLive))
                                                {
                                                    SelfChild->LastActive=time(NULL);
                                                    testfds=clientfds;
                                                    memset(&timeout,0,sizeof(timeout));
                                                    timeout.tv_sec=TimeOut;
                                                    while(((result=select(FD_SETSIZE,&testfds,NULL,NULL,&timeout))==-1)&&(errno==EINTR)) continue;
                                                    if(result==-1)
                                                    {
                                                        LiveSocket=0;
                                                        break;
                                                    }
                                                    else
                                                    if(result==0)
                                                    {
                                                        LiveSocket=0;
                                                        break;
                                                    }
                                                    else
                                                    if(FD_ISSET(client_sockfd,&testfds))
                                                    {
                                                        outcount=0;
                                                        LocI=bufsize-BufCount;
                                                        if(LocI<=0)
                                                        {
                                                            message(0,"%d Preplneni bufferu pro zpravy ...\n",child_pid);
                                                            BufCount=0;
                                                            BufPoint=(char *)buffer;
                                                            LocI=bufsize;
                                                        }
                                                        while(((readcount=recv(client_sockfd,BufPoint,LocI,0))==-1)&&(errno==EINTR)) continue;
                                                        switch(readcount)
                                                        {
                                                            case 0:
                                                            case -1:
                                                            {
                                                                LiveSocket=0;
                                                                break;
                                                                break;
                                                            }
                                                            default:
                                                            {
                                                                BufCount+=readcount;
                                                                if(IsHttpHeadComplete(buffer,BufCount))
                                                                {
                                                                    HTTPAction(client_sockfd,buffer,BufCount,bufsize);
                                                                    BufCount=0;
                                                                    LiveSocket=0;
                                                                }
                                                                else
                                                                {
                                                                    BufPoint=(char *)buffer;
                                                                    BufPoint+=readcount;
                                                                }
                                                                break;
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    else
                                    {
                                        message(0,"%d Pokus o http spojeni z nepovolene adresy %s:%d\n",getpid(),inet_ntoa(client_address.sin_addr),client_address.sin_port);
                                    }
                                    CloseClient(&client_sockfd);
                                }
                            }
                            break;
                        }
                        case child_freezepatrol:
                        {
                            while(ThreadsLive)
                            {
                                sleep(TimeOut);
                                time_t FreezeTime=time(NULL)-TimeOut*3;
                                if(semaphore_p(2,NULL))
                                {
                                    P_pds_child child=_Childs->Busy;
                                    while(child!=NULL)
                                    {
                                        if(child->LastActive!=(time_t)-1)
                                        {
                                            if(child->Local->DisableCheckFreeze==0)
                                            {
                                                if((child->LastActive<FreezeTime))
                                                {
                                                    const char * FuncName="???";
                                                    if(child->Local)
                                                    {
                                                        if(child->Local->FuncName)
                                                            FuncName=child->Local->FuncName;
                                                    }
                                                    message(0,"%d detekovan FreezeThread pid %d funkce %s\n",getpid(),child->pid,FuncName);
                                                    kill(child->pid,SIGUSR1);
                                                }
                                            }
                                            else
                                            {
                                                child->LastActive=(time_t)-1;
                                            }
                                        }
                                        child=child->NextChild;
                                    }
                                    semaphore_v(2,NULL);
                                }
                            }
                            break;
                        }
                    }
                }
                message(3,"%d Uvolneni dcerinneho procesu ...\n",getpid());
                memset(&msg,0,sizeof(msg));
                msg.message_type=parent_pid;
                msg.sign=valid_sign;
                msg.status=child_free;
                msg.pid=child_pid;
                msgsnd(msg_id,&msg,status_message_size,0);
            }
			message(3,"%d Opousteni dcerinneho procesu ...\n",getpid());
			memset(&msg,0,sizeof(msg));
			msg.message_type=parent_pid;
			msg.sign=valid_sign;
			msg.status=child_exit;
			msg.pid=child_pid;
			msgsnd(msg_id,&msg,status_message_size,0);
			FreeMem(buffer);
		}
	}
   	message(1,"%d Dcerinny proces konec\n",getpid());
    _Files->UseCount--;
	exit(0);
}

// ******** ******** ******** ******** ******** ******** ********

int DeleteChild(pid_t pid)
{
	message(3,"DeleteChild ... %d\n",pid);
	pid_t child_pid=getpid();
	if(!semaphore_p(2,NULL))
		return 0;
	P_pds_child child;
	child=_Childs->FirstFree;
	while(child!=NULL)
	{
		if(child->pid==pid)
		{
			status_message msg;
			memset(&msg,0,sizeof(msg));
			msg.message_type=pid;
			msg.sign=valid_sign;
			msg.status=child_exit;
			msg.pid=child_pid;
			msgsnd(msg_id,&msg,status_message_size,0);
			if(child->PrevChild!=NULL)
				child->PrevChild->NextChild=child->NextChild;
			else
				_Childs->FirstFree=child->NextChild;

			if(child->NextChild!=NULL)
				child->NextChild->PrevChild=child->PrevChild;
			_Childs->FreeChilds--;

			child->PrevChild=NULL;
			child->NextChild=_Childs->Unused;
			_Childs->Unused=child;
			message(3,"Zruseny pid %d (z volnych)\n",pid);
			ChildsStatus();
			semaphore_v(2,NULL);
			return 1;
		}
		child=child->NextChild;
	}
	child=_Childs->Busy;
	while(child!=NULL)
	{
	    message(3,"Busy ChildPid ... %d\n",child->pid);
		if(child->pid==pid)
		{
			if(child->PrevChild!=NULL)
				child->PrevChild->NextChild=child->NextChild;
			else
				_Childs->Busy=child->NextChild;

			if(child->NextChild!=NULL)
				child->NextChild->PrevChild=child->PrevChild;
			_Childs->BusyChilds--;

			child->PrevChild=NULL;
			child->NextChild=_Childs->Unused;
			if(child->Local)
			{
				if(child->Local->SelfChild==child)
					LocalDoneFiles(&child->Local);
			}
			_Childs->Unused=child;
			message(3,"Zruseny pid %d (ze zaneprazdnenych)\n",pid);
			ChildsStatus();
			semaphore_v(2,NULL);
			return 1;
		}
		child=child->NextChild;
	}
	message(0,"Nenalezeny pid ke zruseni %d\n",pid);
	ChildsStatus();
	semaphore_v(2,NULL);
	return 0;
}

int FreeChild(pid_t pid)
{
	message(3,"FreeChild ... %d\n",pid);
	if(!semaphore_p(2,NULL))
		return 0;
	P_pds_child child;
	child=_Childs->Busy;
	while(child!=NULL)
	{
		if(child->pid==pid)
		{
			if(child->Local)
				LocalDoneFiles(&child->Local);
			if(child->PrevChild!=NULL)
				child->PrevChild->NextChild=child->NextChild;
			else
				_Childs->Busy=child->NextChild;

			if(child->NextChild!=NULL)
				child->NextChild->PrevChild=child->PrevChild;

			_Childs->FreeChilds++;
			_Childs->BusyChilds--;
			child->PrevChild=NULL;
			child->NextChild=_Childs->FirstFree;
			if(child->NextChild!=NULL)
			{
				child->NextChild->PrevChild=child;
			}
			if(child->Local)
			{
				if(child->Local->SelfChild==child)
					LocalDoneFiles(&child->Local);
			}
			_Childs->FirstFree=child;
			message(3,"Nezamestnany pid %d\n",pid);
			ChildsStatus();
			semaphore_v(2,NULL);
			return 1;
		}
		child=child->NextChild;
	}
	message(0,"Nenalezeny pid k uvolneni %d\n",pid);
	ChildsStatus();
	semaphore_v(2,NULL);
	return 0;
}

void EmployChild(P_pds_child child)
{
	if(!semaphore_p(2,NULL))
		return;
	if(child->PrevChild==NULL)
	{
		if(_Childs->FirstFree==child)
		{
			_Childs->FirstFree=child->NextChild;
		}
		else
		{
			message(0,"Chyba integrity pole !!!\n");
		}
	}
	else
	{
		child->PrevChild->NextChild=child->NextChild;
	}
	if(child->NextChild!=NULL)
	{
		child->NextChild->PrevChild=child->PrevChild;
	}
	child->NextChild=_Childs->Busy;
	if(child->NextChild!=NULL)
	{
		child->NextChild->PrevChild=child;
	}
	_Childs->Busy=child;
	_Childs->FreeChilds--;
	_Childs->BusyChilds++;
	child->PrevChild=NULL;
	child->LastActive=(time_t)-1;
	message(3,"Zamestnani pidu %d\n",child->pid);
	ChildsStatus();
	semaphore_v(2,NULL);
}

void DoneChilds()
{
	int OK=1;
	while((OK)&&(_Childs->FirstFree!=NULL))
	{
		P_pds_child child;
		child=_Childs->FirstFree;
		OK=DeleteChild(child->pid);
	}
	if(msg_id!=-1)
	{
		if(msgctl(msg_id,IPC_RMID,0)==-1)
		{
			message(0,"msgctl(IPC_RMID) selhalo\n");
			fprintf(stderr,"msgctl(IPC_RMID) selhalo\n");fflush(NULL);
		}
	}
	FreeMem(_Childs);
	_Childs=NULL;
	DoneFiles();
};

void OpenLog()
{
    if(!Params->LogMode)
    {
        if(Params->LogName)
        {
            syslog(0,"PDS - Log file: %s\n",Params->LogName);

            int newout=open(Params->LogName,O_APPEND|O_WRONLY);
            if(newout==-1)
            {
                if(errno==2)
                {
                    newout=open(Params->LogName,O_WRONLY|O_CREAT|O_TRUNC,S_IRUSR|S_IWUSR|S_IRGRP);
                    if(newout==-1)
                    {
                        syslog(0,"PDS - Chyba %d pri vytvareni logu %s\n",errno,Params->LogName);
                    }
                }
                else
                {
                    syslog(0,"PDS - Chyba %d pri otevirani logu %s\n",errno,Params->LogName);
                }
            }
            if(newout!=-1)
            {
                syslog(0,"PDS - Log %s otevren ...\n",Params->LogName);
                if(semaphore_p(semaphore_log,NULL))
                {
                    close(1);
                    dup(newout);
                    semaphore_v(semaphore_log,NULL);
                }
                close(newout);
            }
        }
    }
    else
    if(Params->LogMode==1)
    {
        printf("Log file: <output>\n");
        syslog(0,"PDS - Log file: <output>\n");
    }
    else
    if(Params->LogMode==2)
    {
        printf("Log file: <syslog>\n");
        syslog(0,"PDS - Log file: <syslog>\n");
    }
}

void WorkMsg(status_message msg)
{
	message(3,"Zpracovavam zpravu ... zprava: %d\n",msg.status);
	if(msg.sign==valid_sign)
	{
		switch(msg.status)
		{
			case child_create:
			{
				if(!semaphore_p(2,NULL))
					return;
				if((_Childs->ChildsCount<_Childs->MaxChilds)&&(_Childs->Unused!=NULL))
				{
					P_pds_child child;
					child=_Childs->Unused;
					_Childs->Unused=child->NextChild;
					_Childs->Unused->PrevChild=NULL;
					child->NextChild=_Childs->FirstFree;
					if(child->NextChild!=NULL)
						child->NextChild->PrevChild=child;
					child->PrevChild=NULL;
					_Childs->FirstFree=child;
					child->pid=msg.pid;
					_Childs->FreeChilds++;
					_Childs->ChildsCount++;
					message(3,"Zprava o novem vlaknu %d zpracovana ...\n",msg.pid);
					ChildsStatus();
				}
				semaphore_v(2,NULL);
				break;
			}
			case child_exit:
			{
				DeleteChild(msg.pid);
				if((!ThreadsLive)&&(_Childs->Busy==NULL))
				{
					Live=0;
				}
				break;
			}
			case child_free:
			{
				FreeChild(msg.pid);
				break;
			}
			case child_allocfree:
			{
				P_pds_child free_child;
				message(3,"Pokus o alokaci\n");
				free_child=AllocChild();
				message(3,"child alokovan ...\n");
				msg.message_type=msg.pid;
				if(free_child==NULL)
					msg.pid=0;
				else
					msg.pid=free_child->pid;
				message(3,"child odesilan ...\n");
				msg.status=child_returnfree;
				if(msgsnd(msg_id,&msg,status_message_size,0)!=0)
				{
					message(0,"Kriticka chyba !!! Nepodarilo se odeslat alokacni zpravu !!!\n");
					exit(-1);
				}
				break;
			}
			case child_abort:
			{
				if(getpid()==parent_pid)
				{
					DeleteChild(msg.pid);
				}
				break;
			}
			case Reload:
			{
                message(1,"%d SIGHUP signal, znovunacteni konfigurace ...\n",getpid());
                if(semaphore_p(0,NULL))
                {
                    if(GetParams())
                    {
                        OpenLog();
                    }
                    semaphore_v(0,NULL);
                    message(1,"%d Konfigurace znovunactena ...\n",getpid());
                }
			}
		}
	}
}

/* AllocChild */

P_pds_child AllocChild()
{
	int res_msg;
	status_message statusmsg;
	void * child_stack;

	if(!semaphore_p(0,NULL))
		return 0;

	while(_Childs->FreeChilds==0)
	{
		while(1)
		{
 			res_msg=msgrcv(msg_id,&statusmsg,status_message_size,parent_pid,IPC_NOWAIT);
			if(res_msg==-1)
			{
			    if(errno!=4)
                    break;
			}
			if(res_msg==status_message_size)
				WorkMsg(statusmsg);
		}

		if((_Childs->FreeChilds==0)&&(_Childs->ChildsCount<_Childs->MaxChilds))
		{
			pid_t pid;

			child_stack = (void *) GetMem(stack_size);
			if(child_stack==NULL)
			{
				message(0,"Nepodarilo se alokovat prostor pro zasobnik\n");
				if(!semaphore_v(0,NULL))
				{
 	  				message(0,"Nepodarilo se uvolnit semafor 0\n");
				}
				return 0;
			}
			memset(child_stack,0,stack_size);
			pid=clone(ChildProc,(char *)child_stack+stack_size,CLONE_FILES|CLONE_FS|CLONE_VM|CLONE_SIGHAND,NULL);
			if(pid==-1)
			{
				message(0,"Clone selhalo\n");
				if(!semaphore_v(0,NULL))
				{
 	  				message(0,"Nepodarilo se uvolnit semafor 0\n");
				}
				return 0;
			}
			else
			{
		    	message(3,"Cekani na vytvoreni\n");
				if(!semaphore_p(1,NULL))
					return 0;
				if(!semaphore_p(1,NULL))
					return 0;
		    	message(3,"Vytvoreno\n");
				if(!semaphore_v(1,NULL))
					return 0;
			}
		}
	}

	message(3,"Volne vlakno nalezeno ... %d\n",_Childs->FirstFree->pid);

	P_pds_child free_child=_Childs->FirstFree;
	if(free_child==NULL)
	{
		message(0,"Interní chyba ... (1)\n");
		return 0;
	}
	EmployChild(free_child);

	if(!semaphore_v(0,NULL))
	{
 		message(0,"Nepodarilo se uvolnit semafor 0\n");
	}

	message(3,"Vraceni z AllocChild() ...\n");

	return free_child;
}
